(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     15602,        423]
NotebookOptionsPosition[      9970,        322]
NotebookOutlinePosition[     10827,        351]
CellTagsIndexPosition[     10724,        345]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["EPM`Collatz`", "Section",
 InitializationGroup->
  True,ExpressionUUID->"360ed4cd-2c2d-4557-a154-c77c09e97305"],

Cell[TextData[{
 StyleBox["From",
  FontWeight->"Bold"],
 ": ",
 StyleBox["Essentials of Programming in Mathematica\n",
  FontSlant->"Italic"],
 "\[Copyright] Paul R. Wellin 2015"
}], "Text",
 CellMargins->{{28, 10}, {7, 7}},
 FontSize->14,ExpressionUUID->"e7e5d3a0-aeea-4c2a-9bbe-05e898394880"],

Cell[CellGroupData[{

Cell["Metadata", "Subsection",ExpressionUUID->"650bb74a-2414-4a08-96c2-8beda6e3419e"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Name", ":", " ", "EPM`Collatz`"}], " ", "*)"}]], "Input",Expre\
ssionUUID->"daf4a982-b6f6-460f-afbe-55f490ccb7ae"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Book", ":", " ", 
   RowBox[{
   "Essentials", " ", "of", " ", "programming", " ", "in", " ", 
    "Mathematica"}]}], " ", "*)"}]], "Input",ExpressionUUID->"438eb64f-34ab-\
4f70-beca-3473d7f8d9f0"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Paul", " ", "Wellin"}]}]}], " ", "*)"}]], "Input",ExpressionUUID->\
"1a9b1d9e-98a0-450d-8908-012532679865"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Summary", ":", " ", 
   RowBox[{
   "This", " ", "package", " ", "contains", " ", "the", " ", "functions", " ",
     "defined", " ", "in", " ", "the", " ", "solutions", " ", "to", " ", 
    "the", " ", "Collatz", " ", "exercises", " ", "in", " ", "Chapter", " ", 
    "10", " ", 
    RowBox[{"Packages", "."}]}]}], " ", "*)"}]], "Input",ExpressionUUID->\
"dbbf4eeb-6997-4ae2-9d8c-5e34b349aab1"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Context", ":", " ", "EPM`Collatz`"}], " ", "*)"}]], "Input",Ex\
pressionUUID->"fce999c2-b9d2-41b0-b7ed-a278ed0a3f13"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", 
    RowBox[{"Version", ":", " ", "1.0"}]}]}], " ", "*)"}]], "Input",Expression\
UUID->"a9bf5fce-18c7-487e-826a-923322ec3356"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", "Copyright", ":", " ", 
    RowBox[{"Copyright", " ", "2015"}]}], ",", " ", 
   RowBox[{"Paul", " ", "R", " ", "Wellin"}]}], " ", "*)"}]], "Input",Expressi\
onUUID->"94f0be69-8b69-4adb-ae7a-fc219c25915a"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{
     "Version", " ", "1.0", " ", "by", " ", "Paul", " ", "Wellin"}]}]}], ",", 
   " ", 
   RowBox[{"Dec", " ", "2012"}]}], " ", "*)"}]], "Input",ExpressionUUID->\
"e53603de-00ab-4b72-a6f6-230b6c30bf66"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", "Keywords", ":", " ", 
    RowBox[{"Collatz", " ", "sequence"}]}], ",", " ", "PositiveIntegerQ"}], 
  " ", "*)"}]], "Input",ExpressionUUID->"50b2cc41-b385-4571-a9f6-\
28c60f67860f"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Source", ":", " ", 
    RowBox[{"Collatz", ".", "nb"}]}]}], " ", "*)"}]], "Input",ExpressionUUID->\
"3705fab7-1743-4ca3-b683-9d8b458b55e6"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", "Version"}], ":", " ", "10.3"}], " ", 
  "*)"}]], "Input",ExpressionUUID->"402c4e16-b7be-4357-865f-3c184d8a0511"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Tested", " ", "in", " ", "Mathematica", " ", "11.1"}], " ", 
  "*)"}]], "Input",ExpressionUUID->"fa633574-d74b-484c-9b75-8c7fafc03071"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Tested", " ", "in", " ", "Mathematica", " ", "13.2"}], ",", " ", 
   RowBox[{"18", " ", "Aug", " ", "2023"}]}], "*)"}]], "Input",ExpressionUUID->\
"afe21f6e-04ec-4353-96ac-058fee489319"]
}, Closed]],

Cell[CellGroupData[{

Cell["BeginPackage", "Subsection",ExpressionUUID->"97f31e33-fae4-4888-87cf-e580a670adb3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Remove", "[", "CollatzSequence", "]"}], ";"}]], "Input",ExpressionU\
UID->"bfdee65d-baa7-495f-a4ac-55533646798d"],

Cell[BoxData[
 RowBox[{"BeginPackage", "[", "\"\<EPM`Collatz`\>\"", "]"}]], "Input",Expressi\
onUUID->"d9c3dacb-7b5d-45da-9e0b-2b918b463d67"]
}, Closed]],

Cell[CellGroupData[{

Cell["Usage statements", "Subsection",ExpressionUUID->"13870ca4-e1cf-4afe-9a1c-18ec09c73321"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CollatzSequence", "::", "usage"}], "=", 
   "\"\<CollatzSequence[\!\(\*StyleBox[\"n\", \"TI\"]\)] computes the \
sequence of Collatz iterates starting with initial value \
\!\(\*StyleBox[\"n\", \"TI\"]\). The sequence terminates as soon as it \
reaches the value 1.\>\""}], ";"}]], "Input",ExpressionUUID->"f81a686a-498c-\
411d-ab3e-012ae7f38bad"]
}, Closed]],

Cell[CellGroupData[{

Cell["Warning messages", "Subsection",ExpressionUUID->"d495240f-67d3-4b8c-a3df-567a541684e7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CollatzSequence", "::", "notint"}], "=", 
   "\"\<The argument, `1`, to CollatzSequence must be a positive \
integer.\>\""}], ";"}]], "Input",ExpressionUUID->"13765d8c-9bdb-4230-91ad-\
d6d8cc23278b"]
}, Closed]],

Cell["Options", "Subsection",ExpressionUUID->"6c395fff-fc17-4b98-a6c1-44dab8408c17"],

Cell[CellGroupData[{

Cell["Begin private context", "Subsection",ExpressionUUID->"a78f9620-65c2-43ce-ad34-6d37e6538968"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "Input",ExpressionUUID->"bdcd3173-68f7-4780-a0fa-622656c49ae4"]
}, Closed]],

Cell[CellGroupData[{

Cell["The function definitions", "Subsection",ExpressionUUID->"ef70a821-f09b-4287-a1bc-244ceb968180"],

Cell[BoxData[
 RowBox[{
  RowBox[{"collatz", "[", 
   RowBox[{"n_", "?", "EvenQ"}], "]"}], ":=", 
  RowBox[{"n", "/", "2"}]}]], "Input",ExpressionUUID->"7afb98cf-140d-4f81-\
86a8-0105674a64fa"],

Cell[BoxData[
 RowBox[{
  RowBox[{"collatz", "[", 
   RowBox[{"n_", "?", "OddQ"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"3", "n"}], "+", "1"}]}]], "Input",ExpressionUUID->"571f5931-20a6-\
4bc0-bf2f-153b78466a4a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"positiveIntegerQ", "[", "n_", "]"}], ":=", 
  RowBox[{
   RowBox[{"IntegerQ", "[", "n", "]"}], "&&", 
   RowBox[{"Positive", "[", "n", "]"}]}]}]], "Input",ExpressionUUID->\
"00e1c497-362e-4629-a71d-64c49300b8c2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CollatzSequence", "[", "n_", "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"positiveIntegerQ", "[", "n", "]"}], ",", "\[IndentingNewLine]", 
    RowBox[{"NestWhileList", "[", 
     RowBox[{"collatz", ",", "n", ",", 
      RowBox[{
       RowBox[{"#", "\[NotEqual]", "1"}], "&"}]}], "]"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"CollatzSequence", "::", "notint"}], ",", "n"}], "]"}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",ExpressionUUID->"17e49608-bde1-\
4139-980a-eca664f3aa25"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CollatzSequence", "[", 
    RowBox[{"_", ",", "args__"}], "]"}], "/;", 
   RowBox[{"Message", "[", 
    RowBox[{
     RowBox[{
      StyleBox["CollatzSequence", "Color1"], "::", "argx"}], ",", 
     "CollatzSequence", ",", 
     RowBox[{
      RowBox[{"Length", "[", 
       RowBox[{"{", "args", "}"}], "]"}], "+", "1"}]}], "]"}]}], ":=", 
  "Null"}]], "Input",
 CellTags->{
  "M220:7.8.10-2", 
   "M220.7.8"},ExpressionUUID->"0fc49bb5-0643-4444-b15a-4447c289c5ea"]
}, Closed]],

Cell[CellGroupData[{

Cell["End private context", "Subsection",ExpressionUUID->"4699e47c-4b9b-4311-8259-f27c4c23bd83"],

Cell[BoxData[
 RowBox[{"End", "[", "]"}]], "Input",ExpressionUUID->"5c9a0b2a-a825-40d0-93ff-bdd5844b7cbd"]
}, Closed]],

Cell[CellGroupData[{

Cell["EndPackage", "Subsection",ExpressionUUID->"65725ed2-81ac-4f83-9888-b067a4866e21"],

Cell[BoxData[
 RowBox[{"EndPackage", "[", "]"}]], "Input",ExpressionUUID->"a4c1c9ac-4537-47a4-a8e8-61ed3e10359a"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Examples", "Section",ExpressionUUID->"5a5c4774-199b-45f3-b8a9-b430d4042297"],

Cell[CellGroupData[{

Cell["Load package", "Subsection",ExpressionUUID->"6a8b685b-09fc-4ae1-a4e0-d1d57fca2a5f"],

Cell[BoxData["Quit"], "Input",
 CellLabel->"In[5]:=",ExpressionUUID->"2ebe327d-befe-4591-ad6d-52289f51bd72"],

Cell[TextData[{
 "Load package (do ",
 StyleBox["not",
  FontSlant->"Italic"],
 " say \[OpenCurlyDoubleQuote]Yes\[CloseCurlyDoubleQuote] to evaluate init \
cells dialog)."
}], "Text",ExpressionUUID->"ff4ca68a-16dc-414e-a905-05fe1ab721f9"],

Cell[BoxData[
 RowBox[{"<<", "EPM`Collatz`"}]], "Input",
 CellLabel->"In[1]:=",ExpressionUUID->"dd66884e-998a-4f88-91b0-99f97df03bfd"]
}, Closed]],

Cell[CellGroupData[{

Cell["Test usage messages", "Subsection",ExpressionUUID->"1841961f-7867-41c3-afd9-dc0426ed2bb3"],

Cell[BoxData[
 RowBox[{"?", "CollatzSequence"}]], "Input",
 CellLabel->"In[2]:=",ExpressionUUID->"7d61ccf0-3ab2-41eb-b920-a2c9b70e22e6"]
}, Closed]],

Cell[CellGroupData[{

Cell["Exercise the functions", "Subsection",ExpressionUUID->"d7b7d8a5-efcc-43a7-bfdb-671c03ce1131"],

Cell[BoxData[
 RowBox[{"CollatzSequence", "[", "27", "]"}]], "Input",
 CellLabel->"In[6]:=",ExpressionUUID->"4988827a-ee78-4396-bd13-9579b7cfa948"],

Cell[BoxData[
 RowBox[{"CollatzSequence", "[", 
  RowBox[{"-", "5"}], "]"}]], "Input",
 CellLabel->"In[4]:=",ExpressionUUID->"a0cb46ba-18e1-4b29-90f3-091a98d2c4e9"],

Cell[BoxData[
 RowBox[{"CollatzSequence", "[", 
  RowBox[{"3", ",", "4"}], "]"}]], "Input",
 CellLabel->"In[5]:=",ExpressionUUID->"daa64e6b-8e24-4699-a8ae-ca6e106ea6b1"]
}, Closed]]
}, Closed]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{808, 699},
WindowMargins->{{Automatic, 860}, {Automatic, 41}},
ShowSelection->True,
Magnification:>1.25 Inherited,
FrontEndVersion->"13.3 for Mac OS X ARM (64-bit) (July 24, 2023)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"d88f6131-3b05-4af4-9532-650ac75a2745"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "M220:7.8.10-2"->{
  Cell[7317, 233, 512, 16, 67, "Input",ExpressionUUID->"0fc49bb5-0643-4444-b15a-4447c289c5ea",
   CellTags->{"M220:7.8.10-2", "M220.7.8"}]},
 "M220.7.8"->{
  Cell[7317, 233, 512, 16, 67, "Input",ExpressionUUID->"0fc49bb5-0643-4444-b15a-4447c289c5ea",
   CellTags->{"M220:7.8.10-2", "M220.7.8"}]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"M220:7.8.10-2", 10404, 336},
 {"M220.7.8", 10560, 339}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 117, 2, 105, "Section",ExpressionUUID->"360ed4cd-2c2d-4557-a154-c77c09e97305",
 InitializationGroup->True],
Cell[699, 26, 295, 9, 83, "Text",ExpressionUUID->"e7e5d3a0-aeea-4c2a-9bbe-05e898394880"],
Cell[CellGroupData[{
Cell[1019, 39, 85, 0, 84, "Subsection",ExpressionUUID->"650bb74a-2414-4a08-96c2-8beda6e3419e"],
Cell[1107, 41, 165, 3, 46, "Input",ExpressionUUID->"daf4a982-b6f6-460f-afbe-55f490ccb7ae"],
Cell[1275, 46, 248, 6, 46, "Input",ExpressionUUID->"438eb64f-34ab-4f70-beca-3473d7f8d9f0"],
Cell[1526, 54, 203, 5, 46, "Input",ExpressionUUID->"1a9b1d9e-98a0-450d-8908-012532679865"],
Cell[1732, 61, 445, 9, 112, "Input",ExpressionUUID->"dbbf4eeb-6997-4ae2-9d8c-5e34b349aab1"],
Cell[2180, 72, 168, 3, 46, "Input",ExpressionUUID->"fce999c2-b9d2-41b0-b7ed-a278ed0a3f13"],
Cell[2351, 77, 204, 5, 46, "Input",ExpressionUUID->"a9bf5fce-18c7-487e-826a-923322ec3356"],
Cell[2558, 84, 266, 6, 46, "Input",ExpressionUUID->"94f0be69-8b69-4adb-ae7a-fc219c25915a"],
Cell[2827, 92, 313, 9, 46, "Input",ExpressionUUID->"e53603de-00ab-4b72-a6f6-230b6c30bf66"],
Cell[3143, 103, 243, 6, 46, "Input",ExpressionUUID->"50b2cc41-b385-4571-a9f6-28c60f67860f"],
Cell[3389, 111, 202, 5, 46, "Input",ExpressionUUID->"3705fab7-1743-4ca3-b683-9d8b458b55e6"],
Cell[3594, 118, 195, 4, 46, "Input",ExpressionUUID->"402c4e16-b7be-4357-865f-3c184d8a0511"],
Cell[3792, 124, 181, 3, 46, "Input",ExpressionUUID->"fa633574-d74b-484c-9b75-8c7fafc03071"],
Cell[3976, 129, 244, 5, 46, "Input",ExpressionUUID->"afe21f6e-04ec-4353-96ac-058fee489319"]
}, Closed]],
Cell[CellGroupData[{
Cell[4257, 139, 89, 0, 57, "Subsection",ExpressionUUID->"97f31e33-fae4-4888-87cf-e580a670adb3"],
Cell[4349, 141, 148, 3, 40, "Input",ExpressionUUID->"bfdee65d-baa7-495f-a4ac-55533646798d"],
Cell[4500, 146, 141, 2, 40, "Input",ExpressionUUID->"d9c3dacb-7b5d-45da-9e0b-2b918b463d67"]
}, Closed]],
Cell[CellGroupData[{
Cell[4678, 153, 93, 0, 57, "Subsection",ExpressionUUID->"13870ca4-e1cf-4afe-9a1c-18ec09c73321"],
Cell[4774, 155, 394, 8, 120, "Input",ExpressionUUID->"f81a686a-498c-411d-ab3e-012ae7f38bad"]
}, Closed]],
Cell[CellGroupData[{
Cell[5205, 168, 93, 0, 57, "Subsection",ExpressionUUID->"d495240f-67d3-4b8c-a3df-567a541684e7"],
Cell[5301, 170, 246, 6, 112, "Input",ExpressionUUID->"13765d8c-9bdb-4230-91ad-d6d8cc23278b"]
}, Closed]],
Cell[5562, 179, 84, 0, 57, "Subsection",ExpressionUUID->"6c395fff-fc17-4b98-a6c1-44dab8408c17"],
Cell[CellGroupData[{
Cell[5671, 183, 98, 0, 57, "Subsection",ExpressionUUID->"a78f9620-65c2-43ce-ad34-6d37e6538968"],
Cell[5772, 185, 129, 1, 40, "Input",ExpressionUUID->"bdcd3173-68f7-4780-a0fa-622656c49ae4"]
}, Closed]],
Cell[CellGroupData[{
Cell[5938, 191, 101, 0, 57, "Subsection",ExpressionUUID->"ef70a821-f09b-4287-a1bc-244ceb968180"],
Cell[6042, 193, 193, 5, 40, "Input",ExpressionUUID->"7afb98cf-140d-4f81-86a8-0105674a64fa"],
Cell[6238, 200, 211, 6, 40, "Input",ExpressionUUID->"571f5931-20a6-4bc0-bf2f-153b78466a4a"],
Cell[6452, 208, 247, 6, 40, "Input",ExpressionUUID->"00e1c497-362e-4629-a71d-64c49300b8c2"],
Cell[6702, 216, 612, 15, 146, "Input",ExpressionUUID->"17e49608-bde1-4139-980a-eca664f3aa25"],
Cell[7317, 233, 512, 16, 67, "Input",ExpressionUUID->"0fc49bb5-0643-4444-b15a-4447c289c5ea",
 CellTags->{"M220:7.8.10-2", "M220.7.8"}]
}, Closed]],
Cell[CellGroupData[{
Cell[7866, 254, 96, 0, 57, "Subsection",ExpressionUUID->"4699e47c-4b9b-4311-8259-f27c4c23bd83"],
Cell[7965, 256, 106, 1, 35, "Input",ExpressionUUID->"5c9a0b2a-a825-40d0-93ff-bdd5844b7cbd"]
}, Closed]],
Cell[CellGroupData[{
Cell[8108, 262, 87, 0, 57, "Subsection",ExpressionUUID->"65725ed2-81ac-4f83-9888-b067a4866e21"],
Cell[8198, 264, 113, 1, 40, "Input",ExpressionUUID->"a4c1c9ac-4537-47a4-a8e8-61ed3e10359a"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[8360, 271, 82, 0, 105, "Section",ExpressionUUID->"5a5c4774-199b-45f3-b8a9-b430d4042297"],
Cell[CellGroupData[{
Cell[8467, 275, 89, 0, 83, "Subsection",ExpressionUUID->"6a8b685b-09fc-4ae1-a4e0-d1d57fca2a5f"],
Cell[8559, 277, 108, 1, 46, "Input",ExpressionUUID->"2ebe327d-befe-4591-ad6d-52289f51bd72"],
Cell[8670, 280, 238, 6, 55, "Text",ExpressionUUID->"ff4ca68a-16dc-414e-a905-05fe1ab721f9"],
Cell[8911, 288, 134, 2, 46, "Input",ExpressionUUID->"dd66884e-998a-4f88-91b0-99f97df03bfd"]
}, Closed]],
Cell[CellGroupData[{
Cell[9082, 295, 96, 0, 83, "Subsection",ExpressionUUID->"1841961f-7867-41c3-afd9-dc0426ed2bb3"],
Cell[9181, 297, 136, 2, 46, "Input",ExpressionUUID->"7d61ccf0-3ab2-41eb-b920-a2c9b70e22e6"]
}, Closed]],
Cell[CellGroupData[{
Cell[9354, 304, 99, 0, 83, "Subsection",ExpressionUUID->"d7b7d8a5-efcc-43a7-bfdb-671c03ce1131"],
Cell[9456, 306, 147, 2, 46, "Input",ExpressionUUID->"4988827a-ee78-4396-bd13-9579b7cfa948"],
Cell[9606, 310, 164, 3, 46, "Input",ExpressionUUID->"a0cb46ba-18e1-4b29-90f3-091a98d2c4e9"],
Cell[9773, 315, 169, 3, 46, "Input",ExpressionUUID->"daa64e6b-8e24-4699-a8ae-ca6e106ea6b1"]
}, Closed]]
}, Closed]]
}
]
*)

