(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    165504,       4338]
NotebookOptionsPosition[    163624,       4275]
NotebookOutlinePosition[    164127,       4296]
CellTagsIndexPosition[    164084,       4293]
WindowTitle->EPM Tools
WindowFrame->Palette*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 TagBox[
  DynamicModuleBox[{Typeset`var$$ = False}, 
   InterpretationBox[
    StyleBox[
     PaneSelectorBox[{False->GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Stylesheets\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}], True->
      GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Stylesheets\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]},
        {"", 
         PaneBox[
          TagBox[GridBox[{
             {
              ButtonBox[
               StyleBox["\<\"Apply EPM styles\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>SetOptions[
                 SelectedNotebook[], StyleDefinitions -> 
                 FrontEnd`FileName[{"EPM"}, "EPM.nb"]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Edit stylesheet\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "EditStyleDefinitions"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Set nb options\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>(SetOptions[
                  SelectedNotebook[], {
                  WindowMargins -> {{0, Automatic}, {Automatic, 0}}, 
                   WindowSize -> {
                    Scaled[0.5], 
                    Scaled[0.67]}}]; SelectionMove[
                  SelectedNotebook[], All, Notebook]; FrontEndTokenExecute[
                  SelectedNotebook[], "OpenCloseGroup"]),
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Column"],
          ImageMargins->0]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}]}, Dynamic[
      Typeset`var$$],
      Alignment->Left,
      BaselinePosition->Baseline,
      DefaultBaseStyle->"OpenerView",
      ImageMargins->4,
      ImageSize->160],
     Deployed->False,
     StripOnInput->False],
    OpenerView[{
      Style[
      "Stylesheets", {
       FontFamily -> "Helvetica Neue", FontColor -> GrayLevel[0.95], FontSize -> 
        16}], 
      Column[{
        Button[
         Style[
         "Apply EPM styles", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         SetOptions[
          SelectedNotebook[], StyleDefinitions -> 
          FrontEnd`FileName[{"EPM"}, "EPM.nb"]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Edit stylesheet", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "EditStyleDefinitions"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Set nb options", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], SetOptions[
           SelectedNotebook[], {
           WindowMargins -> {{0, Automatic}, {Automatic, 0}}, WindowSize -> {
              Scaled[0.5], 
              Scaled[0.67]}}]; SelectionMove[
           SelectedNotebook[], All, Notebook]; FrontEndTokenExecute[
           SelectedNotebook[], "OpenCloseGroup"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}]}]}, False, {
     ImageSize -> 160, ImageMargins -> 4, Alignment -> Left, BaselinePosition -> 
      Center, FrameMargins -> 0}]],
   DynamicModuleValues:>{}],
  Setting[#, {0}]& ]],
 CellMargins->{{0, 0}, {0, 0}},
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 CellHorizontalScrolling->True,
 PageBreakAbove->True,
 PageBreakWithin->False,
 ShowAutoStyles->True,
 LineSpacing->{1.25, 0},
 AutoItalicWords->{},
 ScriptMinSize->9,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["PanelFontFamily"],
 FontSize:>CurrentValue["PanelFontSize"]],

Cell[BoxData[
 TagBox[
  DynamicModuleBox[{Typeset`var$$ = False}, 
   InterpretationBox[
    StyleBox[
     PaneSelectorBox[{False->GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Tools\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}], True->
      GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Tools\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]},
        {"", 
         PaneBox[
          TagBox[GridBox[{
             {
              ButtonBox[
               StyleBox["\<\"Make Figures\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "Tools", 
                   "MakeFigures.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Make Tables\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "Tools", 
                   "MakeTables.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Make Tools Palette\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "Tools", 
                   "CreateToolsPalette.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Bib Tools\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "Tools", 
                   "BibTools.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Create TOC\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "Tools", 
                   "CreateTOC.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Make Ex & Solns\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "Tools", 
                   "CreateExerciseSolutionsNBSingleFile.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Column"],
          ImageMargins->0]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}]}, Dynamic[
      Typeset`var$$],
      Alignment->Left,
      BaselinePosition->Baseline,
      DefaultBaseStyle->"OpenerView",
      ImageMargins->4,
      ImageSize->160],
     Deployed->False,
     StripOnInput->False],
    OpenerView[{
      Style[
      "Tools", {
       FontFamily -> "Helvetica Neue", FontColor -> GrayLevel[0.95], FontSize -> 
        16}], 
      Column[{
        Button[
         Style[
         "Make Figures", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "Tools", 
            "MakeFigures.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Make Tables", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "Tools", 
            "MakeTables.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Make Tools Palette", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "Tools", 
            "CreateToolsPalette.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Bib Tools", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          FileNameJoin[{$UserBaseDirectory, "Applications", "Tools", 
            "BibTools.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Create TOC", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "Tools", 
            "CreateTOC.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Make Ex & Solns", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "Tools", 
            "CreateExerciseSolutionsNBSingleFile.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}]}]}, False, {
     ImageSize -> 160, ImageMargins -> 4, Alignment -> Left, BaselinePosition -> 
      Center, FrameMargins -> 0}]],
   DynamicModuleValues:>{}],
  Setting[#, {0}]& ]],
 CellMargins->{{0, 0}, {0, 0}},
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 CellHorizontalScrolling->True,
 PageBreakAbove->True,
 PageBreakWithin->False,
 ShowAutoStyles->True,
 LineSpacing->{1.25, 0},
 AutoItalicWords->{},
 ScriptMinSize->9,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["PanelFontFamily"],
 FontSize:>CurrentValue["PanelFontSize"]],

Cell[BoxData[
 TagBox[
  DynamicModuleBox[{Typeset`var$$ = False}, 
   InterpretationBox[
    StyleBox[
     PaneSelectorBox[{False->GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Fix TOC\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}], True->
      GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Fix TOC\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]},
        {"", 
         PaneBox[
          TagBox[GridBox[{
             {
              ButtonBox[
               StyleBox["\<\"Fix Preface cell\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>(NotebookFind[
                  SelectedNotebook[], "Preface", All, CellContents]; 
                NotebookWrite[
                  SelectedNotebook[], 
                  Cell[
                   TextData[{"Preface \[CenterDot] ", 
                    StyleBox["vii", FontSlant -> "Italic"]}], 
                   "ContentsChapterNoNum"]]),
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Fix Bib cell\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>(NotebookFind[
                  SelectedNotebook[], "Bibliography", All, CellContents]; 
                FrontEndTokenExecute[
                  SelectedNotebook[], "Style", "ContentsChapterNoNum"]),
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Fix Index cell\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>(NotebookFind[
                  SelectedNotebook[], "Index", All, CellContents, WordSearch -> 
                  True]; FrontEndTokenExecute[
                  SelectedNotebook[], "Style", "ContentsChapterNoNum"]),
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Fix subsects\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookWrite[
                 SelectedNotebook[], 
                 Cell[
                  TextData[
                   Riffle[
                    ReplaceAll[
                    NotebookRead[
                    SelectedNotebook[]], Cell[
                    TextData[{
                    Pattern[$CellContext`xx, 
                    Blank[String]], 
                    BlankNullSequence[]}], 
                    BlankNullSequence[]] :> $CellContext`xx], 
                    StyleBox[" \[CenterDot] ", FontSlant -> Plain]]], 
                  "ContentsSubsection"]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Column"],
          ImageMargins->0]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}]}, Dynamic[
      Typeset`var$$],
      Alignment->Left,
      BaselinePosition->Baseline,
      DefaultBaseStyle->"OpenerView",
      ImageMargins->4,
      ImageSize->160],
     Deployed->False,
     StripOnInput->False],
    OpenerView[{
      Style[
      "Fix TOC", {
       FontFamily -> "Helvetica Neue", FontColor -> GrayLevel[0.95], FontSize -> 
        16}], 
      Column[{
        Button[
         Style[
         "Fix Preface cell", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], NotebookFind[
           SelectedNotebook[], "Preface", All, CellContents]; NotebookWrite[
           SelectedNotebook[], 
           Cell[
            TextData[{"Preface \[CenterDot] ", 
              StyleBox["vii", FontSlant -> "Italic"]}], 
            "ContentsChapterNoNum"]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Fix Bib cell", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], NotebookFind[
           SelectedNotebook[], "Bibliography", All, CellContents]; 
         FrontEndTokenExecute[
           SelectedNotebook[], "Style", "ContentsChapterNoNum"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Fix Index cell", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], NotebookFind[
           SelectedNotebook[], "Index", All, CellContents, WordSearch -> 
           True]; FrontEndTokenExecute[
           SelectedNotebook[], "Style", "ContentsChapterNoNum"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Fix subsects", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookWrite[
          SelectedNotebook[], 
          Cell[
           TextData[
            Riffle[
             ReplaceAll[
              NotebookRead[
               SelectedNotebook[]], Cell[
                TextData[{
                  Pattern[$CellContext`xx, 
                   Blank[String]], 
                  BlankNullSequence[]}], 
                BlankNullSequence[]] :> $CellContext`xx], 
             StyleBox[" \[CenterDot] ", FontSlant -> Plain]]], 
           "ContentsSubsection"]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}]}]}, False, {
     ImageSize -> 160, ImageMargins -> 4, Alignment -> Left, BaselinePosition -> 
      Center, FrameMargins -> 0}]],
   DynamicModuleValues:>{}],
  Setting[#, {0}]& ]],
 CellMargins->{{0, 0}, {0, 0}},
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 CellHorizontalScrolling->True,
 PageBreakAbove->True,
 PageBreakWithin->False,
 ShowAutoStyles->True,
 LineSpacing->{1.25, 0},
 AutoItalicWords->{},
 ScriptMinSize->9,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["PanelFontFamily"],
 FontSize:>CurrentValue["PanelFontSize"]],

Cell[BoxData[
 TagBox[
  DynamicModuleBox[{Typeset`var$$ = False}, 
   InterpretationBox[
    StyleBox[
     PaneSelectorBox[{False->GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Paging Tools\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}], True->
      GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Paging Tools\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]},
        {"", 
         PaneBox[
          TagBox[GridBox[{
             {
              ButtonBox[
               StyleBox["\<\"Add PageBreak\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "PageBreak"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Open MakeProject Pal\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$InstallationDirectory, "AddOns", 
                   "Applications", "AuthorTools", "FrontEnd", "TextResources",
                    "MakeProject.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Open Paginate Pal\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$InstallationDirectory, "AddOns", 
                   "Applications", "AuthorTools", "FrontEnd", "TextResources",
                    "Paginate.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Open Contents Pal\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 FileNameJoin[{$InstallationDirectory, "AddOns", 
                   "Applications", "AuthorTools", "FrontEnd", "TextResources",
                    "MakeContents.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Open Index Pal\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$InstallationDirectory, "AddOns", 
                   "Applications", "AuthorTools", "FrontEnd", "TextResources",
                    "MakeIndex.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Add TOP\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>SetOptions[
                 NotebookSelection[
                  InputNotebook[]], "TOP"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Remove TOP\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>With[{$CellContext`nb = SelectedNotebook[]}, 
                 NotebookWrite[$CellContext`nb, 
                  DeleteCases[
                   NotebookRead[$CellContext`nb], "TOP", Infinity]]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Add BOTTOM\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>SetOptions[
                 NotebookSelection[
                  InputNotebook[]], "BOTTOM"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Remove BOTTOM\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>With[{$CellContext`nb = SelectedNotebook[]}, 
                 NotebookWrite[$CellContext`nb, 
                  DeleteCases[
                   NotebookRead[$CellContext`nb], "BOTTOM", Infinity]]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Add CellMargin Edit\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>SetOptions[
                 NotebookSelection[
                  InputNotebook[]], 
                 CellBracketOptions -> {"Color" -> RGBColor[1, 0, 1]}],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Remove CellMarginEdit\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>With[{$CellContext`nb = SelectedNotebook[]}, 
                 NotebookWrite[$CellContext`nb, 
                  DeleteCases[
                   NotebookRead[$CellContext`nb], CellBracketOptions -> 
                   Blank[], Infinity]]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Column"],
          ImageMargins->0]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}]}, Dynamic[
      Typeset`var$$],
      Alignment->Left,
      BaselinePosition->Baseline,
      DefaultBaseStyle->"OpenerView",
      ImageMargins->4,
      ImageSize->160],
     Deployed->False,
     StripOnInput->False],
    OpenerView[{
      Style[
      "Paging Tools", {
       FontFamily -> "Helvetica Neue", FontColor -> GrayLevel[0.95], FontSize -> 
        16}], 
      Column[{
        Button[
         Style[
         "Add PageBreak", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "PageBreak"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Open MakeProject Pal", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$InstallationDirectory, "AddOns", "Applications", 
            "AuthorTools", "FrontEnd", "TextResources", "MakeProject.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Open Paginate Pal", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$InstallationDirectory, "AddOns", "Applications", 
            "AuthorTools", "FrontEnd", "TextResources", "Paginate.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Open Contents Pal", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$InstallationDirectory, "AddOns", "Applications", 
            "AuthorTools", "FrontEnd", "TextResources", 
            "MakeContents.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Open Index Pal", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$InstallationDirectory, "AddOns", "Applications", 
            "AuthorTools", "FrontEnd", "TextResources", "MakeIndex.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Add TOP", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         SetOptions[
          NotebookSelection[
           InputNotebook[]], "TOP"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Remove TOP", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         With[{$CellContext`nb = SelectedNotebook[]}, 
          NotebookWrite[$CellContext`nb, 
           DeleteCases[
            NotebookRead[$CellContext`nb], "TOP", Infinity]]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Add BOTTOM", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         SetOptions[
          NotebookSelection[
           InputNotebook[]], "BOTTOM"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Remove BOTTOM", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         With[{$CellContext`nb = SelectedNotebook[]}, 
          NotebookWrite[$CellContext`nb, 
           DeleteCases[
            NotebookRead[$CellContext`nb], "BOTTOM", Infinity]]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Add CellMargin Edit", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         SetOptions[
          NotebookSelection[
           InputNotebook[]], 
          CellBracketOptions -> {"Color" -> RGBColor[1, 0, 1]}], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Remove CellMarginEdit", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         With[{$CellContext`nb = SelectedNotebook[]}, 
          NotebookWrite[$CellContext`nb, 
           DeleteCases[
            NotebookRead[$CellContext`nb], CellBracketOptions -> Blank[], 
            Infinity]]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}]}]}, False, {
     ImageSize -> 160, ImageMargins -> 4, Alignment -> Left, BaselinePosition -> 
      Center, FrameMargins -> 0}]],
   DynamicModuleValues:>{}],
  Setting[#, {0}]& ]],
 CellMargins->{{0, 0}, {0, 0}},
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 CellHorizontalScrolling->True,
 PageBreakAbove->True,
 PageBreakWithin->False,
 ShowAutoStyles->True,
 LineSpacing->{1.25, 0},
 AutoItalicWords->{},
 ScriptMinSize->9,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["PanelFontFamily"],
 FontSize:>CurrentValue["PanelFontSize"]],

Cell[BoxData[
 TagBox[
  DynamicModuleBox[{Typeset`var$$ = False}, 
   InterpretationBox[
    StyleBox[
     PaneSelectorBox[{False->GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Chapters \[Dash] Intro\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}], True->
      GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Chapters \[Dash] Intro\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]},
        {"", 
         PaneBox[
          TagBox[GridBox[{
             {
              ButtonBox[
               StyleBox["\<\"0   Preface\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "EPMIntro",
                    "00Preface.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"1   Introduction\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "EPMIntro",
                    "01Introduction.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"2   Language\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "EPMIntro",
                    "02Language.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"3   Lists\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 FileNameJoin[{$UserBaseDirectory, "Applications", "EPMIntro",
                    "03Lists.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"4   Patterns and rules\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "EPMIntro",
                    "04PatternsAndRules.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"5   Functions\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "EPMIntro",
                    "05Functions.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"6   Programs\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "EPMIntro",
                    "06Programs.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"7   Strings\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "EPMIntro",
                    "07Strings.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"8   Graphics\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "EPMIntro",
                    "08Graphics.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"9   Program Optimization\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "EPMIntro",
                    "09ProgramOptimization.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"10  Packages\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "EPMIntro",
                    "10Packages.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"    Bibliography\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "EPMIntro",
                    "Bibliography.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"    Bibliography Source\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "EPMIntro",
                    "BibliographySource.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"    Solutions\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "EPMIntro",
                    "Solutions.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Column"],
          ImageMargins->0]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}]}, Dynamic[
      Typeset`var$$],
      Alignment->Left,
      BaselinePosition->Baseline,
      DefaultBaseStyle->"OpenerView",
      ImageMargins->4,
      ImageSize->160],
     Deployed->False,
     StripOnInput->False],
    OpenerView[{
      Style[
      "Chapters \[Dash] Intro", {
       FontFamily -> "Helvetica Neue", FontColor -> GrayLevel[0.95], FontSize -> 
        16}], 
      Column[{
        Button[
         Style[
         "0   Preface", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "EPMIntro", 
            "00Preface.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "1   Introduction", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "EPMIntro", 
            "01Introduction.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "2   Language", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "EPMIntro", 
            "02Language.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "3   Lists", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "EPMIntro", 
            "03Lists.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "4   Patterns and rules", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "EPMIntro", 
            "04PatternsAndRules.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "5   Functions", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "EPMIntro", 
            "05Functions.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "6   Programs", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "EPMIntro", 
            "06Programs.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "7   Strings", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "EPMIntro", 
            "07Strings.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "8   Graphics", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "EPMIntro", 
            "08Graphics.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "9   Program Optimization", ShowStringCharacters -> False, 
          FontFamily -> "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], 
          FontSize -> 12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "EPMIntro", 
            "09ProgramOptimization.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "10  Packages", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "EPMIntro", 
            "10Packages.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "    Bibliography", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "EPMIntro", 
            "Bibliography.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "    Bibliography Source", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "EPMIntro", 
            "BibliographySource.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "    Solutions", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "EPMIntro", 
            "Solutions.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}]}]}, False, {
     ImageSize -> 160, ImageMargins -> 4, Alignment -> Left, BaselinePosition -> 
      Center, FrameMargins -> 0}]],
   DynamicModuleValues:>{}],
  Setting[#, {0}]& ]],
 CellMargins->{{0, 0}, {0, 0}},
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 CellHorizontalScrolling->True,
 PageBreakAbove->True,
 PageBreakWithin->False,
 ShowAutoStyles->True,
 LineSpacing->{1.25, 0},
 AutoItalicWords->{},
 ScriptMinSize->9,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["PanelFontFamily"],
 FontSize:>CurrentValue["PanelFontSize"]],

Cell[BoxData[
 TagBox[
  DynamicModuleBox[{Typeset`var$$ = False}, 
   InterpretationBox[
    StyleBox[
     PaneSelectorBox[{False->GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Packages\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}], True->
      GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Packages\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]},
        {"", 
         PaneBox[
          TagBox[GridBox[{
             {
              ButtonBox[
               StyleBox["\<\"1 Introduction\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "EPM", 
                   "Introduction.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"2 Language\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "EPM", 
                   "Language.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"3 Lists\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "EPM", 
                   "Lists.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"4 Patterns and rules\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "EPM", 
                   "Patterns.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"5 Functions\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "EPM", 
                   "Functions.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"6 Programs\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "EPM", 
                   "Programs.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"7 Strings\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "EPM", 
                   "Strings.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"8 Graphics\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "EPM", 
                   "Graphics.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"9 Optimization\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "EPM", 
                   "Optimization.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"    Collatz\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "EPM", 
                   "Collatz.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"    RandomWalks\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "EPM", 
                   "RandomWalks.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"    StemPlots\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "EPM", 
                   "StemPlots.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Column"],
          ImageMargins->0]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}]}, Dynamic[
      Typeset`var$$],
      Alignment->Left,
      BaselinePosition->Baseline,
      DefaultBaseStyle->"OpenerView",
      ImageMargins->4,
      ImageSize->160],
     Deployed->False,
     StripOnInput->False],
    OpenerView[{
      Style[
      "Packages", {
       FontFamily -> "Helvetica Neue", FontColor -> GrayLevel[0.95], FontSize -> 
        16}], 
      Column[{
        Button[
         Style[
         "1 Introduction", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "EPM", 
            "Introduction.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "2 Language", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "EPM", 
            "Language.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "3 Lists", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "EPM", 
            "Lists.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "4 Patterns and rules", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "EPM", 
            "Patterns.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "5 Functions", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "EPM", 
            "Functions.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "6 Programs", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "EPM", 
            "Programs.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "7 Strings", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "EPM", 
            "Strings.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "8 Graphics", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "EPM", 
            "Graphics.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "9 Optimization", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "EPM", 
            "Optimization.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "    Collatz", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "EPM", 
            "Collatz.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "    RandomWalks", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "EPM", 
            "RandomWalks.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "    StemPlots", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "EPM", 
            "StemPlots.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}]}]}, False, {
     ImageSize -> 160, ImageMargins -> 4, Alignment -> Left, BaselinePosition -> 
      Center, FrameMargins -> 0}]],
   DynamicModuleValues:>{}],
  Setting[#, {0}]& ]],
 CellMargins->{{0, 0}, {0, 0}},
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 CellHorizontalScrolling->True,
 PageBreakAbove->True,
 PageBreakWithin->False,
 ShowAutoStyles->True,
 LineSpacing->{1.25, 0},
 AutoItalicWords->{},
 ScriptMinSize->9,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["PanelFontFamily"],
 FontSize:>CurrentValue["PanelFontSize"]],

Cell[BoxData[
 TagBox[
  DynamicModuleBox[{Typeset`var$$ = False}, 
   InterpretationBox[
    StyleBox[
     PaneSelectorBox[{False->GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Chapters \[Dash] Apps\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}], True->
      GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Chapters \[Dash] Apps\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]},
        {"", 
         PaneBox[
          TagBox[GridBox[{
             {
              ButtonBox[
               StyleBox["\<\"01 Random Walks\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "APM", 
                   "Chapters", "01RandomWalks.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"02 Networks\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "APM", 
                   "Chapters", "02Networks.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Bibliography Source\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "APM", 
                   "Chapters", "BibliographySource.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Chapter Template\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 FileNameJoin[{$UserBaseDirectory, "Applications", "APM", 
                   "Chapters", "ChapterTemplate.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Networks\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                 
                 FileNameJoin[{$UserBaseDirectory, "Applications", "APM", 
                   "Chapters", "Networks.nb"}]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Column"],
          ImageMargins->0]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}]}, Dynamic[
      Typeset`var$$],
      Alignment->Left,
      BaselinePosition->Baseline,
      DefaultBaseStyle->"OpenerView",
      ImageMargins->4,
      ImageSize->160],
     Deployed->False,
     StripOnInput->False],
    OpenerView[{
      Style[
      "Chapters \[Dash] Apps", {
       FontFamily -> "Helvetica Neue", FontColor -> GrayLevel[0.95], FontSize -> 
        16}], 
      Column[{
        Button[
         Style[
         "01 Random Walks", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "APM", "Chapters",
             "01RandomWalks.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "02 Networks", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "APM", "Chapters",
             "02Networks.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Bibliography Source", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "APM", "Chapters",
             "BibliographySource.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Chapter Template", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "APM", "Chapters",
             "ChapterTemplate.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Networks", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
          
          FileNameJoin[{$UserBaseDirectory, "Applications", "APM", "Chapters",
             "Networks.nb"}]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}]}]}, False, {
     ImageSize -> 160, ImageMargins -> 4, Alignment -> Left, BaselinePosition -> 
      Center, FrameMargins -> 0}]],
   DynamicModuleValues:>{}],
  Setting[#, {0}]& ]],
 CellMargins->{{0, 0}, {0, 0}},
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 CellHorizontalScrolling->True,
 PageBreakAbove->True,
 PageBreakWithin->False,
 ShowAutoStyles->True,
 LineSpacing->{1.25, 0},
 AutoItalicWords->{},
 ScriptMinSize->9,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["PanelFontFamily"],
 FontSize:>CurrentValue["PanelFontSize"]],

Cell[BoxData[
 TagBox[
  DynamicModuleBox[{Typeset`var$$ = False}, 
   InterpretationBox[
    StyleBox[
     PaneSelectorBox[{False->GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Environments\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}], True->
      GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Environments\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]},
        {"", 
         PaneBox[
          TagBox[GridBox[{
             {
              ButtonBox[
               StyleBox["\<\"Working\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>(CurrentValue[
                   InputNotebook[], ScreenStyleEnvironment] = "Working"; 
                SetOptions[
                  InputNotebook[], {Magnification -> 1.25}]),
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Printout\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>(CurrentValue[
                   InputNotebook[], ScreenStyleEnvironment] = "Printout"; 
                SetOptions[
                  InputNotebook[], {Magnification -> 1.5}]),
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"PrintToPDF\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>(CurrentValue[
                   InputNotebook[], ScreenStyleEnvironment] = "PrintToPDF"; 
                SetOptions[
                  InputNotebook[], {Magnification -> 1.5}]),
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Column"],
          ImageMargins->0]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}]}, Dynamic[
      Typeset`var$$],
      Alignment->Left,
      BaselinePosition->Baseline,
      DefaultBaseStyle->"OpenerView",
      ImageMargins->4,
      ImageSize->160],
     Deployed->False,
     StripOnInput->False],
    OpenerView[{
      Style[
      "Environments", {
       FontFamily -> "Helvetica Neue", FontColor -> GrayLevel[0.95], FontSize -> 
        16}], 
      Column[{
        Button[
         Style[
         "Working", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], CurrentValue[
            InputNotebook[], ScreenStyleEnvironment] = "Working"; SetOptions[
           InputNotebook[], {Magnification -> 1.25}], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Printout", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], CurrentValue[
            InputNotebook[], ScreenStyleEnvironment] = "Printout"; 
         SetOptions[
           InputNotebook[], {Magnification -> 1.5}], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "PrintToPDF", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], CurrentValue[
            InputNotebook[], ScreenStyleEnvironment] = "PrintToPDF"; 
         SetOptions[
           InputNotebook[], {Magnification -> 1.5}], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}]}]}, False, {
     ImageSize -> 160, ImageMargins -> 4, Alignment -> Left, BaselinePosition -> 
      Center, FrameMargins -> 0}]],
   DynamicModuleValues:>{}],
  Setting[#, {0}]& ]],
 CellMargins->{{0, 0}, {0, 0}},
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 CellHorizontalScrolling->True,
 PageBreakAbove->True,
 PageBreakWithin->False,
 ShowAutoStyles->True,
 LineSpacing->{1.25, 0},
 AutoItalicWords->{},
 ScriptMinSize->9,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["PanelFontFamily"],
 FontSize:>CurrentValue["PanelFontSize"]],

Cell[BoxData[
 TagBox[
  DynamicModuleBox[{Typeset`var$$ = False}, 
   InterpretationBox[
    StyleBox[
     PaneSelectorBox[{False->GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Headings\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}], True->
      GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Headings\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]},
        {"", 
         PaneBox[
          TagBox[GridBox[{
             {
              ButtonBox[
               StyleBox["\<\"ChapterTitle\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "ChapterTitle"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"ChapterAbstract\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "ChapterAbstract"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Section\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "Section"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Subsection\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "Subsection"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Subsubsection\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "Subsubsection"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"ChapterTitleNoNum\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "ChapterTitleNoNum"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{0.2}}}],
           "Column"],
          ImageMargins->0]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}]}, Dynamic[
      Typeset`var$$],
      Alignment->Left,
      BaselinePosition->Baseline,
      DefaultBaseStyle->"OpenerView",
      ImageMargins->4,
      ImageSize->160],
     Deployed->False,
     StripOnInput->False],
    OpenerView[{
      Style[
      "Headings", {
       FontFamily -> "Helvetica Neue", FontColor -> GrayLevel[0.95], FontSize -> 
        16}], 
      Column[{
        Button[
         Style[
         "ChapterTitle", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "ChapterTitle"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "ChapterAbstract", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "ChapterAbstract"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Section", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "Section"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Subsection", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "Subsection"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Subsubsection", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "Subsubsection"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "ChapterTitleNoNum", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "ChapterTitleNoNum"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}]}, {Spacings -> {0, 0.2}}]}, False, {
     ImageSize -> 160, ImageMargins -> 4, Alignment -> Left, BaselinePosition -> 
      Center, FrameMargins -> 0}]],
   DynamicModuleValues:>{}],
  Setting[#, {0}]& ]],
 CellMargins->{{0, 0}, {0, 0}},
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 CellHorizontalScrolling->True,
 PageBreakAbove->True,
 PageBreakWithin->False,
 ShowAutoStyles->True,
 LineSpacing->{1.25, 0},
 AutoItalicWords->{},
 ScriptMinSize->9,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["PanelFontFamily"],
 FontSize:>CurrentValue["PanelFontSize"]],

Cell[BoxData[
 TagBox[
  DynamicModuleBox[{Typeset`var$$ = False}, 
   InterpretationBox[
    StyleBox[
     PaneSelectorBox[{False->GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Text\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}], True->
      GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Text\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]},
        {"", 
         PaneBox[
          TagBox[GridBox[{
             {
              ButtonBox[
               StyleBox["\<\"TextFirst\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "TextFirst"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Text\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "Text"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Item\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "Item"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"SubItem\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "SubItem"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"NumberedItem\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "NumberedItem"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"References\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "References"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Tip Template\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookWrite[
                 InputNotebook[], {
                  Cell["", "TipStart"], 
                  Cell["", "NumberedTip"], 
                  Cell[
                  "Lorem ipsum dolor sit amet, consectetur adipiscing elit, \
sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. ", 
                   "TipText"], 
                  Cell["", "TipEnd"]}],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{0.2}}}],
           "Column"],
          ImageMargins->0]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}]}, Dynamic[
      Typeset`var$$],
      Alignment->Left,
      BaselinePosition->Baseline,
      DefaultBaseStyle->"OpenerView",
      ImageMargins->4,
      ImageSize->160],
     Deployed->False,
     StripOnInput->False],
    OpenerView[{
      Style[
      "Text", {FontFamily -> "Helvetica Neue", FontColor -> GrayLevel[0.95], 
        FontSize -> 16}], 
      Column[{
        Button[
         Style[
         "TextFirst", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "TextFirst"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Text", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "Text"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Item", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "Item"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "SubItem", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "SubItem"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "NumberedItem", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "NumberedItem"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "References", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "References"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Tip Template", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookWrite[
          InputNotebook[], {
           Cell["", "TipStart"], 
           Cell["", "NumberedTip"], 
           Cell[
           "Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do \
eiusmod tempor incididunt ut labore et dolore magna aliqua. ", "TipText"], 
           Cell["", "TipEnd"]}], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}]}, {Spacings -> {0, 0.2}}]}, False, {
     ImageSize -> 160, ImageMargins -> 4, Alignment -> Left, BaselinePosition -> 
      Center, FrameMargins -> 0}]],
   DynamicModuleValues:>{}],
  Setting[#, {0}]& ]],
 CellMargins->{{0, 0}, {0, 0}},
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 CellHorizontalScrolling->True,
 PageBreakAbove->True,
 PageBreakWithin->False,
 ShowAutoStyles->True,
 LineSpacing->{1.25, 0},
 AutoItalicWords->{},
 ScriptMinSize->9,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["PanelFontFamily"],
 FontSize:>CurrentValue["PanelFontSize"]],

Cell[BoxData[
 TagBox[
  DynamicModuleBox[{Typeset`var$$ = False}, 
   InterpretationBox[
    StyleBox[
     PaneSelectorBox[{False->GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Inline formatting\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}], True->
      GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Inline formatting\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]},
        {"", 
         PaneBox[
          TagBox[GridBox[{
             {
              ButtonBox[
               StyleBox["\<\"MRInd\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "MRInd"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"TI\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "TI"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"MR\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "MR"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Menu\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "Menu"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"OsF\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "OsF"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"SmallCaps\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "SmallCaps"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"SubsubBold\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "SubsubBold"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{0.2}}}],
           "Column"],
          ImageMargins->0]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}]}, Dynamic[
      Typeset`var$$],
      Alignment->Left,
      BaselinePosition->Baseline,
      DefaultBaseStyle->"OpenerView",
      ImageMargins->4,
      ImageSize->160],
     Deployed->False,
     StripOnInput->False],
    OpenerView[{
      Style[
      "Inline formatting", {
       FontFamily -> "Helvetica Neue", FontColor -> GrayLevel[0.95], FontSize -> 
        16}], 
      Column[{
        Button[
         Style[
         "MRInd", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "MRInd"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "TI", ShowStringCharacters -> False, FontFamily -> "Helvetica Neue", 
          FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "TI"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "MR", ShowStringCharacters -> False, FontFamily -> "Helvetica Neue", 
          FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "MR"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Menu", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "Menu"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "OsF", ShowStringCharacters -> False, FontFamily -> "Helvetica Neue",
           FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "OsF"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "SmallCaps", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "SmallCaps"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "SubsubBold", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "SubsubBold"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}]}, {Spacings -> {0, 0.2}}]}, False, {
     ImageSize -> 160, ImageMargins -> 4, Alignment -> Left, BaselinePosition -> 
      Center, FrameMargins -> 0}]],
   DynamicModuleValues:>{}],
  Setting[#, {0}]& ]],
 CellMargins->{{0, 0}, {0, 0}},
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 CellHorizontalScrolling->True,
 PageBreakAbove->True,
 PageBreakWithin->False,
 ShowAutoStyles->True,
 LineSpacing->{1.25, 0},
 AutoItalicWords->{},
 ScriptMinSize->9,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["PanelFontFamily"],
 FontSize:>CurrentValue["PanelFontSize"]],

Cell[BoxData[
 TagBox[
  DynamicModuleBox[{Typeset`var$$ = False}, 
   InterpretationBox[
    StyleBox[
     PaneSelectorBox[{False->GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Tables/Figures\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}], True->
      GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Tables/Figures\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]},
        {"", 
         PaneBox[
          TagBox[GridBox[{
             {
              ButtonBox[
               StyleBox["\<\"NumberedFigure\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "NumberedFigure"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Figure\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "Figure"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"NumberedTable\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "NumberedTable"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"DisplayTable\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "DisplayTable"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Picture\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "Picture"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{0.2}}}],
           "Column"],
          ImageMargins->0]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}]}, Dynamic[
      Typeset`var$$],
      Alignment->Left,
      BaselinePosition->Baseline,
      DefaultBaseStyle->"OpenerView",
      ImageMargins->4,
      ImageSize->160],
     Deployed->False,
     StripOnInput->False],
    OpenerView[{
      Style[
      "Tables/Figures", {
       FontFamily -> "Helvetica Neue", FontColor -> GrayLevel[0.95], FontSize -> 
        16}], 
      Column[{
        Button[
         Style[
         "NumberedFigure", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "NumberedFigure"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Figure", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "Figure"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "NumberedTable", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "NumberedTable"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "DisplayTable", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "DisplayTable"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Picture", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "Picture"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}]}, {Spacings -> {0, 0.2}}]}, False, {
     ImageSize -> 160, ImageMargins -> 4, Alignment -> Left, BaselinePosition -> 
      Center, FrameMargins -> 0}]],
   DynamicModuleValues:>{}],
  Setting[#, {0}]& ]],
 CellMargins->{{0, 0}, {0, 0}},
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 CellHorizontalScrolling->True,
 PageBreakAbove->True,
 PageBreakWithin->False,
 ShowAutoStyles->True,
 LineSpacing->{1.25, 0},
 AutoItalicWords->{},
 ScriptMinSize->9,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["PanelFontFamily"],
 FontSize:>CurrentValue["PanelFontSize"]],

Cell[BoxData[
 TagBox[
  DynamicModuleBox[{Typeset`var$$ = False}, 
   InterpretationBox[
    StyleBox[
     PaneSelectorBox[{False->GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"NonPrint styles\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}], True->
      GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"NonPrint styles\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]},
        {"", 
         PaneBox[
          TagBox[GridBox[{
             {
              ButtonBox[
               StyleBox["\<\"SectionSpacer\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "SectionSpacer"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"SubsectionSpacer\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "SubsectionSpacer"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Editorial\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "Editorial"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"NonPrintInput\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "NonPrintInput"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{0.2}}}],
           "Column"],
          ImageMargins->0]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}]}, Dynamic[
      Typeset`var$$],
      Alignment->Left,
      BaselinePosition->Baseline,
      DefaultBaseStyle->"OpenerView",
      ImageMargins->4,
      ImageSize->160],
     Deployed->False,
     StripOnInput->False],
    OpenerView[{
      Style[
      "NonPrint styles", {
       FontFamily -> "Helvetica Neue", FontColor -> GrayLevel[0.95], FontSize -> 
        16}], 
      Column[{
        Button[
         Style[
         "SectionSpacer", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "SectionSpacer"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "SubsectionSpacer", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "SubsectionSpacer"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Editorial", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "Editorial"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "NonPrintInput", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "NonPrintInput"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}]}, {Spacings -> {0, 0.2}}]}, False, {
     ImageSize -> 160, ImageMargins -> 4, Alignment -> Left, BaselinePosition -> 
      Center, FrameMargins -> 0}]],
   DynamicModuleValues:>{}],
  Setting[#, {0}]& ]],
 CellMargins->{{0, 0}, {0, 0}},
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 CellHorizontalScrolling->True,
 PageBreakAbove->True,
 PageBreakWithin->False,
 ShowAutoStyles->True,
 LineSpacing->{1.25, 0},
 AutoItalicWords->{},
 ScriptMinSize->9,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["PanelFontFamily"],
 FontSize:>CurrentValue["PanelFontSize"]],

Cell[BoxData[
 TagBox[
  DynamicModuleBox[{Typeset`var$$ = False}, 
   InterpretationBox[
    StyleBox[
     PaneSelectorBox[{False->GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Exercises\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}], True->
      GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Exercises\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]},
        {"", 
         PaneBox[
          TagBox[GridBox[{
             {
              ButtonBox[
               StyleBox["\<\"ExerciseSubsection\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "ExerciseSubsection"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"ExerciseItem\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "ExerciseItem"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"ExerciseSubItem\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "ExerciseSubItem"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"ExerciseText\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "ExerciseText"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"ExerciseDisplayFormula\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "ExerciseDisplayFormula"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"ExerciseInput\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "ExerciseInput"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"ExerciseOutput\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "ExerciseOutput"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"ExerciseTI\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "ExerciseTI"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"ExerciseMR\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "ExerciseMR"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"ExerciseFigure\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "ExerciseFigure"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"ExFigure\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "ExFigure"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"ExerciseTable\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "ExerciseTable"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"ExTable\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "ExTable"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Add ExerciseMR\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>SetOptions[
                 NotebookSelection[
                  InputNotebook[]], "ExerciseMR"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{0.2}}}],
           "Column"],
          ImageMargins->0]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}]}, Dynamic[
      Typeset`var$$],
      Alignment->Left,
      BaselinePosition->Baseline,
      DefaultBaseStyle->"OpenerView",
      ImageMargins->4,
      ImageSize->160],
     Deployed->False,
     StripOnInput->False],
    OpenerView[{
      Style[
      "Exercises", {
       FontFamily -> "Helvetica Neue", FontColor -> GrayLevel[0.95], FontSize -> 
        16}], 
      Column[{
        Button[
         Style[
         "ExerciseSubsection", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "ExerciseSubsection"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "ExerciseItem", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "ExerciseItem"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "ExerciseSubItem", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "ExerciseSubItem"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "ExerciseText", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "ExerciseText"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "ExerciseDisplayFormula", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "ExerciseDisplayFormula"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "ExerciseInput", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "ExerciseInput"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "ExerciseOutput", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "ExerciseOutput"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "ExerciseTI", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "ExerciseTI"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "ExerciseMR", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "ExerciseMR"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "ExerciseFigure", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "ExerciseFigure"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "ExFigure", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "ExFigure"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "ExerciseTable", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "ExerciseTable"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "ExTable", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "ExTable"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Add ExerciseMR", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         SetOptions[
          NotebookSelection[
           InputNotebook[]], "ExerciseMR"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}]}, {Spacings -> {0, 0.2}}]}, False, {
     ImageSize -> 160, ImageMargins -> 4, Alignment -> Left, BaselinePosition -> 
      Center, FrameMargins -> 0}]],
   DynamicModuleValues:>{}],
  Setting[#, {0}]& ]],
 CellMargins->{{0, 0}, {0, 0}},
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 CellHorizontalScrolling->True,
 PageBreakAbove->True,
 PageBreakWithin->False,
 ShowAutoStyles->True,
 LineSpacing->{1.25, 0},
 AutoItalicWords->{},
 ScriptMinSize->9,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["PanelFontFamily"],
 FontSize:>CurrentValue["PanelFontSize"]],

Cell[BoxData[
 TagBox[
  DynamicModuleBox[{Typeset`var$$ = False}, 
   InterpretationBox[
    StyleBox[
     PaneSelectorBox[{False->GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Solutions\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}], True->
      GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Solutions\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]},
        {"", 
         PaneBox[
          TagBox[GridBox[{
             {
              ButtonBox[
               StyleBox["\<\"Chapter\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "Chapter"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Section\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "Section"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"SolutionItem\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "SolutionItem"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"SolutionText\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>FrontEndTokenExecute[
                 InputNotebook[], "Style", "SolutionText"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Add SolutionNonPrint\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>SetOptions[
                 NotebookSelection[
                  InputNotebook[]], "SolutionNonPrint"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Remove SolutionNP\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>With[{$CellContext`nb = SelectedNotebook[]}, 
                 NotebookWrite[$CellContext`nb, 
                  DeleteCases[
                   NotebookRead[$CellContext`nb], "SolutionNonPrint", 
                   Infinity]]],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{0.2}}}],
           "Column"],
          ImageMargins->0]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}]}, Dynamic[
      Typeset`var$$],
      Alignment->Left,
      BaselinePosition->Baseline,
      DefaultBaseStyle->"OpenerView",
      ImageMargins->4,
      ImageSize->160],
     Deployed->False,
     StripOnInput->False],
    OpenerView[{
      Style[
      "Solutions", {
       FontFamily -> "Helvetica Neue", FontColor -> GrayLevel[0.95], FontSize -> 
        16}], 
      Column[{
        Button[
         Style[
         "Chapter", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "Chapter"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Section", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "Section"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "SolutionItem", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "SolutionItem"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "SolutionText", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         FrontEndTokenExecute[
          InputNotebook[], "Style", "SolutionText"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Add SolutionNonPrint", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         SetOptions[
          NotebookSelection[
           InputNotebook[]], "SolutionNonPrint"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Remove SolutionNP", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         With[{$CellContext`nb = SelectedNotebook[]}, 
          NotebookWrite[$CellContext`nb, 
           DeleteCases[
            NotebookRead[$CellContext`nb], "SolutionNonPrint", Infinity]]], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}]}, {Spacings -> {0, 0.2}}]}, False, {
     ImageSize -> 160, ImageMargins -> 4, Alignment -> Left, BaselinePosition -> 
      Center, FrameMargins -> 0}]],
   DynamicModuleValues:>{}],
  Setting[#, {0}]& ]],
 CellMargins->{{0, 0}, {0, 0}},
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 CellHorizontalScrolling->True,
 PageBreakAbove->True,
 PageBreakWithin->False,
 ShowAutoStyles->True,
 LineSpacing->{1.25, 0},
 AutoItalicWords->{},
 ScriptMinSize->9,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["PanelFontFamily"],
 FontSize:>CurrentValue["PanelFontSize"]]
},
Saveable->False,
WindowSize->{Fit, 450},
WindowMargins->{{Automatic, 0}, {Automatic, 0}},
WindowElements->{"VerticalScrollBar", "MagnificationPopUp"},
WindowTitle->"EPM Tools",
Magnification->1,
Background->GrayLevel[0.2],
FrontEndVersion->"10.1 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 23, \
2015)",
StyleDefinitions->"Palette.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[582, 21, 6529, 172, 28, InheritFromParent,
 PageBreakAbove->True,
 PageBreakWithin->False],
Cell[7114, 195, 9733, 258, 28, InheritFromParent,
 PageBreakAbove->True,
 PageBreakWithin->False],
Cell[16850, 455, 8771, 227, 28, InheritFromParent,
 PageBreakAbove->True,
 PageBreakWithin->False],
Cell[25624, 684, 16012, 402, 28, InheritFromParent,
 PageBreakAbove->True,
 PageBreakWithin->False],
Cell[41639, 1088, 19085, 490, 28, InheritFromParent,
 PageBreakAbove->True,
 PageBreakWithin->False],
Cell[60727, 1580, 16475, 433, 28, InheritFromParent,
 PageBreakAbove->True,
 PageBreakWithin->False],
Cell[77205, 2015, 8707, 229, 28, InheritFromParent,
 PageBreakAbove->True,
 PageBreakWithin->False],
Cell[85915, 2246, 6384, 168, 28, InheritFromParent,
 PageBreakAbove->True,
 PageBreakWithin->False],
Cell[92302, 2416, 9079, 236, 28, InheritFromParent,
 PageBreakAbove->True,
 PageBreakWithin->False],
Cell[101384, 2654, 10517, 273, 28, InheritFromParent,
 PageBreakAbove->True,
 PageBreakWithin->False],
Cell[111904, 2929, 9896, 258, 28, InheritFromParent,
 PageBreakAbove->True,
 PageBreakWithin->False],
Cell[121803, 3189, 8030, 211, 28, InheritFromParent,
 PageBreakAbove->True,
 PageBreakWithin->False],
Cell[129836, 3402, 7050, 186, 28, InheritFromParent,
 PageBreakAbove->True,
 PageBreakWithin->False],
Cell[136889, 3590, 17369, 438, 28, InheritFromParent,
 PageBreakAbove->True,
 PageBreakWithin->False],
Cell[154261, 4030, 9359, 243, 28, InheritFromParent,
 PageBreakAbove->True,
 PageBreakWithin->False]
}
]
*)

(* End of internal cache information *)

