(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    126280,       3301]
NotebookOptionsPosition[    124794,       3250]
NotebookOutlinePosition[    125308,       3271]
CellTagsIndexPosition[    125265,       3268]
WindowTitle->Sandbox Notebooks
WindowFrame->Palette*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 TagBox[
  DynamicModuleBox[{Typeset`var$$ = False}, 
   InterpretationBox[
    StyleBox[
     PaneSelectorBox[{False->GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Bioinformatics\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}], True->
      GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Bioinformatics\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]},
        {"", 
         PaneBox[
          TagBox[GridBox[{
             {
              ButtonBox[
               StyleBox["\<\"BacteriophageLambdaGC\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Bioinformatics/BacteriophageLambdaGC.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"BasicGenomics\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Bioinformatics/BasicGenomics.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Bioinformatics\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Bioinformatics/Bioinformatics.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"ColoringResidues\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Bioinformatics/ColoringResidues.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"EbolaVirus\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Bioinformatics/EbolaVirus.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Markov Models\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Bioinformatics/Markov Models.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"PPIs\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Bioinformatics/PPIs.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"RamachandranPlot\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Bioinformatics/RamachandranPlot.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"RNACodon\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Bioinformatics/RNACodon.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"S120Overview\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Bioinformatics/S120Overview.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"SequenceDisplay\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Bioinformatics/SequenceDisplay.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"StemCell\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Bioinformatics/StemCell.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"VisualizingMicroarrayData\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Bioinformatics/VisualizingMicroarrayData.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{0.2}}}],
           "Column"],
          ImageMargins->0]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}]}, Dynamic[
      Typeset`var$$],
      Alignment->Left,
      BaselinePosition->Baseline,
      DefaultBaseStyle->"OpenerView",
      ImageMargins->4,
      ImageSize->160],
     Deployed->False,
     StripOnInput->False],
    OpenerView[{
      Style[
      "Bioinformatics", {
       FontFamily -> "Helvetica Neue", FontColor -> GrayLevel[0.95], FontSize -> 
        16}], 
      Column[{
        Button[
         Style[
         "BacteriophageLambdaGC", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Bioinformatics/BacteriophageLambdaGC.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "BasicGenomics", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Bioinformatics/BasicGenomics.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Bioinformatics", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Bioinformatics/Bioinformatics.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "ColoringResidues", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Bioinformatics/ColoringResidues.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "EbolaVirus", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Bioinformatics/EbolaVirus.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Markov Models", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Bioinformatics/Markov Models.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "PPIs", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Bioinformatics/PPIs.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "RamachandranPlot", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Bioinformatics/RamachandranPlot.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "RNACodon", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Bioinformatics/RNACodon.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "S120Overview", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Bioinformatics/S120Overview.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "SequenceDisplay", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Bioinformatics/SequenceDisplay.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "StemCell", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Bioinformatics/StemCell.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "VisualizingMicroarrayData", ShowStringCharacters -> False, 
          FontFamily -> "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], 
          FontSize -> 12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Bioinformatics/VisualizingMicroarrayData.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}]}, {Spacings -> {0, 0.2}}]}, False, {
     ImageSize -> 160, ImageMargins -> 4, Alignment -> Left, BaselinePosition -> 
      Center, FrameMargins -> 0}]],
   DynamicModuleValues:>{}],
  Setting[#, {0}]& ]],
 CellMargins->{{0, 0}, {0, 0}},
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 CellHorizontalScrolling->True,
 PageBreakAbove->True,
 PageBreakWithin->False,
 ShowAutoStyles->True,
 LineSpacing->{1.25, 0},
 AutoItalicWords->{},
 ScriptMinSize->9,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["PanelFontFamily"],
 FontSize:>CurrentValue["PanelFontSize"]],

Cell[BoxData[
 TagBox[
  DynamicModuleBox[{Typeset`var$$ = False}, 
   InterpretationBox[
    StyleBox[
     PaneSelectorBox[{False->GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Data Analysis\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}], True->
      GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Data Analysis\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]},
        {"", 
         PaneBox[
          TagBox[GridBox[{
             {
              ButtonBox[
               StyleBox["\<\"AirlineData\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Data Analysis/AirlineData.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"BenfordsLaw\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Data Analysis/BenfordsLaw.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"ClusterSummaries\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Data Analysis/ClusterSummaries.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"CompareTemps\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Data Analysis/CompareTemps.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Filters\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Data Analysis/Filters.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"LibraryDensity\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Data Analysis/LibraryDensity.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"MultidimensionalScaling\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Data Analysis/MultidimensionalScaling.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"PrincipalComponentAnalysis\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Data Analysis/PrincipalComponentAnalysis.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"SmoothingHamming\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Data Analysis/SmoothingHamming.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"StateUVExposure\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Data Analysis/StateUVExposure.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{0.2}}}],
           "Column"],
          ImageMargins->0]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}]}, Dynamic[
      Typeset`var$$],
      Alignment->Left,
      BaselinePosition->Baseline,
      DefaultBaseStyle->"OpenerView",
      ImageMargins->4,
      ImageSize->160],
     Deployed->False,
     StripOnInput->False],
    OpenerView[{
      Style[
      "Data Analysis", {
       FontFamily -> "Helvetica Neue", FontColor -> GrayLevel[0.95], FontSize -> 
        16}], 
      Column[{
        Button[
         Style[
         "AirlineData", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Data \
Analysis/AirlineData.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "BenfordsLaw", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Data \
Analysis/BenfordsLaw.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "ClusterSummaries", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Data \
Analysis/ClusterSummaries.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "CompareTemps", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Data \
Analysis/CompareTemps.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Filters", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Data \
Analysis/Filters.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "LibraryDensity", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Data \
Analysis/LibraryDensity.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "MultidimensionalScaling", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Data \
Analysis/MultidimensionalScaling.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "PrincipalComponentAnalysis", ShowStringCharacters -> False, 
          FontFamily -> "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], 
          FontSize -> 12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Data \
Analysis/PrincipalComponentAnalysis.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "SmoothingHamming", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Data \
Analysis/SmoothingHamming.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "StateUVExposure", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Data \
Analysis/StateUVExposure.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}]}, {Spacings -> {0, 0.2}}]}, False, {
     ImageSize -> 160, ImageMargins -> 4, Alignment -> Left, BaselinePosition -> 
      Center, FrameMargins -> 0}]],
   DynamicModuleValues:>{}],
  Setting[#, {0}]& ]],
 CellMargins->{{0, 0}, {0, 0}},
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 CellHorizontalScrolling->True,
 PageBreakAbove->True,
 PageBreakWithin->False,
 ShowAutoStyles->True,
 LineSpacing->{1.25, 0},
 AutoItalicWords->{},
 ScriptMinSize->9,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["PanelFontFamily"],
 FontSize:>CurrentValue["PanelFontSize"]],

Cell[BoxData[
 TagBox[
  DynamicModuleBox[{Typeset`var$$ = False}, 
   InterpretationBox[
    StyleBox[
     PaneSelectorBox[{False->GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"GIS\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}], True->
      GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"GIS\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]},
        {"", 
         PaneBox[
          TagBox[GridBox[{
             {
              ButtonBox[
               StyleBox["\<\"StateOutlines\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Geographic Systems/StateOutlines.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"WorldPopulationData\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Geographic Systems/WorldPopulationData.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{0.2}}}],
           "Column"],
          ImageMargins->0]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}]}, Dynamic[
      Typeset`var$$],
      Alignment->Left,
      BaselinePosition->Baseline,
      DefaultBaseStyle->"OpenerView",
      ImageMargins->4,
      ImageSize->160],
     Deployed->False,
     StripOnInput->False],
    OpenerView[{
      Style[
      "GIS", {FontFamily -> "Helvetica Neue", FontColor -> GrayLevel[0.95], 
        FontSize -> 16}], 
      Column[{
        Button[
         Style[
         "StateOutlines", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Geographic Systems/StateOutlines.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "WorldPopulationData", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Geographic Systems/WorldPopulationData.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}]}, {Spacings -> {0, 0.2}}]}, False, {
     ImageSize -> 160, ImageMargins -> 4, Alignment -> Left, BaselinePosition -> 
      Center, FrameMargins -> 0}]],
   DynamicModuleValues:>{}],
  Setting[#, {0}]& ]],
 CellMargins->{{0, 0}, {0, 0}},
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 CellHorizontalScrolling->True,
 PageBreakAbove->True,
 PageBreakWithin->False,
 ShowAutoStyles->True,
 LineSpacing->{1.25, 0},
 AutoItalicWords->{},
 ScriptMinSize->9,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["PanelFontFamily"],
 FontSize:>CurrentValue["PanelFontSize"]],

Cell[BoxData[
 TagBox[
  DynamicModuleBox[{Typeset`var$$ = False}, 
   InterpretationBox[
    StyleBox[
     PaneSelectorBox[{False->GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Geometry\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}], True->
      GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Geometry\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]},
        {"", 
         PaneBox[
          TagBox[GridBox[{
             {
              ButtonBox[
               StyleBox["\<\"ApolloniusCircleProblem\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Geometry/ApolloniusCircleProblem.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"CenterOfPolygon\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Geometry/CenterOfPolygon.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"ConvexPolygons\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Geometry/ConvexPolygons.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"FindBoundingRectangle\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Geometry/FindBoundingRectangle.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"RegularPolygonRootsOfUnity\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Geometry/RegularPolygonRootsOfUnity.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Tiling\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Geometry/Tiling.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"TriangleCircumcircle\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Geometry/TriangleCircumcircle.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{0.2}}}],
           "Column"],
          ImageMargins->0]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}]}, Dynamic[
      Typeset`var$$],
      Alignment->Left,
      BaselinePosition->Baseline,
      DefaultBaseStyle->"OpenerView",
      ImageMargins->4,
      ImageSize->160],
     Deployed->False,
     StripOnInput->False],
    OpenerView[{
      Style[
      "Geometry", {
       FontFamily -> "Helvetica Neue", FontColor -> GrayLevel[0.95], FontSize -> 
        16}], 
      Column[{
        Button[
         Style[
         "ApolloniusCircleProblem", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Geometry/\
ApolloniusCircleProblem.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "CenterOfPolygon", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Geometry/\
CenterOfPolygon.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "ConvexPolygons", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Geometry/\
ConvexPolygons.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "FindBoundingRectangle", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Geometry/\
FindBoundingRectangle.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "RegularPolygonRootsOfUnity", ShowStringCharacters -> False, 
          FontFamily -> "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], 
          FontSize -> 12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Geometry/\
RegularPolygonRootsOfUnity.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Tiling", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Geometry/\
Tiling.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "TriangleCircumcircle", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Geometry/\
TriangleCircumcircle.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}]}, {Spacings -> {0, 0.2}}]}, False, {
     ImageSize -> 160, ImageMargins -> 4, Alignment -> Left, BaselinePosition -> 
      Center, FrameMargins -> 0}]],
   DynamicModuleValues:>{}],
  Setting[#, {0}]& ]],
 CellMargins->{{0, 0}, {0, 0}},
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 CellHorizontalScrolling->True,
 PageBreakAbove->True,
 PageBreakWithin->False,
 ShowAutoStyles->True,
 LineSpacing->{1.25, 0},
 AutoItalicWords->{},
 ScriptMinSize->9,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["PanelFontFamily"],
 FontSize:>CurrentValue["PanelFontSize"]],

Cell[BoxData[
 TagBox[
  DynamicModuleBox[{Typeset`var$$ = False}, 
   InterpretationBox[
    StyleBox[
     PaneSelectorBox[{False->GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Graphs/Networks\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}], True->
      GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Graphs/Networks\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]},
        {"", 
         PaneBox[
          TagBox[GridBox[{
             {
              ButtonBox[
               StyleBox["\<\"ClosenessCentrality\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Graph & Networks/ClosenessCentrality.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"CorporateOwnership\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Graph & Networks/CorporateOwnership.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"FamilyTree\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Graph & Networks/FamilyTree.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"FoodWebImages\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Graph & Networks/FoodWebImages.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"GeometricGraphs\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Graph & Networks/GeometricGraphs.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"GraphDiameterPath\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Graph & Networks/GraphDiameterPath.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Graphs\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Graph & Networks/Graphs.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"InvasionModel\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Graph & Networks/InvasionModel.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"MeanVertexDegree\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Graph & Networks/MeanVertexDegree.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"RandomGraphs\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Graph & Networks/RandomGraphs.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"TransitiveClosure\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Graph & Networks/TransitiveClosure.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"VertexDistance\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Graph & Networks/VertexDistance.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"WeightedGraphs\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Graph & Networks/WeightedGraphs.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{0.2}}}],
           "Column"],
          ImageMargins->0]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}]}, Dynamic[
      Typeset`var$$],
      Alignment->Left,
      BaselinePosition->Baseline,
      DefaultBaseStyle->"OpenerView",
      ImageMargins->4,
      ImageSize->160],
     Deployed->False,
     StripOnInput->False],
    OpenerView[{
      Style[
      "Graphs/Networks", {
       FontFamily -> "Helvetica Neue", FontColor -> GrayLevel[0.95], FontSize -> 
        16}], 
      Column[{
        Button[
         Style[
         "ClosenessCentrality", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Graph & \
Networks/ClosenessCentrality.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "CorporateOwnership", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Graph & \
Networks/CorporateOwnership.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "FamilyTree", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Graph & \
Networks/FamilyTree.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "FoodWebImages", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Graph & \
Networks/FoodWebImages.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "GeometricGraphs", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Graph & \
Networks/GeometricGraphs.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "GraphDiameterPath", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Graph & \
Networks/GraphDiameterPath.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Graphs", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Graph & \
Networks/Graphs.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "InvasionModel", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Graph & \
Networks/InvasionModel.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "MeanVertexDegree", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Graph & \
Networks/MeanVertexDegree.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "RandomGraphs", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Graph & \
Networks/RandomGraphs.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "TransitiveClosure", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Graph & \
Networks/TransitiveClosure.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "VertexDistance", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Graph & \
Networks/VertexDistance.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "WeightedGraphs", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Graph & \
Networks/WeightedGraphs.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}]}, {Spacings -> {0, 0.2}}]}, False, {
     ImageSize -> 160, ImageMargins -> 4, Alignment -> Left, BaselinePosition -> 
      Center, FrameMargins -> 0}]],
   DynamicModuleValues:>{}],
  Setting[#, {0}]& ]],
 CellMargins->{{0, 0}, {0, 0}},
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 CellHorizontalScrolling->True,
 PageBreakAbove->True,
 PageBreakWithin->False,
 ShowAutoStyles->True,
 LineSpacing->{1.25, 0},
 AutoItalicWords->{},
 ScriptMinSize->9,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["PanelFontFamily"],
 FontSize:>CurrentValue["PanelFontSize"]],

Cell[BoxData[
 TagBox[
  DynamicModuleBox[{Typeset`var$$ = False}, 
   InterpretationBox[
    StyleBox[
     PaneSelectorBox[{False->GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Linguistics\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}], True->
      GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Linguistics\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]},
        {"", 
         PaneBox[
          TagBox[GridBox[{
             {
              ButtonBox[
               StyleBox["\<\"CountPartsOfSpeech\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Linguistics/CountPartsOfSpeech.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Examples\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Linguistics/Examples.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"ExquisiteCorpse\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Linguistics/ExquisiteCorpse.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Passphrase\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Linguistics/Passphrase.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"RandomWord\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Linguistics/RandomWord.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Tokenize words\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Linguistics/Tokenize words.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"WordCollocation\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Linguistics/WordCollocation.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{0.2}}}],
           "Column"],
          ImageMargins->0]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}]}, Dynamic[
      Typeset`var$$],
      Alignment->Left,
      BaselinePosition->Baseline,
      DefaultBaseStyle->"OpenerView",
      ImageMargins->4,
      ImageSize->160],
     Deployed->False,
     StripOnInput->False],
    OpenerView[{
      Style[
      "Linguistics", {
       FontFamily -> "Helvetica Neue", FontColor -> GrayLevel[0.95], FontSize -> 
        16}], 
      Column[{
        Button[
         Style[
         "CountPartsOfSpeech", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Linguistics/CountPartsOfSpeech.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Examples", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Linguistics/Examples.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "ExquisiteCorpse", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Linguistics/ExquisiteCorpse.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Passphrase", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Linguistics/Passphrase.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "RandomWord", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Linguistics/RandomWord.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Tokenize words", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Linguistics/Tokenize words.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "WordCollocation", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Linguistics/WordCollocation.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}]}, {Spacings -> {0, 0.2}}]}, False, {
     ImageSize -> 160, ImageMargins -> 4, Alignment -> Left, BaselinePosition -> 
      Center, FrameMargins -> 0}]],
   DynamicModuleValues:>{}],
  Setting[#, {0}]& ]],
 CellMargins->{{0, 0}, {0, 0}},
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 CellHorizontalScrolling->True,
 PageBreakAbove->True,
 PageBreakWithin->False,
 ShowAutoStyles->True,
 LineSpacing->{1.25, 0},
 AutoItalicWords->{},
 ScriptMinSize->9,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["PanelFontFamily"],
 FontSize:>CurrentValue["PanelFontSize"]],

Cell[BoxData[
 TagBox[
  DynamicModuleBox[{Typeset`var$$ = False}, 
   InterpretationBox[
    StyleBox[
     PaneSelectorBox[{False->GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Math\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}], True->
      GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Math\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]},
        {"", 
         PaneBox[
          TagBox[GridBox[{
             {
              ButtonBox[
               StyleBox["\<\"FFTPolynomialMultiply\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Math/FFTPolynomialMultiply.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"HermitianMatrices\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Math/HermitianMatrices.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"HeronsFormula\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Math/HeronsFormula.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Lemniscates\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Math/Lemniscates.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Transveral of Primes\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Math/Transveral of Primes.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"WeissteinConjecture\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Math/WeissteinConjecture.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{0.2}}}],
           "Column"],
          ImageMargins->0]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}]}, Dynamic[
      Typeset`var$$],
      Alignment->Left,
      BaselinePosition->Baseline,
      DefaultBaseStyle->"OpenerView",
      ImageMargins->4,
      ImageSize->160],
     Deployed->False,
     StripOnInput->False],
    OpenerView[{
      Style[
      "Math", {FontFamily -> "Helvetica Neue", FontColor -> GrayLevel[0.95], 
        FontSize -> 16}], 
      Column[{
        Button[
         Style[
         "FFTPolynomialMultiply", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Math/\
FFTPolynomialMultiply.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "HermitianMatrices", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Math/\
HermitianMatrices.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "HeronsFormula", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Math/\
HeronsFormula.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Lemniscates", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Math/\
Lemniscates.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Transveral of Primes", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Math/\
Transveral of Primes.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "WeissteinConjecture", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Math/\
WeissteinConjecture.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}]}, {Spacings -> {0, 0.2}}]}, False, {
     ImageSize -> 160, ImageMargins -> 4, Alignment -> Left, BaselinePosition -> 
      Center, FrameMargins -> 0}]],
   DynamicModuleValues:>{}],
  Setting[#, {0}]& ]],
 CellMargins->{{0, 0}, {0, 0}},
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 CellHorizontalScrolling->True,
 PageBreakAbove->True,
 PageBreakWithin->False,
 ShowAutoStyles->True,
 LineSpacing->{1.25, 0},
 AutoItalicWords->{},
 ScriptMinSize->9,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["PanelFontFamily"],
 FontSize:>CurrentValue["PanelFontSize"]],

Cell[BoxData[
 TagBox[
  DynamicModuleBox[{Typeset`var$$ = False}, 
   InterpretationBox[
    StyleBox[
     PaneSelectorBox[{False->GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Number Theory\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}], True->
      GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Number Theory\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]},
        {"", 
         PaneBox[
          TagBox[GridBox[{
             {
              ButtonBox[
               StyleBox["\<\"PolyaConjecture\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Number Theory/PolyaConjecture.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"SequenceSums\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Number Theory/SequenceSums.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"SubsetSumProblem\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Number Theory/SubsetSumProblem.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"TriangularNumbers\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Number Theory/TriangularNumbers.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{0.2}}}],
           "Column"],
          ImageMargins->0]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}]}, Dynamic[
      Typeset`var$$],
      Alignment->Left,
      BaselinePosition->Baseline,
      DefaultBaseStyle->"OpenerView",
      ImageMargins->4,
      ImageSize->160],
     Deployed->False,
     StripOnInput->False],
    OpenerView[{
      Style[
      "Number Theory", {
       FontFamily -> "Helvetica Neue", FontColor -> GrayLevel[0.95], FontSize -> 
        16}], 
      Column[{
        Button[
         Style[
         "PolyaConjecture", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Number \
Theory/PolyaConjecture.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "SequenceSums", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Number \
Theory/SequenceSums.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "SubsetSumProblem", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Number \
Theory/SubsetSumProblem.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "TriangularNumbers", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Number \
Theory/TriangularNumbers.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}]}, {Spacings -> {0, 0.2}}]}, False, {
     ImageSize -> 160, ImageMargins -> 4, Alignment -> Left, BaselinePosition -> 
      Center, FrameMargins -> 0}]],
   DynamicModuleValues:>{}],
  Setting[#, {0}]& ]],
 CellMargins->{{0, 0}, {0, 0}},
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 CellHorizontalScrolling->True,
 PageBreakAbove->True,
 PageBreakWithin->False,
 ShowAutoStyles->True,
 LineSpacing->{1.25, 0},
 AutoItalicWords->{},
 ScriptMinSize->9,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["PanelFontFamily"],
 FontSize:>CurrentValue["PanelFontSize"]],

Cell[BoxData[
 TagBox[
  DynamicModuleBox[{Typeset`var$$ = False}, 
   InterpretationBox[
    StyleBox[
     PaneSelectorBox[{False->GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Programming\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}], True->
      GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Programming\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]},
        {"", 
         PaneBox[
          TagBox[GridBox[{
             {
              ButtonBox[
               StyleBox["\<\"AddIntegers\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Programming/AddIntegers.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"BinaryExponentiation\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Programming/BinaryExponentiation.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"FibonacciCurve\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Programming/FibonacciCurve.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"MapReduceNB\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Programming/MapReduceNB.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"NoiseGeneration\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Programming/NoiseGeneration.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Points on a Sphere\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Programming/Points on a Sphere.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"RandomColor\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Programming/RandomColor.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"SortingAlgorithms\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Programming/SortingAlgorithms.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Tally\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Programming/Tally.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"XMLiTunes\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Programming/XMLiTunes.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{0.2}}}],
           "Column"],
          ImageMargins->0]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}]}, Dynamic[
      Typeset`var$$],
      Alignment->Left,
      BaselinePosition->Baseline,
      DefaultBaseStyle->"OpenerView",
      ImageMargins->4,
      ImageSize->160],
     Deployed->False,
     StripOnInput->False],
    OpenerView[{
      Style[
      "Programming", {
       FontFamily -> "Helvetica Neue", FontColor -> GrayLevel[0.95], FontSize -> 
        16}], 
      Column[{
        Button[
         Style[
         "AddIntegers", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Programming/AddIntegers.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "BinaryExponentiation", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Programming/BinaryExponentiation.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "FibonacciCurve", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Programming/FibonacciCurve.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "MapReduceNB", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Programming/MapReduceNB.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "NoiseGeneration", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Programming/NoiseGeneration.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Points on a Sphere", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Programming/Points on a Sphere.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "RandomColor", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Programming/RandomColor.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "SortingAlgorithms", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Programming/SortingAlgorithms.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Tally", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Programming/Tally.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "XMLiTunes", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Programming/XMLiTunes.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}]}, {Spacings -> {0, 0.2}}]}, False, {
     ImageSize -> 160, ImageMargins -> 4, Alignment -> Left, BaselinePosition -> 
      Center, FrameMargins -> 0}]],
   DynamicModuleValues:>{}],
  Setting[#, {0}]& ]],
 CellMargins->{{0, 0}, {0, 0}},
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 CellHorizontalScrolling->True,
 PageBreakAbove->True,
 PageBreakWithin->False,
 ShowAutoStyles->True,
 LineSpacing->{1.25, 0},
 AutoItalicWords->{},
 ScriptMinSize->9,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["PanelFontFamily"],
 FontSize:>CurrentValue["PanelFontSize"]],

Cell[BoxData[
 TagBox[
  DynamicModuleBox[{Typeset`var$$ = False}, 
   InterpretationBox[
    StyleBox[
     PaneSelectorBox[{False->GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Random Walks\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}], True->
      GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Random Walks\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]},
        {"", 
         PaneBox[
          TagBox[GridBox[{
             {
              ButtonBox[
               StyleBox["\<\"RandomAdjMatrix\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Random Walks/RandomAdjMatrix.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"RandomGraphs\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Random Walks/RandomGraphs.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"RandomWalkDecreasingStepsize\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Random Walks/RandomWalkDecreasingStepsize.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"Random Walk on Graphs\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Random Walks/Random Walk on Graphs.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"RandomWalkProcess\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Random Walks/RandomWalkProcess.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"RandomWalksInPwM\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Random Walks/RandomWalksInPwM.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"SitePercolation\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Random Walks/SitePercolation.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]},
             {
              ButtonBox[
               StyleBox["\<\"spectra\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Random Walks/spectra.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{0.2}}}],
           "Column"],
          ImageMargins->0]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}]}, Dynamic[
      Typeset`var$$],
      Alignment->Left,
      BaselinePosition->Baseline,
      DefaultBaseStyle->"OpenerView",
      ImageMargins->4,
      ImageSize->160],
     Deployed->False,
     StripOnInput->False],
    OpenerView[{
      Style[
      "Random Walks", {
       FontFamily -> "Helvetica Neue", FontColor -> GrayLevel[0.95], FontSize -> 
        16}], 
      Column[{
        Button[
         Style[
         "RandomAdjMatrix", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Random \
Walks/RandomAdjMatrix.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "RandomGraphs", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Random \
Walks/RandomGraphs.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "RandomWalkDecreasingStepsize", ShowStringCharacters -> False, 
          FontFamily -> "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], 
          FontSize -> 12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Random \
Walks/RandomWalkDecreasingStepsize.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "Random Walk on Graphs", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Random \
Walks/Random Walk on Graphs.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "RandomWalkProcess", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Random \
Walks/RandomWalkProcess.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "RandomWalksInPwM", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Random \
Walks/RandomWalksInPwM.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "SitePercolation", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Random \
Walks/SitePercolation.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}], 
        Button[
         Style[
         "spectra", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Random \
Walks/spectra.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}]}, {Spacings -> {0, 0.2}}]}, False, {
     ImageSize -> 160, ImageMargins -> 4, Alignment -> Left, BaselinePosition -> 
      Center, FrameMargins -> 0}]],
   DynamicModuleValues:>{}],
  Setting[#, {0}]& ]],
 CellMargins->{{0, 0}, {0, 0}},
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 CellHorizontalScrolling->True,
 PageBreakAbove->True,
 PageBreakWithin->False,
 ShowAutoStyles->True,
 LineSpacing->{1.25, 0},
 AutoItalicWords->{},
 ScriptMinSize->9,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["PanelFontFamily"],
 FontSize:>CurrentValue["PanelFontSize"]],

Cell[BoxData[
 TagBox[
  DynamicModuleBox[{Typeset`var$$ = False}, 
   InterpretationBox[
    StyleBox[
     PaneSelectorBox[{False->GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Units\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}], True->
      GridBox[{
        {
         OpenerBox[Dynamic[Typeset`var$$],
          Appearance->Automatic,
          AutoAction->False,
          ContinuousAction->False,
          Enabled->Automatic], 
         StyleBox["\<\"Units\"\>",
          StripOnInput->False,
          FontFamily->"Helvetica Neue",
          FontSize->16,
          FontColor->GrayLevel[0.95]]},
        {"", 
         PaneBox[
          TagBox[GridBox[{
             {
              ButtonBox[
               StyleBox["\<\"ConvertMilliseconds\"\>",
                StripOnInput->False,
                ShowStringCharacters->False,
                FontFamily->"Helvetica Neue",
                FontSize->12,
                FontColor->RGBColor[1, 0.5, 0.5]],
               Alignment->Left,
               Appearance->Frameless,
               Background->GrayLevel[0.2],
               
               ButtonFunction:>NotebookOpen[
                "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/\
Units/ConvertMilliseconds.nb"],
               Evaluator->Automatic,
               ImageSize->160,
               Method->"Preemptive"]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{0.2}}}],
           "Column"],
          ImageMargins->0]}
       },
       AutoDelete->False,
       BaselinePosition->Center,
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {{0.2}}, "Rows" -> {{0.5}}}]}, Dynamic[
      Typeset`var$$],
      Alignment->Left,
      BaselinePosition->Baseline,
      DefaultBaseStyle->"OpenerView",
      ImageMargins->4,
      ImageSize->160],
     Deployed->False,
     StripOnInput->False],
    OpenerView[{
      Style[
      "Units", {
       FontFamily -> "Helvetica Neue", FontColor -> GrayLevel[0.95], FontSize -> 
        16}], 
      Column[{
        Button[
         Style[
         "ConvertMilliseconds", ShowStringCharacters -> False, FontFamily -> 
          "Helvetica Neue", FontColor -> RGBColor[1, 0.5, 0.5], FontSize -> 
          12], 
         NotebookOpen[
         "/Users/paulwellin/Library/Mathematica/Applications/Sandbox/Units/\
ConvertMilliseconds.nb"], {
         ImageSize -> 160, Background -> GrayLevel[0.2], Alignment -> Left, 
          Appearance -> Frameless}]}, {Spacings -> {0, 0.2}}]}, False, {
     ImageSize -> 160, ImageMargins -> 4, Alignment -> Left, BaselinePosition -> 
      Center, FrameMargins -> 0}]],
   DynamicModuleValues:>{}],
  Setting[#, {0}]& ]],
 CellMargins->{{0, 0}, {0, 0}},
 CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
 CellHorizontalScrolling->True,
 PageBreakAbove->True,
 PageBreakWithin->False,
 ShowAutoStyles->True,
 LineSpacing->{1.25, 0},
 AutoItalicWords->{},
 ScriptMinSize->9,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["PanelFontFamily"],
 FontSize:>CurrentValue["PanelFontSize"]]
},
Saveable->False,
WindowSize->{Fit, 450},
WindowMargins->{{Automatic, 0}, {Automatic, 0}},
WindowElements->{"VerticalScrollBar", "MagnificationPopUp"},
WindowTitle->"Sandbox Notebooks",
Magnification->1.25,
Background->GrayLevel[0.2],
FrontEndVersion->"10.1 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 23, \
2015)",
StyleDefinitions->"Palette.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[590, 21, 17690, 449, 34, InheritFromParent,
 PageBreakAbove->True,
 PageBreakWithin->False],
Cell[18283, 472, 14322, 365, 35, InheritFromParent,
 PageBreakAbove->True,
 PageBreakWithin->False],
Cell[32608, 839, 5196, 141, 34, InheritFromParent,
 PageBreakAbove->True,
 PageBreakWithin->False],
Cell[37807, 982, 10890, 281, 35, InheritFromParent,
 PageBreakAbove->True,
 PageBreakWithin->False],
Cell[48700, 1265, 17781, 449, 35, InheritFromParent,
 PageBreakAbove->True,
 PageBreakWithin->False],
Cell[66484, 1716, 10834, 283, 35, InheritFromParent,
 PageBreakAbove->True,
 PageBreakWithin->False],
Cell[77321, 2001, 9671, 253, 34, InheritFromParent,
 PageBreakAbove->True,
 PageBreakWithin->False],
Cell[86995, 2256, 7488, 198, 35, InheritFromParent,
 PageBreakAbove->True,
 PageBreakWithin->False],
Cell[94486, 2456, 14196, 365, 35, InheritFromParent,
 PageBreakAbove->True,
 PageBreakWithin->False],
Cell[108685, 2823, 12061, 309, 34, InheritFromParent,
 PageBreakAbove->True,
 PageBreakWithin->False],
Cell[120749, 3134, 4041, 114, 34, InheritFromParent,
 PageBreakAbove->True,
 PageBreakWithin->False]
}
]
*)

(* End of internal cache information *)

