(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     92971,       3252]
NotebookOptionsPosition[     61814,       2451]
NotebookOutlinePosition[     62535,       2477]
CellTagsIndexPosition[     62492,       2474]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[TextData[{
 "Style definitions for \n\n",
 StyleBox["Essentials of Programming in Mathematica",
  FontSlant->"Italic"]
}], "Subtitle",
 CellMargins->{{0, 0}, {10, 0}},
 CellGroupingRules->{"SectionGrouping", 30},
 FontFamily->"Times",
 Background->RGBColor[0.87, 0.94, 1]],

Cell[StyleData[StyleDefinitions -> "Default.nb"]]
}, Closed]],

Cell[CellGroupData[{

Cell["Style environment names", "Section"],

Cell[StyleData[All, "Working"],
 PageWidth->WindowWidth,
 ShowCellBracket->Automatic],

Cell[StyleData[All, "Printout"],
 PageWidth->PaperWidth,
 ShowCellBracket->Automatic,
 ShowAutoStyles->True,
 ShowSyntaxStyles->True,
 ScriptSizeMultipliers->{0.75},
 PrivateFontOptions->{"FontType"->"Outline"},
 Magnification->1]
}, Open  ]],

Cell[CellGroupData[{

Cell["Notebook options", "Section"],

Cell["\<\
The options defined for the style below will be used at the Notebook level.\
\>", "Text"],

Cell[StyleData["Notebook"],
 PageHeaderLines->{False, False},
 PageFooterLines->{False, False},
 PrintingOptions->{"PageSize"->{535.6799926757812, 699.8400268554688},
 "PaperSize"->{535.6799926757812, 699.8400268554688}},
 CellLabelAutoDelete->False,
 InputAliases->{
  "fi" -> "\[FiLigature]", "fl" -> "\[FlLigature]", "sss" -> 
   "\[ThickSpace]\[ThickSpace]\[ThickSpace]"},
 AutoStyleOptions->{"UndefinedSymbolStyle"->{FontColor -> GrayLevel[0]}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Headings", "Section"],

Cell[CellGroupData[{

Cell[StyleData["ChapterNumber"],
 CellMargins->{{0, 0}, {0, 0}},
 CellGroupingRules->{"SectionGrouping", 30},
 TextAlignment->Center,
 CounterIncrements->"Chapter",
 CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}, {
   "Subtitle", 0}, {"Subsubtitle", 0}, {"ContentsChapter", 0}},
 MenuSortingValue->1010,
 FontFamily->"Times",
 FontSize->32],

Cell[StyleData["ChapterNumber", "Printout"],
 CellMargins->{{0, 0}, {0, 0}},
 TextAlignment->Center,
 FontFamily->"DTL Albertina TOT Caps",
 FontSize->18,
 FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TitleFlourish"],
 CellFrame->{{0, 0}, {0, 0}},
 CellMargins->{{0, 24}, {0, 0}},
 CellGroupingRules->{"SectionGrouping", 40},
 CellFrameLabels->{{None, None}, {None, 
    Cell[
     BoxData[
      GraphicsBox[
       RasterBox[CompressedData["
1:eJztkldMFFEUhlEpahR7L4khRGMNMRqMmtiiMbFEiSa2qMQGK64URREVERHF
glIEdoEFFpYioPTiylKkiQgoIh0RWBB22cJ2uMczISE++OCbPNwvZ5JJZjL3
zP9/y2zZh20nGBkZTcVLhhdzDxQKhUKhUCgUCuWfIQDDBIaGQTsEWgOoDaDU
g0xHpBoiUUOvGsRK6FKSDgW0ykjzAGmQwjcJ1PbB519Q1QMV3aSkkxT/hPx2
eNcGOS2Q0QSpjST5OyTUgeAria4lvGrgfCLBleRVBQRWkIDyYf+yoeelepyn
xXrfQu2jQo1PgdpLpL6fr/IQKu++U9zOlbvlDNzIkrhm9jun/3JM72Wnih3e
iFnJXZeSOi8kdtjGt52Naz0d23oypvF4dOPRyO9HePU24fUHubUHODX7Qmr2
hlTtDvy0M+DjDv+KbS/KtvqVbH5WvOlJ4UbfgvU+7618hOu889Y+yFvplbPC
M2v5vUzLu+kWt1OXub9dcitlsVvywhuvF7gmznNNmHs9fraLYKajYIaTYLoj
35wdNfVK5BSHqEkOEZNZPDNWhKl9uAmLa2LHMbbnTLjEHX+RgzPuQujIGJ0P
GZnR+9FH+Bq+j2NsF2ZiF2ZqzzVjheEHJ17mTXJgjjBn86ddjcZDZzrFzHKO
xTVwmfnXE3C3RTeTcMml7m9wYYs7aZYeGfgLqzyz13jlrvbOs/IWrvfJ3/BY
ZO1bYP20aMvzD/j721+WYxS7Aiv3BFXtDa7eH1qNQR0K/2oTXofRHYtqOMFv
OhXbckbABHsuvh1Dxqgvp3Rj7Bi+U1qvS0Yf1nEzW+qeI7uTJ8ea7gmV9/OV
D0UqrA97fFKkw0Kx1pelBqwYi8bGsffQSuBWAa+akQGVSPwGqAdKgqrktjLa
oDyoEIr0UcxIhWqhYKgZyobKtcnghxw6FdA9CD0q0q8GqQbkWlDoYFDHGKvR
M/bqhpn5Xz77lRmelegwgRGfMRP02fP9IPqMWWFiY8TnOdfi/vQZBaM+/7vP
QeVk1OfIGuB/gbg6QJ9TGiCtCTKb0WcibCeiDkah0i74u89yQP1QQrGKEVKi
gQEt+kzQZ5WejMhsGGIcxqFQKBQKhUKhUCgUCoVCoVAoY4ffZrJ5Rg==
        "], {{0, 
        0}, {240, 13}}, {0, 255}, ColorFunction -> RGBColor], 
       ImageSize -> {240, 13}, PlotRange -> {{0, 240}, {0, 13}}]]]}}],

Cell[StyleData["TitleFlourish", "Printout"],
 CellFrame->{{0, 0}, {0, 0}},
 CellMargins->{{0, 0}, {75, 0}},
 CellGroupingRules->{"SectionGrouping", 30},
 CellFrameLabels->{{None, None}, {None, 
    Cell[
     BoxData[
      GraphicsBox[
       RasterBox[CompressedData["
1:eJztkldMFFEUhlEpahR7L4khRGMNMRqMmtiiMbFEiSa2qMQGK64URREVERHF
glIEdoEFFpYioPTiylKkiQgoIh0RWBB22cJ2uMczISE++OCbPNwvZ5JJZjL3
zP9/y2zZh20nGBkZTcVLhhdzDxQKhUKhUCgUCuWfIQDDBIaGQTsEWgOoDaDU
g0xHpBoiUUOvGsRK6FKSDgW0ykjzAGmQwjcJ1PbB519Q1QMV3aSkkxT/hPx2
eNcGOS2Q0QSpjST5OyTUgeAria4lvGrgfCLBleRVBQRWkIDyYf+yoeelepyn
xXrfQu2jQo1PgdpLpL6fr/IQKu++U9zOlbvlDNzIkrhm9jun/3JM72Wnih3e
iFnJXZeSOi8kdtjGt52Naz0d23oypvF4dOPRyO9HePU24fUHubUHODX7Qmr2
hlTtDvy0M+DjDv+KbS/KtvqVbH5WvOlJ4UbfgvU+7618hOu889Y+yFvplbPC
M2v5vUzLu+kWt1OXub9dcitlsVvywhuvF7gmznNNmHs9fraLYKajYIaTYLoj
35wdNfVK5BSHqEkOEZNZPDNWhKl9uAmLa2LHMbbnTLjEHX+RgzPuQujIGJ0P
GZnR+9FH+Bq+j2NsF2ZiF2ZqzzVjheEHJ17mTXJgjjBn86ddjcZDZzrFzHKO
xTVwmfnXE3C3RTeTcMml7m9wYYs7aZYeGfgLqzyz13jlrvbOs/IWrvfJ3/BY
ZO1bYP20aMvzD/j721+WYxS7Aiv3BFXtDa7eH1qNQR0K/2oTXofRHYtqOMFv
OhXbckbABHsuvh1Dxqgvp3Rj7Bi+U1qvS0Yf1nEzW+qeI7uTJ8ea7gmV9/OV
D0UqrA97fFKkw0Kx1pelBqwYi8bGsffQSuBWAa+akQGVSPwGqAdKgqrktjLa
oDyoEIr0UcxIhWqhYKgZyobKtcnghxw6FdA9CD0q0q8GqQbkWlDoYFDHGKvR
M/bqhpn5Xz77lRmelegwgRGfMRP02fP9IPqMWWFiY8TnOdfi/vQZBaM+/7vP
QeVk1OfIGuB/gbg6QJ9TGiCtCTKb0WcibCeiDkah0i74u89yQP1QQrGKEVKi
gQEt+kzQZ5WejMhsGGIcxqFQKBQKhUKhUCgUCoVCoVAoY4ffZrJ5Rg==
        "], {{0, 
        0}, {240, 13}}, {0, 255}, ColorFunction -> RGBColor], 
       ImageSize -> {240, 13}, PlotRange -> {{0, 240}, {0, 13}}]]]}},
 TextAlignment->Center,
 Magnification->0.5]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["ChapterTitle"],
 CellMargins->{{0, 0}, {12, 12}},
 CellGroupingRules->{"SectionGrouping", 30},
 TextAlignment->Center,
 MenuSortingValue->1100,
 MenuCommandKey->"1",
 FontFamily->"Times",
 FontSize->30],

Cell[StyleData["ChapterTitle", "Printout"],
 CellMargins->{{0, 0}, {18, 0}},
 TextAlignment->Center,
 LineSpacing->{1.25, 0, 2},
 FontFamily->"DTL Albertina TOT",
 FontSize->18,
 FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ChapterAbstract"],
 CellMargins->{{42, 48}, {44, 0}},
 CellGroupingRules->{"SectionGrouping", 30},
 TextAlignment->Center,
 Hyphenation->False,
 LineSpacing->{1, 2},
 StyleMenuListing->None,
 FontFamily->"Times",
 FontSize->12,
 FontSlant->"Italic"],

Cell[StyleData["ChapterAbstract", "Printout"],
 CellMargins->{{48, 48}, {84, 0}},
 TextAlignment->Center,
 Hyphenation->False,
 LineSpacing->{1.2, 0, 2},
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->9.5,
 FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Section"],
 CellFrame->None,
 ShowGroupOpener->True,
 CellMargins->{{2, 0}, {5, 15}},
 CellGroupingRules->{"SectionGrouping", 30},
 CellFrameLabels->{{
    Cell[
     TextData[{
       StyleBox[
        CounterBox["Chapter"]], 
       StyleBox["."], 
       StyleBox[
        CounterBox["Section"]], "\t"}], CellBaseline -> Baseline], None}, {
   None, None}},
 CellFrameLabelMargins->0,
 TabSpacings->1.25,
 CounterIncrements->"Section",
 CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}, {
   "ExerciseItem", 0}},
 MenuSortingValue->1200,
 MenuCommandKey->"4",
 CounterStyleMenuListing->None,
 FontFamily->"Times",
 FontSize->18,
 FontColor->GrayLevel[0]],

Cell[StyleData["Section", "Printout"],
 ShowGroupOpener->False,
 CellMargins->{{-0.5, 0}, {6.5, 0}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       StyleBox[
        CounterBox["Chapter"]], 
       StyleBox["."], 
       StyleBox[
        CounterBox["Section"]], "\t"}], FontFamily -> 
     "DTL Albertina TOT Caps", CellBaseline -> Baseline], None}, {None, None}},
 CellFrameLabelMargins->0,
 TabSpacings->1.25,
 FontFamily->"DTL Albertina TOTR",
 FontSize->13.5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subsection"],
 CellDingbat->None,
 CellMargins->{{2, Inherited}, {0, 24}},
 CellGroupingRules->{"SectionGrouping", 40},
 MenuSortingValue->1250,
 MenuCommandKey->"5",
 CounterStyleMenuListing->None,
 FontFamily->"Times",
 FontSize->16,
 FontWeight->"Plain",
 FontSlant->"Italic",
 FontColor->GrayLevel[0]],

Cell[StyleData["Subsection", "Printout"],
 CellMargins->{{0, 0}, {0, 0}},
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->12.75]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["Subsubsection"],
 CellDingbat->None,
 CellMargins->{{2, 10}, {0, 7}},
 CellGroupingRules->{"SectionGrouping", 50},
 DefaultNewInlineCellStyle->"None",
 Hyphenation->True,
 LineSpacing->{1, 3},
 TabSpacings->1.4,
 CounterIncrements->"Subsubsection",
 StyleMenuListing->None,
 FontFamily->"Times",
 FontSize->14,
 FontWeight->"Plain",
 FontColor->GrayLevel[0]],

Cell[StyleData["Subsubsection", "Printout"],
 CellMargins->{{0, 0}, {2, 0}},
 TextJustification->1,
 LineSpacing->{1, 2},
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->10.5]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Text", "Section"],

Cell[CellGroupData[{

Cell[StyleData["Text"],
 CellMargins->{{2, 10}, {7, 7}},
 Hyphenation->True,
 LineSpacing->{1, 3},
 ParagraphIndent->17,
 CounterIncrements->"Text",
 MenuSortingValue->1310,
 MenuCommandKey->"7",
 FontFamily->"Times"],

Cell[StyleData["Text", "Printout"],
 CellMargins->{{0, 0}, {2, 0}},
 TextJustification->1,
 LineSpacing->{1, 2},
 ParagraphIndent->13,
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->10.5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TextFirst", StyleDefinitions -> StyleData["Text"]],
 ParagraphIndent->0,
 MenuSortingValue->1300,
 MenuCommandKey->"6"],

Cell[StyleData["TextFirst", "Printout"],
 ParagraphIndent->0]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item"],
 CellDingbat->Cell[
   TextData[
    StyleBox[\[FilledCircle]]], FontSize -> 5, CellBaseline -> Bottom],
 CellMargins->{{40, Inherited}, {Inherited, Inherited}},
 LineSpacing->{1, 3},
 FontFamily->"Times"],

Cell[StyleData["Item", "Printout"],
 CellDingbat->Cell[
   TextData[
    StyleBox[\[FilledCircle]]], FontSize -> 5, CellBaseline -> Bottom],
 CellMargins->{{22, 4}, {6, 0}},
 LineSpacing->{1, 2},
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->10.5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemFirst", StyleDefinitions -> StyleData["Item"]],
 CellMargins->{{40, Inherited}, {Inherited, 4}},
 LineSpacing->{1, 3}],

Cell[StyleData["ItemFirst", "Printout"],
 CellMargins->{{22, Inherited}, {6, Inherited}},
 LineSpacing->{1, 2},
 FontFamily->"DTL Albertina TOTR",
 FontSize->10.5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subitem"],
 CellDingbat->StyleBox["\[FilledSmallSquare]", Alignment -> Baseline]],

Cell[StyleData["Subitem", "Printout"],
 CellMargins->{{48, 4}, {0, 6}},
 LineSpacing->{1, 2},
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->10.5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NumberedItem"],
 CellMargins->{{17, 4}, {0, 8}},
 CellGroupingRules->{"GroupTogetherNestedGrouping", 15000},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["ItemNumber"], "."}], CellBaseline -> Baseline], None}, {
   None, None}},
 Hyphenation->True,
 LineSpacing->{1, 3},
 ParagraphSpacing->{0, 8},
 CounterIncrements->"ItemNumber",
 MenuSortingValue->1340,
 MenuCommandKey->None,
 FontSize->14],

Cell[StyleData["NumberedItem", "Printout"],
 CellMargins->{{13, 0}, {6, 0}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["ItemNumber"], "."}], CellBaseline -> Baseline, FontFamily -> 
     "DTL Albertina TOT Caps"], None}, {None, None}},
 LineSpacing->{1, 2},
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->10.5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TipStart"],
 CellFrame->{{0, 0}, {0, 0.65}},
 CellMargins->{{13, 0}, {-6, 12.35}},
 CellFrameMargins->{{0, 0}, {0, 0}},
 CellFrameColor->CMYKColor[1., 0.33333, 0., 0.4]],

Cell[StyleData["TipStart", "Printout"],
 CellMargins->{{12.8, 0}, {-6, 8}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["TipEnd"],
 CellFrame->{{0, 0}, {0, 0.65}},
 CellMargins->{{13, 0}, {3, 0}},
 CellFrameMargins->{{0, 0}, {0, 0}},
 CellFrameColor->CMYKColor[1., 0.33333, 0., 0.4]],

Cell[StyleData["TipEnd", "Printout"],
 CellMargins->{{12.8, 0}, {1.5, 3}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["NumberedTip"],
 CellMargins->{{11, 24}, {0, 0}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       StyleBox["Tip ", FontSlant -> "Italic"], 
       CounterBox["Chapter"], ".", 
       CounterBox["NumberedTip"]}], CellBaseline -> Baseline], None}, {
   None, None}},
 CounterIncrements->"NumberedTip",
 FormatTypeAutoConvert->False,
 FontSize->14],

Cell[StyleData["NumberedTip", "Printout"],
 CellMargins->{{13.1, 24}, {0, 0}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       StyleBox[
       "Tip ", FontFamily -> "DTL Albertina TOTM Medium", FontSlant -> 
        "Italic"], 
       StyleBox[
        CounterBox["Chapter"], FontFamily -> "DTL Albertina TOT Caps Medium"], 
       StyleBox[".", FontFamily -> "DTL Albertina TOT Caps"], 
       StyleBox[
        CounterBox["NumberedTip"], FontFamily -> 
        "DTL Albertina TOT Caps Medium"]}], CellBaseline -> Baseline], 
    None}, {None, None}},
 CellFrameLabelMargins->0,
 FontSize->10.5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TipText", StyleDefinitions -> StyleData["Text"]],
 CellMargins->{{13, 0}, {Inherited, Inherited}},
 ParagraphIndent->0,
 FontSize->12],

Cell[StyleData["TipText", "Printout"],
 CellMargins->{{13, 0}, {2, Inherited}},
 LineSpacing->{1.1, 0, 2},
 ParagraphIndent->0,
 FontSize->9.5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TipInput", StyleDefinitions -> StyleData["Input"]],
 GeneratedCellStyles->{"Output"->{"TipOutput"}},
 FontSize->12],

Cell[StyleData["TipInput", "Printout"],
 CellMargins->{{52, 0}, {Inherited - 4, Inherited}},
 FontSize->9.]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TipOutput", StyleDefinitions -> StyleData["Output"]],
 FontSize->12],

Cell[StyleData["TipOutput", "Printout"],
 CellMargins->{{52, 0}, {Inherited - 2, Inherited - 1}},
 FontSize->9.]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Input/Output", "Section"],

Cell[CellGroupData[{

Cell[StyleData["Input"],
 CellMargins->{{60, Inherited}, {5, 7}}],

Cell[StyleData["Input", "Printout"],
 CellMargins->{{43.95, 0}, {3., 4.}},
 ShowSyntaxStyles->True,
 FontSize->10.]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["InputOnly", StyleDefinitions -> StyleData["Input"]],
 CellMargins->{{60, Inherited}, {7, 7}}],

Cell[StyleData["InputOnly", "Printout"],
 CellMargins->{{43.95, 0}, {6, 5.5}},
 FontSize->10.]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Output"],
 CellMargins->{{60, Inherited}, {7, 3}}],

Cell[StyleData["Output", "Printout"],
 CellMargins->{{43.95, 0}, {5, 0}},
 FontSize->10.]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Message"],
 CellMargins->{{60, Inherited}, {6.5, 0}}],

Cell[StyleData["Message", "Printout"],
 CellMargins->{{44, Inherited}, {5, 0}},
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Print"],
 CellMargins->{{60, Inherited}, {Inherited, Inherited}}],

Cell[StyleData["Print", "Printout"],
 CellMargins->{{44, Inherited}, {6.5, 2.5}},
 FontSize->10.]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CellLabel"]],

Cell[StyleData["CellLabel", "Printout"],
 FontFamily->"Syntax LT Std",
 FontSize->6.15,
 FontColor->GrayLevel[0.4]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Unique styles", "Section"],

Cell[CellGroupData[{

Cell[StyleData["PrefaceSection"],
 CellFrame->None,
 ShowCellBracket->Automatic,
 ShowGroupOpener->True,
 CellMargins->{{2, 0}, {5, 15}},
 CellGroupingRules->{"SectionGrouping", 30},
 FontFamily->"Times",
 FontSize->18,
 FontColor->GrayLevel[0]],

Cell[StyleData["PrefaceSection", "Printout"],
 ShowGroupOpener->False,
 CellMargins->{{0, 0}, {0, 0}},
 FontFamily->"DTL Albertina TOTR",
 FontSize->13.5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Quote"],
 CellMargins->{{12.5, 36}, {0, 9}},
 Hyphenation->True,
 LineSpacing->{1, 2},
 ParagraphSpacing->{0, 8},
 CounterIncrements->"Text",
 StyleMenuListing->None,
 FontSlant->"Italic"],

Cell[StyleData["Quote", "Printout"],
 CellMargins->{{1, 48}, {4, 6.5}},
 LineSpacing->{1, 1},
 ParagraphIndent->0,
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->9.5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["QuoteAuthor"],
 CellMargins->{{12.5, 36}, {12, 6}},
 Hyphenation->True,
 LineSpacing->{1, 2},
 ParagraphSpacing->{0, 8},
 CounterIncrements->"Text",
 StyleMenuListing->None,
 FontSlant->"Italic"],

Cell[StyleData["QuoteAuthor", "Printout"],
 CellMargins->{{1, 48}, {6.25, 0}},
 LineSpacing->{1, 1},
 ParagraphIndent->0,
 FontFamily->"DTL Albertina TOT Caps",
 FontSize->9.5,
 FontSlant->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Picture"],
 CellMargins->{{28, 10}, {6, 6}},
 CellGroupingRules->"GraphicsGrouping",
 ShowCellLabel->False,
 ShowStringCharacters->False,
 MenuSortingValue->1500,
 MenuCommandKey->None,
 Magnification->1.25],

Cell[StyleData["Picture", "Printout"],
 CellMargins->{{13, 0}, {13, 13}},
 Magnification->1]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["NonPrint styles", "Section"],

Cell[CellGroupData[{

Cell[StyleData["NonPrintSection", StyleDefinitions -> StyleData["Section"]],
 CellFrame->None,
 CellBracketOptions->{"Color"->RGBColor[1, 0, 0],
 "Thickness"->0.55},
 CellFrameLabels->{{None, None}, {None, None}},
 FontColor->GrayLevel[0.45]],

Cell[StyleData["NonPrintSection", "Printout"],
 ShowGroupOpener->False,
 CellElementSpacings->{"CellMinHeight"->1,
 "ClosedCellHeight"->0},
 CellOpen->False,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NonPrintSolutionLink"],
 CellMargins->{{0, 0}, {8, 12}},
 CellBracketOptions->{"Color"->RGBColor[1, 0, 0],
 "Thickness"->0.55},
 CellGroupingRules->{"SectionGrouping", 45},
 FontFamily->"Times",
 FontSize->14,
 FontWeight->"Bold",
 FontSlant->"Italic"],

Cell[StyleData["NonPrintSolutionLink", "Printout"],
 CellMargins->{{Inherited, Inherited}, {-1, 0}},
 CellElementSpacings->{"CellMinHeight"->0,
 "ClosedCellHeight"->0,
 "ClosedGroupTopMargin"->0},
 CellOpen->False]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NonPrintInput", StyleDefinitions -> StyleData["Input"]],
 CellMargins->{{46, Inherited}, {Inherited, Inherited}},
 CellBracketOptions->{"Color"->RGBColor[1, 0, 0]},
 CellGroupingRules->"NormalGrouping",
 FontWeight->"Plain",
 FontColor->RGBColor[1, 0, 0]],

Cell[StyleData["NonPrintInput", "Printout"],
 CellMargins->{{Inherited, Inherited}, {-1, 0}},
 CellElementSpacings->{"CellMinHeight"->0,
 "ClosedCellHeight"->0,
 "ClosedGroupTopMargin"->0},
 CellOpen->False,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Editorial"],
 CellMargins->{{24, 10}, {6, 6}},
 CellBracketOptions->{"Color"->RGBColor[1, 0, 0],
 "Thickness"->0.55},
 CellFrameLabels->{{
    Cell[
     TextData[{"Edit:"}], FontFamily -> "Helvetica", FontSize -> 10, 
     FontWeight -> "Bold", CellBaseline -> Baseline], None}, {None, None}},
 FontColor->RGBColor[1, 0, 0]],

Cell[StyleData["Editorial", "Printout"],
 CellMargins->{{Inherited, Inherited}, {0, 0}},
 CellElementSpacings->{"CellMinHeight"->0,
 "ClosedCellHeight"->0,
 "ClosedGroupTopMargin"->0},
 CellOpen->False,
 FontColor->GrayLevel[0]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Figures, tables, programs", "Section"],

Cell[CellGroupData[{

Cell[StyleData["Figure"],
 Deletable->True,
 CellMargins->{{18, 10}, {14, 12}},
 CellGroupingRules->"OutputGrouping",
 CellAutoOverwrite->False,
 ShowCellLabel->False,
 ShowStringCharacters->False,
 MenuSortingValue->1500,
 MenuCommandKey->None],

Cell[StyleData["Figure", "Printout"],
 CellMargins->{{13, 10}, {13, 0}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NumberedFigure"],
 CellMargins->{{12, 4}, {0, 14}},
 CellGroupingRules->"InputGrouping",
 CellFrameLabels->{{
    Cell[
     TextData[{"Figure ", 
       CounterBox["Chapter"], ".", 
       CounterBox["NumberedFigure"], "\t"}], CellBaseline -> Baseline, 
     FontSlant -> "Plain"], None}, {None, None}},
 TabSpacings->0.25,
 CounterIncrements->"NumberedFigure",
 MenuSortingValue->1670,
 FormatTypeAutoConvert->False,
 FontSize->14,
 FontSlant->"Italic"],

Cell[StyleData["NumberedFigure", "Printout"],
 CellMargins->{{13, Inherited}, {6.5, 6.5}},
 CellFrameLabels->{{
    Cell[
     TextData[{"Figure ", 
       CounterBox["Chapter"], ".", 
       CounterBox["NumberedFigure"], ".", "\t"}], FontFamily -> 
     "DTL Albertina TOT Caps", FontSlant -> "Plain", CellBaseline -> 
     Baseline], None}, {None, None}},
 TabSpacings->0.25,
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->10.5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DisplayTable"],
 CellMargins->{{18, Inherited}, {18, 0}},
 CellGroupingRules->"OutputGrouping",
 DefaultFormatType->DefaultTraditionalFormatType,
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 LanguageCategory->"Formula",
 ScriptLevel->0,
 SingleLetterItalics->True,
 UnderoverscriptBoxOptions->{LimitsPositioning->True}],

Cell[StyleData["DisplayTable", "Printout"],
 CellMargins->{{13, 0}, {15, 5}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NumberedTable"],
 CellMargins->{{18, 4}, {12, 14}},
 CellGroupingRules->"InputGrouping",
 CellFrameLabels->{{
    Cell[
     TextData[{"Table ", 
       CounterBox["Chapter"], ".", 
       CounterBox["NumberedTable"], ".", "\t"}], CellBaseline -> Baseline, 
     FontSlant -> "Plain"], None}, {None, None}},
 TabSpacings->1.1,
 CounterIncrements->"NumberedTable",
 MenuSortingValue->1660,
 FormatTypeAutoConvert->False,
 FontSize->14,
 FontSlant->"Italic"],

Cell[StyleData["NumberedTable", "Printout"],
 CellMargins->{{13, 0}, {0, 7}},
 CellFrameLabels->{{
    Cell[
     TextData[{"Table ", 
       CounterBox["Chapter"], ".", 
       CounterBox["NumberedTable"], ".", "\t"}], CellBaseline -> Baseline, 
     FontFamily -> "DTL Albertina TOT Caps", FontSlant -> "Plain"], None}, {
   None, None}},
 TabSpacings->0.25,
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->10.5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ProgramListing"],
 CellMargins->{{18, 4}, {6, 6}},
 CellGroupingRules->"InputGrouping",
 CellFrameLabels->{{
    Cell[
     TextData[{"Program Listing ", 
       CounterBox["Chapter"], ".", 
       CounterBox["NumberedProgram"], "\t"}], CellBaseline -> Baseline], 
    None}, {None, None}},
 CounterIncrements->"NumberedProgram",
 MenuSortingValue->1680,
 FormatTypeAutoConvert->False,
 FontSize->14],

Cell[StyleData["ProgramListing", "Printout"],
 CellMargins->{{13, 0}, {3.5, 9}},
 CellFrameLabels->{{
    Cell[
     TextData[{"Program Listing ", 
       CounterBox["Chapter"], ".", 
       CounterBox["NumberedProgram"], ".", "\t"}], CellBaseline -> Baseline, 
     FontFamily -> "DTL Albertina TOT Caps", FontSlant -> "Plain"], None}, {
   None, None}},
 TabSpacings->0.25,
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->10.5,
 FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ProgramListingNoLabel"],
 CellMargins->{{42, 4}, {12, 6}},
 MenuSortingValue->1680,
 FormatTypeAutoConvert->False],

Cell[StyleData["ProgramListingNoLabel", "Printout"],
 CellMargins->{{13, Inherited}, {12, 0}},
 FontFamily->"Syntax LT Std",
 FontSize->9]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Inline formatting", "Section"],

Cell[CellGroupData[{

Cell[StyleData["InputForm"]],

Cell[StyleData["InputForm", "Printout"],
 PageWidth->425,
 CellMargins->{{Inherited, Inherited}, {Inherited - 2, Inherited - 2}},
 LineSpacing->{1.25, 0, 2},
 FontFamily->"Inconsolata"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["StandardForm"],
 AutoQuoteCharacters->{},
 StyleMenuListing->None,
 FontFamily->"Courier"],

Cell[StyleData["StandardForm", "Printout"],
 FontFamily->"Inconsolata"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["MR"],
 AutoQuoteCharacters->{},
 StyleMenuListing->None],

Cell[StyleData["MR", "Printout"],
 FontFamily->"Inconsolata",
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TR"],
 StyleMenuListing->None],

Cell[StyleData["TR", "Printout"],
 FontFamily->"DTL Albertina TOTR Book"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TI"],
 StyleMenuListing->None],

Cell[StyleData["TI", "Printout"],
 FontFamily->"DTL Albertina TOTR Book",
 FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["OsFBold"],
 StyleMenuListing->None],

Cell[StyleData["OsFBold", "Printout"],
 FontFamily->"DTL Albertina TOT Caps Medium"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SR"],
 StyleMenuListing->None],

Cell[StyleData["SR", "Printout"],
 FontFamily->"Syntax LT Std"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SRSmall", StyleDefinitions -> StyleData["SR"]],
 FontSize->11.5],

Cell[StyleData["SRSmall", "Printout"],
 FontFamily->"Syntax LT Std",
 FontSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SRTiny", StyleDefinitions -> StyleData["SR"]]],

Cell[StyleData["SRTiny", "Printout"],
 FontFamily->"Syntax LT Std",
 FontSize->6.]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SB"],
 StyleMenuListing->None],

Cell[StyleData["SB", "Printout"],
 FontFamily->"Syntax LT Std",
 FontWeight->"Bold"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TermDefinition"],
 FontSlant->"Italic"],

Cell[StyleData["TermDefinition", "Printout"],
 FontFamily->"DTL Albertina TOTR Book",
 FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SmallCaps"],
 StyleMenuListing->None,
 FontFamily->"Times"],

Cell[StyleData["SmallCaps", "Printout"],
 FontFamily->"DTL Albertina TOT Caps"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["OsF"],
 StyleMenuListing->None,
 FontColor->RGBColor[0, 0, 1]],

Cell[StyleData["OsF", "Printout"],
 FontFamily->"DTL Albertina TOT Caps",
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[StyleData["ChapterNumber"],
 StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["MSG", StyleDefinitions -> None],
 StyleMenuListing->None,
 FontFamily->"Arial",
 FontSize->11],

Cell[StyleData["MSG", "Printout"],
 FontFamily->"Syntax LT Std",
 FontSize->8.75]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Menu"],
 FontFamily->"Helvetica Neue",
 FontSize->13],

Cell[StyleData["Menu", "Printout"],
 FontFamily->"Syntax LT Std",
 FontSize->9.5,
 FontWeight->"Plain",
 FontSlant->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsubBold"],
 FontWeight->"Bold"],

Cell[StyleData["SubsubBold", "Printout"],
 FontFamily->"DTL Albertina TOTR Book",
 FontWeight->"Plain",
 FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableHeading"],
 StyleMenuListing->None,
 FontFamily->"Helvetica",
 FontSize->11],

Cell[StyleData["TableHeading", "Printout"],
 FontFamily->"DTL Albertina TOTM Medium",
 FontSize->9.75]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableText", StyleDefinitions -> StyleData["Text"]],
 LineIndent->Automatic,
 FontSize->12.5],

Cell[StyleData["TableText", "Printout"],
 LineSpacing->{1, 1},
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->9.5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableTextTI", StyleDefinitions -> StyleData["Text"]],
 FontFamily->"Times",
 FontSize->12.5,
 FontWeight->"Plain",
 FontSlant->"Italic"],

Cell[StyleData["TableTextTI", "Printout"],
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->9.5,
 FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableOsF", StyleDefinitions -> StyleData["OsF"]]],

Cell[StyleData["TableOsF", "Printout"],
 FontSize->9.25]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableMR", StyleDefinitions -> StyleData["MR"]],
 AutoQuoteCharacters->{},
 StyleMenuListing->None],

Cell[StyleData["TableMR", "Printout"],
 FontFamily->"Inconsolata",
 FontSize->9.5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseTI"],
 FontFamily->"Times",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Italic"],

Cell[StyleData["ExerciseTI", "Printout"],
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->9.5,
 FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseMR"],
 FontFamily->"Courier",
 FontSize->11.25],

Cell[StyleData["ExerciseMR", "Printout"],
 FontSize->9.25]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseSR", StyleDefinitions -> StyleData["SR"]]],

Cell[StyleData["ExerciseSR", "Printout"],
 FontFamily->"Syntax LT Std",
 FontSize->7.]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CellLabelInline"],
 StyleMenuListing->None,
 FontFamily->"Helvetica Neue",
 FontSize->12,
 FontColor->RGBColor[0.247, 0.24, 0.6]],

Cell[StyleData["CellLabelInline", "Printout"],
 FontFamily->"Syntax LT Std",
 FontSize->9.,
 FontColor->RGBColor[0.247, 0.24, 0.6]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ITBold"],
 FontFamily->"Times",
 FontWeight->"Bold",
 FontSlant->"Italic"],

Cell[StyleData["ITBold", "Printout"],
 FontFamily->"DTL Albertina TOTM Medium",
 FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["WLDC"],
 LineColor->RGBColor[0.269993, 0.308507, 0.6],
 FrontFaceColor->RGBColor[0.269993, 0.308507, 0.6],
 BackFaceColor->RGBColor[0.269993, 0.308507, 0.6],
 GraphicsColor->RGBColor[0.269993, 0.308507, 0.6],
 FontColor->RGBColor[0.269993, 0.308507, 0.6]],

Cell[StyleData["WLDC", "Printout"],
 FontFamily->"Syntax LT Std",
 FontSize->9.75]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PrefaceContentsPageNumber"],
 StyleMenuListing->None,
 FontFamily->"Times",
 FontSize->16,
 FontWeight->"Plain",
 FontSlant->"Plain"],

Cell[StyleData["PrefaceContentsPageNumber", "Printout"],
 FontFamily->"DTL Albertina TOTR",
 FontSize->11,
 FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TRLink"],
 FontFamily->"Times",
 FontColor->RGBColor[0, 0.2, 0.8]],

Cell[StyleData["TRLink", "Printout"],
 FontFamily->"DTL Albertina TOTR Book",
 FontColor->GrayLevel[0]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Formulas and programming", "Section"],

Cell[CellGroupData[{

Cell[StyleData["InlineFormula"],
 CellMargins->{{10, 4}, {0, 8}},
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 LanguageCategory->"Formula",
 ScriptLevel->1,
 SingleLetterItalics->True],

Cell[StyleData["InlineFormula", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DisplayFormula"],
 CellMargins->{{60, 0}, {0, 0}},
 DefaultFormatType->DefaultTraditionalFormatType,
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 LanguageCategory->"Formula",
 ScriptLevel->0,
 SingleLetterItalics->True,
 FontFamily->"Times",
 UnderoverscriptBoxOptions->{LimitsPositioning->True}],

Cell[StyleData["DisplayFormula", "Printout"],
 CellMargins->{{44, Inherited}, {6.5, 4.5}},
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->10.5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Program"],
 CellFrame->0,
 CellMargins->{{20, 4}, {5, 5}},
 Evaluatable->False,
 DefaultFormatType->DefaultInputFormatType,
 ShowAutoStyles->True,
 ShowAutoConvert->True,
 Hyphenation->False,
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 LineSpacing->{1.25, 0, 2},
 AutoItalicWords->{},
 AutoQuoteCharacters->{},
 PasteAutoQuoteCharacters->{},
 LanguageCategory->"Input",
 FormatType->InputForm,
 ScriptLevel->1,
 FontFamily->"Courier",
 FontSize->13],

Cell[StyleData["Program", "Printout"],
 CellMargins->{{44, 0}, {6, 4.5}},
 LineSpacing->{1.25, 0, 2},
 FontFamily->"Inconsolata",
 FontSize->10.]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Headers and footers", "Section"],

Cell[CellGroupData[{

Cell[StyleData["Header"],
 MenuSortingValue->None],

Cell[StyleData["Header", "Printout"],
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->9.5,
 FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FrontMatterHeader"],
 MenuSortingValue->None],

Cell[StyleData["FrontMatterHeader", "Printout"],
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->9.5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["HeaderSection"],
 StyleMenuListing->None],

Cell[StyleData["HeaderSection", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PageFooter"],
 StyleMenuListing->None,
 FontFamily->"Times",
 FontSize->7.5,
 FontSlant->"Italic"],

Cell[StyleData["PageFooter", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PageNumber"],
 StyleMenuListing->None,
 FontFamily->"Times",
 FontSize->9],

Cell[StyleData["PageNumber", "Printout"],
 FontFamily->"DTL Albertina TOT Caps",
 FontSize->9.5,
 FontWeight->"Plain",
 FontSlant->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PageNumberPref"],
 StyleMenuListing->None,
 FontFamily->"Times",
 FontSize->9],

Cell[StyleData["PageNumberPref", "Printout"],
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->9.5,
 FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["HeaderOsF"],
 StyleMenuListing->None,
 FontFamily->"Times",
 FontSize->9],

Cell[StyleData["HeaderOsF", "Printout"],
 FontFamily->"DTL Albertina TOT Caps",
 FontSize->9.5,
 FontSlant->"Plain"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Title page", "Section"],

Cell[CellGroupData[{

Cell[StyleData["SmallText"]],

Cell[StyleData["SmallText", "Printout"],
 CellMargins->{{24, 12}, {4, 4}},
 FontFamily->"Syntax LT Std",
 FontSize->7.5]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Contents", "Section"],

Cell[CellGroupData[{

Cell[StyleData["ContentsTitle", StyleDefinitions -> StyleData["ChapterTitle"]]],

Cell[StyleData["ContentsTitle", "Printout"],
 CellMargins->{{0, 0}, {48, 0}},
 TextAlignment->Center]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ContentsChapterNoNum"],
 CellMargins->{{27, 4}, {0, 12}},
 CellGroupingRules->{"SectionGrouping", 40},
 FontSize->21],

Cell[StyleData["ContentsChapterNoNum", "Printout"],
 CellMargins->{{15.15, 0}, {6, 6}},
 FontFamily->"DTL Albertina TOTR",
 FontSize->12]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ChapterNum"],
 CellGroupingRules->{"SectionGrouping", 40},
 StyleMenuListing->None,
 CounterStyleMenuListing->None],

Cell[StyleData["ChapterNum", "Printout"],
 FontFamily->"DTL Albertina TOT"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ContentsChapter", StyleDefinitions -> StyleData[
 "ChapterTitle"]],
 CellMargins->{{0, 0}, {0, 0}},
 CellGroupingRules->{"SectionGrouping", 40},
 CellFrameLabels->{{
    Cell[
     TextData[{
       StyleBox[
        CounterBox["ContentsChapter"]], "\t"}], CellBaseline -> Baseline], 
    None}, {None, None}},
 CellFrameLabelMargins->0,
 TextAlignment->Left,
 TabSpacings->1.5,
 CounterIncrements->{"ContentsChapter"},
 CounterAssignments->{{"ContentsSection", 0}},
 StyleMenuListing->None,
 FontSize->21,
 FontWeight->"Plain"],

Cell[StyleData["ContentsChapter", "Printout"],
 CellMargins->{{0, 0}, {2, 10}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       StyleBox[
        CounterBox["ContentsChapter"]], "\t"}], FontFamily -> 
     "DTL Albertina TOT Caps", CellBaseline -> Baseline], None}, {None, None}},
 CellFrameLabelMargins->0,
 TextAlignment->Left,
 TabSpacings->1.7,
 CounterIncrements->{"ContentsChapter"},
 CounterAssignments->{{"ContentsSection", 0}},
 StyleMenuListing->None,
 FontFamily->"DTL Albertina TOTR",
 FontSize->12,
 PageBreakAfter -> False]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ContentsSection", StyleDefinitions -> StyleData["Section"]],
 ShowGroupOpener->False,
 CellMargins->{{28, Inherited}, {0, 12}},
 CellGroupingRules->{"SectionGrouping", 45},
 CellFrameLabels->{{
    Cell[
     TextData[{
       StyleBox[
        CounterBox["ContentsChapter"]], 
       StyleBox["."], 
       StyleBox[
        CounterBox["ContentsSection"]], "\t"}], CellBaseline -> Baseline], 
    None}, {None, None}},
 CellFrameLabelMargins->0,
 TabSpacings->2.4,
 CounterIncrements->{"ContentsSection"},
 StyleMenuListing->None,
 FontSize->18,
 FontWeight->"Plain"],

Cell[StyleData["ContentsSection", "Printout"],
 CellMargins->{{15, 0}, {0, 0}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       StyleBox[
        CounterBox["ContentsChapter"]], 
       StyleBox["."], 
       StyleBox[
        CounterBox["ContentsSection"]], "\t"}], FontFamily -> 
     "DTL Albertina TOT Caps", CellBaseline -> Baseline], None}, {None, None}},
 CellFrameLabelMargins->0,
 TabSpacings->1.25,
 FontFamily->"DTL Albertina TOTR",
 FontSize->10.75]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ContentsSubsection", StyleDefinitions -> StyleData[
 "Subsection"]],
 CellMargins->{{28, Inherited}, {12, 6}},
 CellGroupingRules->{"SectionGrouping", 50},
 PageBreakAbove->Automatic],

Cell[StyleData["ContentsSubsection", "Printout"],
 CellMargins->{{34.85, 5}, {5, 0}},
 LineSpacing->{1, 1},
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->9.5,
 FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ContentsPageNumber"],
 StyleMenuListing->None,
 FontFamily->"Times",
 FontSize->16,
 FontWeight->"Plain",
 FontSlant->"Plain"],

Cell[StyleData["ContentsPageNumber", "Printout"],
 FontFamily->"DTL Albertina TOT Caps",
 FontSize->10.75]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ContentsSectionNoNum"],
 CellMargins->{{48, 4}, {0, 12}},
 CellGroupingRules->{"SectionGrouping", 80},
 StyleMenuListing->None],

Cell[StyleData["ContentsSectionNoNum", "Printout"],
 CellMargins->{{20, 0}, {0, 6}},
 FontFamily->"DTL Albertina TOTR",
 FontSize->11]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ContentsSolutionSection"],
 CellMargins->{{28, 4}, {0, 12}},
 CellGroupingRules->{"SectionGrouping", 80},
 CellFrameLabels->{{
    Cell[
     TextData[{
       StyleBox[
        CounterBox["ContentsChapter"]], "\t"}], CellBaseline -> Baseline], 
    None}, {None, None}},
 CellFrameLabelMargins->0,
 TabSpacings->2.2,
 CounterIncrements->{"ContentsChapter"},
 StyleMenuListing->None,
 FontSize->18],

Cell[StyleData["ContentsSolutionSection", "Printout"],
 CellMargins->{{17, 0}, {0, 6}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       StyleBox[
        CounterBox["ContentsChapter"]], "\t"}], FontFamily -> 
     "DTL Albertina TOT Caps", CellBaseline -> Baseline], None}, {None, None}},
 CellFrameLabelMargins->0,
 TabSpacings->2.2,
 FontFamily->"DTL Albertina TOTR",
 FontSize->12]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Bibliography", "Section"],

Cell[CellGroupData[{

Cell[StyleData["ReferenceSection", StyleDefinitions -> StyleData["Subsection"]
 ],
 ShowGroupOpener->True,
 CellFrameLabels->{{
    Cell[
     TextData[{
       StyleBox[
        CounterBox["Chapter"]], 
       StyleBox["."], "\t"}], CellBaseline -> Baseline], None}, {None, None}},
 
 CellFrameLabelMargins->0,
 TabSpacings->1.25,
 CounterIncrements->"Chapter",
 FontSlant->"Plain"],

Cell[StyleData["ReferenceSection", "Printout"],
 ShowGroupOpener->False,
 CellMargins->{{0, 0}, {3, 0}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       StyleBox[
        CounterBox["Chapter"]], 
       StyleBox["."], "\t"}], CellBaseline -> Baseline, FontFamily -> 
     "DTL Albertina TOT Caps"], None}, {None, None}},
 TabSpacings->1.7,
 CounterIncrements->"Chapter",
 FontFamily->"DTL Albertina TOT",
 FontSize->12,
 FontSlant->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ReferenceSubsection", StyleDefinitions -> StyleData[
 "Subsection"]],
 CellGroupingRules->{"SectionGrouping", 45}],

Cell[StyleData["ReferenceSubsection", "Printout"],
 CellMargins->{{0, 0}, {3, 6}},
 LineSpacing->{1, 1},
 FontFamily->"DTL Albertina TOT",
 FontSize->11]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["References"],
 CellMargins->{{0, 10}, {4, 6}},
 DefaultNewInlineCellStyle->"None",
 Hyphenation->False,
 LineSpacing->{1, 3},
 ParagraphIndent->-18,
 StyleMenuListing->None,
 FontFamily->"Times",
 FontSize->12],

Cell[StyleData["References", "Printout"],
 CellMargins->{{0, 2}, {6, 0}},
 LineSpacing->{1, 1.5},
 ParagraphIndent->0,
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->9.5]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["ReferenceAbstract"],
 CellMargins->{{0, 10}, {4, 6}},
 DefaultNewInlineCellStyle->"None",
 Hyphenation->True,
 LineSpacing->{1, 3},
 StyleMenuListing->None,
 FontFamily->"Times",
 FontSize->12],

Cell[StyleData["ReferenceAbstract", "Printout"],
 CellMargins->{{0, 2}, {5, 0}},
 TextJustification->1.,
 LineSpacing->{1.2, 0, 2},
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->9.5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ReferenceSectionNoNum", StyleDefinitions -> StyleData[
 "Subsection"]],
 CellGroupingRules->{"SectionGrouping", 35}],

Cell[StyleData["ReferenceSectionNoNum", "Printout"],
 CellMargins->{{0, 0}, {3, 0}},
 FontFamily->"DTL Albertina TOT",
 FontSize->11,
 FontSlant->"Plain"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Index", "Section"],

Cell[CellGroupData[{

Cell[StyleData["IndexTitle", StyleDefinitions -> StyleData["ChapterTitle"]]],

Cell[StyleData["IndexTitle", "Printout"],
 TextAlignment->-0.25]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Index"],
 CellMargins->{{21, 4}, {0, 0}},
 StyleMenuListing->None],

Cell[StyleData["Index", "Printout"],
 CellMargins->{{13, 0}, {0, 0}},
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->9]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["IndexSubentry"],
 CellMargins->{{36, 4}, {0, 0}}],

Cell[StyleData["IndexSubentry", "Printout"],
 CellMargins->{{24, 0}, {0, 0}},
 FontFamily->"DTL Albertina TOTR Book"]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["Index2Column"],
 CellMargins->{{21, 4}, {0, 8}},
 ParagraphIndent->-12,
 TabSpacings->1.25,
 StyleMenuListing->None],

Cell[StyleData["Index2Column", "Printout"],
 CellMargins->{{0, 2}, {6, 0}},
 ParagraphIndent->-32,
 TabSpacings->1.25,
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->9.]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["IndexPageSC"],
 StyleMenuListing->None],

Cell[StyleData["IndexPageSC", "Printout"],
 FontFamily->"DTL Albertina TOT Caps"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["IndexPageTI"],
 StyleMenuListing->None],

Cell[StyleData["IndexPageTI", "Printout"],
 FontFamily->"DTL Albertina TOTR Book",
 FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["MRInd", StyleDefinitions -> StyleData["MR"]]],

Cell[StyleData["MRInd", "Printout"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Exercises", "Section"],

Cell[CellGroupData[{

Cell[StyleData["ExerciseSpacer"],
 CellFrame->{{0, 0}, {0, 0}},
 CellMargins->{{0, 24}, {0, 0}},
 CellGroupingRules->{"SectionGrouping", 40},
 CellFrameLabels->{{None, None}, {None, 
    Cell[
     BoxData[
      GraphicsBox[
       TagBox[
        RasterBox[CompressedData["
1:eJx10mtOg0AUBWCMK3FLLqEbcIeKgPISHwiUChRtKwiiGMSICNbjvZmm/eGX
kJAAw9xz5mBydDjZlyRpD5eB6+9+LfwI4zgOw/C9q+/7L/JJPoS2bd93NU3z
Ruq6fiUvpKqqZ1KWZVEUT0Ke51mWPZLVarVcLh/IPUnTdE6SJInjOIqiO2E2
m4VhOCVBEPi+73neLbkh1+SKXJILYlmWaZqGYei6fk7OiKZpqqqeCifCMeF7
WZb5qaIoeJk/5EV0gmWxvm3b+JHjOPxfbIA3wxtzXZf36ZOpgHEwFE+HSTEv
pp4LHAiHs1gsEBTi4twQIGLkPAuCkDltxM75cxcohdtBTdutocdNp1xx13Xc
OKrfPgk4Gzghm9Oy/scv/GgUOA==
         "], {{0, 1}, {200, 0}}, {0, 255}, 
         ColorFunction -> RGBColor], 
        BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True], 
        Selectable -> False], BaseStyle -> "ImageGraphics", 
       ImageSizeRaw -> {200, 1}, PlotRange -> {{0, 200}, {0, 1}}]]]}}],

Cell[StyleData["ExerciseSpacer", "Printout"],
 CellFrame->{{0, 0}, {0, 0}},
 CellMargins->{{0, 0}, {25, 12.5}},
 CellGroupingRules->{"SectionGrouping", 40},
 CellFrameLabels->{{None, None}, {None, 
    Cell[
     BoxData[
      GraphicsBox[
       RasterBox[CompressedData["
1:eJztkldMFFEUhlEpahR7L4khRGMNMRqMmtiiMbFEiSa2qMQGK64URREVERHF
glIEdoEFFpYioPTiylKkiQgoIh0RWBB22cJ2uMczISE++OCbPNwvZ5JJZjL3
zP9/y2zZh20nGBkZTcVLhhdzDxQKhUKhUCgUCuWfIQDDBIaGQTsEWgOoDaDU
g0xHpBoiUUOvGsRK6FKSDgW0ykjzAGmQwjcJ1PbB519Q1QMV3aSkkxT/hPx2
eNcGOS2Q0QSpjST5OyTUgeAria4lvGrgfCLBleRVBQRWkIDyYf+yoeelepyn
xXrfQu2jQo1PgdpLpL6fr/IQKu++U9zOlbvlDNzIkrhm9jun/3JM72Wnih3e
iFnJXZeSOi8kdtjGt52Naz0d23oypvF4dOPRyO9HePU24fUHubUHODX7Qmr2
hlTtDvy0M+DjDv+KbS/KtvqVbH5WvOlJ4UbfgvU+7618hOu889Y+yFvplbPC
M2v5vUzLu+kWt1OXub9dcitlsVvywhuvF7gmznNNmHs9fraLYKajYIaTYLoj
35wdNfVK5BSHqEkOEZNZPDNWhKl9uAmLa2LHMbbnTLjEHX+RgzPuQujIGJ0P
GZnR+9FH+Bq+j2NsF2ZiF2ZqzzVjheEHJ17mTXJgjjBn86ddjcZDZzrFzHKO
xTVwmfnXE3C3RTeTcMml7m9wYYs7aZYeGfgLqzyz13jlrvbOs/IWrvfJ3/BY
ZO1bYP20aMvzD/j721+WYxS7Aiv3BFXtDa7eH1qNQR0K/2oTXofRHYtqOMFv
OhXbckbABHsuvh1Dxqgvp3Rj7Bi+U1qvS0Yf1nEzW+qeI7uTJ8ea7gmV9/OV
D0UqrA97fFKkw0Kx1pelBqwYi8bGsffQSuBWAa+akQGVSPwGqAdKgqrktjLa
oDyoEIr0UcxIhWqhYKgZyobKtcnghxw6FdA9CD0q0q8GqQbkWlDoYFDHGKvR
M/bqhpn5Xz77lRmelegwgRGfMRP02fP9IPqMWWFiY8TnOdfi/vQZBaM+/7vP
QeVk1OfIGuB/gbg6QJ9TGiCtCTKb0WcibCeiDkah0i74u89yQP1QQrGKEVKi
gQEt+kzQZ5WejMhsGGIcxqFQKBQKhUKhUCgUCoVCoVAoY4ffZrJ5Rg==
        "], {{0, 
        0}, {240, 13}}, {0, 255}, ColorFunction -> RGBColor], 
       PlotRange -> {{0, 240}, {0, 13}}]]]}},
 Magnification->0.35]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseItem"],
 CellMargins->{{0, 100}, {6, 5}},
 CellGroupingRules->{"SectionGrouping", 45},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["ExerciseItem"], ".", "\t"}], FontWeight -> "Bold", 
     CellBaseline -> Baseline], None}, {None, None}},
 CellFrameLabelMargins->0,
 Hyphenation->True,
 LineSpacing->{1, 3},
 TabSpacings->1.4,
 CounterIncrements->"ExerciseItem",
 CounterAssignments->{{"ExerciseSubItem", 0}},
 MenuSortingValue->1700],

Cell[StyleData["ExerciseItem", "Printout"],
 CellMargins->{{0, 24}, {6, 0}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["ExerciseItem"], ".", "\t"}], FontFamily -> 
     "DTL Albertina TOT Caps", CellBaseline -> Baseline], None}, {None, None}},
 CellFrameLabelMargins->0,
 LineSpacing->{1, 1},
 TabSpacings->2,
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->9.5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseSubItem"],
 CellMargins->{{16, 4}, {6, 0}},
 CellGroupingRules->{"SectionGrouping", 46},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["ExerciseSubItem", CounterFunction -> (Part[
          CharacterRange["a", "z"], #]& )], "."}], CellBaseline -> Baseline, 
     FontFamily -> "Times", FontWeight -> "Bold"], None}, {None, None}},
 Hyphenation->True,
 LineSpacing->{1, 2},
 ParagraphSpacing->{0, 0},
 CounterIncrements->"ExerciseSubItem"],

Cell[StyleData["ExerciseSubItem", "Printout"],
 CellMargins->{{14, 24}, {6, 0}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["ExerciseSubItem", CounterFunction -> (Part[
          CharacterRange["a", "z"], #]& )], "."}], FontFamily -> 
     "DTL Albertina TOTR Book", FontSize -> 8.75, CellBaseline -> Baseline], 
    None}, {None, None}},
 LineSpacing->{1, 1},
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->9.5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseText"],
 CellMargins->{{16, 100}, {5, 5}},
 Hyphenation->True,
 LineSpacing->{1, 2},
 ParagraphSpacing->{0, 8},
 ParagraphIndent->0,
 CounterStyleMenuListing->None],

Cell[StyleData["ExerciseText", "Printout"],
 CellMargins->{{14, 24}, {6, 0}},
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->9.5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseDisplayFormula", StyleDefinitions -> StyleData[
 "DisplayFormula"]],
 ShowCellLabel->False,
 ShowStringCharacters->False,
 FontSize->12],

Cell[StyleData["ExerciseDisplayFormula", "Printout"],
 CellMargins->{{44, Inherited}, {8, 2}},
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->9.5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseInput", StyleDefinitions -> StyleData["Input"]],
 GeneratedCellStyles->{"Output"->{"ExerciseOutput"}},
 FontSize->11.25],

Cell[StyleData["ExerciseInput", "Printout"],
 CellMargins->{{44, Inherited}, {Inherited - 1, Inherited - 5}},
 FontSize->9.]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseInputOnly", StyleDefinitions -> StyleData["Input"]],
 GeneratedCellStyles->{"Output"->"ExerciseOutput"},
 FontSize->11.5],

Cell[StyleData["ExerciseInputOnly", "Printout"],
 CellMargins->{{44, 24}, {4, 0}},
 FontSize->9.]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseOutput", StyleDefinitions -> StyleData["Output"]],
 FontSize->11.25],

Cell[StyleData["ExerciseOutput", "Printout"],
 CellMargins->{{44, 24}, {6, 0}},
 FontSize->9.]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseFigure"],
 CellMargins->{{16, 4}, {0, 12}},
 CellGroupingRules->"InputGrouping",
 CellFrameLabels->{{
    Cell[
     TextData[{"Figure ", 
       CounterBox["Chapter"], ".", 
       CounterBox["NumberedFigure"], "\t"}], CellBaseline -> Baseline, 
     FontSlant -> "Plain"], None}, {None, None}},
 TabSpacings->0.25,
 CounterIncrements->"NumberedFigure",
 MenuSortingValue->1670,
 FormatTypeAutoConvert->False,
 FontSize->12,
 FontSlant->"Italic"],

Cell[StyleData["ExerciseFigure", "Printout"],
 CellMargins->{{14, Inherited}, {0, 3.75}},
 PageBreakBelow->False,
 GroupPageBreakWithin->False,
 CellFrameLabels->{{
    Cell[
     TextData[{"Figure ", 
       CounterBox["Chapter"], ".", 
       CounterBox["NumberedFigure"], ".", "\t"}], FontFamily -> 
     "DTL Albertina TOT Caps", FontSlant -> "Plain", CellBaseline -> 
     Baseline], None}, {None, None}},
 TabSpacings->0.25,
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->9.5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExFigure"],
 Deletable->True,
 CellMargins->{{18, 10}, {14, 12}},
 CellGroupingRules->"OutputGrouping",
 CellAutoOverwrite->False,
 ShowCellLabel->False,
 ShowStringCharacters->False,
 MenuSortingValue->1500,
 MenuCommandKey->None],

Cell[StyleData["ExFigure", "Printout"],
 CellMargins->{{14, 10}, {10.75, 6.75}},
 PageBreakAbove->False,
 GroupPageBreakWithin->False]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["ExTable"],
 Deletable->True,
 CellMargins->{{16, Inherited}, {18, 0}},
 CellGroupingRules->"OutputGrouping",
 DefaultFormatType->DefaultTraditionalFormatType,
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 LanguageCategory->"Formula",
 ScriptLevel->0,
 SingleLetterItalics->True,
 UnderoverscriptBoxOptions->{LimitsPositioning->True}],

Cell[StyleData["ExTable", "Printout"],
 CellMargins->{{18, 0}, {10.75, 6.75}},
 PageBreakAbove->False,
 PageBreakWithin->False,
 GroupPageBreakWithin->False]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseTable"],
 CellMargins->{{16, 4}, {12, 14}},
 CellGroupingRules->"InputGrouping",
 CellFrameLabels->{{
    Cell[
     TextData[{"Table ", 
       CounterBox["Chapter"], ".", 
       CounterBox["NumberedTable"], ".", "\t"}], CellBaseline -> Baseline, 
     FontSlant -> "Plain"], None}, {None, None}},
 TabSpacings->1.1,
 CounterIncrements->"NumberedTable",
 MenuSortingValue->1660,
 FormatTypeAutoConvert->False,
 FontSize->12,
 FontSlant->"Italic"],

Cell[StyleData["ExerciseTable", "Printout"],
 CellMargins->{{13, 0}, {0, 3.75}},
 PageBreakBelow->False,
 GroupPageBreakWithin->False,
 CellFrameLabels->{{
    Cell[
     TextData[{"Table ", 
       CounterBox["Chapter"], ".", 
       CounterBox["NumberedTable"], ".", "\t"}], CellBaseline -> Baseline, 
     FontFamily -> "DTL Albertina TOT Caps", FontSlant -> "Plain"], None}, {
   None, None}},
 TabSpacings->0.25,
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->9.5]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Spacer cells", "Section"],

Cell[CellGroupData[{

Cell[StyleData["FlourishCell"],
 CellFrame->{{0, 0}, {0, 0}},
 CellMargins->{{0, 24}, {0, 0}},
 CellGroupingRules->{"SectionGrouping", 40},
 CellFrameLabels->{{None, None}, {None, 
    Cell[
     BoxData[
      GraphicsBox[
       TagBox[
        RasterBox[CompressedData["
1:eJx10mtOg0AUBWCMK3FLLqEbcIeKgPISHwiUChRtKwiiGMSICNbjvZmm/eGX
kJAAw9xz5mBydDjZlyRpD5eB6+9+LfwI4zgOw/C9q+/7L/JJPoS2bd93NU3z
Ruq6fiUvpKqqZ1KWZVEUT0Ke51mWPZLVarVcLh/IPUnTdE6SJInjOIqiO2E2
m4VhOCVBEPi+73neLbkh1+SKXJILYlmWaZqGYei6fk7OiKZpqqqeCifCMeF7
WZb5qaIoeJk/5EV0gmWxvm3b+JHjOPxfbIA3wxtzXZf36ZOpgHEwFE+HSTEv
pp4LHAiHs1gsEBTi4twQIGLkPAuCkDltxM75cxcohdtBTdutocdNp1xx13Xc
OKrfPgk4Gzghm9Oy/scv/GgUOA==
         "], {{0, 1}, {200, 0}}, {0, 255}, 
         ColorFunction -> RGBColor], 
        BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True], 
        Selectable -> False], BaseStyle -> "ImageGraphics", 
       ImageSizeRaw -> {200, 1}, PlotRange -> {{0, 200}, {0, 1}}]]]}}],

Cell[StyleData["FlourishCell", "Printout"],
 CellFrame->{{0, 0}, {0, 0}},
 CellMargins->{{0, 24}, {0, 0}},
 CellGroupingRules->{"SectionGrouping", 40},
 CellFrameLabels->{{None, None}, {None, 
    Cell[
     BoxData[
      GraphicsBox[
       TagBox[
        RasterBox[CompressedData["
1:eJx10mtOg0AUBWCMK3FLLqEbcIeKgPISHwiUChRtKwiiGMSICNbjvZmm/eGX
kJAAw9xz5mBydDjZlyRpD5eB6+9+LfwI4zgOw/C9q+/7L/JJPoS2bd93NU3z
Ruq6fiUvpKqqZ1KWZVEUT0Ke51mWPZLVarVcLh/IPUnTdE6SJInjOIqiO2E2
m4VhOCVBEPi+73neLbkh1+SKXJILYlmWaZqGYei6fk7OiKZpqqqeCifCMeF7
WZb5qaIoeJk/5EV0gmWxvm3b+JHjOPxfbIA3wxtzXZf36ZOpgHEwFE+HSTEv
pp4LHAiHs1gsEBTi4twQIGLkPAuCkDltxM75cxcohdtBTdutocdNp1xx13Xc
OKrfPgk4Gzghm9Oy/scv/GgUOA==
         "], {{0, 1}, {200, 0}}, {0, 255}, 
         ColorFunction -> RGBColor], 
        BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True], 
        Selectable -> False], BaseStyle -> "ImageGraphics", 
       ImageSizeRaw -> {200, 1}, PlotRange -> {{0, 200}, {0, 1}}]]]}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SectionSpacer"],
 CellDingbat->Cell[
  "Section spacer", "Menu", FontColor -> GrayLevel[1], FontSize -> 8, 
   Background -> GrayLevel[0.67]],
 CellBracketOptions->{"Color"->RGBColor[1, 0, 0],
 "Thickness"->0.55},
 CellGroupingRules->{"SectionGrouping", 31}],

Cell[StyleData["SectionSpacer", "Printout"],
 CellDingbat->None,
 CellMargins->{{Inherited, Inherited}, {13, 0}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsectionSpacer"],
 CellDingbat->Cell[
  "Subsection spacer", "Menu", FontColor -> GrayLevel[1], FontSize -> 8, 
   Background -> GrayLevel[0.67]],
 CellBracketOptions->{"Color"->RGBColor[1, 0, 0],
 "Thickness"->0.55}],

Cell[StyleData["SubsectionSpacer", "Printout"],
 CellDingbat->None,
 CellMargins->{{Inherited, Inherited}, {0, 0}},
 CellElementSpacings->{"CellMinHeight"->0}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["BibliographySpacer"],
 CellDingbat->Cell[
  "Reference spacer", "Menu", FontColor -> GrayLevel[1], FontSize -> 8, 
   Background -> GrayLevel[0.67]],
 CellBracketOptions->{"Color"->RGBColor[1, 0, 0],
 "Thickness"->0.55}],

Cell[StyleData["BibliographySpacer", "Printout"],
 CellDingbat->None,
 CellMargins->{{Inherited, Inherited}, {0, 0}},
 CellElementSpacings->{"CellMinHeight"->0}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOP"],
 CellBracketOptions->{"Color"->RGBColor[1, 0, 1]}],

Cell[StyleData["TOP", "Printout"],
 CellMargins->{{Inherited, Inherited}, {Inherited, Inherited - 1}},
 CellBracketOptions->{"Color"->RGBColor[1, 0, 0],
 "Thickness"->1}]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["BOTTOM"],
 CellBracketOptions->{"Color"->RGBColor[1, 0, 1]}],

Cell[StyleData["BOTTOM", "Printout"],
 CellMargins->{{Inherited, Inherited}, {Inherited + 12, Inherited}},
 CellBracketOptions->{"Color"->RGBColor[1, 0, 0],
 "Thickness"->1}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PageBreak"],
 Editable->False,
 CellFrame->1,
 CellMargins->{{0, 0}, {1, 1}},
 CellBracketOptions->{"Color"->RGBColor[1, 0, 1]},
 CellElementSpacings->{"CellMinHeight"->1,
 "ClosedCellHeight"->1},
 CellOpen->False,
 CellFrameMargins->0,
 CellSize->{Inherited, 2},
 Background->GrayLevel[0.5]],

Cell[StyleData["PageBreak", "Printout"],
 CellFrame->0,
 ShowCellBracket->Automatic,
 CellMargins->{{0, 0}, {0, 0}},
 CellBracketOptions->{"Color"->RGBColor[1, 0, 1]},
 CellElementSpacings->{"CellMinHeight"->0,
 "ClosedCellHeight"->0},
 PageBreakBelow->True,
 Background->None]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Mathematica system\[Hyphen]specific elements", "Section"],

Cell[CellGroupData[{

Cell["Labels, Panels, Manipulate, etc.", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Link"]],

Cell[StyleData["Link", "Printout", StyleDefinitions -> StyleData[
 "Text", "Printout"]],
 FontColor->GrayLevel[0]]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["Hyperlink"],
 FontColor->Hue[0.9]],

Cell[StyleData["Hyperlink", "Printout"],
 FontColor->GrayLevel[0]]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["InformationLink"]],

Cell[StyleData["InformationLink", "Printout"],
 FontFamily->"Syntax LT Std",
 FontSize->9]
}, Closed]],

Cell[StyleData["Placeholder"],
 FontFamily->"Syntax LT Std"],

Cell[CellGroupData[{

Cell[StyleData["DialogStyle"]],

Cell[StyleData["DialogStyle", "Printout"],
 FontFamily->"Syntax LT Std",
 FontSize->7]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Panel"],
 ShowStringCharacters->False,
 FontFamily->CurrentValue["PanelFontFamily"],
 FontSize->CurrentValue["PanelFontSize"],
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontColor->GrayLevel[0],
 Background->CurrentValue["PanelBackground"]],

Cell[StyleData["Panel", "Printout"],
 ShowStringCharacters->False,
 FontFamily->"Syntax LT Std",
 FontSize->8,
 FontColor->GrayLevel[0],
 Background->CurrentValue["PanelBackground"]]
}, Closed]],

Cell[StyleData["TooltipLabel"],
 CellFrame->1.,
 CellFrameMargins:>CurrentValue["TooltipFrameMargins"],
 CellFrameColor:>CurrentValue[{"SystemColor", "TooltipFrame"}],
 TextAlignment->Left,
 TextJustification->0.,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["TooltipFontFamily"],
 FontSize:>CurrentValue["TooltipFontSize"],
 FontWeight->"Plain",
 FontSlant->"Plain",
 Magnification->1.5,
 FontColor->GrayLevel[0],
 FontOpacity->1.,
 Background:>CurrentValue[{"SystemColor", "Tooltip"}]],

Cell[CellGroupData[{

Cell[StyleData["Manipulate"],
 ShowAutoStyles->False,
 ShowStringCharacters->False,
 NumberMarks->False,
 FontWeight->"Plain"],

Cell[StyleData["Manipulate", "Printout"],
 Magnification->0.55,
 AnimatorBoxOptions->{ImageSize->Tiny},
 GraphicsBoxOptions->{ImageSize->{100, Automatic}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["ManipulateLabel"]],

Cell[StyleData["ManipulateLabel", "Printout"],
 FontFamily->"Syntax LT Std",
 FontSize->9.75]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Manipulator"],
 ShowStringCharacters->False,
 NumberMarks->False,
 FontFamily:>CurrentValue["PanelFontFamily"],
 FontSize:>CurrentValue["PanelFontSize"] - 1,
 FontWeight->"Plain"],

Cell[StyleData["Manipulator", "Printout"],
 FontFamily->"Syntax LT Std",
 FontSize->10]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["GenericButton", StyleDefinitions -> StyleData["ControlStyle"]],
 ShowStringCharacters->False],

Cell[StyleData["GenericButton", "Printout"],
 FontFamily->"Syntax LT Std",
 FontSize->9]
}, Closed]],

Cell[StyleData["Animate", StyleDefinitions -> StyleData["Manipulate"]]],

Cell[CellGroupData[{

Cell[StyleData["AnimateLabel", StyleDefinitions -> StyleData[
 "ManipulateLabel"]]],

Cell[StyleData["AnimateLabel", "Printout"],
 FontFamily->"Syntax LT Std",
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TabViewLabel"],
 TextAlignment->Left,
 TextJustification->0.,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["ControlsFontFamily"]],

Cell[StyleData["TabViewLabel", "Printout"],
 FontFamily->"Syntax LT Std",
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PopupMenuLabel", StyleDefinitions -> StyleData["MenuLabel"]],
 FontColor:>CurrentValue[{"SystemColor", "DialogText"}]],

Cell[StyleData["PopupMenuLabel", "Printout"],
 FontFamily->"Syntax LT Std",
 FontSize->9,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[StyleData["Slider2D"],
 Slider2DBoxOptions->{ImageSize->Small}],

Cell[StyleData["Slider"],
 SliderBoxOptions->{ImageSize->Tiny}],

Cell[CellGroupData[{

Cell[StyleData["InfoHeading"]],

Cell[StyleData["InfoHeading", "Printout"],
 FontFamily->"Syntax LT Std",
 FontSize->9.75]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Graphics", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Graphics"],
 FontSize->6.5],

Cell[StyleData["Graphics", "Printout"],
 FontFamily->"Syntax LT Std",
 FontSize->5.25]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Graphics3D"],
 FontSize->6.5],

Cell[StyleData["Graphics3D", "Printout"],
 FontFamily->"Syntax LT Std",
 FontSize->5.25]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Compile and Suggestion bar", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["SuggestionsBarControl"]],

Cell[StyleData["SuggestionsBarControl", "Printout"],
 FontSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SuggestionsBarCategory"]],

Cell[StyleData["SuggestionsBarCategory", "Printout"],
 FontSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SummaryItemAnnotation"]],

Cell[StyleData["SummaryItemAnnotation", "Printout"],
 FontSize->7.]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SummaryItem"]],

Cell[StyleData["SummaryItem", "Printout"],
 FontSize->7]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Miscellaneous", "Subsection"],

Cell[StyleData["CellExpression"],
 PageWidth->Infinity,
 CellMargins->{{6, Inherited}, {Inherited, Inherited}},
 ShowCellLabel->False,
 ContextMenu->FEPrivate`FrontEndResource["ContextMenus", "CellExpression"],
 ShowSpecialCharacters->False,
 AllowInlineCells->False,
 Hyphenation->False,
 AutoItalicWords->{},
 AutoQuoteCharacters->{},
 PasteAutoQuoteCharacters->{},
 LanguageCategory->None,
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->12,
 Magnification->1.25,
 Background->GrayLevel[0.9]]
}, Closed]]
}, Closed]]
},
Editable->True,
Saveable->True,
ScreenStyleEnvironment->"Working",
WindowSize->{922, 863},
WindowMargins->{{Automatic, 234}, {Automatic, 180}},
PrintingCopies->1,
PrintingPageRange->{1, Automatic},
FrontEndVersion->"10.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (December 10, \
2015)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[StyleDefinitions -> "StylesheetFormatting.nb"]]}, Visible -> 
  False, FrontEndVersion -> 
  "10.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (December 10, 2015)", 
  StyleDefinitions -> "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 277, 8, 100, "Subtitle",
 CellGroupingRules->{"SectionGrouping", 30}],
Cell[860, 32, 49, 0, 36, 49, 0, "StyleData", "StyleDefinitions", ""]
}, Closed]],
Cell[CellGroupData[{
Cell[946, 37, 42, 0, 33, "Section"],
Cell[991, 39, 85, 2, 36, 31, 0, "StyleData", "All", "Working"],
Cell[1079, 43, 230, 7, 35, 32, 0, "StyleData", "All", "Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1346, 55, 35, 0, 49, "Section"],
Cell[1384, 57, 99, 2, 43, "Text"],
Cell[1486, 61, 450, 9, 36, 27, 0, "StyleData", "Notebook", "All"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1973, 75, 27, 0, 49, "Section"],
Cell[CellGroupData[{
Cell[2025, 79, 362, 9, 48, 32, 0, "StyleData", "ChapterNumber", "All",
 CounterIncrements->"Chapter",
 CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}, {
   "Subtitle", 0}, {"Subsubtitle", 0}, {"ContentsChapter", 0}},
 MenuSortingValue->1010],
Cell[2390, 90, 176, 5, 38, 44, 0, "StyleData", "ChapterNumber", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[2603, 100, 1566, 30, 45, 32, 0, "StyleData", "TitleFlourish", "All"],
Cell[4172, 132, 1623, 32, 70, 44, 0, "StyleData", "TitleFlourish", \
"Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5832, 169, 218, 7, 70, 31, 0, "StyleData", "ChapterTitle", "All",
 MenuSortingValue->1100,
 MenuCommandKey->"1"],
Cell[6053, 178, 199, 6, 56, 43, 0, "StyleData", "ChapterTitle", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[6289, 189, 265, 9, 72, 34, 0, "StyleData", "ChapterAbstract", "All",
 StyleMenuListing->None],
Cell[6557, 200, 231, 7, 112, 46, 0, "StyleData", "ChapterAbstract", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[6825, 212, 685, 24, 43, 26, 0, "StyleData", "Section", "All",
 CounterIncrements->"Section",
 CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}, {
   "ExerciseItem", 0}},
 MenuSortingValue->1200,
 MenuCommandKey->"4"],
Cell[7513, 238, 471, 15, 39, 38, 0, "StyleData", "Section", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[8021, 258, 321, 11, 36, 29, 0, "StyleData", "Subsection", "All",
 MenuSortingValue->1250,
 MenuCommandKey->"5"],
Cell[8345, 271, 131, 3, 32, 41, 0, "StyleData", "Subsection", "Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8513, 279, 374, 13, 37, 32, 0, "StyleData", "Subsubsection", "All",
 CounterIncrements->"Subsubsection",
 StyleMenuListing->None],
Cell[8890, 294, 178, 5, 31, 44, 0, "StyleData", "Subsubsection", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[9117, 305, 23, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[9165, 309, 217, 8, 44, 23, 0, "StyleData", "Text", "All",
 CounterIncrements->"Text",
 MenuSortingValue->1310,
 MenuCommandKey->"7"],
Cell[9385, 319, 191, 6, 31, 35, 0, "StyleData", "Text", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[9613, 330, 135, 3, 41, 67, 0, "StyleData", "TextFirst", "All",
 MenuSortingValue->1300,
 MenuCommandKey->"6"],
Cell[9751, 335, 61, 1, 38, 40, 0, "StyleData", "TextFirst", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[9849, 341, 229, 6, 38, 23, 0, "StyleData", "Item", "All"],
Cell[10081, 349, 252, 7, 43, 35, 0, "StyleData", "Item", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[10370, 361, 138, 2, 38, 67, 0, "StyleData", "ItemFirst", "All"],
Cell[10511, 365, 163, 4, 39, 40, 0, "StyleData", "ItemFirst", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[10711, 374, 97, 1, 38, 26, 0, "StyleData", "Subitem", "All"],
Cell[10811, 377, 150, 4, 43, 38, 0, "StyleData", "Subitem", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[10998, 386, 430, 14, 34, 31, 0, "StyleData", "NumberedItem", "All",
 CounterIncrements->"ItemNumber",
 MenuSortingValue->1340,
 MenuCommandKey->None],
Cell[11431, 402, 337, 9, 43, 43, 0, "StyleData", "NumberedItem", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[11805, 416, 185, 4, 26, 27, 0, "StyleData", "TipStart", "All"],
Cell[11993, 422, 75, 1, 30, 39, 0, "StyleData", "TipStart", "Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12105, 428, 178, 4, 31, 25, 0, "StyleData", "TipEnd", "All"],
Cell[12286, 434, 74, 1, 32, 37, 0, "StyleData", "TipEnd", "Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12397, 440, 366, 11, 30, 30, 0, "StyleData", "NumberedTip", "All",
 CounterIncrements->"NumberedTip"],
Cell[12766, 453, 603, 16, 27, 42, 0, "StyleData", "NumberedTip", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[13406, 474, 150, 3, 36, 65, 0, "StyleData", "TipText", "All"],
Cell[13559, 479, 143, 4, 34, 38, 0, "StyleData", "TipText", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[13739, 488, 131, 2, 37, 67, 0, "StyleData", "TipInput", "All"],
Cell[13873, 492, 107, 2, 25, 39, 0, "StyleData", "TipInput", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[14017, 499, 84, 1, 38, 69, 0, "StyleData", "TipOutput", "All"],
Cell[14104, 502, 112, 2, 27, 40, 0, "StyleData", "TipOutput", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[14265, 510, 31, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[14321, 514, 65, 1, 41, 24, 0, "StyleData", "Input", "All"],
Cell[14389, 517, 115, 3, 33, 36, 0, "StyleData", "Input", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[14541, 525, 109, 1, 40, 68, 0, "StyleData", "InputOnly", "All"],
Cell[14653, 528, 94, 2, 46, 40, 0, "StyleData", "InputOnly", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[14784, 535, 66, 1, 39, 25, 0, "StyleData", "Output", "All"],
Cell[14853, 538, 89, 2, 31, 37, 0, "StyleData", "Output", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[14979, 545, 69, 1, 35, 26, 0, "StyleData", "Message", "All"],
Cell[15051, 548, 105, 2, 33, 38, 0, "StyleData", "Message", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[15193, 555, 81, 1, 36, 24, 0, "StyleData", "Print", "All"],
Cell[15277, 558, 97, 2, 35, 36, 0, "StyleData", "Print", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[15411, 565, 28, 0, 33, 28, 0, "StyleData", "CellLabel", "All"],
Cell[15442, 567, 115, 3, 30, 40, 0, "StyleData", "CellLabel", "Printout"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[15606, 576, 32, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[15663, 580, 245, 8, 54, 33, 0, "StyleData", "PrefaceSection", "All"],
Cell[15911, 590, 154, 4, 33, 45, 0, "StyleData", "PrefaceSection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[16102, 599, 204, 7, 32, 24, 0, "StyleData", "Quote", "All",
 CounterIncrements->"Text",
 StyleMenuListing->None],
Cell[16309, 608, 170, 5, 38, 36, 0, "StyleData", "Quote", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[16516, 618, 211, 7, 44, 30, 0, "StyleData", "QuoteAuthor", "All",
 CounterIncrements->"Text",
 StyleMenuListing->None],
Cell[16730, 627, 197, 6, 34, 42, 0, "StyleData", "QuoteAuthor", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[16964, 638, 223, 7, 42, 26, 0, "StyleData", "Picture", "All",
 MenuSortingValue->1500,
 MenuCommandKey->None],
Cell[17190, 647, 92, 2, 54, 38, 0, "StyleData", "Picture", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[17331, 655, 34, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[17390, 659, 242, 5, 54, 76, 0, "StyleData", "NonPrintSection", "All"],
Cell[17635, 666, 183, 5, 10, 46, 0, "StyleData", "NonPrintSection", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[17855, 676, 268, 8, 42, 39, 0, "StyleData", "NonPrintSolutionLink", \
"All"],
Cell[18126, 686, 214, 5, 0, 51, 0, "StyleData", "NonPrintSolutionLink", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[18377, 696, 271, 5, 37, 72, 0, "StyleData", "NonPrintInput", "All"],
Cell[18651, 703, 233, 6, 0, 44, 0, "StyleData", "NonPrintInput", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[18921, 714, 341, 8, 38, 28, 0, "StyleData", "Editorial", "All"],
Cell[19265, 724, 228, 6, 0, 40, 0, "StyleData", "Editorial", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[19542, 736, 44, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[19611, 740, 245, 8, 54, 25, 0, "StyleData", "Figure", "All",
 MenuSortingValue->1500,
 MenuCommandKey->None],
Cell[19859, 750, 72, 1, 41, 37, 0, "StyleData", "Figure", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[19968, 756, 471, 14, 34, 33, 0, "StyleData", "NumberedFigure", "All",
 CounterIncrements->"NumberedFigure",
 MenuSortingValue->1670],
Cell[20442, 772, 434, 11, 42, 45, 0, "StyleData", "NumberedFigure", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[20913, 788, 357, 8, 46, 31, 0, "StyleData", "DisplayTable", "All"],
Cell[21273, 798, 77, 1, 48, 43, 0, "StyleData", "DisplayTable", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[21387, 804, 472, 14, 46, 32, 0, "StyleData", "NumberedTable", "All",
 CounterIncrements->"NumberedTable",
 MenuSortingValue->1660],
Cell[21862, 820, 417, 11, 36, 44, 0, "StyleData", "NumberedTable", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[22316, 836, 416, 12, 40, 33, 0, "StyleData", "ProgramListing", "All",
 CounterIncrements->"NumberedProgram",
 MenuSortingValue->1680],
Cell[22735, 850, 454, 12, 41, 45, 0, "StyleData", "ProgramListing", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[23226, 867, 130, 3, 44, 40, 0, "StyleData", "ProgramListingNoLabel", \
"All",
 MenuSortingValue->1680],
Cell[23359, 872, 138, 3, 37, 52, 0, "StyleData", "ProgramListingNoLabel", \
"Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[23546, 881, 36, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[23607, 885, 28, 0, 36, 28, 0, "StyleData", "InputForm", "All"],
Cell[23638, 887, 185, 4, 36, 40, 0, "StyleData", "InputForm", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[23860, 896, 106, 3, 36, 31, 0, "StyleData", "StandardForm", "All",
 StyleMenuListing->None],
Cell[23969, 901, 71, 1, 37, 43, 0, "StyleData", "StandardForm", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[24077, 907, 72, 2, 36, 21, 0, "StyleData", "MR", "All",
 StyleMenuListing->None],
Cell[24152, 911, 87, 2, 46, 33, 0, "StyleData", "MR", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[24276, 918, 46, 1, 36, 21, 0, "StyleData", "TR", "All",
 StyleMenuListing->None],
Cell[24325, 921, 73, 1, 48, 33, 0, "StyleData", "TR", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[24435, 927, 46, 1, 36, 21, 0, "StyleData", "TI", "All",
 StyleMenuListing->None],
Cell[24484, 930, 95, 2, 48, 33, 0, "StyleData", "TI", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[24616, 937, 51, 1, 36, 26, 0, "StyleData", "OsFBold", "All",
 StyleMenuListing->None],
Cell[24670, 940, 84, 1, 39, 38, 0, "StyleData", "OsFBold", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[24791, 946, 46, 1, 36, 21, 0, "StyleData", "SR", "All",
 StyleMenuListing->None],
Cell[24840, 949, 63, 1, 36, 33, 0, "StyleData", "SR", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[24940, 955, 80, 1, 36, 63, 0, "StyleData", "SRSmall", "All"],
Cell[25023, 958, 82, 2, 32, 38, 0, "StyleData", "SRSmall", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[25142, 965, 62, 0, 36, 62, 0, "StyleData", "SRTiny", "All"],
Cell[25207, 967, 82, 2, 30, 37, 0, "StyleData", "SRTiny", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[25326, 974, 46, 1, 36, 21, 0, "StyleData", "SB", "All",
 StyleMenuListing->None],
Cell[25375, 977, 84, 2, 65, 33, 0, "StyleData", "SB", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[25496, 984, 55, 1, 36, 33, 0, "StyleData", "TermDefinition", "All"],
Cell[25554, 987, 107, 2, 48, 45, 0, "StyleData", "TermDefinition", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[25698, 994, 75, 2, 36, 28, 0, "StyleData", "SmallCaps", "All",
 StyleMenuListing->None],
Cell[25776, 998, 79, 1, 48, 40, 0, "StyleData", "SmallCaps", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[25892, 1004, 78, 2, 36, 22, 0, "StyleData", "OsF", "All",
 StyleMenuListing->None],
Cell[25973, 1008, 99, 2, 48, 34, 0, "StyleData", "OsF", "Printout"]
}, Closed]],
Cell[26087, 1013, 57, 1, 48, 32, 0, "StyleData", "ChapterNumber", "All",
 StyleMenuListing->None],
Cell[CellGroupData[{
Cell[26169, 1018, 110, 3, 35, 48, 0, "StyleData", "MSG", "All",
 StyleMenuListing->None],
Cell[26282, 1023, 81, 2, 33, 34, 0, "StyleData", "MSG", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[26400, 1030, 69, 2, 39, 23, 0, "StyleData", "Menu", "All"],
Cell[26472, 1034, 124, 4, 42, 35, 0, "StyleData", "Menu", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[26633, 1043, 50, 1, 36, 29, 0, "StyleData", "SubsubBold", "All"],
Cell[26686, 1046, 125, 3, 48, 41, 0, "StyleData", "SubsubBold", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[26848, 1054, 97, 3, 35, 31, 0, "StyleData", "TableHeading", "All",
 StyleMenuListing->None],
Cell[26948, 1059, 102, 2, 36, 43, 0, "StyleData", "TableHeading", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[27087, 1066, 108, 2, 40, 67, 0, "StyleData", "TableText", "All"],
Cell[27198, 1070, 118, 3, 37, 40, 0, "StyleData", "TableText", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[27353, 1078, 152, 4, 40, 69, 0, "StyleData", "TableTextTI", "All"],
Cell[27508, 1084, 120, 3, 37, 42, 0, "StyleData", "TableTextTI", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[27665, 1092, 65, 0, 36, 65, 0, "StyleData", "TableOsF", "All"],
Cell[27733, 1094, 56, 1, 45, 39, 0, "StyleData", "TableOsF", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[27826, 1100, 114, 2, 36, 63, 0, "StyleData", "TableMR", "All",
 StyleMenuListing->None],
Cell[27943, 1104, 82, 2, 42, 38, 0, "StyleData", "TableMR", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[28062, 1111, 110, 4, 36, 29, 0, "StyleData", "ExerciseTI", "All"],
Cell[28175, 1117, 119, 3, 45, 41, 0, "StyleData", "ExerciseTI", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[28331, 1125, 71, 2, 36, 29, 0, "StyleData", "ExerciseMR", "All"],
Cell[28405, 1129, 58, 1, 42, 41, 0, "StyleData", "ExerciseMR", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[28500, 1135, 66, 0, 36, 66, 0, "StyleData", "ExerciseSR", "All"],
Cell[28569, 1137, 86, 2, 38, 41, 0, "StyleData", "ExerciseSR", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[28692, 1144, 145, 4, 38, 34, 0, "StyleData", "CellLabelInline", "All",
 StyleMenuListing->None],
Cell[28840, 1150, 131, 3, 41, 46, 0, "StyleData", "CellLabelInline", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[29008, 1158, 90, 3, 36, 25, 0, "StyleData", "ITBold", "All"],
Cell[29101, 1163, 101, 2, 48, 37, 0, "StyleData", "ITBold", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[29239, 1170, 271, 5, 36, 23, 0, "StyleData", "WLDC", "All"],
Cell[29513, 1177, 82, 2, 34, 35, 0, "StyleData", "WLDC", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[29632, 1184, 149, 5, 40, 44, 0, "StyleData", \
"PrefaceContentsPageNumber", "All",
 StyleMenuListing->None],
Cell[29784, 1191, 128, 3, 47, 56, 0, "StyleData", \
"PrefaceContentsPageNumber", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[29949, 1199, 82, 2, 36, 25, 0, "StyleData", "TRLink", "All"],
Cell[30034, 1203, 103, 2, 39, 37, 0, "StyleData", "TRLink", "Printout"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[30186, 1211, 43, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[30254, 1215, 206, 5, 37, 32, 0, "StyleData", "InlineFormula", "All"],
Cell[30463, 1222, 44, 0, 37, 44, 0, "StyleData", "InlineFormula", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[30544, 1227, 334, 8, 30, 33, 0, "StyleData", "DisplayFormula", "All"],
Cell[30881, 1237, 147, 3, 40, 45, 0, "StyleData", "DisplayFormula", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[31065, 1245, 488, 17, 39, 26, 0, "StyleData", "Program", "All"],
Cell[31556, 1264, 145, 4, 37, 38, 0, "StyleData", "Program", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[31750, 1274, 38, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[31813, 1278, 50, 1, 23, 25, 0, "StyleData", "Header", "All",
 MenuSortingValue->None],
Cell[31866, 1281, 115, 3, 36, 37, 0, "StyleData", "Header", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[32018, 1289, 61, 1, 36, 36, 0, "StyleData", "FrontMatterHeader", "All",
 MenuSortingValue->None],
Cell[32082, 1292, 104, 2, 36, 48, 0, "StyleData", "FrontMatterHeader", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[32223, 1299, 57, 1, 36, 32, 0, "StyleData", "HeaderSection", "All",
 StyleMenuListing->None],
Cell[32283, 1302, 44, 0, 36, 44, 0, "StyleData", "HeaderSection", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[32364, 1307, 114, 4, 32, 29, 0, "StyleData", "PageFooter", "All",
 StyleMenuListing->None],
Cell[32481, 1313, 41, 0, 32, 41, 0, "StyleData", "PageFooter", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[32559, 1318, 90, 3, 30, 29, 0, "StyleData", "PageNumber", "All",
 StyleMenuListing->None],
Cell[32652, 1323, 139, 4, 36, 41, 0, "StyleData", "PageNumber", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[32828, 1332, 94, 3, 33, 33, 0, "StyleData", "PageNumberPref", "All",
 StyleMenuListing->None],
Cell[32925, 1337, 123, 3, 36, 45, 0, "StyleData", "PageNumberPref", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[33085, 1345, 89, 3, 33, 28, 0, "StyleData", "HeaderOsF", "All",
 StyleMenuListing->None],
Cell[33177, 1350, 116, 3, 36, 40, 0, "StyleData", "HeaderOsF", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[33342, 1359, 29, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[33396, 1363, 28, 0, 51, 28, 0, "StyleData", "SmallText", "All"],
Cell[33427, 1365, 120, 3, 40, 40, 0, "StyleData", "SmallText", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[33596, 1374, 27, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[33648, 1378, 79, 0, 52, 79, 0, "StyleData", "ContentsTitle", "All"],
Cell[33730, 1380, 101, 2, 107, 44, 0, "StyleData", "ContentsTitle", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[33868, 1387, 133, 3, 41, 39, 0, "StyleData", "ContentsChapterNoNum", \
"All"],
Cell[34004, 1392, 137, 3, 43, 51, 0, "StyleData", "ContentsChapterNoNum", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[34178, 1400, 131, 3, 36, 29, 0, "StyleData", "ChapterNum", "All",
 StyleMenuListing->None],
Cell[34312, 1405, 75, 1, 39, 41, 0, "StyleData", "ChapterNum", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[34424, 1411, 544, 17, 37, 83, 1, "StyleData", "ContentsChapter", "All",
 CounterIncrements->{"ContentsChapter"},
 CounterAssignments->{{"ContentsSection", 0}},
 StyleMenuListing->None],
Cell[34971, 1430, 543, 16, 43, 46, 0, "StyleData", "ContentsChapter", \
"Printout",
 CounterIncrements->{"ContentsChapter"},
 CounterAssignments->{{"ContentsSection", 0}},
 StyleMenuListing->None]
}, Closed]],
Cell[CellGroupData[{
Cell[35551, 1451, 584, 18, 38, 76, 0, "StyleData", "ContentsSection", "All",
 CounterIncrements->{"ContentsSection"},
 StyleMenuListing->None],
Cell[36138, 1471, 467, 14, 29, 46, 0, "StyleData", "ContentsSection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[36642, 1490, 199, 4, 50, 84, 1, "StyleData", "ContentsSubsection", "All"],
Cell[36844, 1496, 185, 5, 33, 49, 0, "StyleData", "ContentsSubsection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[37066, 1506, 142, 5, 40, 37, 0, "StyleData", "ContentsPageNumber", "All",
 
 StyleMenuListing->None],
Cell[37211, 1513, 106, 2, 37, 49, 0, "StyleData", "ContentsPageNumber", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[37354, 1520, 143, 3, 40, 39, 0, "StyleData", "ContentsSectionNoNum", \
"All",
 StyleMenuListing->None],
Cell[37500, 1525, 134, 3, 36, 51, 0, "StyleData", "ContentsSectionNoNum", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[37671, 1533, 414, 13, 38, 42, 0, "StyleData", "ContentsSolutionSection", \
"All",
 CounterIncrements->{"ContentsChapter"},
 StyleMenuListing->None],
Cell[38088, 1548, 390, 11, 37, 54, 0, "StyleData", "ContentsSolutionSection", \
"Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[38527, 1565, 31, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[38583, 1569, 383, 13, 56, 82, 1, "StyleData", "ReferenceSection", "All",
 CounterIncrements->"Chapter"],
Cell[38969, 1584, 446, 14, 42, 47, 0, "StyleData", "ReferenceSection", \
"Printout",
 CounterIncrements->"Chapter"]
}, Closed]],
Cell[CellGroupData[{
Cell[39452, 1603, 130, 2, 36, 85, 1, "StyleData", "ReferenceSubsection", \
"All"],
Cell[39585, 1607, 153, 4, 39, 50, 0, "StyleData", "ReferenceSubsection", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[39775, 1616, 226, 8, 36, 29, 0, "StyleData", "References", "All",
 StyleMenuListing->None],
Cell[40004, 1626, 174, 5, 34, 41, 0, "StyleData", "References", "Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[40215, 1636, 209, 7, 38, 36, 0, "StyleData", "ReferenceAbstract", "All",
 StyleMenuListing->None],
Cell[40427, 1645, 187, 5, 33, 48, 0, "StyleData", "ReferenceAbstract", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[40651, 1655, 132, 2, 36, 87, 1, "StyleData", "ReferenceSectionNoNum", \
"All"],
Cell[40786, 1659, 154, 4, 33, 52, 0, "StyleData", "ReferenceSectionNoNum", \
"Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[40989, 1669, 24, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[41038, 1673, 76, 0, 52, 76, 0, "StyleData", "IndexTitle", "All"],
Cell[41117, 1675, 64, 1, 70, 41, 0, "StyleData", "IndexTitle", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[41218, 1681, 82, 2, 28, 24, 0, "StyleData", "Index", "All",
 StyleMenuListing->None],
Cell[41303, 1685, 123, 3, 27, 36, 0, "StyleData", "Index", "Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[41463, 1693, 65, 1, 28, 32, 0, "StyleData", "IndexSubentry", "All"],
Cell[41531, 1696, 117, 2, 31, 44, 0, "StyleData", "IndexSubentry", \
"Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[41685, 1703, 132, 4, 36, 31, 0, "StyleData", "Index2Column", "All",
 StyleMenuListing->None],
Cell[41820, 1709, 173, 5, 33, 43, 0, "StyleData", "Index2Column", "Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[42030, 1719, 55, 1, 36, 30, 0, "StyleData", "IndexPageSC", "All",
 StyleMenuListing->None],
Cell[42088, 1722, 81, 1, 39, 42, 0, "StyleData", "IndexPageSC", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[42206, 1728, 55, 1, 36, 30, 0, "StyleData", "IndexPageTI", "All",
 StyleMenuListing->None],
Cell[42264, 1731, 104, 2, 39, 42, 0, "StyleData", "IndexPageTI", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[42405, 1738, 61, 0, 36, 61, 0, "StyleData", "MRInd", "All"],
Cell[42469, 1740, 36, 0, 37, 36, 0, "StyleData", "MRInd", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[42554, 1746, 28, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[42607, 1750, 964, 21, 44, 33, 0, "StyleData", "ExerciseSpacer", "All"],
Cell[43574, 1773, 1580, 31, 42, 45, 0, "StyleData", "ExerciseSpacer", \
"Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[45191, 1809, 478, 14, 39, 31, 0, "StyleData", "ExerciseItem", "All",
 CounterIncrements->"ExerciseItem",
 CounterAssignments->{{"ExerciseSubItem", 0}},
 MenuSortingValue->1700],
Cell[45672, 1825, 388, 11, 34, 43, 0, "StyleData", "ExerciseItem", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[46097, 1841, 481, 12, 34, 34, 0, "StyleData", "ExerciseSubItem", "All",
 CounterIncrements->"ExerciseSubItem"],
Cell[46581, 1855, 438, 11, 34, 46, 0, "StyleData", "ExerciseSubItem", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[47056, 1871, 188, 6, 37, 31, 0, "StyleData", "ExerciseText", "All"],
Cell[47247, 1879, 133, 3, 34, 43, 0, "StyleData", "ExerciseText", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[47417, 1887, 160, 4, 28, 92, 1, "StyleData", "ExerciseDisplayFormula", \
"All"],
Cell[47580, 1893, 150, 3, 38, 53, 0, "StyleData", "ExerciseDisplayFormula", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[47767, 1901, 144, 2, 37, 72, 0, "StyleData", "ExerciseInput", "All"],
Cell[47914, 1905, 124, 2, 21, 44, 0, "StyleData", "ExerciseInput", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[48075, 1912, 145, 2, 37, 76, 0, "StyleData", "ExerciseInputOnly", \
"All"],
Cell[48223, 1916, 97, 2, 36, 48, 0, "StyleData", "ExerciseInputOnly", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[48357, 1923, 92, 1, 38, 74, 0, "StyleData", "ExerciseOutput", "All"],
Cell[48452, 1926, 94, 2, 38, 45, 0, "StyleData", "ExerciseOutput", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[48583, 1933, 471, 14, 32, 33, 0, "StyleData", "ExerciseFigure", "All",
 CounterIncrements->"NumberedFigure",
 MenuSortingValue->1670],
Cell[49057, 1949, 486, 13, 31, 45, 0, "StyleData", "ExerciseFigure", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[49580, 1967, 247, 8, 46, 27, 0, "StyleData", "ExFigure", "All",
 MenuSortingValue->1500,
 MenuCommandKey->None],
Cell[49830, 1977, 134, 3, 45, 39, 0, "StyleData", "ExFigure", "Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[50001, 1985, 370, 9, 46, 26, 0, "StyleData", "ExTable", "All"],
Cell[50374, 1996, 157, 4, 56, 38, 0, "StyleData", "ExTable", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[50568, 2005, 472, 14, 44, 32, 0, "StyleData", "ExerciseTable", "All",
 CounterIncrements->"NumberedTable",
 MenuSortingValue->1660],
Cell[51043, 2021, 473, 13, 38, 44, 0, "StyleData", "ExerciseTable", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[51565, 2040, 31, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[51621, 2044, 962, 21, 44, 31, 0, "StyleData", "FlourishCell", "All"],
Cell[52586, 2067, 974, 21, 44, 43, 0, "StyleData", "FlourishCell", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[53597, 2093, 274, 6, 36, 32, 0, "StyleData", "SectionSpacer", "All"],
Cell[53874, 2101, 113, 2, 41, 44, 0, "StyleData", "SectionSpacer", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[54024, 2108, 235, 5, 36, 35, 0, "StyleData", "SubsectionSpacer", "All"],
Cell[54262, 2115, 159, 3, 28, 47, 0, "StyleData", "SubsectionSpacer", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[54458, 2123, 236, 5, 36, 37, 0, "StyleData", "BibliographySpacer", "All"],
Cell[54697, 2130, 161, 3, 28, 49, 0, "StyleData", "BibliographySpacer", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[54895, 2138, 73, 1, 36, 22, 0, "StyleData", "TOP", "All"],
Cell[54971, 2141, 170, 3, 34, 34, 0, "StyleData", "TOP", "Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[55178, 2149, 76, 1, 36, 25, 0, "StyleData", "BOTTOM", "All"],
Cell[55257, 2152, 174, 3, 60, 37, 0, "StyleData", "BOTTOM", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[55468, 2160, 308, 10, 4, 28, 0, "StyleData", "PageBreak", "All"],
Cell[55779, 2172, 277, 8, 28, 40, 0, "StyleData", "PageBreak", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[56105, 2186, 63, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[56193, 2190, 54, 0, 45, "Subsection"],
Cell[CellGroupData[{
Cell[56272, 2194, 23, 0, 36, 23, 0, "StyleData", "Link", "All"],
Cell[56298, 2196, 114, 2, 31, 88, 1, "StyleData", "Link", "Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[56449, 2203, 50, 1, 36, 28, 0, "StyleData", "Hyperlink", "All"],
Cell[56502, 2206, 66, 1, 36, 40, 0, "StyleData", "Hyperlink", "Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[56605, 2212, 34, 0, 36, 34, 0, "StyleData", "InformationLink", "All"],
Cell[56642, 2214, 90, 2, 33, 46, 0, "StyleData", "InformationLink", "Printout"]
}, Closed]],
Cell[56747, 2219, 60, 1, 49, 30, 0, "StyleData", "Placeholder", "All"],
Cell[CellGroupData[{
Cell[56832, 2224, 30, 0, 36, 30, 0, "StyleData", "DialogStyle", "All"],
Cell[56865, 2226, 86, 2, 38, 42, 0, "StyleData", "DialogStyle", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[56988, 2233, 257, 7, 52, 24, 0, "StyleData", "Panel", "All"],
Cell[57248, 2242, 182, 5, 60, 36, 0, "StyleData", "Panel", "Printout"]
}, Closed]],
Cell[57445, 2250, 498, 14, 55, 31, 0, "StyleData", "TooltipLabel", "All"],
Cell[CellGroupData[{
Cell[57968, 2268, 126, 4, 36, 29, 0, "StyleData", "Manipulate", "All"],
Cell[58097, 2274, 155, 3, 27, 41, 0, "StyleData", "Manipulate", "Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[58289, 2282, 34, 0, 35, 34, 0, "StyleData", "ManipulateLabel", "All"],
Cell[58326, 2284, 93, 2, 42, 46, 0, "StyleData", "ManipulateLabel", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[58456, 2291, 195, 5, 35, 30, 0, "StyleData", "Manipulator", "All"],
Cell[58654, 2298, 87, 2, 34, 42, 0, "StyleData", "Manipulator", "Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[58778, 2305, 109, 1, 40, 79, 0, "StyleData", "GenericButton", "All"],
Cell[58890, 2308, 88, 2, 41, 44, 0, "StyleData", "GenericButton", "Printout"]
}, Closed]],
Cell[58993, 2313, 71, 0, 36, 71, 0, "StyleData", "Animate", "All"],
Cell[CellGroupData[{
Cell[59089, 2317, 83, 1, 36, 83, 1, "StyleData", "AnimateLabel", "All"],
Cell[59175, 2320, 88, 2, 42, 43, 0, "StyleData", "AnimateLabel", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[59300, 2327, 156, 4, 38, 31, 0, "StyleData", "TabViewLabel", "All"],
Cell[59459, 2333, 87, 2, 41, 43, 0, "StyleData", "TabViewLabel", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[59583, 2340, 134, 1, 40, 77, 0, "StyleData", "PopupMenuLabel", "All"],
Cell[59720, 2343, 115, 3, 41, 45, 0, "StyleData", "PopupMenuLabel", "Printout"]
}, Closed]],
Cell[59850, 2349, 68, 1, 36, 27, 0, "StyleData", "Slider2D", "All"],
Cell[59921, 2352, 63, 1, 36, 25, 0, "StyleData", "Slider", "All"],
Cell[CellGroupData[{
Cell[60009, 2357, 30, 0, 34, 30, 0, "StyleData", "InfoHeading", "All"],
Cell[60042, 2359, 89, 2, 42, 42, 0, "StyleData", "InfoHeading", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[60180, 2367, 30, 0, 29, "Subsection"],
Cell[CellGroupData[{
Cell[60235, 2371, 43, 1, 31, 27, 0, "StyleData", "Graphics", "All"],
Cell[60281, 2374, 86, 2, 30, 39, 0, "StyleData", "Graphics", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[60404, 2381, 45, 1, 31, 29, 0, "StyleData", "Graphics3D", "All"],
Cell[60452, 2384, 88, 2, 30, 41, 0, "StyleData", "Graphics3D", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[60589, 2392, 48, 0, 29, "Subsection"],
Cell[CellGroupData[{
Cell[60662, 2396, 40, 0, 36, 40, 0, "StyleData", "SuggestionsBarControl", \
"All"],
Cell[60705, 2398, 66, 1, 32, 52, 0, "StyleData", "SuggestionsBarControl", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[60808, 2404, 41, 0, 36, 41, 0, "StyleData", "SuggestionsBarCategory", \
"All"],
Cell[60852, 2406, 67, 1, 32, 53, 0, "StyleData", "SuggestionsBarCategory", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[60956, 2412, 40, 0, 36, 40, 0, "StyleData", "SummaryItemAnnotation", \
"All"],
Cell[60999, 2414, 67, 1, 31, 52, 0, "StyleData", "SummaryItemAnnotation", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[61103, 2420, 30, 0, 36, 30, 0, "StyleData", "SummaryItem", "All"],
Cell[61136, 2422, 56, 1, 31, 42, 0, "StyleData", "SummaryItem", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[61241, 2429, 35, 0, 29, "Subsection"],
Cell[61279, 2431, 507, 16, 57, 33, 0, "StyleData", "CellExpression", "All",
 StyleMenuListing->None]
}, Closed]]
}, Closed]]
}
]
*)

(* End of internal cache information *)
