(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     51905,       1763]
NotebookOptionsPosition[     36019,       1370]
NotebookOutlinePosition[     36395,       1386]
CellTagsIndexPosition[     36352,       1383]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[StyleData[StyleDefinitions -> "Default.nb"]],

Cell[CellGroupData[{

Cell["Environment names", "Section",
 ShowGroupOpener->True],

Cell[StyleData[All, "Working"]],

Cell[StyleData[All, "Printout"]],

Cell[StyleData[All, "PrintToPDF"],
 PageWidth->PaperWidth]
}, Closed]],

Cell[CellGroupData[{

Cell["Headings", "Section",
 ShowGroupOpener->True],

Cell[CellGroupData[{

Cell[StyleData["TitleFlourish"],
 CellFrame->{{0, 0}, {0, 0}},
 CellMargins->{{0, 24}, {0, 0}},
 CellGroupingRules->{"SectionGrouping", 30},
 CellFrameLabels->{{None, None}, {None, 
    Cell[
     BoxData[
      GraphicsBox[
       RasterBox[CompressedData["
1:eJztkldMFFEUhlEpahR7L4khRGMNMRqMmtiiMbFEiSa2qMQGK64URREVERHF
glIEdoEFFpYioPTiylKkiQgoIh0RWBB22cJ2uMczISE++OCbPNwvZ5JJZjL3
zP9/y2zZh20nGBkZTcVLhhdzDxQKhUKhUCgUCuWfIQDDBIaGQTsEWgOoDaDU
g0xHpBoiUUOvGsRK6FKSDgW0ykjzAGmQwjcJ1PbB519Q1QMV3aSkkxT/hPx2
eNcGOS2Q0QSpjST5OyTUgeAria4lvGrgfCLBleRVBQRWkIDyYf+yoeelepyn
xXrfQu2jQo1PgdpLpL6fr/IQKu++U9zOlbvlDNzIkrhm9jun/3JM72Wnih3e
iFnJXZeSOi8kdtjGt52Naz0d23oypvF4dOPRyO9HePU24fUHubUHODX7Qmr2
hlTtDvy0M+DjDv+KbS/KtvqVbH5WvOlJ4UbfgvU+7618hOu889Y+yFvplbPC
M2v5vUzLu+kWt1OXub9dcitlsVvywhuvF7gmznNNmHs9fraLYKajYIaTYLoj
35wdNfVK5BSHqEkOEZNZPDNWhKl9uAmLa2LHMbbnTLjEHX+RgzPuQujIGJ0P
GZnR+9FH+Bq+j2NsF2ZiF2ZqzzVjheEHJ17mTXJgjjBn86ddjcZDZzrFzHKO
xTVwmfnXE3C3RTeTcMml7m9wYYs7aZYeGfgLqzyz13jlrvbOs/IWrvfJ3/BY
ZO1bYP20aMvzD/j721+WYxS7Aiv3BFXtDa7eH1qNQR0K/2oTXofRHYtqOMFv
OhXbckbABHsuvh1Dxqgvp3Rj7Bi+U1qvS0Yf1nEzW+qeI7uTJ8ea7gmV9/OV
D0UqrA97fFKkw0Kx1pelBqwYi8bGsffQSuBWAa+akQGVSPwGqAdKgqrktjLa
oDyoEIr0UcxIhWqhYKgZyobKtcnghxw6FdA9CD0q0q8GqQbkWlDoYFDHGKvR
M/bqhpn5Xz77lRmelegwgRGfMRP02fP9IPqMWWFiY8TnOdfi/vQZBaM+/7vP
QeVk1OfIGuB/gbg6QJ9TGiCtCTKb0WcibCeiDkah0i74u89yQP1QQrGKEVKi
gQEt+kzQZ5WejMhsGGIcxqFQKBQKhUKhUCgUCoVCoVAoY4ffZrJ5Rg==
        "], {{0, 
        0}, {240, 13}}, {0, 255}, ColorFunction -> RGBColor], 
       ImageSize -> {240, 13}, PlotRange -> {{0, 240}, {0, 13}}]]]}}],

Cell[StyleData["TitleFlourish", "Printout"],
 CellFrame->{{0, 0}, {0, 0}},
 CellMargins->{{0, 0}, {75, 0}},
 CellGroupingRules->{"SectionGrouping", 30},
 CellFrameLabels->{{None, None}, {None, 
    Cell[
     BoxData[
      GraphicsBox[
       RasterBox[CompressedData["
1:eJztkldMFFEUhlEpahR7L4khRGMNMRqMmtiiMbFEiSa2qMQGK64URREVERHF
glIEdoEFFpYioPTiylKkiQgoIh0RWBB22cJ2uMczISE++OCbPNwvZ5JJZjL3
zP9/y2zZh20nGBkZTcVLhhdzDxQKhUKhUCgUCuWfIQDDBIaGQTsEWgOoDaDU
g0xHpBoiUUOvGsRK6FKSDgW0ykjzAGmQwjcJ1PbB519Q1QMV3aSkkxT/hPx2
eNcGOS2Q0QSpjST5OyTUgeAria4lvGrgfCLBleRVBQRWkIDyYf+yoeelepyn
xXrfQu2jQo1PgdpLpL6fr/IQKu++U9zOlbvlDNzIkrhm9jun/3JM72Wnih3e
iFnJXZeSOi8kdtjGt52Naz0d23oypvF4dOPRyO9HePU24fUHubUHODX7Qmr2
hlTtDvy0M+DjDv+KbS/KtvqVbH5WvOlJ4UbfgvU+7618hOu889Y+yFvplbPC
M2v5vUzLu+kWt1OXub9dcitlsVvywhuvF7gmznNNmHs9fraLYKajYIaTYLoj
35wdNfVK5BSHqEkOEZNZPDNWhKl9uAmLa2LHMbbnTLjEHX+RgzPuQujIGJ0P
GZnR+9FH+Bq+j2NsF2ZiF2ZqzzVjheEHJ17mTXJgjjBn86ddjcZDZzrFzHKO
xTVwmfnXE3C3RTeTcMml7m9wYYs7aZYeGfgLqzyz13jlrvbOs/IWrvfJ3/BY
ZO1bYP20aMvzD/j721+WYxS7Aiv3BFXtDa7eH1qNQR0K/2oTXofRHYtqOMFv
OhXbckbABHsuvh1Dxqgvp3Rj7Bi+U1qvS0Yf1nEzW+qeI7uTJ8ea7gmV9/OV
D0UqrA97fFKkw0Kx1pelBqwYi8bGsffQSuBWAa+akQGVSPwGqAdKgqrktjLa
oDyoEIr0UcxIhWqhYKgZyobKtcnghxw6FdA9CD0q0q8GqQbkWlDoYFDHGKvR
M/bqhpn5Xz77lRmelegwgRGfMRP02fP9IPqMWWFiY8TnOdfi/vQZBaM+/7vP
QeVk1OfIGuB/gbg6QJ9TGiCtCTKb0WcibCeiDkah0i74u89yQP1QQrGKEVKi
gQEt+kzQZ5WejMhsGGIcxqFQKBQKhUKhUCgUCoVCoVAoY4ffZrJ5Rg==
        "], {{0, 
        0}, {240, 13}}, {0, 255}, ColorFunction -> RGBColor], 
       ImageSize -> {240, 13}, PlotRange -> {{0, 240}, {0, 13}}]]]}},
 TextAlignment->Center,
 Magnification->0.5],

Cell[StyleData["TitleFlourish", "PrintToPDF"],
 CellFrame->{{0, 0}, {0, 0}},
 CellMargins->{{0, 0}, {75, 0}},
 CellGroupingRules->{"SectionGrouping", 30},
 CellFrameLabels->{{None, None}, {None, 
    Cell[
     BoxData[
      GraphicsBox[
       RasterBox[CompressedData["
1:eJztkldMFFEUhlEpahR7L4khRGMNMRqMmtiiMbFEiSa2qMQGK64URREVERHF
glIEdoEFFpYioPTiylKkiQgoIh0RWBB22cJ2uMczISE++OCbPNwvZ5JJZjL3
zP9/y2zZh20nGBkZTcVLhhdzDxQKhUKhUCgUCuWfIQDDBIaGQTsEWgOoDaDU
g0xHpBoiUUOvGsRK6FKSDgW0ykjzAGmQwjcJ1PbB519Q1QMV3aSkkxT/hPx2
eNcGOS2Q0QSpjST5OyTUgeAria4lvGrgfCLBleRVBQRWkIDyYf+yoeelepyn
xXrfQu2jQo1PgdpLpL6fr/IQKu++U9zOlbvlDNzIkrhm9jun/3JM72Wnih3e
iFnJXZeSOi8kdtjGt52Naz0d23oypvF4dOPRyO9HePU24fUHubUHODX7Qmr2
hlTtDvy0M+DjDv+KbS/KtvqVbH5WvOlJ4UbfgvU+7618hOu889Y+yFvplbPC
M2v5vUzLu+kWt1OXub9dcitlsVvywhuvF7gmznNNmHs9fraLYKajYIaTYLoj
35wdNfVK5BSHqEkOEZNZPDNWhKl9uAmLa2LHMbbnTLjEHX+RgzPuQujIGJ0P
GZnR+9FH+Bq+j2NsF2ZiF2ZqzzVjheEHJ17mTXJgjjBn86ddjcZDZzrFzHKO
xTVwmfnXE3C3RTeTcMml7m9wYYs7aZYeGfgLqzyz13jlrvbOs/IWrvfJ3/BY
ZO1bYP20aMvzD/j721+WYxS7Aiv3BFXtDa7eH1qNQR0K/2oTXofRHYtqOMFv
OhXbckbABHsuvh1Dxqgvp3Rj7Bi+U1qvS0Yf1nEzW+qeI7uTJ8ea7gmV9/OV
D0UqrA97fFKkw0Kx1pelBqwYi8bGsffQSuBWAa+akQGVSPwGqAdKgqrktjLa
oDyoEIr0UcxIhWqhYKgZyobKtcnghxw6FdA9CD0q0q8GqQbkWlDoYFDHGKvR
M/bqhpn5Xz77lRmelegwgRGfMRP02fP9IPqMWWFiY8TnOdfi/vQZBaM+/7vP
QeVk1OfIGuB/gbg6QJ9TGiCtCTKb0WcibCeiDkah0i74u89yQP1QQrGKEVKi
gQEt+kzQZ5WejMhsGGIcxqFQKBQKhUKhUCgUCoVCoVAoY4ffZrJ5Rg==
        "], {{0, 
        0}, {240, 13}}, {0, 255}, ColorFunction -> RGBColor], 
       ImageSize -> {240, 13}, PlotRange -> {{0, 240}, {0, 13}}]]]}},
 TextAlignment->Center,
 Magnification->0.5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ChapterNumber"],
 CellMargins->{{0, 0}, {0, 0}},
 CellGroupingRules->{"SectionGrouping", 30},
 TextAlignment->Center,
 CounterIncrements->"Chapter",
 CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}, {
   "Subtitle", 0}, {"Subsubtitle", 0}, {"ContentsChapter", 0}},
 MenuSortingValue->1010,
 FontFamily->"Times",
 FontSize->28],

Cell[StyleData["ChapterNumber", "Printout"],
 CellMargins->{{0, 0}, {0, 0}},
 TextAlignment->Center,
 FontFamily->"Times",
 FontSize->18,
 FontWeight->"Plain"],

Cell[StyleData["ChapterNumber", "PrintToPDF"],
 CellMargins->{{0, 0}, {0, 0}},
 TextAlignment->Center,
 FontFamily->"DTL Albertina TOT Caps",
 FontSize->18]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ChapterTitle"],
 WholeCellGroupOpener->False,
 CellMargins->{{0, 0}, {44, 12}},
 CellGroupingRules->{"SectionGrouping", 30},
 TextAlignment->Center,
 CounterAssignments->{{"Section", 0}},
 MenuSortingValue->1100,
 MenuCommandKey->"1",
 FontFamily->"Times",
 FontSize->28],

Cell[StyleData["ChapterTitle", "Printout"],
 WholeCellGroupOpener->False,
 FontFamily->"Times",
 FontSize->22,
 FontWeight->"Plain"],

Cell[StyleData["ChapterTitle", "PrintToPDF"],
 WholeCellGroupOpener->False,
 FontFamily->"DTL Albertina TOTR",
 FontSize->18]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseSubsection"],
 CellFrame->None,
 ShowGroupOpener->True,
 CellMargins->{{0, 0}, {2, 12}},
 CellGroupingRules->{"SectionGrouping", 40},
 CellFrameLabels->{{
    Cell[
     TextData[{
       StyleBox[
        CounterBox["Chapter"]], 
       StyleBox["."], 
       StyleBox[
        CounterBox["Section"]], "\t"}], CellBaseline -> Baseline, FontSlant -> 
     "Plain", FontSize -> 17], None}, {None, None}},
 CellFrameLabelMargins->0,
 TabSpacings->1.25,
 CounterIncrements->"Section",
 CounterAssignments->{{"ExerciseItem", 0}},
 FontSize->18,
 FontWeight->"Plain"],

Cell[StyleData["ExerciseSubsection", "Printout"],
 CellFrame->None,
 ShowGroupOpener->False,
 CellMargins->{{0, 0}, {13, 13}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       StyleBox[
        CounterBox["Chapter"]], 
       StyleBox["."], 
       StyleBox[
        CounterBox["Section"]], "\t"}], CellBaseline -> Baseline, FontSlant -> 
     "Plain"], None}, {None, None}},
 CellFrameLabelMargins->0,
 TabSpacings->1.25,
 CounterIncrements->"Section",
 CounterAssignments->{{"ExerciseItem", 0}},
 FontFamily->"Times",
 FontSize->13],

Cell[StyleData["ExerciseSubsection", "PrintToPDF"],
 CellFrame->None,
 ShowGroupOpener->False,
 CellMargins->{{0, 0}, {3, 20}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       StyleBox[
        CounterBox["Chapter"]], 
       StyleBox["."], 
       StyleBox[
        CounterBox["Section"]], "\t"}], CellBaseline -> Baseline, FontFamily -> 
     "DTL Albertina TOT Caps", FontSlant -> "Plain"], None}, {None, None}},
 CellFrameLabelMargins->0,
 TabSpacings->1.25,
 CounterIncrements->"Section",
 CounterAssignments->{{"ExerciseItem", 0}},
 FontFamily->"DTL Albertina TOTR",
 FontSize->13]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["SolutionSubsection"],
 CellFrame->None,
 ShowGroupOpener->True,
 CellMargins->{{64, Inherited}, {6, 12}},
 CellGroupingRules->{"SectionGrouping", 40},
 CellFrameLabels->{{
    Cell[
     TextData[{
       StyleBox[
        CounterBox["Chapter"]], 
       StyleBox["."], 
       StyleBox[
        CounterBox["Section"]], "\t"}], CellBaseline -> Baseline, FontSize -> 
     17], None}, {None, None}},
 CellFrameLabelMargins->0,
 TabSpacings->1.25,
 CounterAssignments->{{"SolutionItem", 0}},
 FontFamily->"Times",
 FontSize->18,
 FontColor->CMYKColor[1, 0.3, 0, 0.4]],

Cell[StyleData["SolutionSubsection", "Printout"],
 CellFrame->None,
 ShowGroupOpener->False,
 CellMargins->{{28, 24}, {3, 10}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       StyleBox[
        CounterBox["Chapter"]], 
       StyleBox["."], 
       StyleBox[
        CounterBox["Section"]], "\t"}], CellBaseline -> Baseline, FontSlant -> 
     "Plain"], None}, {None, None}},
 CellFrameLabelMargins->0,
 TabSpacings->1.25,
 FontFamily->"Times",
 FontSize->13],

Cell[StyleData["SolutionSubsection", "PrintToPDF"],
 CellFrame->None,
 ShowGroupOpener->False,
 CellMargins->{{20, 24}, {3, 10}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       StyleBox[
        CounterBox["Chapter"]], 
       StyleBox["."], 
       StyleBox[
        CounterBox["Section"]], "\t"}], CellBaseline -> Baseline, FontFamily -> 
     "DTL Albertina TOT Caps", FontSlant -> "Plain"], None}, {None, None}},
 CellFrameLabelMargins->0,
 TabSpacings->1.25,
 FontFamily->"DTL Albertina TOTR",
 FontSize->13]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Nonprint", "Section"],

Cell[CellGroupData[{

Cell[StyleData["SolutionNonPrint"],
 CellBracketOptions->{"Color"->RGBColor[1, 0, 0]},
 Evaluatable->False,
 FontWeight->"Plain",
 FontColor->RGBColor[1, 0, 0]],

Cell[StyleData["SolutionNonPrint", "Printout"],
 CellMargins->{{Inherited, Inherited}, {-1, 0}},
 CellElementSpacings->{"CellMinHeight"->0,
 "ClosedCellHeight"->0,
 "ClosedGroupTopMargin"->0},
 CellOpen->False]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsectionSpacer"],
 CellDingbat->Cell[
  "Subsection spacer", "Menu", FontColor -> GrayLevel[1], FontSize -> 8, 
   Background -> GrayLevel[0.67]],
 CellBracketOptions->{"Color"->RGBColor[1, 0, 0],
 "Thickness"->0.55}],

Cell[StyleData["SubsectionSpacer", "Printout"],
 CellDingbat->None,
 CellMargins->{{Inherited, Inherited}, {0, 0}},
 CellElementSpacings->{"CellMinHeight"->0},
 PageBreakAbove->False]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NonPrintSolutionLink"],
 CellMargins->{{46, 0}, {0, 6}},
 CellBracketOptions->{"Color"->RGBColor[1, 0, 0],
 "Thickness"->0.55},
 CellGroupingRules->{"SectionGrouping", 55},
 FontFamily->"Times",
 FontSize->14,
 FontWeight->"Bold",
 FontSlant->"Italic"],

Cell[StyleData["NonPrintSolutionLink", "Printout"],
 CellMargins->{{Inherited, Inherited}, {-1, 0}},
 CellElementSpacings->{"CellMinHeight"->0,
 "ClosedCellHeight"->0,
 "ClosedGroupTopMargin"->0},
 CellOpen->False]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NonPrintInput", StyleDefinitions -> StyleData["Input"]],
 CellBracketOptions->{"Color"->RGBColor[1, 0, 0]},
 CellGroupingRules->{"SectionGrouping", 55},
 FontWeight->"Plain",
 FontColor->RGBColor[1, 0, 0]],

Cell[StyleData["NonPrintInput", "Printout"],
 CellMargins->{{Inherited, Inherited}, {-1, 0}},
 CellElementSpacings->{"CellMinHeight"->0,
 "ClosedCellHeight"->0,
 "ClosedGroupTopMargin"->0},
 CellOpen->False]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Editorial"],
 CellMargins->{{24, 10}, {6, 6}},
 CellBracketOptions->{"Color"->RGBColor[1, 0, 0],
 "Thickness"->0.55},
 CellFrameLabels->{{
    Cell[
     TextData[{"Edit:"}], FontFamily -> "Helvetica", FontSize -> 10, 
     FontWeight -> "Bold", CellBaseline -> Baseline], None}, {None, None}},
 FontColor->RGBColor[1, 0, 0]],

Cell[StyleData["Editorial", "Printout"],
 CellMargins->{{Inherited, Inherited}, {0, 0}},
 CellElementSpacings->{"CellMinHeight"->0,
 "ClosedCellHeight"->0,
 "ClosedGroupTopMargin"->0},
 CellOpen->False]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NonPrintSection", StyleDefinitions -> StyleData["Section"]],
 CellFrame->None,
 CellBracketOptions->{"Color"->RGBColor[1, 0, 0],
 "Thickness"->0.55},
 CellGroupingRules->{"SectionGrouping", 30},
 CellFrameLabels->{{None, None}, {None, None}},
 FontColor->GrayLevel[0.45]],

Cell[StyleData["NonPrintSection", "Printout"],
 CellElementSpacings->{"CellMinHeight"->1,
 "ClosedCellHeight"->0},
 CellOpen->False]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Input/Output", "Section",
 ShowGroupOpener->True],

Cell[CellGroupData[{

Cell[StyleData["Input"],
 CellMargins->{{83, Inherited}, {8, 10}},
 FontSize->13],

Cell[StyleData["Input", "Printout"],
 CellMargins->{{72, 0}, {0, 5}},
 FontSize->9],

Cell[StyleData["Input", "PrintToPDF"],
 CellMargins->{{60, 0}, {2, 4}},
 FontFamily->"Inconsolata",
 FontSize->9]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["InputOnly"],
 CellMargins->{{83, Inherited}, {0, 9}},
 FontSize->13],

Cell[StyleData["InputOnly", "Printout"],
 CellMargins->{{72, Inherited}, {5, 0}},
 FontSize->9],

Cell[StyleData["InputOnly", "PrintToPDF"],
 CellMargins->{{60, Inherited}, {4, 0}},
 FontSize->9]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["Output"],
 CellMargins->{{83, Inherited}, {5, 0}},
 FontSize->13],

Cell[StyleData["Output", "Printout"],
 CellMargins->{{72, 0}, {5, 0}},
 FontSize->9],

Cell[StyleData["Output", "PrintToPDF"],
 CellMargins->{{60, 0}, {4, 2}},
 FontFamily->"Inconsolata",
 FontSize->9]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["Message"],
 CellMargins->{{64, Inherited}, {7, Inherited}},
 CellGroupingRules->"OutputGrouping",
 PageBreakWithin->False,
 GroupPageBreakWithin->False,
 GeneratedCell->True,
 CellAutoOverwrite->True,
 ShowCellLabel->False,
 DefaultFormatType->DefaultOutputFormatType,
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 AutoItalicWords->{},
 FormatType->InputForm,
 CounterIncrements->"Message",
 StyleMenuListing->None,
 FontSize->11,
 FontColor->RGBColor[0, 0, 1]],

Cell[StyleData["Message", "Printout"],
 CellMargins->{{48, Inherited}, {5, 2}},
 FontSize->8.5,
 FontColor->GrayLevel[0]],

Cell[StyleData["Message", "PrintToPDF"],
 CellMargins->{{42, 18}, {0, 5}},
 FontFamily->"Syntax LT Std",
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Print"],
 CellMargins->{{64, Inherited}, {Inherited + 2, Inherited}},
 CellGroupingRules->"OutputGrouping",
 CellHorizontalScrolling->True,
 PageBreakWithin->False,
 GroupPageBreakWithin->False,
 GeneratedCell->True,
 CellAutoOverwrite->True,
 ShowCellLabel->False,
 DefaultFormatType->DefaultOutputFormatType,
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 AutoItalicWords->{},
 FormatType->InputForm,
 CounterIncrements->"Print",
 StyleMenuListing->None,
 FontSize->13],

Cell[StyleData["Print", "Printout"],
 CellMargins->{{54, Inherited}, {9, 0}},
 FontSize->9],

Cell[StyleData["Print", "PrintToPDF"],
 CellMargins->{{72, 60}, {9, 0}},
 FontSize->9]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["PrintUsage"],
 Editable->False,
 PageWidth->WindowWidth,
 CellFrame->{{0, 0}, {0, 3}},
 CellFrameColor->RGBColor[1, 0.6000000000000001, 0],
 ContextMenu->FEPrivate`FrontEndResource["ContextMenus", "Output"],
 Background->RGBColor[1, 0.993332, 0.899718]],

Cell[StyleData["PrintUsage", "Printout"],
 PageWidth->PaperWidth],

Cell[StyleData["PrintUsage", "PrintToPDF"],
 PageWidth->PaperWidth,
 FontFamily->"Syntax LT Std",
 FontSize->7.5]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["CellLabel"],
 StyleMenuListing->None,
 FontFamily->"Helvetica",
 FontSize->7,
 FontColor->RGBColor[0, 0, 1]],

Cell[StyleData["CellLabel", "Printout"],
 FontFamily->"Helvetica",
 FontSize->6,
 FontColor->RGBColor[0.247, 0.24, 0.6]],

Cell[StyleData["CellLabel", "PrintToPDF"],
 FontFamily->"Syntax LT Std",
 FontSize->6,
 FontColor->RGBColor[0.247, 0.24, 0.6]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Exercises", "Section"],

Cell[CellGroupData[{

Cell[StyleData["ExerciseItem"],
 CellMargins->{{16, 6}, {6, 14}},
 CellGroupingRules->{"SectionGrouping", 53},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["ExerciseItem"], ".", "\t"}], FontWeight -> "Bold", 
     CellBaseline -> Baseline], None}, {None, None}},
 CellFrameLabelMargins->0,
 Hyphenation->True,
 LineSpacing->{1, 2},
 TabSpacings->1.4,
 CounterIncrements->"ExerciseItem",
 CounterAssignments->{{"ExerciseSubItem", 0}},
 MenuSortingValue->1700,
 FontSize->14],

Cell[StyleData["ExerciseItem", "Printout"],
 CellMargins->{{11, 24}, {6, 0}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["ExerciseItem"], ".", "\t"}], CellBaseline -> Baseline], 
    None}, {None, None}},
 CellFrameLabelMargins->0,
 LineSpacing->{1, 3},
 TabSpacings->2,
 FontFamily->"Times",
 FontSize->10],

Cell[StyleData["ExerciseItem", "PrintToPDF"],
 CellMargins->{{1, 24}, {6, 0}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["ExerciseItem"], ".", "\t"}], FontFamily -> 
     "DTL Albertina TOT Caps", CellBaseline -> Baseline], None}, {None, None}},
 CellFrameLabelMargins->0,
 LineSpacing->{1, 1},
 TabSpacings->2,
 FontFamily->"DTL Albertina TOTR",
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseSubItem"],
 CellMargins->{{34, 4}, {2, 6}},
 CellGroupingRules->{"SectionGrouping", 56},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["ExerciseSubItem", CounterFunction -> (Part[
          CharacterRange["a", "z"], #]& )], "."}], FontWeight -> "Bold", 
     CellBaseline -> Baseline, FontFamily -> "Times"], None}, {None, None}},
 Hyphenation->True,
 LineSpacing->{1, 2},
 ParagraphSpacing->{0, 0},
 CounterIncrements->"ExerciseSubItem",
 FontSize->14],

Cell[StyleData["ExerciseSubItem", "Printout"],
 CellMargins->{{28, 24}, {6, 0}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["ExerciseSubItem", CounterFunction -> (Part[
          CharacterRange["a", "z"], #]& )], "."}], CellBaseline -> Baseline, 
     FontFamily -> "Times"], None}, {None, None}},
 LineSpacing->{1, 1},
 FontFamily->"Times",
 FontSize->10],

Cell[StyleData["ExerciseSubItem", "PrintToPDF"],
 CellMargins->{{17, 24}, {6, 0}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["ExerciseSubItem", CounterFunction -> (Part[
          CharacterRange["a", "z"], #]& )], "."}], CellBaseline -> Baseline, 
     FontFamily -> "DTL Albertina TOTR"], None}, {None, None}},
 LineSpacing->{1, 1},
 FontFamily->"DTL Albertina TOTR",
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseText"],
 CellMargins->{{36, 4}, {5, 5}},
 Hyphenation->True,
 LineSpacing->{1, 2},
 ParagraphSpacing->{0, 8},
 CounterStyleMenuListing->None,
 FontSize->14],

Cell[StyleData["ExerciseText", "Printout"],
 CellMargins->{{28, 24}, {6, 0}},
 FontFamily->"Times",
 FontSize->10],

Cell[StyleData["ExerciseText", "PrintToPDF"],
 CellMargins->{{18, 24}, {6, 0}},
 LineSpacing->{1, 1},
 FontFamily->"DTL Albertina TOTR",
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseDisplayFormula", StyleDefinitions -> StyleData[
 "DisplayFormula"]],
 CellMargins->{{70, Inherited}, {10, 10}},
 ShowCellLabel->False,
 ShowStringCharacters->False,
 FontFamily->"Times",
 FontSize->14],

Cell[StyleData["ExerciseDisplayFormula", "Printout"],
 CellMargins->{{48, Inherited}, {7, 0}},
 FontFamily->"Times",
 FontSize->10],

Cell[StyleData["ExerciseDisplayFormula", "PrintToPDF"],
 CellMargins->{{48, Inherited}, {7, 3}},
 FontFamily->"DTL Albertina TOTR",
 FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Solutions", "Section",
 ShowGroupOpener->True],

Cell[CellGroupData[{

Cell[StyleData["SolutionItem"],
 CellMargins->{{54, 4}, {2, 18}},
 CellGroupingRules->{"SectionGrouping", 55},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["SolutionItem"], ".", "\t"}], CellBaseline -> Baseline, 
     FontWeight -> "Bold"], None}, {None, None}},
 Hyphenation->True,
 LineSpacing->{1, 3},
 ParagraphSpacing->{0, 8},
 TabSpacings->1.75,
 CounterIncrements->"SolutionItem",
 CounterAssignments->{{"SolutionSubItem", 0}},
 MenuSortingValue->1300,
 MenuCommandKey->"6",
 FontSize->14],

Cell[StyleData["SolutionItem", "Printout"],
 CellMargins->{{32, 0}, {2, 0}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["SolutionItem"], ".", "\t"}], CellBaseline -> Baseline], 
    None}, {None, None}},
 TabSpacings->2.2,
 FontFamily->"Times",
 FontSize->10],

Cell[StyleData["SolutionItem", "PrintToPDF"],
 CellMargins->{{21, 0}, {2, 0}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["SolutionItem"], ".", "\t"}], FontFamily -> 
     "DTL Albertina TOT Caps", CellBaseline -> Baseline], None}, {None, None}},
 LineSpacing->{1, 1},
 TabSpacings->1.25,
 FontFamily->"DTL Albertina TOTR",
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SolutionSubItem"],
 CellMargins->{{84, 4}, {0, 8}},
 CellGroupingRules->{"SectionGrouping", 60},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["SolutionSubItem"], "."}], CellBaseline -> Baseline, 
     FontWeight -> "Bold", CounterBoxOptions -> {CounterFunction :> (Part[
         CharacterRange["a", "z"], #]& )}], None}, {None, None}},
 Hyphenation->True,
 LineSpacing->{1, 3},
 ParagraphSpacing->{0, 8},
 CounterIncrements->"SolutionSubItem",
 MenuSortingValue->1410,
 MenuCommandKey->"8",
 FontSize->14],

Cell[StyleData["SolutionSubItem", "Printout"],
 CellMargins->{{44, 0}, {5, 3}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["SolutionSubItem"], "."}], CellBaseline -> Baseline, 
     CounterBoxOptions -> {CounterFunction :> (Part[
         CharacterRange["a", "z"], #]& )}], None}, {None, None}},
 LineSpacing->{1, 1},
 FontFamily->"Times",
 FontSize->10],

Cell[StyleData["SolutionSubItem", "PrintToPDF"],
 CellMargins->{{38, 0}, {5, 3}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["SolutionSubItem"], "."}], CellBaseline -> Baseline, 
     CounterBoxOptions -> {CounterFunction :> (Part[
         CharacterRange["a", "z"], #]& )}], None}, {None, None}},
 LineSpacing->{1, 1},
 FontFamily->"DTL Albertina TOTR",
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SolutionText"],
 CellMargins->{{82, 4}, {0, 8}},
 Hyphenation->True,
 LineSpacing->{1, 3},
 ParagraphSpacing->{0, 8},
 MenuSortingValue->1400,
 MenuCommandKey->"7",
 CounterStyleMenuListing->None,
 FontSize->14],

Cell[StyleData["SolutionText", "Printout"],
 CellMargins->{{48, 0}, {5, 2}},
 LineSpacing->{1, 3},
 FontFamily->"Times",
 FontSize->10],

Cell[StyleData["SolutionText", "PrintToPDF"],
 CellMargins->{{38, 0}, {5, 2}},
 LineSpacing->{1, 1},
 FontFamily->"DTL Albertina TOTR",
 FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Figures and tables", "Section"],

Cell[CellGroupData[{

Cell[StyleData["ExerciseFigure"],
 CellMargins->{{48, 4}, {0, 12}},
 CellGroupingRules->"InputGrouping",
 CellFrameLabels->{{
    Cell[
     TextData[{"Figure ", 
       CounterBox["Chapter"], ".", 
       CounterBox["NumberedFigure"], "\t"}], CellBaseline -> Baseline, 
     FontSlant -> "Plain"], None}, {None, None}},
 TabSpacings->0.25,
 CounterIncrements->"NumberedFigure",
 MenuSortingValue->1670,
 FormatTypeAutoConvert->False,
 FontSize->13,
 FontSlant->"Italic"],

Cell[StyleData["ExerciseFigure", "Printout"],
 CellMargins->{{26, Inherited}, {0, 3.75}},
 CellFrameLabels->{{
    Cell[
     TextData[{"Figure ", 
       CounterBox["Chapter"], ".", 
       CounterBox["NumberedFigure"], ".", "\t"}], FontSlant -> "Plain", 
     CellBaseline -> Baseline], None}, {None, None}},
 TabSpacings->0.25,
 FontFamily->"Times",
 FontSize->10],

Cell[StyleData["ExerciseFigure", "PrintToPDF"],
 CellMargins->{{26, Inherited}, {0, 3.75}},
 CellFrameLabels->{{
    Cell[
     TextData[{"Figure ", 
       CounterBox["Chapter"], ".", 
       CounterBox["NumberedFigure"], ".", "\t"}], FontFamily -> 
     "DTL Albertina TOT Caps", FontSlant -> "Plain", CellBaseline -> 
     Baseline], None}, {None, None}},
 TabSpacings->0.25,
 FontFamily->"DTL Albertina TOTR",
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExFigure"],
 Deletable->True,
 CellMargins->{{48, 10}, {14, 12}},
 CellGroupingRules->"OutputGrouping",
 CellAutoOverwrite->False,
 ShowCellLabel->False,
 ShowStringCharacters->False,
 MenuSortingValue->1500,
 MenuCommandKey->None,
 FontSize->14],

Cell[StyleData["ExFigure", "Printout"],
 CellMargins->{{26, 10}, {10.75, 6.75}},
 FontSize->10],

Cell[StyleData["ExFigure", "PrintToPDF"],
 CellMargins->{{26, 10}, {10.75, 6.75}},
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExTable"],
 Deletable->True,
 CellMargins->{{36, Inherited}, {18, 0}},
 CellGroupingRules->"OutputGrouping",
 DefaultFormatType->DefaultTraditionalFormatType,
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 LanguageCategory->"Formula",
 ScriptLevel->0,
 SingleLetterItalics->True,
 UnderoverscriptBoxOptions->{LimitsPositioning->True}],

Cell[StyleData["ExTable", "Printout"],
 CellMargins->{{18, 0}, {10.75, 6.75}},
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseTable"],
 CellMargins->{{36, 4}, {12, 14}},
 CellGroupingRules->"InputGrouping",
 CellFrameLabels->{{
    Cell[
     TextData[{"Table ", 
       CounterBox["Chapter"], ".", 
       CounterBox["NumberedTable"], ".", "\t"}], CellBaseline -> Baseline, 
     FontSlant -> "Plain"], None}, {None, None}},
 TabSpacings->1.1,
 CounterIncrements->"NumberedTable",
 MenuSortingValue->1660,
 FormatTypeAutoConvert->False,
 FontSize->14,
 FontSlant->"Italic"],

Cell[StyleData["ExerciseTable", "Printout"],
 CellMargins->{{26, 0}, {0, 3.75}},
 PageBreakBelow->False,
 GroupPageBreakWithin->False,
 CellFrameLabels->{{
    Cell[
     TextData[{"Table ", 
       CounterBox["Chapter"], ".", 
       CounterBox["NumberedTable"], ".", "\t"}], CellBaseline -> Baseline, 
     FontSlant -> "Plain"], None}, {None, None}},
 TabSpacings->0.25,
 FontFamily->"Times",
 FontSize->10],

Cell[StyleData["ExerciseTable", "PrintToPDF"],
 CellMargins->{{26, 0}, {0, 3.75}},
 PageBreakBelow->False,
 GroupPageBreakWithin->False,
 CellFrameLabels->{{
    Cell[
     TextData[{"Table ", 
       CounterBox["Chapter"], ".", 
       CounterBox["NumberedTable"], ".", "\t"}], CellBaseline -> Baseline, 
     FontFamily -> "DTL Albertina TOT Caps", FontSlant -> "Plain"], None}, {
   None, None}},
 TabSpacings->0.25,
 FontFamily->"Times",
 FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Inline formatting", "Section",
 ShowGroupOpener->True],

Cell[CellGroupData[{

Cell[StyleData["StandardForm"]],

Cell[StyleData["StandardForm", "Printout"],
 FontFamily->"Courier"],

Cell[StyleData["StandardForm", "PrintToPDF"],
 FontFamily->"Inconsolata"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["MR"],
 AutoQuoteCharacters->{},
 StyleMenuListing->None],

Cell[StyleData["MR", "Printout"],
 FontColor->GrayLevel[0]],

Cell[StyleData["MR", "PrintToPDF"],
 FontFamily->"Inconsolata",
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["MSG"],
 CellMargins->{{Inherited + 18, Inherited}, {Inherited + 4, Inherited - 3}},
 StyleMenuListing->None],

Cell[StyleData["MSG", "Printout"],
 StyleMenuListing->None,
 FontFamily->"Helvetica",
 FontSize->7.5],

Cell[StyleData["MSG", "PrintToPDF"],
 StyleMenuListing->None,
 FontFamily->"Syntax LT Std",
 FontSize->8.25]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["OsF"],
 FontColor->GrayLevel[0]],

Cell[StyleData["OsF", "Printout"],
 StyleMenuListing->None,
 FontFamily->"Times"],

Cell[StyleData["OsF", "PrintToPDF"],
 StyleMenuListing->None,
 FontFamily->"DTL Albertina TOT Caps"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseTI"],
 FontFamily->"Times",
 FontWeight->"Plain",
 FontSlant->"Italic"],

Cell[StyleData["ExerciseTI", "Printout"],
 FontFamily->"Times",
 FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseSR", StyleDefinitions -> StyleData["SR"]],
 FontSize->11],

Cell[StyleData["ExerciseSR", "Printout"],
 FontFamily->"Helvetica",
 FontSize->7.],

Cell[StyleData["ExerciseSR", "PrintToPDF"],
 FontFamily->"Syntax LT Std",
 FontSize->7.]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TRLink"],
 FontFamily->"Times",
 FontColor->RGBColor[0, 0.2, 0.8]],

Cell[StyleData["TRLink", "Printout"],
 FontFamily->"Times",
 FontColor->GrayLevel[0]],

Cell[StyleData["TRLink", "PrintToPDF"],
 FontFamily->"DTL Albertina TOTR",
 FontColor->RGBColor[0, 0.2, 0.8]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Spacer cells", "Section",
 ShowGroupOpener->True],

Cell["\<\
These are causing running heads to break. Not clear why but should not use \
them for now.\
\>", "Text"],

Cell[CellGroupData[{

Cell[StyleData["SectionSpacer"],
 CellDingbat->Cell[
  "Section spacer", "Menu", FontColor -> GrayLevel[1], FontSize -> 8, 
   Background -> GrayLevel[0.67]],
 CellBracketOptions->{"Color"->RGBColor[1, 0, 0],
 "Thickness"->0.55}],

Cell[StyleData["SectionSpacer", "Printout"],
 CellDingbat->None,
 CellMargins->{{Inherited, Inherited}, {0, 10}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsectionSpacer"],
 CellDingbat->Cell[
  "Subsection spacer", "Menu", FontColor -> GrayLevel[1], FontSize -> 8, 
   Background -> GrayLevel[0.67]],
 CellBracketOptions->{"Color"->RGBColor[1, 0, 0],
 "Thickness"->0.55}],

Cell[StyleData["SubsectionSpacer", "Printout"],
 CellDingbat->None,
 CellMargins->{{Inherited, Inherited}, {0, 0}},
 CellElementSpacings->{"CellMinHeight"->0},
 PageBreakAbove->False]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ReferenceSpacer"],
 CellDingbat->Cell[
  "Reference spacer", "Menu", FontColor -> GrayLevel[1], FontSize -> 8, 
   Background -> GrayLevel[0.67]],
 CellBracketOptions->{"Color"->RGBColor[1, 0, 0],
 "Thickness"->0.55}],

Cell[StyleData["ReferenceSpacer", "Printout"],
 CellDingbat->None,
 CellMargins->{{Inherited, Inherited}, {5, 0}},
 CellElementSpacings->{"CellMinHeight"->0},
 PageBreakAbove->False]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOP"],
 CellBracketOptions->{"Color"->RGBColor[0, 1, 0]}],

Cell[StyleData["TOP", "Printout"],
 CellMargins->{{Inherited, Inherited}, {Inherited, 0}},
 CellBracketOptions->{"Color"->RGBColor[1, 0, 0],
 "Thickness"->1}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Headers and footers", "Section",
 ShowGroupOpener->True],

Cell[CellGroupData[{

Cell[StyleData["Header"],
 LineSpacing->{1, 8},
 MenuSortingValue->None,
 FontSlant->"Plain"],

Cell[StyleData["Header", "Printout"],
 CellMargins->{{0, 0}, {0, 0}},
 FontFamily->"Times",
 FontSize->9.5,
 FontSlant->"Italic"],

Cell[StyleData["Header", "PrintToPDF"],
 CellMargins->{{0, 0}, {0, 0}},
 FontFamily->"DTL Albertina TOTR",
 FontSize->9.,
 FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PageNumber"],
 CellMargins->{{0, 0}, {4, 1}},
 StyleMenuListing->None,
 FontFamily->"Times",
 FontSize->9],

Cell[StyleData["PageNumber", "Printout"],
 CellMargins->{{0, 0}, {0, 0}},
 FontFamily->"Times",
 FontWeight->"Plain",
 FontSlant->"Plain"],

Cell[StyleData["PageNumber", "PrintToPDF"],
 CellMargins->{{0, 0}, {0, 0}},
 FontFamily->"DTL Albertina TOT Caps",
 FontSize->9,
 FontSlant->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["HeaderOsF"],
 StyleMenuListing->None,
 FontFamily->"Times",
 FontSize->9],

Cell[StyleData["HeaderOsF", "Printout"],
 FontFamily->"Times",
 FontSize->9.5,
 FontSlant->"Plain"],

Cell[StyleData["HeaderOsF", "PrintToPDF"],
 FontFamily->"DTL Albertina TOT Caps",
 FontSize->9.,
 FontSlant->"Plain"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Graphics", "Section"],

Cell[CellGroupData[{

Cell[StyleData["Graphics"],
 FontSize->7],

Cell[StyleData["Graphics", "Printout"],
 FontSize->5],

Cell[StyleData["Graphics", "PrintToPDF"],
 FontFamily->"Syntax LT Std",
 FontSize->5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Graphics3D"],
 FontSize->6.5],

Cell[StyleData["Graphics3D", "Printout"],
 FontSize->5],

Cell[StyleData["Graphics3D", "PrintToPDF"],
 FontFamily->"Syntax LT Std",
 FontSize->5]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Compile and Suggestion bar", "Section"],

Cell[CellGroupData[{

Cell[StyleData["SuggestionsBarControl"]],

Cell[StyleData["SuggestionsBarControl", "Printout"],
 FontSize->8],

Cell[StyleData["SuggestionsBarControl", "PrintToPDF"],
 FontFamily->"Syntax LT Std",
 FontSize->7]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SuggestionsBarCategory"]],

Cell[StyleData["SuggestionsBarCategory", "Printout"],
 FontSize->8],

Cell[StyleData["SuggestionsBarCategory", "PrintToPDF"],
 FontFamily->"Syntax LT Std",
 FontSize->7]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SummaryItemAnnotation"]],

Cell[StyleData["SummaryItemAnnotation", "Printout"],
 FontSize->7.],

Cell[StyleData["SummaryItemAnnotation", "PrintToPDF"],
 FontFamily->"Syntax LT Std",
 FontSize->6.25]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SummaryItem"]],

Cell[StyleData["SummaryItem", "Printout"],
 FontSize->7],

Cell[StyleData["SummaryItem", "PrintToPDF"],
 FontFamily->"Syntax LT Std",
 FontSize->6.25]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Miscellaneous", "Section"],

Cell[CellGroupData[{

Cell[StyleData["PageBreak"],
 Editable->False,
 CellFrame->1,
 CellMargins->{{0, 0}, {1, 1}},
 CellElementSpacings->{"CellMinHeight"->1,
 "ClosedCellHeight"->1},
 CellOpen->False,
 PageBreakBelow->True,
 CellFrameMargins->0,
 CellSize->{Inherited, 2},
 Background->GrayLevel[0.5]],

Cell[StyleData["PageBreak", "Printout"],
 CellFrame->0,
 ShowCellBracket->False,
 Background->None],

Cell[StyleData["PageBreak", "PrintToPDF"],
 CellFrame->0,
 ShowCellBracket->False,
 CellMargins->{{0, 0}, {0, 0}},
 Background->None]
}, Closed]],

Cell[StyleData["CellExpression"],
 PageWidth->Infinity,
 CellMargins->{{6, Inherited}, {Inherited, Inherited}},
 ShowCellLabel->False,
 ContextMenu->FEPrivate`FrontEndResource["ContextMenus", "CellExpression"],
 ShowSpecialCharacters->False,
 AllowInlineCells->False,
 Hyphenation->False,
 AutoItalicWords->{},
 AutoQuoteCharacters->{},
 PasteAutoQuoteCharacters->{},
 LanguageCategory->None,
 StyleMenuListing->None,
 FontFamily->"Courier",
 FontSize->12,
 Magnification->1.25,
 Background->GrayLevel[0.9]],

Cell[CellGroupData[{

Cell[StyleData["ManipulateLabel"]],

Cell[StyleData["ManipulateLabel", "PrintToPDF"],
 ShowStringCharacters->False,
 NumberMarks->False,
 FontFamily->"Syntax LT Std",
 FontSize->8,
 FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PopupMenuLabel", StyleDefinitions -> StyleData["MenuLabel"]],
 FontColor:>CurrentValue[{"SystemColor", "DialogText"}]],

Cell[StyleData["PopupMenuLabel", "PrintToPDF"],
 FontFamily->"Syntax LT Std",
 FontSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Setter"]],

Cell[StyleData["Setter", "PrintToPDF"],
 FontFamily->"Syntax LT Std",
 FontSize->6.5]
}, Closed]]
}, Closed]]
},
WindowSize->{706, 736},
WindowMargins->{{Automatic, 286}, {Automatic, 45}},
FrontEndVersion->"10.1 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 23, \
2015)",
StyleDefinitions->"PrivateStylesheetFormatting.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 49, 0, 36, 49, 0, "StyleData", "StyleDefinitions", ""],
Cell[CellGroupData[{
Cell[631, 24, 60, 1, 49, "Section"],
Cell[694, 27, 31, 0, 32, 31, 0, "StyleData", "All", "Working"],
Cell[728, 29, 32, 0, 24, 32, 0, "StyleData", "All", "Printout"],
Cell[763, 31, 58, 1, 32, 34, 0, "StyleData", "All", "PrintToPDF"]
}, Closed]],
Cell[CellGroupData[{
Cell[858, 37, 51, 1, 33, "Section"],
Cell[CellGroupData[{
Cell[934, 42, 1566, 30, 45, 32, 0, "StyleData", "TitleFlourish", "All"],
Cell[2503, 74, 1623, 32, 70, 44, 0, "StyleData", "TitleFlourish", \
"Printout"],
Cell[4129, 108, 1625, 32, 70, 46, 0, "StyleData", "TitleFlourish", \
"PrintToPDF"]
}, Closed]],
Cell[CellGroupData[{
Cell[5791, 145, 362, 9, 44, 32, 0, "StyleData", "ChapterNumber", "All",
 CounterIncrements->"Chapter",
 CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}, {
   "Subtitle", 0}, {"Subsubtitle", 0}, {"ContentsChapter", 0}},
 MenuSortingValue->1010],
Cell[6156, 156, 159, 5, 31, 44, 0, "StyleData", "ChapterNumber", "Printout"],
Cell[6318, 163, 156, 4, 35, 46, 0, "StyleData", "ChapterNumber", \
"PrintToPDF"]
}, Closed]],
Cell[CellGroupData[{
Cell[6511, 172, 287, 9, 92, 31, 0, "StyleData", "ChapterTitle", "All",
 CounterAssignments->{{"Section", 0}},
 MenuSortingValue->1100,
 MenuCommandKey->"1"],
Cell[6801, 183, 132, 4, 43, 43, 0, "StyleData", "ChapterTitle", "Printout"],
Cell[6936, 189, 125, 3, 43, 45, 0, "StyleData", "ChapterTitle", "PrintToPDF"]
}, Closed]],
Cell[CellGroupData[{
Cell[7098, 197, 586, 19, 40, 37, 0, "StyleData", "ExerciseSubsection", "All",
 CounterIncrements->"Section",
 CounterAssignments->{{"ExerciseItem", 0}}],
Cell[7687, 218, 539, 18, 55, 49, 0, "StyleData", "ExerciseSubsection", \
"Printout",
 CounterIncrements->"Section",
 CounterAssignments->{{"ExerciseItem", 0}}],
Cell[8229, 238, 593, 18, 55, 51, 0, "StyleData", "ExerciseSubsection", \
"PrintToPDF",
 CounterIncrements->"Section",
 CounterAssignments->{{"ExerciseItem", 0}}]
}, Open  ]],
Cell[CellGroupData[{
Cell[8859, 261, 581, 19, 52, 37, 0, "StyleData", "SolutionSubsection", "All",
 CounterAssignments->{{"SolutionItem", 0}}],
Cell[9443, 282, 465, 16, 42, 49, 0, "StyleData", "SolutionSubsection", \
"Printout"],
Cell[9911, 300, 520, 16, 45, 51, 0, "StyleData", "SolutionSubsection", \
"PrintToPDF"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[10480, 322, 27, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[10532, 326, 160, 4, 36, 35, 0, "StyleData", "SolutionNonPrint", "All"],
Cell[10695, 332, 210, 5, 1, 47, 0, "StyleData", "SolutionNonPrint", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[10942, 342, 235, 5, 36, 35, 0, "StyleData", "SubsectionSpacer", "All"],
Cell[11180, 349, 183, 4, 70, 47, 0, "StyleData", "SubsectionSpacer", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[11400, 358, 268, 8, 34, 39, 0, "StyleData", "NonPrintSolutionLink", \
"All"],
Cell[11671, 368, 214, 5, 70, 51, 0, "StyleData", "NonPrintSolutionLink", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[11922, 378, 221, 4, 35, 72, 0, "StyleData", "NonPrintInput", "All"],
Cell[12146, 384, 207, 5, 70, 44, 0, "StyleData", "NonPrintInput", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[12390, 394, 341, 8, 38, 28, 0, "StyleData", "Editorial", "All"],
Cell[12734, 404, 202, 5, 70, 40, 0, "StyleData", "Editorial", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[12973, 414, 287, 6, 41, 76, 0, "StyleData", "NonPrintSection", "All"],
Cell[13263, 422, 132, 3, 70, 46, 0, "StyleData", "NonPrintSection", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[13444, 431, 55, 1, 33, "Section"],
Cell[CellGroupData[{
Cell[13524, 436, 81, 2, 47, 24, 0, "StyleData", "Input", "All"],
Cell[13608, 440, 83, 2, 30, 36, 0, "StyleData", "Input", "Printout"],
Cell[13694, 444, 113, 3, 32, 38, 0, "StyleData", "Input", "PrintToPDF"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13844, 452, 84, 2, 38, 28, 0, "StyleData", "InputOnly", "All"],
Cell[13931, 456, 95, 2, 30, 40, 0, "StyleData", "InputOnly", "Printout"],
Cell[14029, 460, 97, 2, 29, 42, 0, "StyleData", "InputOnly", "PrintToPDF"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14163, 467, 81, 2, 34, 25, 0, "StyleData", "Output", "All"],
Cell[14247, 471, 84, 2, 30, 37, 0, "StyleData", "Output", "Printout"],
Cell[14334, 475, 114, 3, 32, 39, 0, "StyleData", "Output", "PrintToPDF"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14485, 483, 498, 15, 40, 26, 0, "StyleData", "Message", "All",
 CounterIncrements->"Message",
 StyleMenuListing->None],
Cell[14986, 500, 121, 3, 32, 38, 0, "StyleData", "Message", "Printout"],
Cell[15110, 505, 130, 3, 33, 40, 0, "StyleData", "Message", "PrintToPDF"]
}, Closed]],
Cell[CellGroupData[{
Cell[15277, 513, 507, 15, 41, 24, 0, "StyleData", "Print", "All",
 CounterIncrements->"Print",
 StyleMenuListing->None],
Cell[15787, 530, 91, 2, 34, 36, 0, "StyleData", "Print", "Printout"],
Cell[15881, 534, 86, 2, 34, 38, 0, "StyleData", "Print", "PrintToPDF"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16004, 541, 269, 6, 55, 29, 0, "StyleData", "PrintUsage", "All"],
Cell[16276, 549, 65, 1, 36, 41, 0, "StyleData", "PrintUsage", "Printout"],
Cell[16344, 552, 113, 3, 32, 43, 0, "StyleData", "PrintUsage", "PrintToPDF"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16494, 560, 124, 4, 31, 28, 0, "StyleData", "CellLabel", "All",
 StyleMenuListing->None],
Cell[16621, 566, 120, 3, 27, 40, 0, "StyleData", "CellLabel", "Printout"],
Cell[16744, 571, 126, 3, 27, 42, 0, "StyleData", "CellLabel", "PrintToPDF"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[16919, 580, 28, 0, 49, "Section"],
Cell[CellGroupData[{
Cell[16972, 584, 493, 15, 50, 31, 0, "StyleData", "ExerciseItem", "All",
 CounterIncrements->"ExerciseItem",
 CounterAssignments->{{"ExerciseSubItem", 0}},
 MenuSortingValue->1700],
Cell[17468, 601, 329, 11, 29, 43, 0, "StyleData", "ExerciseItem", \
"Printout"],
Cell[17800, 614, 384, 11, 31, 45, 0, "StyleData", "ExerciseItem", "PrintToPDF"]
}, Closed]],
Cell[CellGroupData[{
Cell[18221, 630, 496, 13, 36, 34, 0, "StyleData", "ExerciseSubItem", "All",
 CounterIncrements->"ExerciseSubItem"],
Cell[18720, 645, 378, 10, 32, 46, 0, "StyleData", "ExerciseSubItem", \
"Printout"],
Cell[19101, 657, 406, 10, 34, 48, 0, "StyleData", "ExerciseSubItem", \
"PrintToPDF"]
}, Closed]],
Cell[CellGroupData[{
Cell[19544, 672, 180, 6, 40, 31, 0, "StyleData", "ExerciseText", "All"],
Cell[19727, 680, 114, 3, 32, 43, 0, "StyleData", "ExerciseText", "Printout"],
Cell[19844, 685, 151, 4, 34, 45, 0, "StyleData", "ExerciseText", \
"PrintToPDF"]
}, Closed]],
Cell[CellGroupData[{
Cell[20032, 694, 225, 6, 50, 92, 1, "StyleData", "ExerciseDisplayFormula", \
"All"],
Cell[20260, 702, 131, 3, 33, 53, 0, "StyleData", "ExerciseDisplayFormula", \
"Printout"],
Cell[20394, 707, 146, 3, 38, 55, 0, "StyleData", "ExerciseDisplayFormula", \
"PrintToPDF"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[20589, 716, 52, 1, 33, "Section"],
Cell[CellGroupData[{
Cell[20666, 721, 516, 16, 47, 31, 0, "StyleData", "SolutionItem", "All",
 CounterIncrements->"SolutionItem",
 CounterAssignments->{{"SolutionSubItem", 0}},
 MenuSortingValue->1300,
 MenuCommandKey->"6"],
Cell[21185, 739, 281, 9, 25, 43, 0, "StyleData", "SolutionItem", "Printout"],
Cell[21469, 750, 360, 10, 27, 45, 0, "StyleData", "SolutionItem", "PrintToPDF"]
}, Closed]],
Cell[CellGroupData[{
Cell[21866, 765, 542, 15, 35, 34, 0, "StyleData", "SolutionSubItem", "All",
 CounterIncrements->"SolutionSubItem",
 MenuSortingValue->1410,
 MenuCommandKey->"8"],
Cell[22411, 782, 376, 10, 31, 46, 0, "StyleData", "SolutionSubItem", \
"Printout"],
Cell[22790, 794, 391, 10, 33, 48, 0, "StyleData", "SolutionSubItem", \
"PrintToPDF"]
}, Closed]],
Cell[CellGroupData[{
Cell[23218, 809, 227, 8, 35, 31, 0, "StyleData", "SolutionText", "All",
 MenuSortingValue->1400,
 MenuCommandKey->"7"],
Cell[23448, 819, 135, 4, 30, 43, 0, "StyleData", "SolutionText", "Printout"],
Cell[23586, 825, 150, 4, 32, 45, 0, "StyleData", "SolutionText", \
"PrintToPDF"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[23785, 835, 37, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[23847, 839, 471, 14, 41, 33, 0, "StyleData", "ExerciseFigure", "All",
 CounterIncrements->"NumberedFigure",
 MenuSortingValue->1670],
Cell[24321, 855, 367, 10, 29, 45, 0, "StyleData", "ExerciseFigure", \
"Printout"],
Cell[24691, 867, 428, 11, 31, 47, 0, "StyleData", "ExerciseFigure", \
"PrintToPDF"]
}, Closed]],
Cell[CellGroupData[{
Cell[25156, 883, 262, 9, 56, 27, 0, "StyleData", "ExFigure", "All",
 MenuSortingValue->1500,
 MenuCommandKey->None],
Cell[25421, 894, 95, 2, 43, 39, 0, "StyleData", "ExFigure", "Printout"],
Cell[25519, 898, 97, 2, 43, 41, 0, "StyleData", "ExFigure", "PrintToPDF"]
}, Closed]],
Cell[CellGroupData[{
Cell[25653, 905, 370, 9, 46, 26, 0, "StyleData", "ExTable", "All"],
Cell[26026, 916, 93, 2, 43, 38, 0, "StyleData", "ExTable", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[26156, 923, 472, 14, 56, 32, 0, "StyleData", "ExerciseTable", "All",
 CounterIncrements->"NumberedTable",
 MenuSortingValue->1660],
Cell[26631, 939, 410, 12, 29, 44, 0, "StyleData", "ExerciseTable", "Printout"],
Cell[27044, 953, 456, 13, 29, 46, 0, "StyleData", "ExerciseTable", \
"PrintToPDF"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[27549, 972, 60, 1, 33, "Section"],
Cell[CellGroupData[{
Cell[27634, 977, 31, 0, 36, 31, 0, "StyleData", "StandardForm", "All"],
Cell[27668, 979, 67, 1, 32, 43, 0, "StyleData", "StandardForm", "Printout"],
Cell[27738, 982, 73, 1, 33, 45, 0, "StyleData", "StandardForm", "PrintToPDF"]
}, Closed]],
Cell[CellGroupData[{
Cell[27848, 988, 72, 2, 36, 21, 0, "StyleData", "MR", "All",
 StyleMenuListing->None],
Cell[27923, 992, 59, 1, 32, 33, 0, "StyleData", "MR", "Printout"],
Cell[27985, 995, 89, 2, 33, 35, 0, "StyleData", "MR", "PrintToPDF"]
}, Closed]],
Cell[CellGroupData[{
Cell[28111, 1002, 124, 2, 39, 22, 0, "StyleData", "MSG", "All",
 StyleMenuListing->None],
Cell[28238, 1006, 101, 3, 32, 34, 0, "StyleData", "MSG", "Printout",
 StyleMenuListing->None],
Cell[28342, 1011, 108, 3, 33, 36, 0, "StyleData", "MSG", "PrintToPDF",
 StyleMenuListing->None]
}, Closed]],
Cell[CellGroupData[{
Cell[28487, 1019, 48, 1, 36, 22, 0, "StyleData", "OsF", "All"],
Cell[28538, 1022, 81, 2, 36, 34, 0, "StyleData", "OsF", "Printout",
 StyleMenuListing->None],
Cell[28622, 1026, 100, 2, 39, 36, 0, "StyleData", "OsF", "PrintToPDF",
 StyleMenuListing->None]
}, Closed]],
Cell[CellGroupData[{
Cell[28759, 1033, 95, 3, 36, 29, 0, "StyleData", "ExerciseTI", "All"],
Cell[28857, 1038, 85, 2, 32, 41, 0, "StyleData", "ExerciseTI", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[28979, 1045, 81, 1, 35, 66, 0, "StyleData", "ExerciseSR", "All"],
Cell[29063, 1048, 82, 2, 31, 41, 0, "StyleData", "ExerciseSR", "Printout"],
Cell[29148, 1052, 88, 2, 31, 43, 0, "StyleData", "ExerciseSR", "PrintToPDF"]
}, Closed]],
Cell[CellGroupData[{
Cell[29273, 1059, 82, 2, 36, 25, 0, "StyleData", "TRLink", "All"],
Cell[29358, 1063, 85, 2, 36, 37, 0, "StyleData", "TRLink", "Printout"],
Cell[29446, 1067, 109, 2, 39, 39, 0, "StyleData", "TRLink", "PrintToPDF"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[29604, 1075, 55, 1, 33, "Section"],
Cell[29662, 1078, 114, 3, 43, "Text"],
Cell[CellGroupData[{
Cell[29801, 1085, 229, 5, 36, 32, 0, "StyleData", "SectionSpacer", "All"],
Cell[30033, 1092, 113, 2, 70, 44, 0, "StyleData", "SectionSpacer", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[30183, 1099, 235, 5, 36, 35, 0, "StyleData", "SubsectionSpacer", "All"],
Cell[30421, 1106, 183, 4, 70, 47, 0, "StyleData", "SubsectionSpacer", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[30641, 1115, 233, 5, 36, 34, 0, "StyleData", "ReferenceSpacer", "All"],
Cell[30877, 1122, 182, 4, 70, 46, 0, "StyleData", "ReferenceSpacer", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[31096, 1131, 73, 1, 36, 22, 0, "StyleData", "TOP", "All"],
Cell[31172, 1134, 158, 3, 31, 34, 0, "StyleData", "TOP", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[31379, 1143, 62, 1, 33, "Section"],
Cell[CellGroupData[{
Cell[31466, 1148, 93, 3, 20, 25, 0, "StyleData", "Header", "All",
 MenuSortingValue->None],
Cell[31562, 1153, 129, 4, 20, 37, 0, "StyleData", "Header", "Printout"],
Cell[31694, 1159, 143, 4, 24, 39, 0, "StyleData", "Header", "PrintToPDF"]
}, Closed]],
Cell[CellGroupData[{
Cell[31874, 1168, 122, 4, 27, 29, 0, "StyleData", "PageNumber", "All",
 StyleMenuListing->None],
Cell[31999, 1174, 138, 4, 22, 41, 0, "StyleData", "PageNumber", "Printout"],
Cell[32140, 1180, 149, 4, 24, 43, 0, "StyleData", "PageNumber", "PrintToPDF"]
}, Closed]],
Cell[CellGroupData[{
Cell[32326, 1189, 89, 3, 30, 28, 0, "StyleData", "HeaderOsF", "All",
 StyleMenuListing->None],
Cell[32418, 1194, 99, 3, 30, 40, 0, "StyleData", "HeaderOsF", "Printout"],
Cell[32520, 1199, 117, 3, 32, 42, 0, "StyleData", "HeaderOsF", "PrintToPDF"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[32686, 1208, 27, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[32738, 1212, 41, 1, 28, 27, 0, "StyleData", "Graphics", "All"],
Cell[32782, 1215, 53, 1, 26, 39, 0, "StyleData", "Graphics", "Printout"],
Cell[32838, 1218, 85, 2, 26, 41, 0, "StyleData", "Graphics", "PrintToPDF"]
}, Closed]],
Cell[CellGroupData[{
Cell[32960, 1225, 45, 1, 26, 29, 0, "StyleData", "Graphics3D", "All"],
Cell[33008, 1228, 55, 1, 26, 41, 0, "StyleData", "Graphics3D", "Printout"],
Cell[33066, 1231, 87, 2, 26, 43, 0, "StyleData", "Graphics3D", "PrintToPDF"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[33202, 1239, 45, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[33272, 1243, 40, 0, 36, 40, 0, "StyleData", "SuggestionsBarControl", \
"All"],
Cell[33315, 1245, 66, 1, 28, 52, 0, "StyleData", "SuggestionsBarControl", \
"Printout"],
Cell[33384, 1248, 98, 2, 28, 54, 0, "StyleData", "SuggestionsBarControl", \
"PrintToPDF"]
}, Closed]],
Cell[CellGroupData[{
Cell[33519, 1255, 41, 0, 36, 41, 0, "StyleData", "SuggestionsBarCategory", \
"All"],
Cell[33563, 1257, 67, 1, 28, 53, 0, "StyleData", "SuggestionsBarCategory", \
"Printout"],
Cell[33633, 1260, 99, 2, 28, 55, 0, "StyleData", "SuggestionsBarCategory", \
"PrintToPDF"]
}, Closed]],
Cell[CellGroupData[{
Cell[33769, 1267, 40, 0, 36, 40, 0, "StyleData", "SummaryItemAnnotation", \
"All"],
Cell[33812, 1269, 67, 1, 28, 52, 0, "StyleData", "SummaryItemAnnotation", \
"Printout"],
Cell[33882, 1272, 101, 2, 27, 54, 0, "StyleData", "SummaryItemAnnotation", \
"PrintToPDF"]
}, Closed]],
Cell[CellGroupData[{
Cell[34020, 1279, 30, 0, 36, 30, 0, "StyleData", "SummaryItem", "All"],
Cell[34053, 1281, 56, 1, 28, 42, 0, "StyleData", "SummaryItem", "Printout"],
Cell[34112, 1284, 91, 2, 27, 44, 0, "StyleData", "SummaryItem", "PrintToPDF"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[34252, 1292, 32, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[34309, 1296, 280, 10, 4, 28, 0, "StyleData", "PageBreak", "All"],
Cell[34592, 1308, 99, 3, 36, 40, 0, "StyleData", "PageBreak", "Printout"],
Cell[34694, 1313, 133, 4, 28, 42, 0, "StyleData", "PageBreak", "PrintToPDF"]
}, Closed]],
Cell[34842, 1320, 507, 16, 61, 33, 0, "StyleData", "CellExpression", "All",
 StyleMenuListing->None],
Cell[CellGroupData[{
Cell[35374, 1340, 34, 0, 35, 34, 0, "StyleData", "ManipulateLabel", "All"],
Cell[35411, 1342, 165, 5, 32, 48, 0, "StyleData", "ManipulateLabel", \
"PrintToPDF"]
}, Closed]],
Cell[CellGroupData[{
Cell[35613, 1352, 134, 1, 40, 77, 0, "StyleData", "PopupMenuLabel", "All"],
Cell[35750, 1355, 91, 2, 32, 47, 0, "StyleData", "PopupMenuLabel", \
"PrintToPDF"]
}, Closed]],
Cell[CellGroupData[{
Cell[35878, 1362, 25, 0, 36, 25, 0, "StyleData", "Setter", "All"],
Cell[35906, 1364, 85, 2, 31, 39, 0, "StyleData", "Setter", "PrintToPDF"]
}, Closed]]
}, Closed]]
}
]
*)

(* End of internal cache information *)
