(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     32673,       1190]
NotebookOptionsPosition[     21503,        899]
NotebookOutlinePosition[     21939,        918]
CellTagsIndexPosition[     21896,        915]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[StyleData[StyleDefinitions -> "Default.nb"]],

Cell[CellGroupData[{

Cell["Headings", "Section"],

Cell[StyleData["TitleFlourish"],
 CellMargins->{{0, 0}, {26, 6}},
 CellGroupingRules->{"SectionGrouping", 30},
 TextAlignment->Center,
 Magnification->1],

Cell[CellGroupData[{

Cell[StyleData["ChapterTitle"],
 TextAlignment->Center,
 FontFamily->"Times",
 FontSize->18,
 FontWeight->"Plain",
 FontSlant->"Plain"],

Cell[StyleData["ChapterTitle", "Printout"]]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["Chapter"],
 ShowGroupOpener->True,
 CellMargins->{{0, 0}, {0, 0}},
 CellGroupingRules->{"SectionGrouping", 30},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["Chapter"], "\t"}], CellBaseline -> Baseline], None}, {
   None, None}},
 TabSpacings->1.3,
 CounterIncrements->"Chapter",
 CounterAssignments->{{"Section", 0}, {"Figure", 0}, {"SolutionItem", 0}},
 FontFamily->"Times",
 FontSize->25,
 FontWeight->"Plain",
 FontSlant->"Plain"],

Cell[StyleData["Chapter", "Printout"],
 ShowGroupOpener->False,
 CellMargins->{{0, 0}, {2, 6}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["Chapter"], "\t"}], CellBaseline -> Baseline], None}, {
   None, None}},
 TabSpacings->1.65,
 FontFamily->"Times",
 FontSize->15]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Section"],
 CellFrame->None,
 ShowGroupOpener->True,
 CellMargins->{{2, 0}, {5, 15}},
 CellGroupingRules->{"SectionGrouping", 30},
 CellFrameLabels->{{
    Cell[
     TextData[{
       StyleBox[
        CounterBox["Chapter"]], 
       StyleBox["."], 
       StyleBox[
        CounterBox["Section"]], "\t"}], CellBaseline -> Baseline], None}, {
   None, None}},
 CellFrameLabelMargins->0,
 TabSpacings->1.25,
 CounterIncrements->"Section",
 CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}, {
   "ExerciseItem", 0}},
 MenuSortingValue->1200,
 MenuCommandKey->"4",
 CounterStyleMenuListing->None,
 FontFamily->"Times",
 FontSize->18,
 FontColor->GrayLevel[0]],

Cell[StyleData["Section", "Printout"],
 ShowGroupOpener->False,
 CellMargins->{{-0.5, 0}, {6.5, 0}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       StyleBox[
        CounterBox["Chapter"]], 
       StyleBox["."], 
       StyleBox[
        CounterBox["Section"]], "\t"}], CellBaseline -> Baseline], None}, {
   None, None}},
 CellFrameLabelMargins->0,
 TabSpacings->1.25,
 FontFamily->"Times",
 FontSize->13.5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subsection"],
 CellDingbat->None,
 CellMargins->{{2, Inherited}, {0, 24}},
 CellGroupingRules->{"SectionGrouping", 40},
 MenuSortingValue->1250,
 MenuCommandKey->"5",
 CounterStyleMenuListing->None,
 FontFamily->"Times",
 FontSize->16,
 FontWeight->"Plain",
 FontSlant->"Italic",
 FontColor->GrayLevel[0]],

Cell[StyleData["Subsection", "Printout"],
 CellMargins->{{0., 0}, {0, 0}},
 FontFamily->"Times",
 FontSize->12.75]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Text", "Section"],

Cell[CellGroupData[{

Cell[StyleData["Text"],
 CellMargins->{{2, 10}, {7, 7}},
 Hyphenation->True,
 LineSpacing->{1, 3},
 ParagraphIndent->17,
 CounterIncrements->"Text",
 MenuSortingValue->1310,
 MenuCommandKey->"7",
 FontFamily->"Times"],

Cell[StyleData["Text", "Printout"],
 CellMargins->{{0, 0}, {2, 0}},
 TextJustification->1,
 LineSpacing->{1, 2},
 ParagraphIndent->13,
 FontFamily->"Times",
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TextFirst", StyleDefinitions -> StyleData["Text"]],
 ParagraphIndent->0,
 MenuSortingValue->1300,
 MenuCommandKey->"6"],

Cell[StyleData["TextFirst", "Printout"],
 ParagraphIndent->0]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Input/Output", "Section"],

Cell[CellGroupData[{

Cell[StyleData["Input"],
 CellMargins->{{60, Inherited}, {Inherited - 1, Inherited + 6}}],

Cell[StyleData["Input", "Printout"],
 CellMargins->{{62, 0}, {3, 3.}},
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["InputOnly"],
 CellMargins->{{60, Inherited}, {0, 9}}],

Cell[StyleData["InputOnly", "Printout", StyleDefintions -> None],
 CellMargins->{{62, Inherited}, {3, 5}},
 LinebreakAdjustments->{0.85, 2, 10, 1, 1},
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Output"],
 CellMargins->{{60, Inherited}, {Inherited + 2, Inherited}}],

Cell[StyleData["Output", "Printout"],
 CellMargins->{{62, 0}, {5, 0}},
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Message"],
 CellMargins->{{60, Inherited}, {Inherited, Inherited}}],

Cell[StyleData["Message", "Printout"],
 CellMargins->{{62, Inherited}, {8, 5}},
 FontSize->10,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Print"],
 CellMargins->{{45, Inherited}, {Inherited, Inherited}}],

Cell[StyleData["Print", "Printout"],
 CellMargins->{{42, Inherited}, {6, 3}},
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CellLabel"],
 StyleMenuListing->None,
 FontFamily->"Helvetica",
 FontSize->8,
 FontColor->RGBColor[0, 0, 1]],

Cell[StyleData["CellLabel", "Printout"],
 FontSize->7]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Exercises", "Section"],

Cell[CellGroupData[{

Cell[StyleData["ExerciseItem"],
 CellMargins->{{0, 100}, {6, 5}},
 CellGroupingRules->{"SectionGrouping", 45},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["ExerciseItem"], ".", "\t"}], FontWeight -> "Bold", 
     CellBaseline -> Baseline], None}, {None, None}},
 CellFrameLabelMargins->0,
 Hyphenation->True,
 LineSpacing->{1, 3},
 TabSpacings->1.4,
 CounterIncrements->"ExerciseItem",
 CounterAssignments->{{"ExerciseSubItem", 0}},
 MenuSortingValue->1700,
 FontSize->14],

Cell[StyleData["ExerciseItem", "Printout"],
 CellMargins->{{0, 24}, {6, 0}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["ExerciseItem"], ".", "\t"}], CellBaseline -> Baseline], 
    None}, {None, None}},
 CellFrameLabelMargins->0,
 LineSpacing->{1, 1},
 TabSpacings->2,
 FontFamily->"Times",
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseSubItem"],
 CellMargins->{{16, 4}, {6, 0}},
 CellGroupingRules->{"SectionGrouping", 46},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["ExerciseSubItem", CounterFunction -> (Part[
          CharacterRange["a", "z"], #]& )], "."}], CellBaseline -> Baseline, 
     FontFamily -> "Times", FontWeight -> "Bold"], None}, {None, None}},
 Hyphenation->True,
 LineSpacing->{1, 2},
 ParagraphSpacing->{0, 0},
 CounterIncrements->"ExerciseSubItem",
 FontSize->14],

Cell[StyleData["ExerciseSubItem", "Printout"],
 CellMargins->{{15, 24}, {6, 0}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["ExerciseSubItem", CounterFunction -> (Part[
          CharacterRange["a", "z"], #]& )], "."}], FontSize -> 8.75, 
     CellBaseline -> Baseline], None}, {None, None}},
 LineSpacing->{1, 1},
 FontFamily->"Times",
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseText"],
 CellMargins->{{16, 100}, {5, 5}},
 Hyphenation->True,
 LineSpacing->{1, 2},
 ParagraphSpacing->{0, 8},
 ParagraphIndent->0,
 CounterStyleMenuListing->None,
 FontSize->14],

Cell[StyleData["ExerciseText", "Printout"],
 CellMargins->{{14, 24}, {6, 0}},
 FontFamily->"Times",
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseDisplayFormula", StyleDefinitions -> StyleData[
 "DisplayFormula"]],
 ShowCellLabel->False,
 ShowStringCharacters->False,
 FontSize->14],

Cell[StyleData["ExerciseDisplayFormula", "Printout"],
 CellMargins->{{24, Inherited}, {6, 0}},
 FontFamily->"Times",
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseInput", StyleDefinitions -> StyleData["Input"]],
 GeneratedCellStyles->{"Output"->{"ExerciseOutput"}},
 FontSize->13,
 FontWeight->"Bold"],

Cell[StyleData["ExerciseInput", "Printout"],
 CellMargins->{{44, Inherited}, {Inherited - 1, Inherited - 5}},
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseInputOnly", StyleDefinitions -> StyleData["Input"]],
 GeneratedCellStyles->{"Output"->"ExerciseOutput"},
 FontSize->13,
 FontWeight->"Medium"],

Cell[StyleData["ExerciseInputOnly", "Printout"],
 CellMargins->{{44, 24}, {4, 0}},
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseOutput", StyleDefinitions -> StyleData["Output"]],
 FontSize->13],

Cell[StyleData["ExerciseOutput", "Printout"],
 CellMargins->{{44, 24}, {6, 0}},
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseFigure"],
 CellMargins->{{18, 4}, {0, 12}},
 CellGroupingRules->"InputGrouping",
 CellFrameLabels->{{
    Cell[
     TextData[{"Figure ", 
       CounterBox["Chapter"], ".", 
       CounterBox["NumberedFigure"], "\t"}], CellBaseline -> Baseline, 
     FontSlant -> "Plain"], None}, {None, None}},
 TabSpacings->0.25,
 CounterIncrements->"NumberedFigure",
 MenuSortingValue->1670,
 FormatTypeAutoConvert->False,
 FontSize->14,
 FontSlant->"Italic"],

Cell[StyleData["ExerciseFigure", "Printout"],
 CellMargins->{{16, Inherited}, {0, 3.75}},
 PageBreakBelow->False,
 GroupPageBreakWithin->False,
 CellFrameLabels->{{
    Cell[
     TextData[{"Figure ", 
       CounterBox["Chapter"], ".", 
       CounterBox["NumberedFigure"], ".", "\t"}], FontSlant -> "Plain", 
     CellBaseline -> Baseline], None}, {None, None}},
 TabSpacings->0.25,
 FontFamily->"Times",
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExFigure"],
 Deletable->True,
 CellMargins->{{18, 10}, {14, 12}},
 CellGroupingRules->"OutputGrouping",
 CellAutoOverwrite->False,
 ShowCellLabel->False,
 ShowStringCharacters->False,
 MenuSortingValue->1500,
 MenuCommandKey->None],

Cell[StyleData["ExFigure", "Printout"],
 CellMargins->{{22, 10}, {10.75, 6.75}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExTable"],
 Deletable->True,
 CellMargins->{{16, Inherited}, {18, 0}},
 CellGroupingRules->"OutputGrouping",
 DefaultFormatType->DefaultTraditionalFormatType,
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 LanguageCategory->"Formula",
 ScriptLevel->0,
 SingleLetterItalics->True,
 UnderoverscriptBoxOptions->{LimitsPositioning->True}],

Cell[StyleData["ExTable", "Printout"],
 CellMargins->{{18, 0}, {10.75, 6.75}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseTable"],
 CellMargins->{{16, 4}, {12, 14}},
 CellGroupingRules->"InputGrouping",
 CellFrameLabels->{{
    Cell[
     TextData[{"Table ", 
       CounterBox["Chapter"], ".", 
       CounterBox["NumberedTable"], ".", "\t"}], CellBaseline -> Baseline, 
     FontSlant -> "Plain"], None}, {None, None}},
 TabSpacings->1.1,
 CounterIncrements->"NumberedTable",
 MenuSortingValue->1660,
 FormatTypeAutoConvert->False,
 FontSize->14,
 FontSlant->"Italic"],

Cell[StyleData["ExerciseTable", "Printout"],
 CellMargins->{{13, 0}, {0, 3.75}},
 PageBreakBelow->False,
 GroupPageBreakWithin->False,
 CellFrameLabels->{{
    Cell[
     TextData[{"Table ", 
       CounterBox["Chapter"], ".", 
       CounterBox["NumberedTable"], ".", "\t"}], CellBaseline -> Baseline, 
     FontSlant -> "Plain"], None}, {None, None}},
 TabSpacings->0.25,
 FontFamily->"Times",
 FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Solutions", "Section"],

Cell[CellGroupData[{

Cell[StyleData["SolutionItem"],
 CellMargins->{{0, 4}, {0, 8}},
 CellGroupingRules->{"SectionGrouping", 55},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["SolutionItem"], ".", "\t"}], CellBaseline -> Baseline, 
     FontWeight -> "Bold"], None}, {None, None}},
 Hyphenation->True,
 LineSpacing->{1, 3},
 ParagraphSpacing->{0, 8},
 TabSpacings->1.75,
 CounterIncrements->"SolutionItem",
 CounterAssignments->{{"SolutionSubItem", 0}},
 MenuSortingValue->1300,
 MenuCommandKey->"6",
 FontSize->14],

Cell[StyleData["SolutionItem", "Printout"],
 CellMargins->{{0, 0}, {4, 4}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["SolutionItem"], ".", "\t"}], CellBaseline -> Baseline], 
    None}, {None, None}},
 LineSpacing->{1.25, 0, 2},
 TabSpacings->2.2,
 FontFamily->"Times",
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SolutionSubItem"],
 CellMargins->{{62, 4}, {0, 8}},
 CellGroupingRules->{"SectionGrouping", 60},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["SolutionSubItem"], "."}], CellBaseline -> Baseline, 
     CounterBoxOptions -> {CounterFunction :> (Part[
         CharacterRange["a", "z"], #]& )}], None}, {None, None}},
 Hyphenation->True,
 LineSpacing->{1, 3},
 ParagraphSpacing->{0, 8},
 CounterIncrements->"SolutionSubItem",
 MenuSortingValue->1410,
 MenuCommandKey->"8",
 FontSize->14],

Cell[StyleData["SolutionSubItem", "Printout"],
 CellMargins->{{23, 0}, {5, 3}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["SolutionSubItem"], "."}], CellBaseline -> Baseline, 
     CounterBoxOptions -> {CounterFunction :> (Part[
         CharacterRange["a", "z"], #]& )}], None}, {None, None}},
 LineSpacing->{1, 1},
 FontFamily->"Times",
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SolutionText"],
 CellMargins->{{28, 4}, {0, 8}},
 Hyphenation->True,
 LineSpacing->{1, 3},
 ParagraphSpacing->{0, 8},
 MenuSortingValue->1400,
 MenuCommandKey->"7",
 CounterStyleMenuListing->None,
 FontSize->14],

Cell[StyleData["SolutionText", "Printout"],
 CellMargins->{{24, 0}, {4, 2}},
 LineSpacing->{1, 2},
 FontFamily->"Times",
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SolutionsPageRef"],
 CellMargins->{{0, 0}, {4, 1}},
 StyleMenuListing->None,
 FontFamily->"Times",
 FontWeight->"Plain",
 FontSlant->"Italic"],

Cell[StyleData["SolutionsPageRef", "Printout"],
 CellMargins->{{0, 0}, {4, 1}},
 StyleMenuListing->None,
 FontFamily->"DTL Albertina TOT",
 FontSize->10,
 FontSlant->"Italic"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Inline formatting", "Section"],

Cell[CellGroupData[{

Cell[StyleData["SRSmall", StyleDefinitions -> StyleData["SR"]]],

Cell[StyleData["SRSmall", "Printout"],
 FontSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SRTiny", StyleDefinitions -> StyleData["SR"]]],

Cell[StyleData["SRTiny", "Printout"],
 FontSize->6.]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SB"],
 StyleMenuListing->None],

Cell[StyleData["SB", "Printout"],
 FontWeight->"Bold"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SmallCaps"],
 StyleMenuListing->None,
 FontFamily->"Times",
 FontColor->GrayLevel[0]],

Cell[StyleData["SmallCaps", "Printout"],
 FontFamily->"Times"]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["OsF"],
 StyleMenuListing->None],

Cell[StyleData["OsF", "Printout"],
 FontFamily->"Times"]
}, Closed]],

Cell[StyleData["ChapterNumber"],
 StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["SubsubBold"],
 FontWeight->"Bold"],

Cell[StyleData["SubsubBold", "Printout"],
 FontFamily->"Times",
 FontWeight->"Plain",
 FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableHeading"],
 StyleMenuListing->None,
 FontFamily->"Helvetica",
 FontSize->11],

Cell[StyleData["TableHeading", "Printout"],
 FontFamily->"Helvetica",
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableText", StyleDefinitions -> StyleData["Text"]],
 LineIndent->Automatic,
 FontSize->12.5],

Cell[StyleData["TableText", "Printout"],
 LineSpacing->{1, 1},
 FontFamily->"Times",
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableTextTI", StyleDefinitions -> StyleData["Text"]],
 FontFamily->"Times",
 FontSize->12.5,
 FontWeight->"Plain",
 FontSlant->"Italic"],

Cell[StyleData["TableTextTI", "Printout"],
 FontFamily->"Times",
 FontSize->10,
 FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableOsF", StyleDefinitions -> StyleData["OsF"]]],

Cell[StyleData["TableOsF", "Printout"],
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableMR", StyleDefinitions -> StyleData["MR"]],
 AutoQuoteCharacters->{},
 StyleMenuListing->None],

Cell[StyleData["TableMR", "Printout"],
 FontFamily->"Courier",
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseTI"],
 FontFamily->"Times",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Italic"],

Cell[StyleData["ExerciseTI", "Printout"],
 FontFamily->"Times",
 FontSize->10,
 FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseMR"],
 FontFamily->"Courier",
 FontSize->11.25],

Cell[StyleData["ExerciseMR", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseSR", StyleDefinitions -> StyleData["SR"]]],

Cell[StyleData["ExerciseSR", "Printout"],
 FontSize->7.]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CellLabelInline"],
 StyleMenuListing->None,
 FontFamily->"Helvetica Neue",
 FontSize->12,
 FontColor->RGBColor[0.247, 0.24, 0.6]],

Cell[StyleData["CellLabelInline", "Printout"],
 FontSize->9.,
 FontColor->RGBColor[0.247, 0.24, 0.6]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ITBold"],
 FontFamily->"Times",
 FontWeight->"Bold",
 FontSlant->"Italic"],

Cell[StyleData["ITBold", "Printout"],
 FontFamily->"Times",
 FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["WLDC"],
 LineColor->RGBColor[0.269993, 0.308507, 0.6],
 FrontFaceColor->RGBColor[0.269993, 0.308507, 0.6],
 BackFaceColor->RGBColor[0.269993, 0.308507, 0.6],
 GraphicsColor->RGBColor[0.269993, 0.308507, 0.6],
 FontColor->RGBColor[0.269993, 0.308507, 0.6]],

Cell[StyleData["WLDC", "Printout"],
 FontFamily->"Helvetica",
 FontSize->9.75]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Graphics", "Section"],

Cell[CellGroupData[{

Cell[StyleData["Graphics"],
 FontSize->7],

Cell[StyleData["Graphics", "Printout"],
 FontSize->6]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Miscellaneous", "Section"],

Cell[CellGroupData[{

Cell[StyleData["Hyperlink"],
 FontFamily->"Times",
 FontVariations->{"Underline"->True},
 FontColor->RGBColor[0.269993, 0.308507, 0.6]],

Cell[StyleData["Hyperlink", "Printout"],
 FontVariations->{"Underline"->False},
 FontColor->GrayLevel[1]]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["References"],
 CellMargins->{{0, 10}, {4, 6}},
 DefaultNewInlineCellStyle->"None",
 Hyphenation->True,
 LineSpacing->{1, 3},
 ParagraphIndent->0,
 StyleMenuListing->None,
 FontFamily->"Times",
 FontSize->12,
 FontColor->GrayLevel[0.35]],

Cell[StyleData["References", "Printout"],
 CellMargins->{{0, 2}, {6, 0}},
 LineSpacing->{1, 1.5},
 ParagraphIndent->0,
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->9.5]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["ReferenceAbstract"],
 CellMargins->{{0, 10}, {4, 6}},
 DefaultNewInlineCellStyle->"None",
 Hyphenation->True,
 LineSpacing->{1, 3},
 StyleMenuListing->None,
 FontFamily->"Times",
 FontSize->12],

Cell[StyleData["ReferenceAbstract", "Printout"],
 CellMargins->{{0, 2}, {5, 0}},
 TextJustification->1.,
 LineSpacing->{1.2, 0, 2},
 FontFamily->"DTL Albertina TOTR Book",
 FontSize->9.5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FlourishCell"],
 CellFrame->{{0, 0}, {0, 0}},
 CellMargins->{{0, 24}, {0, 0}},
 CellGroupingRules->{"SectionGrouping", 40},
 CellFrameLabels->{{None, None}, {None, 
    Cell[
     BoxData[
      GraphicsBox[
       TagBox[
        RasterBox[CompressedData["
1:eJx10mtOg0AUBWCMK3FLLqEbcIeKgPISHwiUChRtKwiiGMSICNbjvZmm/eGX
kJAAw9xz5mBydDjZlyRpD5eB6+9+LfwI4zgOw/C9q+/7L/JJPoS2bd93NU3z
Ruq6fiUvpKqqZ1KWZVEUT0Ke51mWPZLVarVcLh/IPUnTdE6SJInjOIqiO2E2
m4VhOCVBEPi+73neLbkh1+SKXJILYlmWaZqGYei6fk7OiKZpqqqeCifCMeF7
WZb5qaIoeJk/5EV0gmWxvm3b+JHjOPxfbIA3wxtzXZf36ZOpgHEwFE+HSTEv
pp4LHAiHs1gsEBTi4twQIGLkPAuCkDltxM75cxcohdtBTdutocdNp1xx13Xc
OKrfPgk4Gzghm9Oy/scv/GgUOA==
         "], {{0, 1}, {200, 0}}, {0, 255}, 
         ColorFunction -> RGBColor], 
        BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True], 
        Selectable -> False], BaseStyle -> "ImageGraphics", 
       ImageSizeRaw -> {200, 1}, PlotRange -> {{0, 200}, {0, 1}}]]]}}],

Cell[StyleData["FlourishCell", "Printout"],
 CellFrame->{{0, 0}, {0, 0}},
 CellMargins->{{0, 24}, {0, 0}},
 CellGroupingRules->{"SectionGrouping", 40},
 CellFrameLabels->{{None, None}, {None, 
    Cell[
     BoxData[
      GraphicsBox[
       TagBox[
        RasterBox[CompressedData["
1:eJx10mtOg0AUBWCMK3FLLqEbcIeKgPISHwiUChRtKwiiGMSICNbjvZmm/eGX
kJAAw9xz5mBydDjZlyRpD5eB6+9+LfwI4zgOw/C9q+/7L/JJPoS2bd93NU3z
Ruq6fiUvpKqqZ1KWZVEUT0Ke51mWPZLVarVcLh/IPUnTdE6SJInjOIqiO2E2
m4VhOCVBEPi+73neLbkh1+SKXJILYlmWaZqGYei6fk7OiKZpqqqeCifCMeF7
WZb5qaIoeJk/5EV0gmWxvm3b+JHjOPxfbIA3wxtzXZf36ZOpgHEwFE+HSTEv
pp4LHAiHs1gsEBTi4twQIGLkPAuCkDltxM75cxcohdtBTdutocdNp1xx13Xc
OKrfPgk4Gzghm9Oy/scv/GgUOA==
         "], {{0, 1}, {200, 0}}, {0, 255}, 
         ColorFunction -> RGBColor], 
        BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True], 
        Selectable -> False], BaseStyle -> "ImageGraphics", 
       ImageSizeRaw -> {200, 1}, PlotRange -> {{0, 200}, {0, 1}}]]]}}]
}, Open  ]]
}, Open  ]]
},
Editable->True,
Saveable->True,
ScreenStyleEnvironment->"Working",
WindowSize->{737, 691},
WindowMargins->{{350, Automatic}, {63, Automatic}},
FrontEndVersion->"10.1 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 23, \
2015)",
StyleDefinitions->"StylesheetFormatting.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 49, 0, 36, 49, 0, "StyleData", "StyleDefinitions", ""],
Cell[CellGroupData[{
Cell[632, 24, 27, 0, 49, "Section"],
Cell[662, 26, 153, 4, 60, 32, 0, "StyleData", "TitleFlourish", "All"],
Cell[CellGroupData[{
Cell[840, 34, 135, 5, 42, 31, 0, "StyleData", "ChapterTitle", "All"],
Cell[978, 41, 43, 0, 42, 43, 0, "StyleData", "ChapterTitle", "Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1058, 46, 470, 15, 41, 26, 0, "StyleData", "Chapter", "All",
 CounterIncrements->"Chapter",
 CounterAssignments->{{"Section", 0}, {"Figure", 0}, {"SolutionItem", 0}}],
Cell[1531, 63, 290, 10, 39, 38, 0, "StyleData", "Chapter", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[1858, 78, 685, 24, 43, 26, 0, "StyleData", "Section", "All",
 CounterIncrements->"Section",
 CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}, {
   "ExerciseItem", 0}},
 MenuSortingValue->1200,
 MenuCommandKey->"4"],
Cell[2546, 104, 416, 15, 36, 38, 0, "StyleData", "Section", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[2999, 124, 321, 11, 36, 29, 0, "StyleData", "Subsection", "All",
 MenuSortingValue->1250,
 MenuCommandKey->"5"],
Cell[3323, 137, 114, 3, 29, 41, 0, "StyleData", "Subsection", "Printout"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[3486, 146, 23, 0, 49, "Section"],
Cell[CellGroupData[{
Cell[3534, 150, 217, 8, 44, 23, 0, "StyleData", "Text", "All",
 CounterIncrements->"Text",
 MenuSortingValue->1310,
 MenuCommandKey->"7"],
Cell[3754, 160, 171, 6, 28, 35, 0, "StyleData", "Text", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[3962, 171, 135, 3, 41, 67, 0, "StyleData", "TextFirst", "All",
 MenuSortingValue->1300,
 MenuCommandKey->"6"],
Cell[4100, 176, 61, 1, 28, 40, 0, "StyleData", "TextFirst", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[4210, 183, 31, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[4266, 187, 89, 1, 47, 24, 0, "StyleData", "Input", "All"],
Cell[4358, 190, 85, 2, 32, 36, 0, "StyleData", "Input", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[4480, 197, 69, 1, 38, 28, 0, "StyleData", "InputOnly", "All"],
Cell[4552, 200, 165, 3, 34, 65, 0, "StyleData", "InputOnly", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[4754, 208, 86, 1, 41, 25, 0, "StyleData", "Output", "All"],
Cell[4843, 211, 85, 2, 31, 37, 0, "StyleData", "Output", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[4965, 218, 83, 1, 37, 26, 0, "StyleData", "Message", "All"],
Cell[5051, 221, 120, 3, 39, 38, 0, "StyleData", "Message", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[5208, 229, 81, 1, 36, 24, 0, "StyleData", "Print", "All"],
Cell[5292, 232, 92, 2, 35, 36, 0, "StyleData", "Print", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[5421, 239, 124, 4, 32, 28, 0, "StyleData", "CellLabel", "All",
 StyleMenuListing->None],
Cell[5548, 245, 54, 1, 31, 40, 0, "StyleData", "CellLabel", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[5651, 252, 28, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[5704, 256, 493, 15, 41, 31, 0, "StyleData", "ExerciseItem", "All",
 CounterIncrements->"ExerciseItem",
 CounterAssignments->{{"ExerciseSubItem", 0}},
 MenuSortingValue->1700],
Cell[6200, 273, 328, 11, 32, 43, 0, "StyleData", "ExerciseItem", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[6565, 289, 496, 13, 36, 34, 0, "StyleData", "ExerciseSubItem", "All",
 CounterIncrements->"ExerciseSubItem"],
Cell[7064, 304, 373, 10, 32, 46, 0, "StyleData", "ExerciseSubItem", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[7474, 319, 203, 7, 40, 31, 0, "StyleData", "ExerciseText", "All"],
Cell[7680, 328, 114, 3, 32, 43, 0, "StyleData", "ExerciseText", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[7831, 336, 160, 4, 38, 92, 1, "StyleData", "ExerciseDisplayFormula", \
"All"],
Cell[7994, 342, 131, 3, 32, 53, 0, "StyleData", "ExerciseDisplayFormula", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[8162, 350, 162, 3, 42, 72, 0, "StyleData", "ExerciseInput", "All"],
Cell[8327, 355, 124, 2, 22, 44, 0, "StyleData", "ExerciseInput", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[8488, 362, 166, 3, 42, 76, 0, "StyleData", "ExerciseInputOnly", "All"],
Cell[8657, 367, 97, 2, 30, 48, 0, "StyleData", "ExerciseInputOnly", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[8791, 374, 89, 1, 39, 74, 0, "StyleData", "ExerciseOutput", "All"],
Cell[8883, 377, 94, 2, 32, 45, 0, "StyleData", "ExerciseOutput", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[9014, 384, 471, 14, 42, 33, 0, "StyleData", "ExerciseFigure", "All",
 CounterIncrements->"NumberedFigure",
 MenuSortingValue->1670],
Cell[9488, 400, 421, 12, 29, 45, 0, "StyleData", "ExerciseFigure", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[9946, 417, 247, 8, 54, 27, 0, "StyleData", "ExFigure", "All",
 MenuSortingValue->1500,
 MenuCommandKey->None],
Cell[10196, 427, 80, 1, 45, 39, 0, "StyleData", "ExFigure", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[10313, 433, 370, 9, 46, 26, 0, "StyleData", "ExTable", "All"],
Cell[10686, 444, 78, 1, 45, 38, 0, "StyleData", "ExTable", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[10801, 450, 472, 14, 56, 32, 0, "StyleData", "ExerciseTable", "All",
 CounterIncrements->"NumberedTable",
 MenuSortingValue->1660],
Cell[11276, 466, 410, 12, 29, 44, 0, "StyleData", "ExerciseTable", \
"Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[11735, 484, 28, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[11788, 488, 514, 16, 38, 31, 0, "StyleData", "SolutionItem", "All",
 CounterIncrements->"SolutionItem",
 CounterAssignments->{{"SolutionSubItem", 0}},
 MenuSortingValue->1300,
 MenuCommandKey->"6"],
Cell[12305, 506, 308, 10, 34, 43, 0, "StyleData", "SolutionItem", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[12650, 521, 520, 15, 38, 34, 0, "StyleData", "SolutionSubItem", "All",
 CounterIncrements->"SolutionSubItem",
 MenuSortingValue->1410,
 MenuCommandKey->"8"],
Cell[13173, 538, 376, 10, 34, 46, 0, "StyleData", "SolutionSubItem", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[13586, 553, 227, 8, 38, 31, 0, "StyleData", "SolutionText", "All",
 MenuSortingValue->1400,
 MenuCommandKey->"7"],
Cell[13816, 563, 135, 4, 32, 43, 0, "StyleData", "SolutionText", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[13988, 572, 158, 5, 33, 35, 0, "StyleData", "SolutionsPageRef", "All",
 StyleMenuListing->None],
Cell[14149, 579, 175, 5, 33, 47, 0, "StyleData", "SolutionsPageRef", \
"Printout",
 StyleMenuListing->None]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[14373, 590, 36, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[14434, 594, 63, 0, 36, 63, 0, "StyleData", "SRSmall", "All"],
Cell[14500, 596, 52, 1, 32, 38, 0, "StyleData", "SRSmall", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[14589, 602, 62, 0, 36, 62, 0, "StyleData", "SRTiny", "All"],
Cell[14654, 604, 52, 1, 30, 37, 0, "StyleData", "SRTiny", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[14743, 610, 46, 1, 36, 21, 0, "StyleData", "SB", "All",
 StyleMenuListing->None],
Cell[14792, 613, 54, 1, 36, 33, 0, "StyleData", "SB", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[14883, 619, 101, 3, 36, 28, 0, "StyleData", "SmallCaps", "All",
 StyleMenuListing->None],
Cell[14987, 624, 62, 1, 36, 40, 0, "StyleData", "SmallCaps", "Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[15086, 630, 47, 1, 36, 22, 0, "StyleData", "OsF", "All",
 StyleMenuListing->None],
Cell[15136, 633, 56, 1, 36, 34, 0, "StyleData", "OsF", "Printout"]
}, Closed]],
Cell[15207, 637, 57, 1, 36, 32, 0, "StyleData", "ChapterNumber", "All",
 StyleMenuListing->None],
Cell[CellGroupData[{
Cell[15289, 642, 50, 1, 36, 29, 0, "StyleData", "SubsubBold", "All"],
Cell[15342, 645, 107, 3, 36, 41, 0, "StyleData", "SubsubBold", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[15486, 653, 97, 3, 35, 31, 0, "StyleData", "TableHeading", "All",
 StyleMenuListing->None],
Cell[15586, 658, 84, 2, 34, 43, 0, "StyleData", "TableHeading", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[15707, 665, 108, 2, 40, 67, 0, "StyleData", "TableText", "All"],
Cell[15818, 669, 99, 3, 28, 40, 0, "StyleData", "TableText", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[15954, 677, 152, 4, 40, 69, 0, "StyleData", "TableTextTI", "All"],
Cell[16109, 683, 101, 3, 28, 42, 0, "StyleData", "TableTextTI", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[16247, 691, 65, 0, 36, 65, 0, "StyleData", "TableOsF", "All"],
Cell[16315, 693, 54, 1, 34, 39, 0, "StyleData", "TableOsF", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[16406, 699, 114, 2, 36, 63, 0, "StyleData", "TableMR", "All",
 StyleMenuListing->None],
Cell[16523, 703, 77, 2, 34, 38, 0, "StyleData", "TableMR", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[16637, 710, 110, 4, 36, 29, 0, "StyleData", "ExerciseTI", "All"],
Cell[16750, 716, 100, 3, 34, 41, 0, "StyleData", "ExerciseTI", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[16887, 724, 71, 2, 36, 29, 0, "StyleData", "ExerciseMR", "All"],
Cell[16961, 728, 41, 0, 36, 41, 0, "StyleData", "ExerciseMR", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[17039, 733, 66, 0, 36, 66, 0, "StyleData", "ExerciseSR", "All"],
Cell[17108, 735, 56, 1, 31, 41, 0, "StyleData", "ExerciseSR", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[17201, 741, 145, 4, 38, 34, 0, "StyleData", "CellLabelInline", "All",
 StyleMenuListing->None],
Cell[17349, 747, 101, 2, 33, 46, 0, "StyleData", "CellLabelInline", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[17487, 754, 90, 3, 36, 25, 0, "StyleData", "ITBold", "All"],
Cell[17580, 759, 81, 2, 36, 37, 0, "StyleData", "ITBold", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[17698, 766, 271, 5, 36, 23, 0, "StyleData", "WLDC", "All"],
Cell[17972, 773, 78, 2, 34, 35, 0, "StyleData", "WLDC", "Printout"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[18099, 781, 27, 0, 49, "Section"],
Cell[CellGroupData[{
Cell[18151, 785, 41, 1, 31, 27, 0, "StyleData", "Graphics", "All"],
Cell[18195, 788, 53, 1, 30, 39, 0, "StyleData", "Graphics", "Printout"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[18297, 795, 32, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[18354, 799, 135, 3, 36, 28, 0, "StyleData", "Hyperlink", "All"],
Cell[18492, 804, 105, 2, 36, 40, 0, "StyleData", "Hyperlink", "Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[18634, 811, 252, 9, 38, 29, 0, "StyleData", "References", "All",
 StyleMenuListing->None],
Cell[18889, 822, 174, 5, 34, 41, 0, "StyleData", "References", "Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19100, 832, 209, 7, 38, 36, 0, "StyleData", "ReferenceAbstract", "All",
 StyleMenuListing->None],
Cell[19312, 841, 187, 5, 33, 48, 0, "StyleData", "ReferenceAbstract", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[19536, 851, 962, 21, 44, 31, 0, "StyleData", "FlourishCell", "All"],
Cell[20501, 874, 974, 21, 44, 43, 0, "StyleData", "FlourishCell", "Printout"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
