(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     27115,        992]
NotebookOptionsPosition[     17170,        731]
NotebookOutlinePosition[     17605,        750]
CellTagsIndexPosition[     17562,        747]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[StyleData[StyleDefinitions -> FrontEnd`FileName[{"EPM"}, "EPM.nb"]]],

Cell[CellGroupData[{

Cell["Headings", "Section"],

Cell[StyleData["TitleFlourish"],
 CellMargins->{{0, 0}, {26, 6}},
 CellGroupingRules->{"SectionGrouping", 30},
 TextAlignment->Center,
 Magnification->1],

Cell[CellGroupData[{

Cell[StyleData["ChapterTitle"]],

Cell[StyleData["ChapterTitle", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Chapter"],
 ShowGroupOpener->True,
 CellMargins->{{0, 0}, {0, 0}},
 CellGroupingRules->{"SectionGrouping", 30},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["Chapter"], "\t"}], CellBaseline -> Baseline], None}, {
   None, None}},
 TabSpacings->1.3,
 CounterIncrements->"Chapter",
 CounterAssignments->{{"Section", 0}, {"Figure", 0}, {"SolutionItem", 0}},
 FontFamily->"Times",
 FontSize->25,
 FontWeight->"Plain",
 FontSlant->"Plain"],

Cell[StyleData["Chapter", "Printout"],
 ShowGroupOpener->False,
 CellMargins->{{0, 0}, {2, 6}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["Chapter"], "\t"}], FontFamily -> "DTL Albertina TOT Caps", 
     CellBaseline -> Baseline], None}, {None, None}},
 TabSpacings->1.5,
 FontFamily->"DTL Albertina TOT",
 FontSize->15]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["Section"],
 CellGroupingRules->{"SectionGrouping", 35},
 CounterAssignments->{{"SolutionItem", 0}},
 FontSize->22.222],

Cell[StyleData["Section", "Printout"],
 ShowGroupOpener->False,
 CellMargins->{{0, 0}, {0, 0}},
 TabSpacings->1.2,
 FontFamily->"DTL Albertina TOT",
 FontSize->13,
 FontWeight->"Plain"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Nonprint", "Section"],

Cell[CellGroupData[{

Cell[StyleData["SolutionNonPrint"],
 CellBracketOptions->{"Color"->RGBColor[1, 0, 0]},
 Evaluatable->False,
 FontWeight->"Plain",
 FontColor->RGBColor[1, 0, 0]],

Cell[StyleData["SolutionNonPrint", "Printout"],
 CellMargins->{{Inherited, Inherited}, {-1, 0}},
 CellElementSpacings->{"CellMinHeight"->0,
 "ClosedCellHeight"->0,
 "ClosedGroupTopMargin"->0},
 CellOpen->False]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsectionSpacer"],
 CellDingbat->Cell[
  "Subsection spacer", "Menu", FontColor -> GrayLevel[1], FontSize -> 8, 
   Background -> GrayLevel[0.67]],
 CellBracketOptions->{"Color"->RGBColor[1, 0, 0],
 "Thickness"->0.55}],

Cell[StyleData["SubsectionSpacer", "Printout"],
 CellDingbat->None,
 CellMargins->{{Inherited, Inherited}, {0, 0}},
 CellElementSpacings->{"CellMinHeight"->0},
 PageBreakAbove->False]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NonPrintSolutionLink"],
 CellMargins->{{46, 0}, {0, 6}},
 CellBracketOptions->{"Color"->RGBColor[1, 0, 0],
 "Thickness"->0.55},
 CellGroupingRules->{"SectionGrouping", 55},
 FontFamily->"Times",
 FontSize->14,
 FontWeight->"Bold",
 FontSlant->"Italic"],

Cell[StyleData["NonPrintSolutionLink", "Printout"],
 CellMargins->{{Inherited, Inherited}, {-1, 0}},
 CellElementSpacings->{"CellMinHeight"->0,
 "ClosedCellHeight"->0,
 "ClosedGroupTopMargin"->0},
 CellOpen->False]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NonPrintInput", StyleDefinitions -> StyleData["Input"]],
 CellBracketOptions->{"Color"->RGBColor[1, 0, 0]},
 CellGroupingRules->{"InputGrouping", 53},
 FontWeight->"Plain",
 FontColor->RGBColor[1, 0, 0]],

Cell[StyleData["NonPrintInput", "Printout"],
 CellMargins->{{Inherited, Inherited}, {-1, 0}},
 CellElementSpacings->{"CellMinHeight"->0,
 "ClosedCellHeight"->0,
 "ClosedGroupTopMargin"->0},
 CellOpen->False]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Editorial"],
 CellMargins->{{24, 10}, {6, 6}},
 CellBracketOptions->{"Color"->RGBColor[1, 0, 0],
 "Thickness"->0.55},
 CellFrameLabels->{{
    Cell[
     TextData[{"Edit:"}], FontFamily -> "Helvetica", FontSize -> 10, 
     FontWeight -> "Bold", CellBaseline -> Baseline], None}, {None, None}},
 FontColor->RGBColor[1, 0, 0]],

Cell[StyleData["Editorial", "Printout"],
 CellMargins->{{Inherited, Inherited}, {0, 0}},
 CellElementSpacings->{"CellMinHeight"->0,
 "ClosedCellHeight"->0,
 "ClosedGroupTopMargin"->0},
 CellOpen->False]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NonPrintSection", StyleDefinitions -> StyleData["Section"]],
 CellFrame->None,
 CellBracketOptions->{"Color"->RGBColor[1, 0, 0],
 "Thickness"->0.55},
 CellGroupingRules->{"SectionGrouping", 30},
 CellFrameLabels->{{None, None}, {None, None}},
 FontColor->GrayLevel[0.45]],

Cell[StyleData["NonPrintSection", "Printout"],
 CellElementSpacings->{"CellMinHeight"->1,
 "ClosedCellHeight"->0},
 CellOpen->False]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Input/Output", "Section"],

Cell[CellGroupData[{

Cell[StyleData["Input"],
 CellMargins->{{60, Inherited}, {Inherited - 1, Inherited + 6}}],

Cell[StyleData["Input", "Printout"],
 CellMargins->{{62, 0}, {3, 3.}},
 FontSize->9.25]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["InputOnly"],
 CellMargins->{{60, Inherited}, {0, 9}}],

Cell[StyleData["InputOnly", "Printout", StyleDefintions -> None],
 CellMargins->{{62, Inherited}, {3, 5}},
 LinebreakAdjustments->{0.85, 2, 10, 1, 1},
 FontSize->9.25]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Output"],
 CellMargins->{{60, Inherited}, {Inherited + 2, Inherited}}],

Cell[StyleData["Output", "Printout"],
 CellMargins->{{62, 0}, {5, 0}},
 FontSize->9.25]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Message"],
 CellMargins->{{60, Inherited}, {Inherited, Inherited}}],

Cell[StyleData["Message", "Printout"],
 CellMargins->{{62, Inherited}, {8, 5}},
 FontSize->9.25,
 FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Print"],
 CellMargins->{{45, Inherited}, {Inherited, Inherited}}],

Cell[StyleData["Print", "Printout"],
 CellMargins->{{42, Inherited}, {6, 3}},
 FontSize->9.25]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CellLabel"],
 StyleMenuListing->None,
 FontFamily->"Helvetica",
 FontColor->RGBColor[0, 0, 1]],

Cell[StyleData["CellLabel", "Printout"],
 FontFamily->"Syntax LT Std",
 FontSize->6.5,
 FontColor->RGBColor[0.247, 0.24, 0.6]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Solutions", "Section"],

Cell[CellGroupData[{

Cell[StyleData["SolutionItem"],
 CellMargins->{{0, 4}, {0, 8}},
 CellGroupingRules->{"SectionGrouping", 55},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["SolutionItem"], ".", "\t"}], CellBaseline -> Baseline, 
     FontWeight -> "Bold"], None}, {None, None}},
 Hyphenation->True,
 LineSpacing->{1, 3},
 ParagraphSpacing->{0, 8},
 TabSpacings->1.75,
 CounterIncrements->"SolutionItem",
 CounterAssignments->{{"SolutionSubItem", 0}},
 MenuSortingValue->1300,
 MenuCommandKey->"6",
 FontSize->14],

Cell[StyleData["SolutionItem", "Printout"],
 CellMargins->{{0, 0}, {4, 4}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["SolutionItem"], ".", "\t"}], CellBaseline -> Baseline, 
     FontFamily -> "DTL Albertina TOT Caps"], None}, {None, None}},
 LineSpacing->{1.25, 0, 2},
 TabSpacings->2.25,
 FontFamily->"DTL Albertina TOT",
 FontSize->10]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["SolutionSubItem"],
 CellMargins->{{62, 4}, {0, 8}},
 CellGroupingRules->{"SectionGrouping", 60},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["SolutionSubItem"], "."}], CellBaseline -> Baseline, 
     CounterBoxOptions -> {CounterFunction :> (Part[
         CharacterRange["a", "z"], #]& )}], None}, {None, None}},
 Hyphenation->True,
 LineSpacing->{1, 3},
 ParagraphSpacing->{0, 8},
 CounterIncrements->"SolutionSubItem",
 MenuSortingValue->1410,
 MenuCommandKey->"8",
 FontSize->14],

Cell[StyleData["SolutionSubItem", "Printout"],
 CellMargins->{{23, 0}, {5, 3}},
 CellFrameLabels->{{
    Cell[
     TextData[{
       CounterBox["SolutionSubItem"], "."}], CellBaseline -> Baseline, 
     FontSize -> 9, CounterBoxOptions -> {CounterFunction :> (Part[
         CharacterRange["a", "z"], #]& )}], None}, {None, None}},
 LineSpacing->{1, 1},
 FontFamily->"DTL Albertina TOT",
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SolutionText"],
 CellMargins->{{24, 4}, {0, 8}},
 Hyphenation->True,
 LineSpacing->{1, 3},
 ParagraphSpacing->{0, 8},
 MenuSortingValue->1400,
 MenuCommandKey->"7",
 CounterStyleMenuListing->None,
 FontSize->14],

Cell[StyleData["SolutionText", "Printout"],
 CellMargins->{{23, 0}, {4, 2}},
 LineSpacing->{1, 2},
 FontFamily->"DTL Albertina TOT",
 FontSize->10]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["SolutionsPageRef"],
 CellMargins->{{0, 0}, {4, 1}},
 StyleMenuListing->None,
 FontFamily->"Times",
 FontWeight->"Plain",
 FontSlant->"Italic"],

Cell[StyleData["SolutionsPageRef", "Printout"],
 CellMargins->{{0, 0}, {4, 1}},
 StyleMenuListing->None,
 FontFamily->"DTL Albertina TOT",
 FontSize->10,
 FontSlant->"Italic"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Formulas and programs", "Section"],

Cell[CellGroupData[{

Cell[StyleData["ExerciseDisplayFormula"],
 CellMargins->{{48, 0}, {4, 8}},
 FontSize->14],

Cell[StyleData["ExerciseDisplayFormula", "Printout"],
 CellMargins->{{48, 0}, {6.75, 6.75}},
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Program"],
 CellMargins->{{90, 0}, {4, 8}}],

Cell[StyleData["Program", "Printout"],
 CellMargins->{{48, 0}, {3, 1}},
 PageBreakBelow->False,
 FontSize->8.5]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Inline formatting", "Section"],

Cell[CellGroupData[{

Cell[StyleData["StandardForm"]],

Cell[StyleData["StandardForm", "Printout"]]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["MR"],
 AutoQuoteCharacters->{},
 StyleMenuListing->None],

Cell[StyleData["MR", "Printout"],
 FontColor->GrayLevel[0]]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["MSG"],
 StyleMenuListing->None],

Cell[StyleData["MSG", "Printout"],
 StyleMenuListing->None,
 FontFamily->"Syntax LT Std"]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["OsF"],
 FontColor->GrayLevel[0]],

Cell[StyleData["OsF", "Printout"],
 StyleMenuListing->None,
 FontFamily->"DTL Albertina TOT Caps"]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["ExerciseTI"],
 FontFamily->"Times",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Italic"],

Cell[StyleData["ExerciseTI", "Printout"],
 FontFamily->"DTL Albertina TOT",
 FontSlant->"Italic"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Spacer cells", "Section"],

Cell[CellGroupData[{

Cell[StyleData["SectionSpacer"],
 CellDingbat->Cell[
  "Section spacer", "Menu", FontColor -> GrayLevel[1], FontSize -> 8, 
   Background -> GrayLevel[0.67]],
 CellBracketOptions->{"Color"->RGBColor[1, 0, 0],
 "Thickness"->0.55}],

Cell[StyleData["SectionSpacer", "Printout"],
 CellDingbat->None,
 CellMargins->{{Inherited, Inherited}, {0, 10}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsectionSpacer"],
 CellDingbat->Cell[
  "Subsection spacer", "Menu", FontColor -> GrayLevel[1], FontSize -> 8, 
   Background -> GrayLevel[0.67]],
 CellBracketOptions->{"Color"->RGBColor[1, 0, 0],
 "Thickness"->0.55}],

Cell[StyleData["SubsectionSpacer", "Printout"],
 CellDingbat->None,
 CellMargins->{{Inherited, Inherited}, {0, 0}},
 CellElementSpacings->{"CellMinHeight"->0},
 PageBreakAbove->False]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ReferenceSpacer"],
 CellDingbat->Cell[
  "Reference spacer", "Menu", FontColor -> GrayLevel[1], FontSize -> 8, 
   Background -> GrayLevel[0.67]],
 CellBracketOptions->{"Color"->RGBColor[1, 0, 0],
 "Thickness"->0.55}],

Cell[StyleData["ReferenceSpacer", "Printout"],
 CellDingbat->None,
 CellMargins->{{Inherited, Inherited}, {5, 0}},
 CellElementSpacings->{"CellMinHeight"->0},
 PageBreakAbove->False]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOP"],
 CellBracketOptions->{"Color"->RGBColor[1, 0, 1]}],

Cell[StyleData["TOP", "Printout"],
 CellMargins->{{Inherited, Inherited}, {Inherited, 0}},
 CellBracketOptions->{"Color"->RGBColor[1, 0, 0],
 "Thickness"->1}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Headers and footers", "Section"],

Cell[CellGroupData[{

Cell[StyleData["Header"],
 LineSpacing->{1, 8},
 MenuSortingValue->None,
 FontSlant->"Plain"],

Cell[StyleData["Header", "Printout"],
 CellMargins->{{0, 0}, {0, 0}},
 FontFamily->"DTL Albertina TOT",
 FontSize->9.5,
 FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PageNumber"],
 CellMargins->{{0, 0}, {4, 1}},
 StyleMenuListing->None,
 FontFamily->"Times",
 FontSize->9],

Cell[StyleData["PageNumber", "Printout"],
 CellMargins->{{0, 0}, {0, 0}},
 FontFamily->"DTL Albertina TOT Caps",
 FontWeight->"Plain",
 FontSlant->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["HeaderOsF"],
 StyleMenuListing->None,
 FontFamily->"Times",
 FontSize->9],

Cell[StyleData["HeaderOsF", "Printout"],
 FontFamily->"DTL Albertina TOT Caps",
 FontSize->9.5,
 FontSlant->"Plain"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " system\[Hyphen]specific elements"
}], "Section"],

Cell[CellGroupData[{

Cell["Labels, Panels, Manipulate, etc.", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["DialogStyle"]],

Cell[StyleData["DialogStyle", "Printout"],
 FontFamily->"Syntax LT Std",
 FontSize->7]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Panel"],
 ShowStringCharacters->False,
 FontFamily->CurrentValue["PanelFontFamily"],
 FontSize->CurrentValue["PanelFontSize"],
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontColor->GrayLevel[0],
 Background->CurrentValue["PanelBackground"]],

Cell[StyleData["Panel", "Printout"],
 ShowStringCharacters->False,
 FontFamily->"Syntax LT Std",
 FontSize->8,
 FontColor->GrayLevel[0],
 Background->CurrentValue["PanelBackground"]]
}, Closed]],

Cell[StyleData["TooltipLabel"],
 CellFrame->1.,
 CellFrameMargins:>CurrentValue["TooltipFrameMargins"],
 CellFrameColor:>CurrentValue[{"SystemColor", "TooltipFrame"}],
 TextAlignment->Left,
 TextJustification->0.,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["TooltipFontFamily"],
 FontSize:>CurrentValue["TooltipFontSize"],
 FontWeight->"Plain",
 FontSlant->"Plain",
 Magnification->1.5,
 FontColor:>CurrentValue[{"SystemColor", "TooltipText"}],
 FontOpacity->1.,
 Background:>CurrentValue[{"SystemColor", "Tooltip"}]],

Cell[CellGroupData[{

Cell[StyleData["Manipulate"],
 ShowAutoStyles->False,
 ShowStringCharacters->False,
 NumberMarks->False,
 FontWeight->"Plain"],

Cell[StyleData["Manipulate", "Printout"],
 ShowAutoStyles->False,
 ShowStringCharacters->False,
 NumberMarks->False,
 FontWeight->"Plain",
 Magnification->0.67,
 AnimatorBoxOptions->{ImageSize->Tiny},
 GraphicsBoxOptions->{ImageSize->{100, Automatic}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ManipulateLabel"]],

Cell[StyleData["ManipulateLabel", "Printout"],
 FontFamily->"Syntax LT Std",
 FontSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Manipulator"]],

Cell[StyleData["Manipulator", "Printout"],
 FontFamily->"Syntax LT Std",
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GenericButton", StyleDefinitions -> StyleData["ControlStyle"]],
 ShowStringCharacters->False],

Cell[StyleData["GenericButton", "Printout"],
 FontFamily->"Syntax LT Std",
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AnimateLabel", StyleDefinitions -> StyleData[
 "ManipulateLabel"]]],

Cell[StyleData["AnimateLabel", "Printout"],
 FontFamily->"Syntax LT Std",
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TabViewLabel"],
 TextAlignment->Left,
 TextJustification->0.,
 ShowStringCharacters->False,
 FontFamily:>CurrentValue["ControlsFontFamily"]],

Cell[StyleData["TabViewLabel", "Printout"],
 FontFamily->"Syntax LT Std",
 FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PopupMenuLabel", StyleDefinitions -> StyleData["MenuLabel"]],
 FontColor:>CurrentValue[{"SystemColor", "DialogText"}]],

Cell[StyleData["PopupMenuLabel", "Printout"],
 FontFamily->"Syntax LT Std",
 FontSize->9]
}, Closed]]
}, Closed]],

Cell["Graphics", "Subsection"],

Cell[CellGroupData[{

Cell["Links", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Link"],
 FontFamily->"Times",
 FontVariations->{"Underline"->True},
 FontColor->RGBColor[0.269993, 0.308507, 0.6]],

Cell[StyleData["Link", "Printout"],
 FontColor->GrayLevel[0]]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["Hyperlink"],
 FontFamily->"Times",
 FontVariations->{"Underline"->True},
 FontColor->RGBColor[0.269993, 0.308507, 0.6]],

Cell[StyleData["Hyperlink", "Printout"],
 FontVariations->{"Underline"->False},
 FontColor->GrayLevel[0]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
Editable->True,
Saveable->True,
ScreenStyleEnvironment->"Working",
WindowSize->{614, 691},
WindowMargins->{{Automatic, 185}, {Automatic, 0}},
FrontEndVersion->"10.1 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 23, \
2015)",
StyleDefinitions->"StylesheetFormatting.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 73, 0, 36, 73, 0, "StyleData", "StyleDefinitions", ""],
Cell[CellGroupData[{
Cell[656, 24, 27, 0, 49, "Section"],
Cell[686, 26, 153, 4, 76, 32, 0, "StyleData", "TitleFlourish", "All"],
Cell[CellGroupData[{
Cell[864, 34, 31, 0, 62, 31, 0, "StyleData", "ChapterTitle", "All"],
Cell[898, 36, 43, 0, 56, 43, 0, "StyleData", "ChapterTitle", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[978, 41, 470, 15, 41, 26, 0, "StyleData", "Chapter", "All",
 CounterIncrements->"Chapter",
 CounterAssignments->{{"Section", 0}, {"Figure", 0}, {"SolutionItem", 0}}],
Cell[1451, 58, 343, 10, 43, 38, 0, "StyleData", "Chapter", "Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1831, 73, 134, 3, 59, 26, 0, "StyleData", "Section", "All",
 CounterAssignments->{{"SolutionItem", 0}}],
Cell[1968, 78, 185, 6, 32, 38, 0, "StyleData", "Section", "Printout"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2202, 90, 27, 0, 49, "Section"],
Cell[CellGroupData[{
Cell[2254, 94, 160, 4, 108, 35, 0, "StyleData", "SolutionNonPrint", "All"],
Cell[2417, 100, 210, 5, 108, 47, 0, "StyleData", "SolutionNonPrint", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[2664, 110, 235, 5, 108, 35, 0, "StyleData", "SubsectionSpacer", "All"],
Cell[2902, 117, 183, 4, 108, 47, 0, "StyleData", "SubsectionSpacer", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[3122, 126, 268, 8, 108, 39, 0, "StyleData", "NonPrintSolutionLink", \
"All"],
Cell[3393, 136, 214, 5, 108, 51, 0, "StyleData", "NonPrintSolutionLink", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[3644, 146, 219, 4, 108, 72, 0, "StyleData", "NonPrintInput", "All"],
Cell[3866, 152, 207, 5, 108, 44, 0, "StyleData", "NonPrintInput", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[4110, 162, 341, 8, 108, 28, 0, "StyleData", "Editorial", "All"],
Cell[4454, 172, 202, 5, 108, 40, 0, "StyleData", "Editorial", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[4693, 182, 287, 6, 108, 76, 0, "StyleData", "NonPrintSection", "All"],
Cell[4983, 190, 132, 3, 108, 46, 0, "StyleData", "NonPrintSection", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[5164, 199, 31, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[5220, 203, 89, 1, 47, 24, 0, "StyleData", "Input", "All"],
Cell[5312, 206, 87, 2, 32, 36, 0, "StyleData", "Input", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[5436, 213, 69, 1, 38, 28, 0, "StyleData", "InputOnly", "All"],
Cell[5508, 216, 167, 3, 34, 65, 0, "StyleData", "InputOnly", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[5712, 224, 86, 1, 41, 25, 0, "StyleData", "Output", "All"],
Cell[5801, 227, 87, 2, 31, 37, 0, "StyleData", "Output", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[5925, 234, 83, 1, 37, 26, 0, "StyleData", "Message", "All"],
Cell[6011, 237, 122, 3, 39, 38, 0, "StyleData", "Message", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[6170, 245, 81, 1, 36, 24, 0, "StyleData", "Print", "All"],
Cell[6254, 248, 94, 2, 35, 36, 0, "StyleData", "Print", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[6385, 255, 110, 3, 33, 28, 0, "StyleData", "CellLabel", "All",
 StyleMenuListing->None],
Cell[6498, 260, 126, 3, 31, 40, 0, "StyleData", "CellLabel", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[6673, 269, 28, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[6726, 273, 514, 16, 38, 31, 0, "StyleData", "SolutionItem", "All",
 CounterIncrements->"SolutionItem",
 CounterAssignments->{{"SolutionSubItem", 0}},
 MenuSortingValue->1300,
 MenuCommandKey->"6"],
Cell[7243, 291, 362, 10, 36, 43, 0, "StyleData", "SolutionItem", "Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7642, 306, 520, 15, 38, 34, 0, "StyleData", "SolutionSubItem", "All",
 CounterIncrements->"SolutionSubItem",
 MenuSortingValue->1410,
 MenuCommandKey->"8"],
Cell[8165, 323, 403, 10, 36, 46, 0, "StyleData", "SolutionSubItem", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[8605, 338, 227, 8, 34, 31, 0, "StyleData", "SolutionText", "All",
 MenuSortingValue->1400,
 MenuCommandKey->"7"],
Cell[8835, 348, 147, 4, 34, 43, 0, "StyleData", "SolutionText", "Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9019, 357, 158, 5, 33, 35, 0, "StyleData", "SolutionsPageRef", "All",
 StyleMenuListing->None],
Cell[9180, 364, 175, 5, 33, 47, 0, "StyleData", "SolutionsPageRef", "Printout",
 StyleMenuListing->None]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9404, 375, 40, 0, 49, "Section"],
Cell[CellGroupData[{
Cell[9469, 379, 89, 2, 42, 41, 0, "StyleData", "ExerciseDisplayFormula", \
"All"],
Cell[9561, 383, 107, 2, 41, 53, 0, "StyleData", "ExerciseDisplayFormula", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[9705, 390, 59, 1, 42, 26, 0, "StyleData", "Program", "All"],
Cell[9767, 393, 111, 3, 108, 38, 0, "StyleData", "Program", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[9927, 402, 36, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[9988, 406, 31, 0, 36, 31, 0, "StyleData", "StandardForm", "All"],
Cell[10022, 408, 43, 0, 37, 43, 0, "StyleData", "StandardForm", "Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10102, 413, 72, 2, 36, 21, 0, "StyleData", "MR", "All",
 StyleMenuListing->None],
Cell[10177, 417, 59, 1, 37, 33, 0, "StyleData", "MR", "Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10273, 423, 47, 1, 37, 22, 0, "StyleData", "MSG", "All",
 StyleMenuListing->None],
Cell[10323, 426, 89, 2, 33, 34, 0, "StyleData", "MSG", "Printout",
 StyleMenuListing->None]
}, Open  ]],
Cell[CellGroupData[{
Cell[10449, 433, 48, 1, 36, 22, 0, "StyleData", "OsF", "All"],
Cell[10500, 436, 98, 2, 39, 34, 0, "StyleData", "OsF", "Printout",
 StyleMenuListing->None]
}, Open  ]],
Cell[CellGroupData[{
Cell[10635, 443, 110, 4, 36, 29, 0, "StyleData", "ExerciseTI", "All"],
Cell[10748, 449, 97, 2, 36, 41, 0, "StyleData", "ExerciseTI", "Printout"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[10894, 457, 31, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[10950, 461, 229, 5, 108, 32, 0, "StyleData", "SectionSpacer", "All"],
Cell[11182, 468, 113, 2, 108, 44, 0, "StyleData", "SectionSpacer", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[11332, 475, 235, 5, 108, 35, 0, "StyleData", "SubsectionSpacer", "All"],
Cell[11570, 482, 183, 4, 108, 47, 0, "StyleData", "SubsectionSpacer", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[11790, 491, 233, 5, 108, 34, 0, "StyleData", "ReferenceSpacer", "All"],
Cell[12026, 498, 182, 4, 108, 46, 0, "StyleData", "ReferenceSpacer", \
"Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[12245, 507, 73, 1, 108, 22, 0, "StyleData", "TOP", "All"],
Cell[12321, 510, 158, 3, 108, 34, 0, "StyleData", "TOP", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[12528, 519, 38, 0, 33, "Section"],
Cell[CellGroupData[{
Cell[12591, 523, 93, 3, 108, 25, 0, "StyleData", "Header", "All",
 MenuSortingValue->None],
Cell[12687, 528, 141, 4, 108, 37, 0, "StyleData", "Header", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[12865, 537, 122, 4, 108, 29, 0, "StyleData", "PageNumber", "All",
 StyleMenuListing->None],
Cell[12990, 543, 155, 4, 108, 41, 0, "StyleData", "PageNumber", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[13182, 552, 89, 3, 108, 28, 0, "StyleData", "HeaderOsF", "All",
 StyleMenuListing->None],
Cell[13274, 557, 116, 3, 108, 40, 0, "StyleData", "HeaderOsF", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[13439, 566, 116, 4, 33, "Section"],
Cell[CellGroupData[{
Cell[13580, 574, 54, 0, 45, "Subsection"],
Cell[CellGroupData[{
Cell[13659, 578, 30, 0, 36, 30, 0, "StyleData", "DialogStyle", "All"],
Cell[13692, 580, 86, 2, 108, 42, 0, "StyleData", "DialogStyle", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[13815, 587, 257, 7, 52, 24, 0, "StyleData", "Panel", "All"],
Cell[14075, 596, 182, 5, 108, 36, 0, "StyleData", "Panel", "Printout"]
}, Closed]],
Cell[14272, 604, 530, 14, 55, 31, 0, "StyleData", "TooltipLabel", "All"],
Cell[CellGroupData[{
Cell[14827, 622, 126, 4, 36, 29, 0, "StyleData", "Manipulate", "All"],
Cell[14956, 628, 252, 7, 108, 41, 0, "StyleData", "Manipulate", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[15245, 640, 34, 0, 35, 34, 0, "StyleData", "ManipulateLabel", "All"],
Cell[15282, 642, 90, 2, 108, 46, 0, "StyleData", "ManipulateLabel", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[15409, 649, 30, 0, 35, 30, 0, "StyleData", "Manipulator", "All"],
Cell[15442, 651, 87, 2, 108, 42, 0, "StyleData", "Manipulator", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[15566, 658, 109, 1, 40, 79, 0, "StyleData", "GenericButton", "All"],
Cell[15678, 661, 88, 2, 108, 44, 0, "StyleData", "GenericButton", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[15803, 668, 83, 1, 35, 83, 1, "StyleData", "AnimateLabel", "All"],
Cell[15889, 671, 87, 2, 108, 43, 0, "StyleData", "AnimateLabel", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[16013, 678, 156, 4, 38, 31, 0, "StyleData", "TabViewLabel", "All"],
Cell[16172, 684, 87, 2, 108, 43, 0, "StyleData", "TabViewLabel", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[16296, 691, 134, 1, 40, 77, 0, "StyleData", "PopupMenuLabel", "All"],
Cell[16433, 694, 89, 2, 108, 45, 0, "StyleData", "PopupMenuLabel", \
"Printout"]
}, Closed]]
}, Closed]],
Cell[16549, 700, 30, 0, 29, "Subsection"],
Cell[CellGroupData[{
Cell[16604, 704, 27, 0, 29, "Subsection"],
Cell[CellGroupData[{
Cell[16656, 708, 130, 3, 36, 23, 0, "StyleData", "Link", "All"],
Cell[16789, 713, 61, 1, 31, 35, 0, "StyleData", "Link", "Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16887, 719, 135, 3, 36, 28, 0, "StyleData", "Hyperlink", "All"],
Cell[17025, 724, 105, 2, 36, 40, 0, "StyleData", "Hyperlink", "Printout"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
