(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     23585,        621]
NotebookOptionsPosition[     16474,        498]
NotebookOutlinePosition[     17224,        525]
CellTagsIndexPosition[     17158,        520]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["EPM`Introduction`", "Section",
 InitializationGroup->
  True,ExpressionUUID->"bd70b444-6f8d-4d52-80bf-40b540539633"],

Cell[TextData[{
 StyleBox["From",
  FontWeight->"Bold"],
 ": ",
 StyleBox["Essentials of Programming in Mathematica\n",
  FontSlant->"Italic"],
 "\[Copyright] Paul R. Wellin 2015"
}], "Text",
 CellMargins->{{28, 10}, {7, 7}},
 FontSize->14,ExpressionUUID->"0e4319ad-7363-4bce-a6a2-14933a21226d"],

Cell[CellGroupData[{

Cell["Metadata", "Subsection",ExpressionUUID->"04c0d4d4-fc57-40a2-bbdc-d148fae21ce8"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Name", ":", " ", "EPM`Introduction`"}], " ", "*)"}]], "Input",\
ExpressionUUID->"9dbe9063-3aee-4804-8c2b-3455953a3f6e"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Book", ":", " ", 
   RowBox[{
   "Essentials", " ", "of", " ", "Programming", " ", "in", " ", 
    "Mathematica"}]}], " ", "*)"}]], "Input",ExpressionUUID->"972d5476-4696-\
49b8-b389-4d6f2f08f429"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Paul", " ", "Wellin"}]}]}], " ", "*)"}]], "Input",ExpressionUUID->\
"d1ee7ee6-3401-4e44-a206-74d05d5d3edc"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Summary", ":", " ", 
   RowBox[{
   "This", " ", "package", " ", "contains", " ", "the", " ", "functions", " ",
     "defined", " ", "in", " ", "Chapter", " ", "1"}]}], " ", "*)"}]], "Input",\
ExpressionUUID->"b0693f7b-93fe-4c58-be94-8d6a9638cfa3"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Context", ":", " ", "EPM`Introduction`"}], " ", 
  "*)"}]], "Input",ExpressionUUID->"acadc45c-2e88-4226-8710-f5afc83dd4f8"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", "Version"}], ":", " ", "1.1"}], " ", 
  "*)"}]], "Input",ExpressionUUID->"8455b199-9e7f-4fde-a0fc-12aa2936da3d"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", "Copyright", ":", " ", 
    RowBox[{"Copyright", " ", "2015"}]}], ",", " ", 
   RowBox[{"Paul", " ", "R", " ", "Wellin"}]}], " ", "*)"}]], "Input",Expressi\
onUUID->"86bad378-527f-4639-96be-8bb134620056"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{
     "Version", " ", "1.0", " ", "by", " ", "Paul", " ", "Wellin"}]}]}], ",", 
   " ", 
   RowBox[{
   "Dec", " ", "2012", "\[IndentingNewLine]", "\t\t\t", "Version", " ", "1.1",
     " ", "by", " ", "Paul", " ", "Wellin", " ", "July", " ", "2014"}]}], " ",
   "*)"}]], "Input",ExpressionUUID->"ccd84b52-aaba-4eda-8de1-de875d9fe66e"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", "Keywords", ":", " ", 
    RowBox[{"leading", " ", "digit"}]}], ",", " ", 
   RowBox[{"pass", " ", "phrase"}], ",", " ", "StringMemberQ"}], " ", 
  "*)"}]], "Input",ExpressionUUID->"84f31f16-5bfc-46cb-ad7c-b596c90bccab"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Source", ":", " ", 
   RowBox[{"Introduction", ".", "nb"}]}], " ", "*)"}]], "Input",ExpressionUUID\
->"a080374a-0ff2-47ae-bc98-49c4bb14a452"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", "Version"}], ":", " ", "10.3"}], " ", 
  "*)"}]], "Input",ExpressionUUID->"467b194a-0499-4f40-904e-2e39e62a80ee"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Tested", " ", "in", " ", "Mathematica", " ", "11.1"}], " ", 
  "*)"}]], "Input",ExpressionUUID->"3d782710-4ead-4efa-98ee-737dd709e683"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Tested", " ", "in", " ", "Mathematica", " ", "12.0"}], ",", " ", 
   RowBox[{"Feb", " ", "2019"}]}], " ", "*)"}]], "Input",ExpressionUUID->\
"2b100d90-55d4-412a-b94c-3a12294c2c2a"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Tested", " ", "in", " ", "Mathematica", " ", "13.2"}], ",", " ", 
   RowBox[{"Aug", " ", "2023"}]}], " ", "*)"}]], "Input",ExpressionUUID->\
"c7954e0a-cfb1-4a9d-9a49-274a9ad5f0a5"]
}, Open  ]],

Cell[CellGroupData[{

Cell["BeginPackage", "Subsection",ExpressionUUID->"13c07081-b124-4dac-a1b4-f0234d1181c1"],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{
  "LeadingDigit", ",", "LeadingDigitChart", ",", "PassPhrase", ",", 
   "StringMemberQ"}], "]"}]], "Input",ExpressionUUID->"7d0b5147-e2c4-4b39-\
ab5d-f7399c8c1324"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"BeginPackage", "[", "\"\<EPM`Introduction`\>\"", "]"}], " ", 
  "*)"}]], "Input",ExpressionUUID->"a7576329-b0e4-4771-99c7-87e1a3453cf6"]
}, Closed]],

Cell[CellGroupData[{

Cell["Usage messages for public functions", "Subsection",ExpressionUUID->"4cd52bb0-068b-430f-b859-a5c193478b7a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{"LeadingDigit", "::", "usage"}], "MessageName"], "=", 
   "\"\<LeadingDigit[\!\(\*StyleBox[\"n\", \"TI\"]\)] returns the leading \
digit of the integer \!\(\*StyleBox[\"n\", \"TI\"]\).\>\""}], ";"}]], "Input",\
ExpressionUUID->"5ab135be-02cd-4937-bc7a-da9bbb3353cb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{"LeadingDigitChart", "::", "usage"}], "MessageName"], "=", 
   "\"\<LeadingDigitChart[\!\(\*StyleBox[\"data\", \"TI\"]\)] makes a \
horizontal bar chart showing the distribution of the leading digits among the \
\!\(\*StyleBox[\"data\", \"TI\"]\).\>\""}], ";"}]], "Input",ExpressionUUID->\
"da67986c-5493-448e-8090-53817bad2dc2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LeadingDigitChart", "::", "badinput"}], "=", 
   "\"\<The argument to LeadingDigitChart must be an array of numerical data.\
\>\""}], ";"}]], "Input",ExpressionUUID->"0ac92d02-4a68-4f1d-8ecf-\
26f7052e1453"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{"PassPhrase", "::", "usage"}], "MessageName"], "=", 
   "\"\<PassPhrase[\!\(\*StyleBox[\"n\", \"TI\"]\)\!\(\*StyleBox[\",\", \
\"TI\"]\)\!\(\*StyleBox[\" \", \"TI\"]\)\!\(\*StyleBox[\"{\", \
\"TI\"]\)\!\(\*StyleBox[\"min\", \"TI\"]\)\!\(\*StyleBox[\",\", \"TI\"]\)\!\(\
\*StyleBox[\" \", \"TI\"]\)\!\(\*StyleBox[\"max\", \
\"TI\"]\)\!\(\*StyleBox[\"}\", \"TI\"]\)] generates a phrase of \
\!\(\*StyleBox[\"n\", \"TI\"]\) random words from the dictionary each of \
string length from \!\(\*StyleBox[\"min\", \"TI\"]\) to \
\!\(\*StyleBox[\"max\", \"TI\"]\).\>\""}], ";"}]], "Input",ExpressionUUID->\
"355b4fa7-9d9b-458c-aa1e-5a827fcdb435"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{"StringMemberQ", "::", "usage"}], "MessageName"], "=", 
   "\"\<StringMemberQ[\!\(\*StyleBox[\"str\", \"TI\"]\)\!\(\*StyleBox[\",\", \
\"TI\"]\)\!\(\*StyleBox[\" \", \"TI\"]\)\!\(\*StyleBox[\"chars\", \"TI\"]\)] \
returns True if the list of string characters, \!\(\*StyleBox[\"chars\", \"TI\
\"]\) are all present in the string \!\(\*StyleBox[\"str\", \"TI\"]\).\>\""}],
   ";"}]], "Input",ExpressionUUID->"13398712-abcb-4539-9530-87e858ea316b"]
}, Closed]],

Cell[CellGroupData[{

Cell["Options", "Subsection",ExpressionUUID->"620dcfb9-f783-481a-96d0-e68d85f7f9e4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "BondPercolation", "]"}], "=", 
   RowBox[{"Options", "[", "Graph", "]"}]}], ";"}]], "Input",ExpressionUUID->\
"6e283cc9-4ef3-473e-8223-b7c50a95c99c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "LeadingDigitChart", "]"}], "=", 
   RowBox[{"Options", "[", "BarChart", "]"}]}], ";"}]], "Input",ExpressionUUID\
->"951f882c-6c70-464c-a598-086e350247d8"]
}, Closed]],

Cell[CellGroupData[{

Cell["Private context", "Subsection",ExpressionUUID->"4cd6ca10-9722-4a9a-810c-11ae3c786b3f"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "Input",ExpressionUUID->"f40f417f-d9a7-4035-b886-41b171c8971a"]
}, Closed]],

Cell[CellGroupData[{

Cell["Function definitions (public and private)", "Subsection",ExpressionUUID->"2d37f557-3088-4f5c-9cae-55b1a8ed9b3e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LeadingDigit", "[", "n_Integer", "]"}], ":=", 
  RowBox[{"First", "[", 
   RowBox[{"IntegerDigits", "[", "n", "]"}], "]"}]}]], "Input",ExpressionUUID->\
"4514ce95-a55e-40d8-a2c1-3855bd576e9e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ToPercents", "[", "lis_", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"StringJoin", "[", 
      RowBox[{
       RowBox[{"ToString", "[", 
        RowBox[{"SetPrecision", "[", 
         RowBox[{"#", ",", "3"}], "]"}], "]"}], ",", "\"\<%\>\""}], "]"}], 
     "&"}], ",", 
    RowBox[{"100", 
     RowBox[{"N", "[", 
      RowBox[{"lis", "/", 
       RowBox[{"Total", "[", "lis", "]"}]}], "]"}]}]}], "]"}]}]], "Input",Expr\
essionUUID->"6bfe152c-a8c6-421e-a10d-b4053e455115"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LeadingDigitChart", "[", 
   RowBox[{"data_", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"digCounts", ",", "ratios", ",", "labels"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"Not", "@", 
       RowBox[{"ArrayQ", "[", 
        RowBox[{"data", ",", "1", ",", "NumericQ"}], "]"}]}], ",", 
      RowBox[{"Message", "[", 
       RowBox[{"LeadingDigitChart", "::", "badinput"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"digCounts", "=", 
        RowBox[{"Sort", "@", 
         RowBox[{
          RowBox[{"Tally", "[", "data", "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "2"}], "]"}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"labels", "=", 
        RowBox[{"ToPercents", "[", "digCounts", "]"}]}], ";", 
       RowBox[{"BarChart", "[", 
        RowBox[{
         RowBox[{"MapThread", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Labeled", "[", 
             RowBox[{"#1", ",", "#2", ",", "Right"}], "]"}], "&"}], ",", 
           RowBox[{"{", 
            RowBox[{"digCounts", ",", "labels"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", "opts", ",", 
         RowBox[{"BarOrigin", "\[Rule]", "Left"}], ",", "\[IndentingNewLine]", 
         RowBox[{"ChartLabels", "\[Rule]", 
          RowBox[{"Reverse", "@", 
           RowBox[{"Range", "[", 
            RowBox[{"Length", "[", "labels", "]"}], "]"}]}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ChartStyle", "\[Rule]", "47"}]}], "]"}]}]}], "]"}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",ExpressionUUID->"b4928a5d-9856-\
442d-8e6e-5d35944e5821"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PassPhrase", "[", 
   RowBox[{"n_", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"min_", ":", "2"}], ",", 
      RowBox[{"max_", ":", "6"}]}], "}"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "words", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"words", "=", 
      RowBox[{"DictionaryLookup", "[", 
       RowBox[{"w__", "/;", 
        RowBox[{"min", "\[LessEqual]", 
         RowBox[{"StringLength", "[", "w", "]"}], "\[LessEqual]", "max"}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"StringJoin", "[", 
      RowBox[{"Riffle", "[", 
       RowBox[{
        RowBox[{"RandomChoice", "[", 
         RowBox[{"words", ",", "n"}], "]"}], ",", "\"\< \>\""}], "]"}], 
      "]"}]}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 CellTags->"1.1",ExpressionUUID->"a59b03fb-5ea7-4e56-80db-fdcc594db23a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"StringMemberQ", "[", 
   RowBox[{"str_String", ",", "chars_List"}], "]"}], ":=", 
  RowBox[{"SubsetQ", "[", 
   RowBox[{
    RowBox[{"Characters", "[", "str", "]"}], ",", "chars"}], 
   "]"}]}]], "InputOnly",
 CellTags->"1.1",ExpressionUUID->"24ebfd01-0482-44d6-8404-e91d1b3401b1"]
}, Closed]],

Cell[CellGroupData[{

Cell["End private context", "Subsection",ExpressionUUID->"cfc3708a-bdb5-4004-b90c-08d9eec0ec3f"],

Cell[BoxData[
 RowBox[{"End", "[", "]"}]], "Input",ExpressionUUID->"628eb4b3-293e-4814-aeb4-0725c965741d"]
}, Closed]],

Cell[CellGroupData[{

Cell["EndPackage", "Subsection",ExpressionUUID->"499c8467-3608-431c-869f-47eb4a60e94b"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"EndPackage", "[", "]"}], "*)"}]], "Input",ExpressionUUID->\
"98fb02be-7d2a-401b-b34b-54b7c9c2d1f2"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Examples", "Section",ExpressionUUID->"4fc28b77-9220-49c6-8cd7-5d5e7eb11d5a"],

Cell[CellGroupData[{

Cell["Load package", "Subsection",ExpressionUUID->"f12dd979-e5d8-4495-b84c-9db66897d8d0"],

Cell[BoxData[
 RowBox[{"Quit", "[", "]"}]], "Input",ExpressionUUID->"c05ee97e-a95a-4ea5-9b17-e13d87605ba2"],

Cell[TextData[{
 "Load package (do ",
 StyleBox["not",
  FontSlant->"Italic"],
 " say \[OpenCurlyDoubleQuote]Yes\[CloseCurlyDoubleQuote] to dialog asking to \
evaluate init cells in this notebook)."
}], "Text",ExpressionUUID->"43363d32-82e1-4b76-b463-b65c7de5b6b1"],

Cell[BoxData[
 RowBox[{"<<", "EPM`"}]], "Input",
 CellLabel->"In[1]:=",ExpressionUUID->"32f41260-a967-4ec3-a9e8-5c7fe7f335b7"]
}, Closed]],

Cell[CellGroupData[{

Cell["Test usage messages", "Subsection",ExpressionUUID->"90103e65-8d25-4706-bba5-f00c776d0cf1"],

Cell[BoxData[
 RowBox[{"?", "LeadingDigit"}]], "Input",
 CellLabel->"In[5]:=",ExpressionUUID->"ee29c823-acb9-4a58-bf4b-76c320e7d05c"],

Cell[BoxData[
 RowBox[{"?", "LeadingDigitChart"}]], "Input",
 CellLabel->"In[6]:=",ExpressionUUID->"2ad946bf-29dc-4bfb-a976-8b03619c80df"],

Cell[BoxData[
 RowBox[{"?", "PassPhrase"}]], "Input",
 CellLabel->"In[7]:=",ExpressionUUID->"0ffdb8d8-0f0f-470d-94ef-cb11926430a0"],

Cell[BoxData[
 RowBox[{"?", "StringMemberQ"}]], "Input",
 CellLabel->"In[8]:=",ExpressionUUID->"0856c5a7-8c3f-493b-86da-68bba5da9637"]
}, Closed]],

Cell[CellGroupData[{

Cell["Exercise the functions and options", "Subsection",ExpressionUUID->"3a5d7601-757e-482d-8984-a098218d3446"],

Cell[CellGroupData[{

Cell["LeadingDigit", "Subsubsection",ExpressionUUID->"9aa6fb5a-5c57-4116-9a19-d22a6a6f5ea8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"leadingDigs", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"LeadingDigit", "[", 
      RowBox[{"Fibonacci", "[", "i", "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "5000"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[9]:=",ExpressionUUID->"460da3db-35a8-4598-9c75-eb2d3be7fc96"],

Cell[BoxData[
 RowBox[{"LeadingDigitChart", "[", 
  RowBox[{"leadingDigs", ",", 
   RowBox[{"ImageSize", "\[Rule]", "Medium"}]}], "]"}]], "Input",
 CellLabel->"In[10]:=",ExpressionUUID->"45783aea-5d82-42e4-a08b-5af9254e75d4"]
}, Closed]],

Cell[CellGroupData[{

Cell["LeadingDigitChart", "Subsubsection",ExpressionUUID->"bec0d66e-1eb0-41fd-8ced-587950ad5e2e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"leadingDigs", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"LeadingDigit", "[", 
      RowBox[{"Fibonacci", "[", "i", "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "5000"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[11]:=",ExpressionUUID->"241f2032-6a11-4881-a1f6-493f22b9fc99"],

Cell[BoxData[
 RowBox[{"LeadingDigitChart", "[", 
  RowBox[{"leadingDigs", ",", 
   RowBox[{"ImageSize", "\[Rule]", "Medium"}]}], "]"}]], "Input",
 CellLabel->"In[12]:=",ExpressionUUID->"13e9198b-f0ec-47fc-b1df-cf33a24dee98"]
}, Closed]],

Cell[CellGroupData[{

Cell["PassPhrase", "Subsubsection",ExpressionUUID->"bebf7826-5c4a-4edd-ace8-80c2226ce8f7"],

Cell[BoxData[
 RowBox[{"PassPhrase", "[", 
  RowBox[{"4", ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "5"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[13]:=",ExpressionUUID->"4e163a0d-65a1-4281-ba8c-7ac6096c5d87"]
}, Closed]],

Cell[CellGroupData[{

Cell["StringMemberQ", "Subsubsection",ExpressionUUID->"d1701a92-c43f-4236-98d8-5e6d89f7e9f7"],

Cell[BoxData[
 RowBox[{"StringMemberQ", "[", 
  RowBox[{"\"\<equation\>\"", ",", 
   RowBox[{"{", 
    RowBox[{
    "\"\<a\>\"", ",", "\"\<e\>\"", ",", "\"\<i\>\"", ",", "\"\<o\>\"", ",", 
     "\"\<u\>\""}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[14]:=",ExpressionUUID->"43b6be22-9589-4136-bd1e-b66389781e3f"]
}, Closed]]
}, Closed]]
}, Closed]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{857, 824},
WindowMargins->{{12, Automatic}, {Automatic, 4}},
ShowSelection->True,
Magnification:>1.25 Inherited,
FrontEndVersion->"13.3 for Mac OS X ARM (64-bit) (July 24, 2023)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"ae11ef5c-3310-4970-be58-19820949ae24"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "1.1"->{
  Cell[10917, 321, 902, 24, 100, "Input",ExpressionUUID->"a59b03fb-5ea7-4e56-80db-fdcc594db23a",
   CellTags->"1.1"],
  Cell[11822, 347, 316, 8, 33, "InputOnly",ExpressionUUID->"24ebfd01-0482-44d6-8404-e91d1b3401b1",
   CellTags->"1.1"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"1.1", 16896, 512}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 122, 2, 105, "Section",ExpressionUUID->"bd70b444-6f8d-4d52-80bf-40b540539633",
 InitializationGroup->True],
Cell[704, 26, 295, 9, 83, "Text",ExpressionUUID->"0e4319ad-7363-4bce-a6a2-14933a21226d"],
Cell[CellGroupData[{
Cell[1024, 39, 85, 0, 84, "Subsection",ExpressionUUID->"04c0d4d4-fc57-40a2-bbdc-d148fae21ce8"],
Cell[1112, 41, 170, 3, 47, "Input",ExpressionUUID->"9dbe9063-3aee-4804-8c2b-3455953a3f6e"],
Cell[1285, 46, 248, 6, 47, "Input",ExpressionUUID->"972d5476-4696-49b8-b389-4d6f2f08f429"],
Cell[1536, 54, 203, 5, 47, "Input",ExpressionUUID->"d1ee7ee6-3401-4e44-a206-74d05d5d3edc"],
Cell[1742, 61, 299, 6, 80, "Input",ExpressionUUID->"b0693f7b-93fe-4c58-be94-8d6a9638cfa3"],
Cell[2044, 69, 174, 3, 47, "Input",ExpressionUUID->"acadc45c-2e88-4226-8710-f5afc83dd4f8"],
Cell[2221, 74, 190, 4, 47, "Input",ExpressionUUID->"8455b199-9e7f-4fde-a0fc-12aa2936da3d"],
Cell[2414, 80, 266, 6, 47, "Input",ExpressionUUID->"86bad378-527f-4639-96be-8bb134620056"],
Cell[2683, 88, 444, 11, 112, "Input",ExpressionUUID->"ccd84b52-aaba-4eda-8de1-de875d9fe66e"],
Cell[3130, 101, 282, 6, 80, "Input",ExpressionUUID->"84f31f16-5bfc-46cb-ad7c-b596c90bccab"],
Cell[3415, 109, 192, 4, 47, "Input",ExpressionUUID->"a080374a-0ff2-47ae-bc98-49c4bb14a452"],
Cell[3610, 115, 195, 4, 47, "Input",ExpressionUUID->"467b194a-0499-4f40-904e-2e39e62a80ee"],
Cell[3808, 121, 181, 3, 47, "Input",ExpressionUUID->"3d782710-4ead-4efa-98ee-737dd709e683"],
Cell[3992, 126, 238, 5, 47, "Input",ExpressionUUID->"2b100d90-55d4-412a-b94c-3a12294c2c2a"],
Cell[4233, 133, 238, 5, 47, "Input",ExpressionUUID->"c7954e0a-cfb1-4a9d-9a49-274a9ad5f0a5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4508, 143, 89, 0, 84, "Subsection",ExpressionUUID->"13c07081-b124-4dac-a1b4-f0234d1181c1"],
Cell[4600, 145, 214, 5, 80, "Input",ExpressionUUID->"7d0b5147-e2c4-4b39-ab5d-f7399c8c1324"],
Cell[4817, 152, 182, 3, 47, "Input",ExpressionUUID->"a7576329-b0e4-4771-99c7-87e1a3453cf6"]
}, Closed]],
Cell[CellGroupData[{
Cell[5036, 160, 112, 0, 57, "Subsection",ExpressionUUID->"4cd52bb0-068b-430f-b859-a5c193478b7a"],
Cell[5151, 162, 326, 7, 64, "Input",ExpressionUUID->"5ab135be-02cd-4937-bc7a-da9bbb3353cb"],
Cell[5480, 171, 389, 8, 116, "Input",ExpressionUUID->"da67986c-5493-448e-8090-53817bad2dc2"],
Cell[5872, 181, 254, 6, 90, "Input",ExpressionUUID->"0ac92d02-4a68-4f1d-8ecf-26f7052e1453"],
Cell[6129, 189, 698, 13, 116, "Input",ExpressionUUID->"355b4fa7-9d9b-458c-aa1e-5a827fcdb435"],
Cell[6830, 204, 506, 9, 90, "Input",ExpressionUUID->"13398712-abcb-4539-9530-87e858ea316b"]
}, Closed]],
Cell[CellGroupData[{
Cell[7373, 218, 84, 0, 57, "Subsection",ExpressionUUID->"620dcfb9-f783-481a-96d0-e68d85f7f9e4"],
Cell[7460, 220, 212, 5, 37, "Input",ExpressionUUID->"6e283cc9-4ef3-473e-8223-b7c50a95c99c"],
Cell[7675, 227, 217, 5, 37, "Input",ExpressionUUID->"951f882c-6c70-464c-a598-086e350247d8"]
}, Closed]],
Cell[CellGroupData[{
Cell[7929, 237, 92, 0, 57, "Subsection",ExpressionUUID->"4cd6ca10-9722-4a9a-810c-11ae3c786b3f"],
Cell[8024, 239, 129, 1, 637, "Input",ExpressionUUID->"f40f417f-d9a7-4035-b886-41b171c8971a"]
}, Closed]],
Cell[CellGroupData[{
Cell[8190, 245, 118, 0, 57, "Subsection",ExpressionUUID->"2d37f557-3088-4f5c-9cae-55b1a8ed9b3e"],
Cell[8311, 247, 227, 5, 35, "Input",ExpressionUUID->"4514ce95-a55e-40d8-a2c1-3855bd576e9e"],
Cell[8541, 254, 538, 16, 57, "Input",ExpressionUUID->"6bfe152c-a8c6-421e-a10d-b4053e455115"],
Cell[9082, 272, 1832, 47, 206, "Input",ExpressionUUID->"b4928a5d-9856-442d-8e6e-5d35944e5821"],
Cell[10917, 321, 902, 24, 100, "Input",ExpressionUUID->"a59b03fb-5ea7-4e56-80db-fdcc594db23a",
 CellTags->"1.1"],
Cell[11822, 347, 316, 8, 33, "InputOnly",ExpressionUUID->"24ebfd01-0482-44d6-8404-e91d1b3401b1",
 CellTags->"1.1"]
}, Closed]],
Cell[CellGroupData[{
Cell[12175, 360, 96, 0, 57, "Subsection",ExpressionUUID->"cfc3708a-bdb5-4004-b90c-08d9eec0ec3f"],
Cell[12274, 362, 106, 1, 1391, "Input",ExpressionUUID->"628eb4b3-293e-4814-aeb4-0725c965741d"]
}, Closed]],
Cell[CellGroupData[{
Cell[12417, 368, 87, 0, 57, "Subsection",ExpressionUUID->"499c8467-3608-431c-869f-47eb4a60e94b"],
Cell[12507, 370, 140, 3, 70, "Input",ExpressionUUID->"98fb02be-7d2a-401b-b34b-54b7c9c2d1f2"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[12696, 379, 82, 0, 105, "Section",ExpressionUUID->"4fc28b77-9220-49c6-8cd7-5d5e7eb11d5a"],
Cell[CellGroupData[{
Cell[12803, 383, 89, 0, 84, "Subsection",ExpressionUUID->"f12dd979-e5d8-4495-b84c-9db66897d8d0"],
Cell[12895, 385, 107, 1, 47, "Input",ExpressionUUID->"c05ee97e-a95a-4ea5-9b17-e13d87605ba2"],
Cell[13005, 388, 265, 6, 91, "Text",ExpressionUUID->"43363d32-82e1-4b76-b463-b65c7de5b6b1"],
Cell[13273, 396, 126, 2, 47, "Input",ExpressionUUID->"32f41260-a967-4ec3-a9e8-5c7fe7f335b7"]
}, Closed]],
Cell[CellGroupData[{
Cell[13436, 403, 96, 0, 84, "Subsection",ExpressionUUID->"90103e65-8d25-4706-bba5-f00c776d0cf1"],
Cell[13535, 405, 133, 2, 47, "Input",ExpressionUUID->"ee29c823-acb9-4a58-bf4b-76c320e7d05c"],
Cell[13671, 409, 138, 2, 47, "Input",ExpressionUUID->"2ad946bf-29dc-4bfb-a976-8b03619c80df"],
Cell[13812, 413, 131, 2, 47, "Input",ExpressionUUID->"0ffdb8d8-0f0f-470d-94ef-cb11926430a0"],
Cell[13946, 417, 134, 2, 47, "Input",ExpressionUUID->"0856c5a7-8c3f-493b-86da-68bba5da9637"]
}, Closed]],
Cell[CellGroupData[{
Cell[14117, 424, 111, 0, 84, "Subsection",ExpressionUUID->"3a5d7601-757e-482d-8984-a098218d3446"],
Cell[CellGroupData[{
Cell[14253, 428, 92, 0, 71, "Subsubsection",ExpressionUUID->"9aa6fb5a-5c57-4116-9a19-d22a6a6f5ea8"],
Cell[14348, 430, 351, 9, 80, "Input",ExpressionUUID->"460da3db-35a8-4598-9c75-eb2d3be7fc96"],
Cell[14702, 441, 225, 4, 47, "Input",ExpressionUUID->"45783aea-5d82-42e4-a08b-5af9254e75d4"]
}, Closed]],
Cell[CellGroupData[{
Cell[14964, 450, 97, 0, 71, "Subsubsection",ExpressionUUID->"bec0d66e-1eb0-41fd-8ced-587950ad5e2e"],
Cell[15064, 452, 352, 9, 80, "Input",ExpressionUUID->"241f2032-6a11-4881-a1f6-493f22b9fc99"],
Cell[15419, 463, 225, 4, 47, "Input",ExpressionUUID->"13e9198b-f0ec-47fc-b1df-cf33a24dee98"]
}, Closed]],
Cell[CellGroupData[{
Cell[15681, 472, 90, 0, 71, "Subsubsection",ExpressionUUID->"bebf7826-5c4a-4edd-ace8-80c2226ce8f7"],
Cell[15774, 474, 214, 5, 47, "Input",ExpressionUUID->"4e163a0d-65a1-4281-ba8c-7ac6096c5d87"]
}, Closed]],
Cell[CellGroupData[{
Cell[16025, 484, 93, 0, 71, "Subsubsection",ExpressionUUID->"d1701a92-c43f-4236-98d8-5e6d89f7e9f7"],
Cell[16121, 486, 313, 7, 47, "Input",ExpressionUUID->"43b6be22-9589-4136-bd1e-b66389781e3f"]
}, Closed]]
}, Closed]]
}, Closed]]
}
]
*)

