(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     29815,        774]
NotebookOptionsPosition[     21555,        644]
NotebookOutlinePosition[     22035,        663]
CellTagsIndexPosition[     21992,        660]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["EPM`Lists`", "Section",
 InitializationGroup->
  True,ExpressionUUID->"a1230bbd-8545-4601-bca0-86768ce0435e"],

Cell[TextData[{
 StyleBox["From",
  FontWeight->"Bold"],
 ": ",
 StyleBox["Essentials of Programming in Mathematica\n",
  FontSlant->"Italic"],
 "\[Copyright] Paul R. Wellin 2015"
}], "Text",
 CellMargins->{{28, 10}, {7, 7}},
 FontSize->14,ExpressionUUID->"f7260412-f36c-427a-95a7-44d92cbe6428"],

Cell[CellGroupData[{

Cell["Metadata", "Subsection",ExpressionUUID->"d768ad9d-d39e-4a2c-aa15-2f202727f1fd"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Name", ":", " ", "EPM`Lists`"}], " ", "*)"}]], "Input",
 CellLabel->"In[1]:=",ExpressionUUID->"05067a9c-ff05-4be7-8064-990547c61795"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Book", ":", " ", 
   RowBox[{
   "Essentials", " ", "of", " ", "Programming", " ", "in", " ", 
    "Mathematica"}]}], " ", "*)"}]], "Input",
 CellLabel->"In[2]:=",ExpressionUUID->"48e77683-fde0-43a6-aebc-0b7ea1d93721"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Paul", " ", "Wellin"}]}]}], " ", "*)"}]], "Input",
 CellLabel->"In[3]:=",ExpressionUUID->"665c9abc-3f7c-412b-8519-c3d24e369e4e"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Summary", ":", " ", 
   RowBox[{
   "This", " ", "package", " ", "contains", " ", "the", " ", "functions", " ",
     "defined", " ", "in", " ", "Chapter", " ", "3", " ", 
    RowBox[{"Lists", "."}]}]}], " ", "*)"}]], "Input",
 CellLabel->"In[4]:=",ExpressionUUID->"d0037c70-a5ec-4f29-9b6f-21fc500e3cf5"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Context", ":", " ", "EPM`Lists`"}], " ", "*)"}]], "Input",
 CellLabel->"In[5]:=",ExpressionUUID->"9eb19701-0998-4cb6-b07d-103dab1ed4a0"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", 
    RowBox[{"Version", ":", " ", "1.0"}]}]}], " ", "*)"}]], "Input",
 CellLabel->"In[6]:=",ExpressionUUID->"8221aac2-755c-49e0-b806-adf3d8dbbed9"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", "Copyright", ":", " ", 
    RowBox[{"Copyright", " ", "2015"}]}], ",", " ", 
   RowBox[{"Paul", " ", "R", " ", "Wellin"}]}], " ", "*)"}]], "Input",
 CellLabel->"In[7]:=",ExpressionUUID->"ea16bce8-1937-41d6-8bb9-dbcc86dce333"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{
     "Version", " ", "1.0", " ", "by", " ", "Paul", " ", "Wellin"}]}]}], ",", 
   " ", 
   RowBox[{"Dec", " ", "2012"}]}], " ", "*)"}]], "Input",
 CellLabel->"In[8]:=",ExpressionUUID->"e5ac14fb-1bc2-44df-b4ae-f062c0327af8"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", "Keywords", ":", " ", 
    RowBox[{"integer", " ", "lattice"}]}], ",", " ", "palindromes", ",", " ", 
   
   RowBox[{
    RowBox[{"Pascal", "'"}], "s", " ", "triangle"}], ",", " ", "Ngrams"}], 
  " ", "*)"}]], "Input",
 CellLabel->"In[9]:=",ExpressionUUID->"ece3c010-a6ff-47a3-a69f-007a7b85fcfb"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Source", ":", " ", 
   RowBox[{"Lists", ".", "nb"}]}], " ", "*)"}]], "Input",
 CellLabel->"In[10]:=",ExpressionUUID->"0188bad8-b0d6-442a-bd98-970eb671560a"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", "Version"}], ":", " ", "10.2"}], " ", 
  "*)"}]], "Input",
 CellLabel->"In[11]:=",ExpressionUUID->"c4630835-064a-4b76-900c-a1f7c2faf342"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Tested", " ", "in", " ", "Mathematica", " ", "11.1"}], " ", 
  "*)"}]], "Input",
 CellLabel->"In[12]:=",ExpressionUUID->"09454c24-c018-4ebd-b75f-815fdc551253"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Tested", " ", "in", " ", "Mathematica", " ", "12.0"}], ",", " ", 
   RowBox[{"Feb", " ", "2019"}]}], " ", "*)"}]], "Input",ExpressionUUID->\
"64c92466-8eb1-40cb-915a-e43727c0ccc2"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Tested", " ", "in", " ", "Mathematica", " ", "13.2"}], ",", " ", 
   RowBox[{"Aug", " ", "2023"}]}], " ", "*)"}]], "Input",ExpressionUUID->\
"9947858e-7346-4ffd-acef-259feff37184"]
}, Closed]],

Cell[CellGroupData[{

Cell["BeginPackage", "Subsection",ExpressionUUID->"7ced4f12-1fbd-484e-ade8-bb1d0e8be7ba"],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{
  "AddColumn", ",", "Lattice", ",", "NGrams", ",", "palindromeQ", ",", 
   "PascalTable", ",", "TriangleForm"}], "]"}]], "Input",
 CellLabel->"In[13]:=",ExpressionUUID->"6fc4f009-8047-4efd-b1ea-5e59db6c6e8a"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"BeginPackage", "[", "\"\<EPM`Lists`\>\"", "]"}], "*)"}]], "Input",
 CellLabel->"In[14]:=",ExpressionUUID->"df1f176d-9d96-43e2-9751-8f92c3d5aa92"]
}, Closed]],

Cell[CellGroupData[{

Cell["Usage messages for public functions", "Subsection",ExpressionUUID->"9a5c0737-9fb6-4682-a6e6-0497184f6d29"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddColumn", "::", "usage"}], "=", 
   "\"\<AddColumn[\!\(\*StyleBox[\"mat\", \"TI\"]\), \!\(\*StyleBox[\"col\", \
\"TI\"]\), \!\(\*StyleBox[\"pos\", \"TI\"]\)] inserts the column vector \
\!\(\*StyleBox[\"col\", \"TI\"]\) to the matrix \!\(\*StyleBox[\"mat\", \
\"TI\"]\) at position \!\(\*StyleBox[\"pos\", \"TI\"]\).\>\""}], 
  ";"}]], "Input",
 CellLabel->"In[15]:=",ExpressionUUID->"1e4bd474-bba2-4078-b1ea-1dd6ea250488"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Lattice", "::", "usage"}], "=", 
   "\"\<Lattice[{{\!\(\*StyleBox[\"xmin\", \"TI\"]\), \
\!\(\*StyleBox[\"xmax\", \"TI\"]\)},{\!\(\*StyleBox[\"ymin\", \"TI\"]\), \!\(\
\*StyleBox[\"ymax\", \"TI\"]\)}}] creates a two-dimensional rectangular \
lattice.\>\""}], ";"}]], "Input",
 CellLabel->"In[16]:=",ExpressionUUID->"982f350e-f214-4393-9ff3-f5b3a83ce4fe"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NGrams", "::", "usage"}], "=", 
   "\"\<NGrams[\!\(\*StyleBox[\"text\", \"TI\"]\), \!\(\*StyleBox[\"n\", \"TI\
\"]\)] splits \!\(\*StyleBox[\"text\", \"TI\"]\) into overlapping lists of \!\
\(\*StyleBox[\"n\", \"TI\"]\) words.\>\""}], ";"}]], "Input",
 CellLabel->"In[17]:=",ExpressionUUID->"331f4185-65d0-489f-9097-09cb77a42427"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"palindromeQ", "::", "usage"}], "=", 
   "\"\<palindromeQ[\!\(\*StyleBox[\"n\", \"TI\"]\)] returns True if \
\!\(\*StyleBox[\"n\", \"TI\"]\) is a palindromic number.\>\""}], 
  ";"}]], "Input",
 CellLabel->"In[18]:=",ExpressionUUID->"87ae0717-14f1-41d5-9129-db0f61fa088a"],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"$VersionNumber", "<", "10.3"}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PalindromeQ", "::", "usage"}], "=", 
     "\"\<PalindromeQ[\!\(\*StyleBox[\"n\", \"TI\"]\)] returns True if \
\!\(\*StyleBox[\"n\", \"TI\"]\) is a palindromic number.\>\""}], ";"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"palindromeQ", "::", "usage"}], "=", 
     "\"\<palindromeQ[\!\(\*StyleBox[\"n\", \"TI\"]\)] returns True if \
\!\(\*StyleBox[\"n\", \"TI\"]\) is a palindromic number.\>\""}], ";"}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",
 CellLabel->"In[19]:=",ExpressionUUID->"db6bc509-23c1-4866-b7c6-29c94442853b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PascalTable", "::", "usage"}], "=", 
   "\"\<PascalTable[\!\(\*StyleBox[\"n\", \"TI\"]\)] returns the first \
\!\(\*StyleBox[\"n\", \"TI\"]\) rows of Pascal's Triangle, where the \
\!\(\*StyleBox[\"n\", \"TI\"]\)th row consists of the coefficients of the \
expansion of the polynomial \
(1\[VeryThinSpace]+\[VeryThinSpace]\!\(\*StyleBox[\"x\", \
\"TI\"]\)\!\(\*SuperscriptBox[\")\", StyleBox[\"n\", \"TI\"]]\).\>\""}], 
  ";"}]], "Input",
 CellLabel->"In[20]:=",ExpressionUUID->"a5c4ef77-f7f9-4c6e-bcb8-761647a9e077"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TriangleForm", "::", "usage"}], "=", 
   "\"\<TriangleForm[\!\(\*StyleBox[\"lis\", \"TI\"]\)] displays the list \
\!\(\*StyleBox[\"lis\", \"TI\"]\) in a triangular form, padding shorter rows \
to the same length as the longest row.\>\""}], ";"}]], "Input",
 CellLabel->"In[21]:=",ExpressionUUID->"5b57d90c-696d-4d78-a780-970288bf281f"]
}, Closed]],

Cell["Options", "Subsection",ExpressionUUID->"ac4506b0-7ec5-41c6-bd29-2a8330c60aaa"],

Cell[CellGroupData[{

Cell["Private context", "Subsection",ExpressionUUID->"b7d20c9b-8922-47bd-a3ba-34af605d5d9b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}], ";"}]], "Input",
 CellLabel->"In[22]:=",ExpressionUUID->"849b28f6-aa14-4bf4-ae05-90e40bdbb11b"]
}, Closed]],

Cell[CellGroupData[{

Cell["Function definitions (public and private)", "Subsection",ExpressionUUID->"3d9da3c0-32c3-4c87-9d4b-bd853aa64c96"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddColumn", "[", 
    RowBox[{"mat_", ",", "col_", ",", "pos_"}], "]"}], "/;", 
   RowBox[{
    RowBox[{"Length", "[", "col", "]"}], "\[Equal]", 
    RowBox[{"Length", "[", "mat", "]"}]}]}], ":=", 
  RowBox[{"Transpose", "[", 
   RowBox[{"Insert", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", "mat", "]"}], ",", "col", ",", "pos"}], "]"}], 
   "]"}]}]], "Input",
 CellLabel->"In[23]:=",ExpressionUUID->"98a4742c-fb38-4f4d-9cc0-c4e07680f407"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Lattice", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"xmin_", ",", "xmax_"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"ymin_", ",", "ymax_"}], "}"}]}], "}"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "coords", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"coords", "=", 
      RowBox[{"CoordinateBoundsArray", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"xmin", ",", "xmax"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"ymin", ",", "ymax"}], "}"}]}], "}"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Graphics", "[", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Line", "[", "coords", "]"}], ",", 
        RowBox[{"Line", "[", 
         RowBox[{"Transpose", "[", "coords", "]"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"PointSize", "[", "Medium", "]"}], ",", 
        RowBox[{"Point", "[", 
         RowBox[{"Flatten", "[", 
          RowBox[{"coords", ",", "1"}], "]"}], "]"}]}], "\[IndentingNewLine]",
        "}"}], "]"}]}]}], "]"}]}]], "Input",
 CellLabel->"In[24]:=",ExpressionUUID->"e08a8bb6-5304-47c5-8649-71372f6cf03c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Lattice", "[", 
   RowBox[{"{", 
    RowBox[{"xdim_", ",", "ydim_"}], "}"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "coords", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"coords", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"i", ",", "j"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", "xdim"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "1", ",", "ydim"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Graphics", "[", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Line", "[", "coords", "]"}], ",", 
        RowBox[{"Line", "[", 
         RowBox[{"Transpose", "[", "coords", "]"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"PointSize", "[", "Medium", "]"}], ",", 
        RowBox[{"Point", "[", 
         RowBox[{"Flatten", "[", 
          RowBox[{"coords", ",", "1"}], "]"}], "]"}]}], "\[IndentingNewLine]",
        "}"}], "]"}]}]}], "]"}]}]], "Input",
 CellLabel->"In[25]:=",ExpressionUUID->"9972b5eb-ff4f-497b-ba0c-38d54724d4fb"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NGrams", "[", 
   RowBox[{"text_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Partition", "[", 
   RowBox[{
    RowBox[{"TextWords", "[", "text", "]"}], ",", "n", ",", "1"}], 
   "]"}]}]], "Input",
 CellLabel->"In[26]:=",ExpressionUUID->"fce425ed-7c7b-43e2-9deb-0d45775223f0"],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"$VersionNumber", "<", "10.3"}], ",", " ", "\n", "\t", 
   RowBox[{
    RowBox[{
     RowBox[{"PalindromeQ", "[", "num_Integer", "]"}], ":=", 
     RowBox[{
      RowBox[{"IntegerDigits", "[", "num", "]"}], "==", 
      RowBox[{"Reverse", "[", 
       RowBox[{"IntegerDigits", "[", "num", "]"}], "]"}]}]}], ";"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"palindromeQ", "[", "num_Integer", "]"}], ":=", 
     RowBox[{
      RowBox[{"IntegerDigits", "[", "num", "]"}], "==", 
      RowBox[{"Reverse", "[", 
       RowBox[{"IntegerDigits", "[", "num", "]"}], "]"}]}]}], ";"}]}], "\n", 
  "]"}]], "Input",
 CellLabel->"In[27]:=",ExpressionUUID->"0496c338-7487-4dd0-9b4d-f32b967cf61c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PascalTable", "[", "rows_", "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"Binomial", "[", 
     RowBox[{"n", ",", "m"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"n", ",", "0", ",", "rows"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"m", ",", "0", ",", "n"}], "}"}]}], "]"}]}]], "Input",
 CellLabel->"In[28]:=",ExpressionUUID->"90599a5a-0781-4dd4-9d17-e988d3ebdf97"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TriangleForm", "[", "expr_", "]"}], ":=", 
  RowBox[{"Block", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"rows", "=", 
      RowBox[{"Length", "[", "expr", "]"}]}], "}"}], ",", 
    RowBox[{"DisplayForm", "[", 
     RowBox[{"GridBox", "[", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"PadLeft", "[", 
          RowBox[{
           RowBox[{"Rest", "[", 
            RowBox[{"Flatten", "[", 
             RowBox[{"Map", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"\"\<\>\"", ",", "#"}], "}"}], "&"}], ",", "#"}], 
              "]"}], "]"}], "]"}], ",", 
           RowBox[{
            RowBox[{"2", "rows"}], "+", "1"}], ",", "\"\<\>\"", ",", 
           RowBox[{"rows", "-", 
            RowBox[{"Length", "[", "#", "]"}], "+", "1"}]}], "]"}], "&"}], 
        ",", "expr"}], "]"}], "]"}], "]"}]}], "]"}]}]], "Input",
 CellLabel->"In[29]:=",ExpressionUUID->"87b9527a-8d9c-4a44-9d98-66ff85c0f1f6"]
}, Closed]],

Cell[CellGroupData[{

Cell["End private context", "Subsection",ExpressionUUID->"f6f06ef9-f5c6-43b6-8659-40025f2421eb"],

Cell[BoxData[
 RowBox[{
  RowBox[{"End", "[", "]"}], ";"}]], "Input",
 CellLabel->"In[30]:=",ExpressionUUID->"5af31875-3502-40c7-89e7-9e2abdcc4bad"]
}, Closed]],

Cell[CellGroupData[{

Cell["EndPackage", "Subsection",ExpressionUUID->"7519dfdc-bad4-4c44-9d95-2e39bc798dc7"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"EndPackage", "[", "]"}], "*)"}]], "Input",
 CellLabel->"In[31]:=",ExpressionUUID->"d003876f-2b5e-41cc-b9e8-6fc03cfb59de"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Examples", "Section",ExpressionUUID->"50e56217-5516-49f7-8b3c-ea6cbc61e470"],

Cell[CellGroupData[{

Cell["Load package", "Subsection",ExpressionUUID->"9495c679-6884-4491-8a4a-0d7791a7785f"],

Cell["Quit current session:", "Text",ExpressionUUID->"d22593a1-24bc-473a-8ef2-374de7cabc16"],

Cell[BoxData["Quit"], "Input",
 CellLabel->"In[33]:=",ExpressionUUID->"17c94c27-d41c-4d9b-9485-5f4193180975"],

Cell[TextData[{
 "Load package (do ",
 StyleBox["not",
  FontSlant->"Italic"],
 " say \[OpenCurlyDoubleQuote]Yes\[CloseCurlyDoubleQuote] to dialog asking to \
evaluate init cells in this notebook)."
}], "Text",ExpressionUUID->"f524ec49-55e9-4c3c-9a18-7f4c363732f4"],

Cell[BoxData[
 RowBox[{"<<", "EPM`"}]], "Input",
 CellLabel->"In[1]:=",ExpressionUUID->"d927125a-fd28-4fdf-bcbf-f671d8ef92f2"]
}, Closed]],

Cell[CellGroupData[{

Cell["Test usage messages", "Subsection",ExpressionUUID->"e967bbf6-3d77-4440-9687-ab439dafee37"],

Cell[BoxData[
 RowBox[{"?", "AddColumn"}]], "Input",
 CellLabel->"In[45]:=",ExpressionUUID->"6ee1f501-9154-4da0-aa5f-63f54bbddfda"],

Cell[BoxData[
 RowBox[{"?", "Lattice"}]], "Input",
 CellLabel->"In[46]:=",ExpressionUUID->"38165872-643b-4c3c-a7a7-10b02b41a511"],

Cell[BoxData[
 RowBox[{"?", "NGrams"}]], "Input",
 CellLabel->"In[47]:=",ExpressionUUID->"76571a98-54c5-4679-831a-2d7768c8ffa1"],

Cell[TextData[{
 "If ",
 ButtonBox["$VersionNumber",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/$VersionNumber"],
 " \[GreaterEqual] 10.3:"
}], "Text",ExpressionUUID->"c2e3a9dd-1535-4e5a-8bda-26a0788060d1"],

Cell[BoxData[
 RowBox[{"?", "palindromeQ"}]], "Input",
 CellLabel->"In[48]:=",ExpressionUUID->"c496b22f-20e7-40ea-abb3-b243776eca53"],

Cell[TextData[{
 "If ",
 ButtonBox["$VersionNumber",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/$VersionNumber"],
 " < 10.3:"
}], "Text",ExpressionUUID->"1fc23e13-8326-4355-8566-23c53324f04a"],

Cell[BoxData[
 RowBox[{"?", "PalindromeQ"}]], "Input",
 CellLabel->"In[49]:=",ExpressionUUID->"becf0173-8637-47ba-a2c6-0a1ff56136e5"],

Cell[BoxData[
 RowBox[{"?", "PascalTable"}]], "Input",
 CellLabel->"In[50]:=",ExpressionUUID->"5bd70210-a67a-47ec-84b4-7f07c262a61a"],

Cell[BoxData[
 RowBox[{"?", "TriangleForm"}]], "Input",
 CellLabel->"In[51]:=",ExpressionUUID->"c37cfb0a-6df8-4156-b5cd-67429916c7a8"]
}, Closed]],

Cell[CellGroupData[{

Cell["Exercise the functions and options", "Subsection",ExpressionUUID->"6fc61788-7c70-44cd-b9a9-7a73a3296e83"],

Cell[CellGroupData[{

Cell["AddColumn", "Subsubsection",ExpressionUUID->"caea03dd-c099-4f2a-8758-1b9768787b34"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"mat", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"9", ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "4"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"MatrixForm", "[", "mat", "]"}]}], "Input",
 CellLabel->"In[52]:=",ExpressionUUID->"8418e7ad-03dc-4b40-a773-1d508d75f899"],

Cell[BoxData[
 RowBox[{
  RowBox[{"AddColumn", "[", 
   RowBox[{"mat", ",", 
    RowBox[{"{", 
     RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}], ",", "3"}], "]"}], "//",
   "MatrixForm"}]], "Input",
 CellLabel->"In[54]:=",ExpressionUUID->"fb2134ec-a1f2-4403-9bf0-ec1c2a7555bb"]
}, Closed]],

Cell[CellGroupData[{

Cell["Lattice", "Subsubsection",ExpressionUUID->"9b6df16d-814f-4774-9461-e08b6fe1bf63"],

Cell[BoxData[
 RowBox[{"Lattice", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0", ",", "8"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "5"}], "}"}]}], "}"}], "]"}]], "Input",
 CellLabel->"In[55]:=",ExpressionUUID->"8948152d-4940-40ee-9ad3-ad0fc3612929"]
}, Closed]],

Cell[CellGroupData[{

Cell["NGrams", "Subsubsection",ExpressionUUID->"bd41e01d-37b9-451e-8628-f65f6bba7bcb"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
  "sentence", "=", "\"\<Colorless green, ideas sleep furiously.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"NGrams", "[", 
  RowBox[{"sentence", ",", "3"}], "]"}]}], "Input",
 CellLabel->"In[56]:=",ExpressionUUID->"9bc03e2b-56ff-4326-b54c-e7634c0a7d95"],

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"n", "=", "3"}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{"TextWords", "[", "sentence", "]"}], ",", "n", ",", "1"}], 
    "]"}]}], "\[IndentingNewLine]", "]"}]], "Input",
 CellLabel->"In[58]:=",ExpressionUUID->"4cb34623-0bdb-4cc4-9d9a-18f7d6d6a090"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"text", "=", 
   RowBox[{"ExampleData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<Text\>\"", ",", "\"\<TheRaven\>\""}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Head", "[", "text", "]"}]}], "Input",
 CellLabel->"In[59]:=",ExpressionUUID->"8c1dedb7-dc56-4db6-acc3-3f07461e617f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NGrams", "[", 
   RowBox[{"text", ",", "3"}], "]"}], "//", "Timing"}]], "Input",
 CellLabel->"In[61]:=",ExpressionUUID->"1edcf77f-1436-4d9f-a5c2-950c535d8655"]
}, Closed]],

Cell[CellGroupData[{

Cell["palindromeQ", "Subsubsection",ExpressionUUID->"84b1a8af-a950-4f87-879b-bf627acdfccb"],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"$VersionNumber", "\[GreaterEqual]", "10.3"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"palindromeQ", "[", "123454321", "]"}], ",", "\[IndentingNewLine]", 
   RowBox[{"PalindromeQ", "[", "123454321", "]"}]}], "\[IndentingNewLine]", 
  "]"}]], "Input",
 CellLabel->"In[62]:=",ExpressionUUID->"046dd450-2d78-4412-84c2-3c2ce7afb735"]
}, Closed]],

Cell[CellGroupData[{

Cell["PascalTable", "Subsubsection",ExpressionUUID->"664b0974-73f8-4b47-9fda-85c8a7f1a2ae"],

Cell[BoxData[
 RowBox[{"PascalTable", "[", "5", "]"}]], "Input",
 CellLabel->"In[63]:=",ExpressionUUID->"73e26cf7-8bd3-4806-999c-65fca52b8fa8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PascalTable", "[", "8", "]"}], "//", "TriangleForm"}]], "Input",
 CellLabel->"In[64]:=",ExpressionUUID->"be8dd0b0-7b32-4dfb-b00a-796bf8140631"]
}, Closed]],

Cell[CellGroupData[{

Cell["TriangleForm", "Subsubsection",ExpressionUUID->"61591d29-01a3-4116-be12-ab96f595f83c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PascalTable", "[", "8", "]"}], "//", "TriangleForm"}]], "Input",
 CellLabel->"In[65]:=",ExpressionUUID->"1b094381-ee6b-47a9-89ce-0a8f84bb78e7"]
}, Closed]]
}, Closed]]
}, Closed]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{1133, 790},
WindowMargins->{{163, Automatic}, {Automatic, 27}},
ShowSelection->True,
Magnification:>1.25 Inherited,
FrontEndVersion->"13.3 for Mac OS X ARM (64-bit) (July 24, 2023)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"c57e25f8-58cd-487f-b9ce-7da54b2de937"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 115, 2, 105, "Section",ExpressionUUID->"a1230bbd-8545-4601-bca0-86768ce0435e",
 InitializationGroup->True],
Cell[697, 26, 295, 9, 83, "Text",ExpressionUUID->"f7260412-f36c-427a-95a7-44d92cbe6428"],
Cell[CellGroupData[{
Cell[1017, 39, 85, 0, 84, "Subsection",ExpressionUUID->"d768ad9d-d39e-4a2c-aa15-2f202727f1fd"],
Cell[1105, 41, 184, 3, 47, "Input",ExpressionUUID->"05067a9c-ff05-4be7-8064-990547c61795"],
Cell[1292, 46, 269, 6, 47, "Input",ExpressionUUID->"48e77683-fde0-43a6-aebc-0b7ea1d93721"],
Cell[1564, 54, 224, 5, 47, "Input",ExpressionUUID->"665c9abc-3f7c-412b-8519-c3d24e369e4e"],
Cell[1791, 61, 354, 7, 47, "Input",ExpressionUUID->"d0037c70-a5ec-4f29-9b6f-21fc500e3cf5"],
Cell[2148, 70, 187, 3, 47, "Input",ExpressionUUID->"9eb19701-0998-4cb6-b07d-103dab1ed4a0"],
Cell[2338, 75, 225, 5, 47, "Input",ExpressionUUID->"8221aac2-755c-49e0-b806-adf3d8dbbed9"],
Cell[2566, 82, 287, 6, 47, "Input",ExpressionUUID->"ea16bce8-1937-41d6-8bb9-dbcc86dce333"],
Cell[2856, 90, 334, 9, 47, "Input",ExpressionUUID->"e5ac14fb-1bc2-44df-b4ae-f062c0327af8"],
Cell[3193, 101, 358, 9, 47, "Input",ExpressionUUID->"ece3c010-a6ff-47a3-a69f-007a7b85fcfb"],
Cell[3554, 112, 207, 4, 47, "Input",ExpressionUUID->"0188bad8-b0d6-442a-bd98-970eb671560a"],
Cell[3764, 118, 219, 5, 47, "Input",ExpressionUUID->"c4630835-064a-4b76-900c-a1f7c2faf342"],
Cell[3986, 125, 205, 4, 47, "Input",ExpressionUUID->"09454c24-c018-4ebd-b75f-815fdc551253"],
Cell[4194, 131, 238, 5, 47, "Input",ExpressionUUID->"64c92466-8eb1-40cb-915a-e43727c0ccc2"],
Cell[4435, 138, 238, 5, 47, "Input",ExpressionUUID->"9947858e-7346-4ffd-acef-259feff37184"]
}, Closed]],
Cell[CellGroupData[{
Cell[4710, 148, 89, 0, 57, "Subsection",ExpressionUUID->"7ced4f12-1fbd-484e-ade8-bb1d0e8be7ba"],
Cell[4802, 150, 258, 5, 37, "Input",ExpressionUUID->"6fc4f009-8047-4efd-b1ea-5e59db6c6e8a"],
Cell[5063, 157, 186, 3, 37, "Input",ExpressionUUID->"df1f176d-9d96-43e2-9751-8f92c3d5aa92"]
}, Closed]],
Cell[CellGroupData[{
Cell[5286, 165, 112, 0, 57, "Subsection",ExpressionUUID->"9a5c0737-9fb6-4682-a6e6-0497184f6d29"],
Cell[5401, 167, 472, 9, 90, "Input",ExpressionUUID->"1e4bd474-bba2-4078-b1ea-1dd6ea250488"],
Cell[5876, 178, 401, 8, 90, "Input",ExpressionUUID->"982f350e-f214-4393-9ff3-f5b3a83ce4fe"],
Cell[6280, 188, 377, 7, 37, "Input",ExpressionUUID->"331f4185-65d0-489f-9097-09cb77a42427"],
Cell[6660, 197, 318, 7, 37, "Input",ExpressionUUID->"87ae0717-14f1-41d5-9129-db0f61fa088a"],
Cell[6981, 206, 717, 16, 116, "Input",ExpressionUUID->"db6bc509-23c1-4866-b7c6-29c94442853b"],
Cell[7701, 224, 564, 11, 116, "Input",ExpressionUUID->"a5c4ef77-f7f9-4c6e-bcb8-761647a9e077"],
Cell[8268, 237, 382, 7, 90, "Input",ExpressionUUID->"5b57d90c-696d-4d78-a780-970288bf281f"]
}, Closed]],
Cell[8665, 247, 84, 0, 57, "Subsection",ExpressionUUID->"ac4506b0-7ec5-41c6-bd29-2a8330c60aaa"],
Cell[CellGroupData[{
Cell[8774, 251, 92, 0, 57, "Subsection",ExpressionUUID->"b7d20c9b-8922-47bd-a3ba-34af605d5d9b"],
Cell[8869, 253, 171, 3, 40, "Input",ExpressionUUID->"849b28f6-aa14-4bf4-ae05-90e40bdbb11b"]
}, Closed]],
Cell[CellGroupData[{
Cell[9077, 261, 118, 0, 57, "Subsection",ExpressionUUID->"3d9da3c0-32c3-4c87-9d4b-bd853aa64c96"],
Cell[9198, 263, 493, 13, 37, "Input",ExpressionUUID->"98a4742c-fb38-4f4d-9cc0-c4e07680f407"],
Cell[9694, 278, 1260, 34, 168, "Input",ExpressionUUID->"e08a8bb6-5304-47c5-8649-71372f6cf03c"],
Cell[10957, 314, 1180, 31, 168, "Input",ExpressionUUID->"9972b5eb-ff4f-497b-ba0c-38d54724d4fb"],
Cell[12140, 347, 306, 8, 37, "Input",ExpressionUUID->"fce425ed-7c7b-43e2-9deb-0d45775223f0"],
Cell[12449, 357, 768, 20, 116, "Input",ExpressionUUID->"0496c338-7487-4dd0-9b4d-f32b967cf61c"],
Cell[13220, 379, 425, 11, 37, "Input",ExpressionUUID->"90599a5a-0781-4dd4-9d17-e988d3ebdf97"],
Cell[13648, 392, 1035, 28, 116, "Input",ExpressionUUID->"87b9527a-8d9c-4a44-9d98-66ff85c0f1f6"]
}, Closed]],
Cell[CellGroupData[{
Cell[14720, 425, 96, 0, 57, "Subsection",ExpressionUUID->"f6f06ef9-f5c6-43b6-8659-40025f2421eb"],
Cell[14819, 427, 148, 3, 40, "Input",ExpressionUUID->"5af31875-3502-40c7-89e7-9e2abdcc4bad"]
}, Closed]],
Cell[CellGroupData[{
Cell[15004, 435, 87, 0, 57, "Subsection",ExpressionUUID->"7519dfdc-bad4-4c44-9d95-2e39bc798dc7"],
Cell[15094, 437, 162, 3, 40, "Input",ExpressionUUID->"d003876f-2b5e-41cc-b9e8-6fc03cfb59de"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[15305, 446, 82, 0, 105, "Section",ExpressionUUID->"50e56217-5516-49f7-8b3c-ea6cbc61e470"],
Cell[CellGroupData[{
Cell[15412, 450, 89, 0, 84, "Subsection",ExpressionUUID->"9495c679-6884-4491-8a4a-0d7791a7785f"],
Cell[15504, 452, 92, 0, 55, "Text",ExpressionUUID->"d22593a1-24bc-473a-8ef2-374de7cabc16"],
Cell[15599, 454, 109, 1, 47, "Input",ExpressionUUID->"17c94c27-d41c-4d9b-9485-5f4193180975"],
Cell[15711, 457, 265, 6, 55, "Text",ExpressionUUID->"f524ec49-55e9-4c3c-9a18-7f4c363732f4"],
Cell[15979, 465, 126, 2, 47, "Input",ExpressionUUID->"d927125a-fd28-4fdf-bcbf-f671d8ef92f2"]
}, Closed]],
Cell[CellGroupData[{
Cell[16142, 472, 96, 0, 84, "Subsection",ExpressionUUID->"e967bbf6-3d77-4440-9687-ab439dafee37"],
Cell[16241, 474, 131, 2, 47, "Input",ExpressionUUID->"6ee1f501-9154-4da0-aa5f-63f54bbddfda"],
Cell[16375, 478, 129, 2, 47, "Input",ExpressionUUID->"38165872-643b-4c3c-a7a7-10b02b41a511"],
Cell[16507, 482, 128, 2, 47, "Input",ExpressionUUID->"76571a98-54c5-4679-831a-2d7768c8ffa1"],
Cell[16638, 486, 210, 6, 55, "Text",ExpressionUUID->"c2e3a9dd-1535-4e5a-8bda-26a0788060d1"],
Cell[16851, 494, 133, 2, 47, "Input",ExpressionUUID->"c496b22f-20e7-40ea-abb3-b243776eca53"],
Cell[16987, 498, 196, 6, 55, "Text",ExpressionUUID->"1fc23e13-8326-4355-8566-23c53324f04a"],
Cell[17186, 506, 133, 2, 47, "Input",ExpressionUUID->"becf0173-8637-47ba-a2c6-0a1ff56136e5"],
Cell[17322, 510, 133, 2, 47, "Input",ExpressionUUID->"5bd70210-a67a-47ec-84b4-7f07c262a61a"],
Cell[17458, 514, 134, 2, 47, "Input",ExpressionUUID->"c37cfb0a-6df8-4156-b5cd-67429916c7a8"]
}, Closed]],
Cell[CellGroupData[{
Cell[17629, 521, 111, 0, 84, "Subsection",ExpressionUUID->"6fc61788-7c70-44cd-b9a9-7a73a3296e83"],
Cell[CellGroupData[{
Cell[17765, 525, 89, 0, 71, "Subsubsection",ExpressionUUID->"caea03dd-c099-4f2a-8758-1b9768787b34"],
Cell[17857, 527, 335, 8, 80, "Input",ExpressionUUID->"8418e7ad-03dc-4b40-a773-1d508d75f899"],
Cell[18195, 537, 284, 7, 47, "Input",ExpressionUUID->"fb2134ec-a1f2-4403-9bf0-ec1c2a7555bb"]
}, Closed]],
Cell[CellGroupData[{
Cell[18516, 549, 87, 0, 71, "Subsubsection",ExpressionUUID->"9b6df16d-814f-4774-9461-e08b6fe1bf63"],
Cell[18606, 551, 288, 8, 47, "Input",ExpressionUUID->"8948152d-4940-40ee-9ad3-ad0fc3612929"]
}, Closed]],
Cell[CellGroupData[{
Cell[18931, 564, 86, 0, 71, "Subsubsection",ExpressionUUID->"bd41e01d-37b9-451e-8628-f65f6bba7bcb"],
Cell[19020, 566, 297, 7, 80, "Input",ExpressionUUID->"9bc03e2b-56ff-4326-b54c-e7634c0a7d95"],
Cell[19320, 575, 377, 9, 112, "Input",ExpressionUUID->"4cb34623-0bdb-4cc4-9d9a-18f7d6d6a090"],
Cell[19700, 586, 331, 8, 80, "Input",ExpressionUUID->"8c1dedb7-dc56-4db6-acc3-3f07461e617f"],
Cell[20034, 596, 194, 4, 47, "Input",ExpressionUUID->"1edcf77f-1436-4d9f-a5c2-950c535d8655"]
}, Closed]],
Cell[CellGroupData[{
Cell[20265, 605, 91, 0, 71, "Subsubsection",ExpressionUUID->"84b1a8af-a950-4f87-879b-bf627acdfccb"],
Cell[20359, 607, 391, 8, 144, "Input",ExpressionUUID->"046dd450-2d78-4412-84c2-3c2ce7afb735"]
}, Closed]],
Cell[CellGroupData[{
Cell[20787, 620, 91, 0, 71, "Subsubsection",ExpressionUUID->"664b0974-73f8-4b47-9fda-85c8a7f1a2ae"],
Cell[20881, 622, 143, 2, 47, "Input",ExpressionUUID->"73e26cf7-8bd3-4806-999c-65fca52b8fa8"],
Cell[21027, 626, 178, 3, 47, "Input",ExpressionUUID->"be8dd0b0-7b32-4dfb-b00a-796bf8140631"]
}, Closed]],
Cell[CellGroupData[{
Cell[21242, 634, 92, 0, 71, "Subsubsection",ExpressionUUID->"61591d29-01a3-4116-be12-ab96f595f83c"],
Cell[21337, 636, 178, 3, 47, "Input",ExpressionUUID->"1b094381-ee6b-47a9-89ce-0a8f84bb78e7"]
}, Closed]]
}, Closed]]
}, Closed]]
}
]
*)

