(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     25300,        662]
NotebookOptionsPosition[     17539,        533]
NotebookOutlinePosition[     18457,        562]
CellTagsIndexPosition[     18380,        557]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["EPM`Optimization`", "Section",
 InitializationGroup->
  True,ExpressionUUID->"535d16e1-60f0-4dbc-a877-61b9dd647d6b"],

Cell[TextData[{
 StyleBox["From",
  FontWeight->"Bold"],
 ": ",
 StyleBox["Essentials of Programming in Mathematica\n",
  FontSlant->"Italic"],
 "\[Copyright] Paul R. Wellin 2015"
}], "Text",
 CellMargins->{{28, 10}, {7, 7}},
 FontSize->14,ExpressionUUID->"dd395b1b-a536-4615-9306-6f0efeab8d1e"],

Cell[CellGroupData[{

Cell["Metadata", "Subsection",ExpressionUUID->"fec269f3-834f-40cc-b786-110793f6ffac"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Name", ":", " ", "EPM`Optimization`"}], " ", "*)"}]], "Input",\
ExpressionUUID->"ecd58d32-3f11-4f91-b7f9-a80c60e624da"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Book", ":", " ", 
   RowBox[{
   "Essentials", " ", "of", " ", "Programming", " ", "in", " ", 
    "Mathematica"}]}], " ", "*)"}]], "Input",ExpressionUUID->"0f32a8d1-c04d-\
4028-b792-b33b8e9f8fe9"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Paul", " ", "Wellin"}]}]}], " ", "*)"}]], "Input",ExpressionUUID->\
"68969746-1fe5-4b27-9a59-05266dfa8922"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", "Summary", ":", " ", 
    RowBox[{
    "This", " ", "package", " ", "contains", " ", "the", " ", "functions", 
     " ", "defined", " ", "in", " ", "Chapter", " ", "9"}]}], ",", " ", 
   RowBox[{"Optimizing", " ", "Mathematica", " ", 
    RowBox[{"programs", "."}]}]}], " ", "*)"}]], "Input",ExpressionUUID->\
"6c4295cc-f4aa-4940-b7fd-cab82884aa3f"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Context", ":", " ", "EPM`Optimization`"}], " ", 
  "*)"}]], "Input",ExpressionUUID->"c3af74ac-b35c-4bda-be9d-b2145dd59709"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", 
    RowBox[{"Version", ":", " ", "1.0"}]}]}], " ", "*)"}]], "Input",Expression\
UUID->"071abee6-88e6-436a-a79a-00a5247b5c0a"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", "Copyright", ":", " ", 
    RowBox[{"Copyright", " ", "2015"}]}], ",", " ", 
   RowBox[{"Paul", " ", "R", " ", "Wellin"}]}], " ", "*)"}]], "Input",Expressi\
onUUID->"e43a39d9-88e0-49fc-9c09-446259981f05"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{
     "Version", " ", "1.0", " ", "by", " ", "Paul", " ", "Wellin"}]}]}], ",", 
   " ", 
   RowBox[{"Dec", " ", "2012"}]}], " ", "*)"}]], "Input",ExpressionUUID->\
"05058690-75e0-4131-a5d3-119bf9bfb4cf"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Keywords", ":", " ", "timing"}]}], ",", " ", "blanagrams", ",", 
   " ", 
   RowBox[{"Mandebrot", " ", "set"}], ",", " ", 
   RowBox[{"sieving", " ", "algorithms"}]}], " ", "*)"}]], "Input",ExpressionU\
UID->"4c062062-2faf-48b2-ba5b-d43c54fe4b08"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Source", ":", " ", 
   RowBox[{"Optimization", ".", "nb"}]}], " ", "*)"}]], "Input",ExpressionUUID\
->"a1285434-b074-433d-bb91-fa5a410d1f86"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", "Version"}], ":", " ", "10.3"}], " ", 
  "*)"}]], "Input",ExpressionUUID->"b9a2ed77-b459-49da-b4fb-88512d9d9e63"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Tested", " ", "in", " ", "Mathematica", " ", "11.1"}], " ", 
  "*)"}]], "Input",ExpressionUUID->"96b8a861-1592-4409-95e4-2ee9ec2d9508"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Tested", " ", "in", " ", "Mathematica", " ", "12.0"}], ",", " ", 
   RowBox[{"Feb", " ", "2019"}]}], " ", "*)"}]], "Input",ExpressionUUID->\
"711d4e95-7354-4064-a263-faacb385a733"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Tested", " ", "in", " ", "Mathematica", " ", "13.2"}], ",", " ", 
   RowBox[{"Aug", " ", "2023"}]}], " ", "*)"}]], "Input",ExpressionUUID->\
"035c10d4-1cf0-4498-aa30-01c0d5a4e74b"]
}, Closed]],

Cell[CellGroupData[{

Cell["BeginPackage", "Subsection",ExpressionUUID->"036e38ac-150a-4795-807a-703f14072741"],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{
  "AverageTiming", ",", "BlanagramsParallel", ",", "Mandelbrot", ",", 
   "Sieve"}], "]"}]], "Input",ExpressionUUID->"6f5b9363-e7c5-4764-804a-\
9fc6b7c7802e"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"BeginPackage", "[", 
   RowBox[{"\"\<EPM`Optimization`\>\"", ",", " ", 
    RowBox[{"{", "\"\<EPM`Strings`\>\"", "}"}]}], "]"}], " ", "*)"}]], "Input",\
ExpressionUUID->"fa358544-c095-47cb-b23b-6e1f5a1997f3"]
}, Closed]],

Cell[CellGroupData[{

Cell["Usage messages for public functions", "Subsection",ExpressionUUID->"ce755cd3-634d-4551-acfe-64f2d2a6dbab"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AverageTiming", "::", "usage"}], "=", 
   "\"\<AverageTiming[\!\(\*StyleBox[\"expr\", \"TI\"]\), \
\!\(\*StyleBox[\"trials\", \"TI\"]\)] evaluates \!\(\*StyleBox[\"expr\", \"TI\
\"]\) a number of times given by \!\(\*StyleBox[\"trials\", \"TI\"]\) and \
averages the evaluation timings.\>\""}], ";"}]], "Input",ExpressionUUID->\
"d9edd10c-1fd5-4db9-9e64-236ca08a12e3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BlanagramsParallel", "::", "usage"}], "=", 
   "\"\<BlanagramsParallel[\\\"\!\(\*StyleBox[\"word\", \"TI\"]\)\\\"] finds \
all blanagrams of the string, \!\(\*StyleBox[\"word\", \"TI\"]\), running the \
computation in parallel. It requires the package EPM`09Strings` to be \
installed.\>\""}], ";"}]], "Input",ExpressionUUID->"dbaf0d96-6a6e-4d56-be79-\
bb42262bd128"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Mandelbrot", "::", "usage"}], "=", 
   "\"\<Mandelbrot[\!\(\*StyleBox[\"c\", \"TI\"]\)] iterates the function \
\!\(\*SuperscriptBox[StyleBox[\"z\", \"TI\"], \"2\"]\) + \
\!\(\*StyleBox[\"c\", \"TI\"]\) until its absolute value is greater than two. \
It returns the length of the iteration; if unbounded, it returns the \
iteration limit, which is, by default, equal to 250.\>\""}], ";"}]], "Input",E\
xpressionUUID->"af94fc9f-b2eb-4b35-be4c-ef9289a1f31a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Sieve", "::", "usage"}], "=", 
   "\"\<Sieve[\!\(\*StyleBox[\"n\", \"TI\"]\)] uses a sieving algorithm due \
to Eratosthenes to find all prime numbers less than \!\(\*StyleBox[\"n\", \
\"TI\"]\).\>\""}], ";"}]], "Input",ExpressionUUID->"25250e32-c4e1-4ce6-ad37-\
d39e9f0258af"]
}, Closed]],

Cell["Options", "Subsection",ExpressionUUID->"d41879d6-12b1-4189-a31c-a1edf1d0045d"],

Cell[CellGroupData[{

Cell["Private context", "Subsection",ExpressionUUID->"f558d9ab-4989-445c-9569-b48502543ed2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}], ";"}]], "Input",Expression\
UUID->"36ed9448-9969-40fd-91eb-dade983b82fb"]
}, Closed]],

Cell[CellGroupData[{

Cell["Function definitions (public and private)", "Subsection",ExpressionUUID->"c773f2b7-c70b-4587-8ae5-26a23b485391"],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"AverageTiming", ",", "HoldAll"}], "]"}]], "Input",ExpressionUUID->\
"219c9166-1a4e-4f37-8fec-97f1320b1ad5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"AverageTiming", "[", 
   RowBox[{"expr_", ",", "trials_"}], "]"}], ":=", 
  RowBox[{"Mean", "[", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"First", "[", 
      RowBox[{"AbsoluteTiming", "[", "expr", "]"}], "]"}], ",", 
     RowBox[{"{", "trials", "}"}]}], "]"}], "]"}]}]], "Input",ExpressionUUID->\
"77d77dd5-3150-49f0-bb22-0c681e14a5f2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BlanagramsParallel", "[", "word_String", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "blana", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ParallelNeeds", "[", "\"\<EPM`\>\"", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"blana", "=", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"StringReplacePart", "[", 
            RowBox[{"word", ",", "ch", ",", 
             RowBox[{"{", 
              RowBox[{"#", ",", "#"}], "}"}]}], "]"}], "&"}], ",", 
          RowBox[{"Range", "[", 
           RowBox[{"StringLength", "[", "word", "]"}], "]"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"ch", ",", 
          RowBox[{"CharacterRange", "[", 
           RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}]}], "}"}]}], "]"}]}],
      ";", "\[IndentingNewLine]", 
     RowBox[{"DeleteDuplicates", "@", 
      RowBox[{"Flatten", "[", 
       RowBox[{"ParallelMap", "[", 
        RowBox[{"EPM`Anagrams", ",", "blana", ",", 
         RowBox[{"{", "2", "}"}]}], "]"}], "]"}]}]}]}], "\[IndentingNewLine]",
    "]"}]}]], "Input",ExpressionUUID->"54088119-9359-4c2f-b228-1a68e37b2f7e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Mandelbrot", "[", 
   RowBox[{"c_Complex", ",", 
    RowBox[{"iter_", ":", "250"}]}], "]"}], ":=", 
  RowBox[{"Length", "[", 
   RowBox[{"NestWhileList", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"#", "^", "2"}], "+", "c"}], "&"}], ",", "0", ",", 
     RowBox[{
      RowBox[{
       RowBox[{"Abs", "[", "#", "]"}], "<", "2"}], "&"}], ",", "1", ",", 
     "iter"}], "]"}], "]"}]}]], "Input", "ExerciseMR",
 CellTags->
  "12.3 Exercises",ExpressionUUID->"3f6d3c7f-b66e-4f70-96ff-e7b7cac2ff10"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Sieve", "[", "n_Integer", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"ints", "=", 
      RowBox[{"Range", "[", "n", "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ints", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"2", " ", "p"}], ";;", 
           RowBox[{"-", "1"}], ";;", "p"}], "]"}], "]"}], "=", "1"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"p", ",", "2", ",", 
         SqrtBox["n"]}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"DeleteCases", "[", 
      RowBox[{"ints", ",", "1"}], "]"}]}]}], "]"}]}]], "Input",ExpressionUUID->\
"b4ecf1bf-d9ef-477f-b48c-d82d8a70807a"]
}, Closed]],

Cell[CellGroupData[{

Cell["End private context", "Subsection",ExpressionUUID->"0b0edea9-6686-4084-9d10-2a05bc4a048a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"End", "[", "]"}], ";"}]], "Input",ExpressionUUID->"0fd95d55-51d1-4428-a587-32c6dd934f78"]
}, Closed]],

Cell[CellGroupData[{

Cell["EndPackage", "Subsection",ExpressionUUID->"596416c9-6036-4c26-b839-654fee14512e"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"EndPackage", "[", "]"}], "*)"}]], "Input",ExpressionUUID->\
"988c443b-5b23-4226-b5cc-b0c58ce57bf5"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Examples", "Section",ExpressionUUID->"07f580da-92c7-4325-aaec-29984997547d"],

Cell[CellGroupData[{

Cell["Load package", "Subsection",ExpressionUUID->"7f3ebba5-20a3-42a4-b1d6-3490faa94ac9"],

Cell["Quit current session:", "Text",ExpressionUUID->"50cc34e2-9614-49cb-8a51-2c932dc73434"],

Cell[BoxData["Quit"], "Input",ExpressionUUID->"75e977d6-65b4-4a21-8c3b-61e133be6670"],

Cell[TextData[{
 "Load package (do ",
 StyleBox["not",
  FontSlant->"Italic"],
 " say \[OpenCurlyDoubleQuote]Yes\[CloseCurlyDoubleQuote] to dialog asking to \
evaluate init cells in this notebook)."
}], "Text",ExpressionUUID->"8ac33baf-fbb7-482e-b789-761b7ae2a37d"],

Cell[BoxData[
 RowBox[{"<<", "EPM`"}]], "Input",ExpressionUUID->"7a01049d-655d-4e0a-aff0-8e46ad6d02ae"]
}, Closed]],

Cell[CellGroupData[{

Cell["Test usage messages", "Subsection",ExpressionUUID->"4281aa7e-ab39-445d-b211-2b31ae57d312"],

Cell[BoxData[
 RowBox[{"?", "AverageTiming"}]], "Input",
 CellLabel->"In[66]:=",ExpressionUUID->"b26b09c9-9847-4903-8283-01e108c5ea84"],

Cell[BoxData[
 RowBox[{"?", "BlanagramsParallel"}]], "Input",
 CellLabel->"In[67]:=",ExpressionUUID->"94f07fbc-a142-4807-8e4f-e13ee9c3bf9d"],

Cell[BoxData[
 RowBox[{"?", "Mandelbrot"}]], "Input",
 CellLabel->"In[68]:=",ExpressionUUID->"483979b4-edd3-4085-b57f-d5a8edac0efd"],

Cell[BoxData[
 RowBox[{"?", "Sieve"}]], "Input",
 CellLabel->"In[69]:=",ExpressionUUID->"47fb26fc-cf79-477d-b411-16dfce99f252"]
}, Closed]],

Cell[CellGroupData[{

Cell["Exercise the functions and options", "Subsection",ExpressionUUID->"cd35cf77-c5e9-4357-a780-e977f5f8af83"],

Cell[CellGroupData[{

Cell["AverageTiming", "Subsubsection",ExpressionUUID->"9c81666d-5353-401f-b394-56a3f8c0332b"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"mat", "=", 
   RowBox[{"RandomReal", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"1000", ",", "1000"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"AbsoluteTiming", "[", 
  RowBox[{
   RowBox[{"mat", ".", "mat"}], ";"}], "]"}]}], "Input",
 CellLabel->"In[70]:=",ExpressionUUID->"f1d7eff9-8294-4766-8876-0a4a4a5b7a1b"],

Cell[BoxData[
 RowBox[{"AverageTiming", "[", 
  RowBox[{
   RowBox[{"mat", ".", "mat"}], ",", "5"}], "]"}]], "Input",
 CellLabel->"In[72]:=",ExpressionUUID->"0ff7845c-f3cf-42de-b41e-43a37b0a20d5"],

Cell["\<\
For a compound expression, you can either enclose the subexpressions in a \
list or separate them with semicolons.\
\>", "Text",ExpressionUUID->"900f7b7b-91f9-4b90-ab91-1ace6dcc865e"],

Cell[BoxData[
 RowBox[{"AverageTiming", "[", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"mat", ".", "mat"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Inverse", "[", "mat", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Det", "[", "mat", "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
   "3"}], "]"}]], "Input",
 CellLabel->"In[73]:=",ExpressionUUID->"421d45a8-9967-4b5f-86cf-774fb07ee9d4"],

Cell[BoxData[
 RowBox[{"AverageTiming", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"mat", ".", "mat"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Inverse", "[", "mat", "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Det", "[", "mat", "]"}], ";"}], ",", "\[IndentingNewLine]", 
   "3"}], "]"}]], "Input",
 CellLabel->"In[74]:=",ExpressionUUID->"04287fe0-6473-4584-bfab-334c56a676d1"]
}, Closed]],

Cell[CellGroupData[{

Cell["BlanagramsParallel", "Subsubsection",ExpressionUUID->"48bf177a-1673-4647-9986-4aa0c7ad1912"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BlanagramsParallel", "[", "\"\<strand\>\"", "]"}], "//", 
  "AbsoluteTiming"}]], "Input",
 CellLabel->"In[75]:=",ExpressionUUID->"e9fc0309-d88d-4102-8c78-6513d20c9b08"]
}, Closed]],

Cell[CellGroupData[{

Cell["Mandelbrot", "Subsubsection",ExpressionUUID->"17803fba-e5bd-47ff-bb30-8d48734cfd0b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n", "=", "200"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Mandelbrot", "[", 
        RowBox[{"x", "+", 
         RowBox[{"I", " ", "y"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"y", ",", 
         RowBox[{"-", "0.5"}], ",", "0.5", ",", 
         FractionBox["1", "n"]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"-", "1.75"}], ",", 
         RowBox[{"-", "0.75"}], ",", 
         FractionBox["1", "n"]}], "}"}]}], "]"}]}], "]"}]}], ";"}]], "Input", \
"ExerciseMR",
 CellTags->"12.3 Exercises",
 CellLabel->"In[76]:=",ExpressionUUID->"1fcab0f6-f084-418f-993d-9727e73e4e6d"],

Cell[BoxData[
 RowBox[{"ArrayPlot", "[", 
  RowBox[{"data", ",", 
   RowBox[{"ColorFunction", "\[Rule]", "\"\<GreenPinkTones\>\""}]}], 
  "]"}]], "Input", "ExerciseMR",
 CellTags->"12.3 Exercises",
 CellLabel->"In[77]:=",ExpressionUUID->"446c895d-ae19-46cf-a1bd-315e48c86c59"]
}, Closed]],

Cell[CellGroupData[{

Cell["Sieve", "Subsubsection",ExpressionUUID->"4178c4c5-375c-4f22-92a7-a3366f4eb43e"],

Cell[BoxData[
 RowBox[{"Sieve", "[", "100", "]"}]], "Input",
 CellLabel->"In[78]:=",ExpressionUUID->"9c10f7da-b144-4419-a113-ed5d83bbf713"],

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{
   RowBox[{"Sieve", "[", 
    SuperscriptBox["10", "6"], "]"}], ";"}], "]"}]], "Input",
 CellLabel->"In[79]:=",ExpressionUUID->"9c3a56d0-6ed4-4e9f-853e-61423478df02"],

Cell["Check against built-in functions:", "Text",ExpressionUUID->"807fd0bd-9899-409e-b212-35b9bd8e7c60"],

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{
   RowBox[{"Map", "[", 
    RowBox[{"Prime", ",", 
     RowBox[{"Range", "@", 
      RowBox[{"PrimePi", "[", 
       SuperscriptBox["10", "6"], "]"}]}]}], "]"}], ";"}], "]"}]], "Input",
 CellLabel->"In[80]:=",ExpressionUUID->"a976b2ed-cddd-4c1a-99bf-75867952727e"],

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"n", "=", 
     SuperscriptBox["10", "6"]}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Sieve", "[", "n", "]"}], "==", 
    RowBox[{"Map", "[", 
     RowBox[{"Prime", ",", 
      RowBox[{"Range", "@", 
       RowBox[{"PrimePi", "[", "n", "]"}]}]}], "]"}]}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",
 CellLabel->"In[81]:=",ExpressionUUID->"2ccadfee-b42e-49cd-9658-561e150689ed"]
}, Closed]]
}, Closed]]
}, Closed]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{969, 817},
WindowMargins->{{48, Automatic}, {Automatic, 27}},
ShowSelection->True,
Magnification:>1.25 Inherited,
FrontEndVersion->"13.3 for Mac OS X ARM (64-bit) (July 24, 2023)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"2430f2c4-c309-4942-b29b-07a030a8f1ee"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "12.3 Exercises"->{
  Cell[9308, 276, 548, 16, 70, "Input",ExpressionUUID->"3f6d3c7f-b66e-4f70-96ff-e7b7cac2ff10",
   CellTags->"12.3 Exercises"],
  Cell[15037, 454, 797, 23, 175, "Input",ExpressionUUID->"1fcab0f6-f084-418f-993d-9727e73e4e6d",
   CellTags->"12.3 Exercises"],
  Cell[15837, 479, 276, 6, 47, "Input",ExpressionUUID->"446c895d-ae19-46cf-a1bd-315e48c86c59",
   CellTags->"12.3 Exercises"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"12.3 Exercises", 17973, 547}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 122, 2, 105, "Section",ExpressionUUID->"535d16e1-60f0-4dbc-a877-61b9dd647d6b",
 InitializationGroup->True],
Cell[704, 26, 295, 9, 83, "Text",ExpressionUUID->"dd395b1b-a536-4615-9306-6f0efeab8d1e"],
Cell[CellGroupData[{
Cell[1024, 39, 85, 0, 84, "Subsection",ExpressionUUID->"fec269f3-834f-40cc-b786-110793f6ffac"],
Cell[1112, 41, 170, 3, 47, "Input",ExpressionUUID->"ecd58d32-3f11-4f91-b7f9-a80c60e624da"],
Cell[1285, 46, 248, 6, 47, "Input",ExpressionUUID->"0f32a8d1-c04d-4028-b792-b33b8e9f8fe9"],
Cell[1536, 54, 203, 5, 47, "Input",ExpressionUUID->"68969746-1fe5-4b27-9a59-05266dfa8922"],
Cell[1742, 61, 411, 9, 80, "Input",ExpressionUUID->"6c4295cc-f4aa-4940-b7fd-cab82884aa3f"],
Cell[2156, 72, 174, 3, 47, "Input",ExpressionUUID->"c3af74ac-b35c-4bda-be9d-b2145dd59709"],
Cell[2333, 77, 204, 5, 47, "Input",ExpressionUUID->"071abee6-88e6-436a-a79a-00a5247b5c0a"],
Cell[2540, 84, 266, 6, 47, "Input",ExpressionUUID->"e43a39d9-88e0-49fc-9c09-446259981f05"],
Cell[2809, 92, 313, 9, 47, "Input",ExpressionUUID->"05058690-75e0-4131-a5d3-119bf9bfb4cf"],
Cell[3125, 103, 323, 8, 80, "Input",ExpressionUUID->"4c062062-2faf-48b2-ba5b-d43c54fe4b08"],
Cell[3451, 113, 192, 4, 47, "Input",ExpressionUUID->"a1285434-b074-433d-bb91-fa5a410d1f86"],
Cell[3646, 119, 195, 4, 47, "Input",ExpressionUUID->"b9a2ed77-b459-49da-b4fb-88512d9d9e63"],
Cell[3844, 125, 181, 3, 47, "Input",ExpressionUUID->"96b8a861-1592-4409-95e4-2ee9ec2d9508"],
Cell[4028, 130, 238, 5, 47, "Input",ExpressionUUID->"711d4e95-7354-4064-a263-faacb385a733"],
Cell[4269, 137, 238, 5, 47, "Input",ExpressionUUID->"035c10d4-1cf0-4498-aa30-01c0d5a4e74b"]
}, Closed]],
Cell[CellGroupData[{
Cell[4544, 147, 89, 0, 57, "Subsection",ExpressionUUID->"036e38ac-150a-4795-807a-703f14072741"],
Cell[4636, 149, 208, 5, 50, "Input",ExpressionUUID->"6f5b9363-e7c5-4764-804a-9fc6b7c7802e"],
Cell[4847, 156, 254, 5, 50, "Input",ExpressionUUID->"fa358544-c095-47cb-b23b-6e1f5a1997f3"]
}, Closed]],
Cell[CellGroupData[{
Cell[5138, 166, 112, 0, 57, "Subsection",ExpressionUUID->"ce755cd3-634d-4551-acfe-64f2d2a6dbab"],
Cell[5253, 168, 415, 8, 90, "Input",ExpressionUUID->"d9edd10c-1fd5-4db9-9e64-236ca08a12e3"],
Cell[5671, 178, 414, 8, 116, "Input",ExpressionUUID->"dbaf0d96-6a6e-4d56-be79-bb42262bd128"],
Cell[6088, 188, 503, 9, 142, "Input",ExpressionUUID->"af94fc9f-b2eb-4b35-be4c-ef9289a1f31a"],
Cell[6594, 199, 324, 7, 90, "Input",ExpressionUUID->"25250e32-c4e1-4ce6-ad37-d39e9f0258af"]
}, Closed]],
Cell[6933, 209, 84, 0, 57, "Subsection",ExpressionUUID->"d41879d6-12b1-4189-a31c-a1edf1d0045d"],
Cell[CellGroupData[{
Cell[7042, 213, 92, 0, 57, "Subsection",ExpressionUUID->"f558d9ab-4989-445c-9569-b48502543ed2"],
Cell[7137, 215, 149, 3, 40, "Input",ExpressionUUID->"36ed9448-9969-40fd-91eb-dade983b82fb"]
}, Closed]],
Cell[CellGroupData[{
Cell[7323, 223, 118, 0, 57, "Subsection",ExpressionUUID->"c773f2b7-c70b-4587-8ae5-26a23b485391"],
Cell[7444, 225, 164, 3, 42, "Input",ExpressionUUID->"219c9166-1a4e-4f37-8fec-97f1320b1ad5"],
Cell[7611, 230, 384, 10, 42, "Input",ExpressionUUID->"77d77dd5-3150-49f0-bb22-0c681e14a5f2"],
Cell[7998, 242, 1307, 32, 202, "Input",ExpressionUUID->"54088119-9359-4c2f-b228-1a68e37b2f7e"],
Cell[9308, 276, 548, 16, 70, "Input",ExpressionUUID->"3f6d3c7f-b66e-4f70-96ff-e7b7cac2ff10",
 CellTags->"12.3 Exercises"],
Cell[9859, 294, 809, 23, 190, "Input",ExpressionUUID->"b4ecf1bf-d9ef-477f-b48c-d82d8a70807a"]
}, Closed]],
Cell[CellGroupData[{
Cell[10705, 322, 96, 0, 57, "Subsection",ExpressionUUID->"0b0edea9-6686-4084-9d10-2a05bc4a048a"],
Cell[10804, 324, 124, 2, 40, "Input",ExpressionUUID->"0fd95d55-51d1-4428-a587-32c6dd934f78"]
}, Closed]],
Cell[CellGroupData[{
Cell[10965, 331, 87, 0, 57, "Subsection",ExpressionUUID->"596416c9-6036-4c26-b839-654fee14512e"],
Cell[11055, 333, 140, 3, 55, "Input",ExpressionUUID->"988c443b-5b23-4226-b5cc-b0c58ce57bf5"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[11244, 342, 82, 0, 105, "Section",ExpressionUUID->"07f580da-92c7-4325-aaec-29984997547d"],
Cell[CellGroupData[{
Cell[11351, 346, 89, 0, 84, "Subsection",ExpressionUUID->"7f3ebba5-20a3-42a4-b1d6-3490faa94ac9"],
Cell[11443, 348, 92, 0, 55, "Text",ExpressionUUID->"50cc34e2-9614-49cb-8a51-2c932dc73434"],
Cell[11538, 350, 85, 0, 47, "Input",ExpressionUUID->"75e977d6-65b4-4a21-8c3b-61e133be6670"],
Cell[11626, 352, 265, 6, 91, "Text",ExpressionUUID->"8ac33baf-fbb7-482e-b789-761b7ae2a37d"],
Cell[11894, 360, 103, 1, 47, "Input",ExpressionUUID->"7a01049d-655d-4e0a-aff0-8e46ad6d02ae"]
}, Closed]],
Cell[CellGroupData[{
Cell[12034, 366, 96, 0, 84, "Subsection",ExpressionUUID->"4281aa7e-ab39-445d-b211-2b31ae57d312"],
Cell[12133, 368, 135, 2, 47, "Input",ExpressionUUID->"b26b09c9-9847-4903-8283-01e108c5ea84"],
Cell[12271, 372, 140, 2, 47, "Input",ExpressionUUID->"94f07fbc-a142-4807-8e4f-e13ee9c3bf9d"],
Cell[12414, 376, 132, 2, 47, "Input",ExpressionUUID->"483979b4-edd3-4085-b57f-d5a8edac0efd"],
Cell[12549, 380, 127, 2, 47, "Input",ExpressionUUID->"47fb26fc-cf79-477d-b411-16dfce99f252"]
}, Closed]],
Cell[CellGroupData[{
Cell[12713, 387, 111, 0, 84, "Subsection",ExpressionUUID->"cd35cf77-c5e9-4357-a780-e977f5f8af83"],
Cell[CellGroupData[{
Cell[12849, 391, 93, 0, 71, "Subsubsection",ExpressionUUID->"9c81666d-5353-401f-b394-56a3f8c0332b"],
Cell[12945, 393, 389, 11, 80, "Input",ExpressionUUID->"f1d7eff9-8294-4766-8876-0a4a4a5b7a1b"],
Cell[13337, 406, 196, 4, 47, "Input",ExpressionUUID->"0ff7845c-f3cf-42de-b41e-43a37b0a20d5"],
Cell[13536, 412, 193, 3, 91, "Text",ExpressionUUID->"900f7b7b-91f9-4b90-ab91-1ace6dcc865e"],
Cell[13732, 417, 427, 9, 176, "Input",ExpressionUUID->"421d45a8-9967-4b5f-86cf-774fb07ee9d4"],
Cell[14162, 428, 404, 8, 176, "Input",ExpressionUUID->"04287fe0-6473-4584-bfab-334c56a676d1"]
}, Closed]],
Cell[CellGroupData[{
Cell[14603, 441, 98, 0, 71, "Subsubsection",ExpressionUUID->"48bf177a-1673-4647-9986-4aa0c7ad1912"],
Cell[14704, 443, 203, 4, 47, "Input",ExpressionUUID->"e9fc0309-d88d-4102-8c78-6513d20c9b08"]
}, Closed]],
Cell[CellGroupData[{
Cell[14944, 452, 90, 0, 71, "Subsubsection",ExpressionUUID->"17803fba-e5bd-47ff-bb30-8d48734cfd0b"],
Cell[15037, 454, 797, 23, 175, "Input",ExpressionUUID->"1fcab0f6-f084-418f-993d-9727e73e4e6d",
 CellTags->"12.3 Exercises"],
Cell[15837, 479, 276, 6, 47, "Input",ExpressionUUID->"446c895d-ae19-46cf-a1bd-315e48c86c59",
 CellTags->"12.3 Exercises"]
}, Closed]],
Cell[CellGroupData[{
Cell[16150, 490, 85, 0, 71, "Subsubsection",ExpressionUUID->"4178c4c5-375c-4f22-92a7-a3366f4eb43e"],
Cell[16238, 492, 139, 2, 47, "Input",ExpressionUUID->"9c10f7da-b144-4419-a113-ed5d83bbf713"],
Cell[16380, 496, 216, 5, 51, "Input",ExpressionUUID->"9c3a56d0-6ed4-4e9f-853e-61423478df02"],
Cell[16599, 503, 104, 0, 55, "Text",ExpressionUUID->"807fd0bd-9899-409e-b212-35b9bd8e7c60"],
Cell[16706, 505, 314, 8, 51, "Input",ExpressionUUID->"a976b2ed-cddd-4c1a-99bf-75867952727e"],
Cell[17023, 515, 476, 13, 120, "Input",ExpressionUUID->"2ccadfee-b42e-49cd-9658-561e150689ed"]
}, Closed]]
}, Closed]]
}, Closed]]
}
]
*)

