(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     37500,        975]
NotebookOptionsPosition[     28470,        825]
NotebookOutlinePosition[     29663,        860]
CellTagsIndexPosition[     29565,        854]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["EPM`Patterns`", "Section",
 InitializationGroup->
  True,ExpressionUUID->"c94a21cb-3aba-448d-99e2-29813c50cc8b"],

Cell[TextData[{
 StyleBox["From",
  FontWeight->"Bold"],
 ": ",
 StyleBox["Essentials of Programming in Mathematica\n",
  FontSlant->"Italic"],
 "\[Copyright] Paul R. Wellin 2015"
}], "Text",
 CellMargins->{{28, 10}, {7, 7}},
 FontSize->14,ExpressionUUID->"6feaa97d-d1c7-4346-a1c5-9f261df2ea55"],

Cell[CellGroupData[{

Cell["Metadata", "Subsection",ExpressionUUID->"086f15bd-ebdf-4cbe-a271-eb7e9b08f7ef"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Name", ":", " ", "EPM`Patterns`"}], " ", "*)"}]], "Input",Expr\
essionUUID->"aa435e2d-3933-4421-aee3-f0b1487f5271"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Book", ":", " ", 
   RowBox[{
   "Essentials", " ", "of", " ", "Programming", " ", "in", " ", 
    "Mathematica"}]}], " ", "*)"}]], "Input",ExpressionUUID->"49335658-028b-\
4b97-a34c-3b4088dcb2f5"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Paul", " ", "Wellin"}]}]}], " ", "*)"}]], "Input",ExpressionUUID->\
"91d3a3f4-a19f-4dc7-9e9a-114cba80b384"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Summary", ":", " ", 
   RowBox[{
   "This", " ", "package", " ", "contains", " ", "the", " ", "functions", " ",
     "defined", " ", "in", " ", "Chapter", " ", "4", " ", "Patterns", " ", 
    "and", " ", 
    RowBox[{"rules", "."}]}]}], " ", "*)"}]], "Input",ExpressionUUID->\
"09c8a8e1-e149-4620-a8a1-a2537c8c7caa"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Context", ":", " ", "EPM`Patterns`"}], " ", "*)"}]], "Input",E\
xpressionUUID->"6e7b36fd-79f8-484a-84cb-db33fdf32d28"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", "Version"}], ":", " ", "1.1"}], " ", 
  "*)"}]], "Input",ExpressionUUID->"038495be-b44f-4da8-963a-8eb99211d5ae"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", "Copyright", ":", " ", 
    RowBox[{"Copyright", " ", "2015"}]}], ",", " ", 
   RowBox[{"Paul", " ", "R", " ", "Wellin"}]}], " ", "*)"}]], "Input",Expressi\
onUUID->"bc444255-131a-4ad7-9668-a116f2e6af4b"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{
    RowBox[{":", "History", ":", "\[IndentingNewLine]", "\t", 
     RowBox[{"Version", " ", "1.0", " ", "Dec", " ", "2012"}]}], ";", 
    "\[IndentingNewLine]", "\t", 
    RowBox[{"Version", " ", "1.1", " ", "Apr", " ", "2017"}]}], ",", " ", 
   RowBox[{
    RowBox[{"check", " ", "$VersionNumber", " ", "for", " ", "Perimeter"}], 
    ";"}]}], "\[IndentingNewLine]", " ", "*)"}]], "Input",ExpressionUUID->\
"23379a7f-967b-4f9d-9910-0e39a940652e"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Keywords", ":", " ", "dice"}]}], ",", " ", 
   RowBox[{"finding", " ", "subsequences"}], ",", " ", 
   RowBox[{"square", " ", "matrix"}], ",", " ", 
   RowBox[{"area", " ", "of", " ", "triangle"}], ",", " ", "perimeter"}], " ",
   "*)"}]], "Input",ExpressionUUID->"01c7ebfa-ec8a-471a-b1a1-50ae495b9d7a"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Source", ":", " ", 
   RowBox[{"Patterns", ".", "nb"}]}], " ", "*)"}]], "Input",ExpressionUUID->\
"f8fd5c7a-68cb-4553-a692-1943bfa26960"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", "Version"}], ":", " ", "10.3"}], " ", 
  "*)"}]], "Input",ExpressionUUID->"a0bce5c4-b43f-4d9b-9354-9412df3cb502"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Tested", " ", "in", " ", "Mathematica", " ", "11.1"}], " ", 
  "*)"}]], "Input",ExpressionUUID->"03b9e7c3-fc4d-48eb-a992-7aeab7e952ff"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Tested", " ", "in", " ", "Mathematica", " ", "12.0"}], ",", " ", 
   RowBox[{"Feb", " ", "2019"}]}], " ", "*)"}]], "Input",ExpressionUUID->\
"525b72b2-2298-4b19-ae3f-16bcdf7f464d"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Tested", " ", "in", " ", "Mathematica", " ", "13.2"}], ",", " ", 
   RowBox[{"Aug", " ", "2023"}]}], " ", "*)"}]], "Input",ExpressionUUID->\
"d1db429f-7c9a-47f4-af8d-2e7d96dde62e"]
}, Closed]],

Cell[CellGroupData[{

Cell["BeginPackage", "Subsection",ExpressionUUID->"14832385-07e7-4612-8ec4-a672fd61c504"],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{
  "Color", ",", "Dice", ",", "findSubsequence", ",", "FixArray", ",", 
   "SignedArea", ",", "perimeter", ",", "squareMatrixQ"}], "]"}]], "Input",Exp\
ressionUUID->"a2e607ba-4e6f-41ce-a51e-a1947c744c7e"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"BeginPackage", "[", "\"\<EPM`Patterns`\>\"", "]"}], " ", 
  "*)"}]], "Input",ExpressionUUID->"411063df-cce9-4e91-802d-7b0afd832737"]
}, Closed]],

Cell[CellGroupData[{

Cell["Usage messages for public functions", "Subsection",ExpressionUUID->"6b34136a-06ca-41e3-9657-5284641f432f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Color", "::", "usage"}], "=", 
   "\"\<Color is an option for Dice that specifies the background color. The \
default value is Darker@Blue.\>\""}], ";"}]], "Input",ExpressionUUID->\
"af0c6934-33d9-43f0-9c22-c54f532b2040"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Dice", "::", "usage"}], "=", 
   "\"\<Dice[\!\(\*StyleBox[\"n\", \"TI\"]\)] displays a regular six-sided \
die with value \!\(\*StyleBox[\"n\", \"TI\"]\).\>\""}], ";"}]], "Input",Expres\
sionUUID->"e98eb8c3-002c-425b-8332-f144d50ae5ae"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"findSubsequence", "::", "usage"}], "=", 
   "\"\<findSubsequence[\!\(\*StyleBox[\"digs\", \
\"TI\"]\)\!\(\*StyleBox[\",\", \"TI\"]\)\!\(\*StyleBox[\" \", \
\"TI\"]\)\!\(\*StyleBox[\"subseq\", \"TI\"]\)] returns the positions in the \
sequence of digits \!\(\*StyleBox[\"digs\", \"TI\"]\) where the subsequence \
\!\(\*StyleBox[\"subseq\", \"TI\"]\) occurs.\>\""}], ";"}]], "Input",Expressio\
nUUID->"5f6df003-da3a-4948-9e4f-757dd47b601e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FixArray", "::", "usage"}], "=", 
   "\"\<FixArray[\!\(\*StyleBox[\"mat\", \"TI\"]\)] replaces any occurrences \
of the string \\\"NAN\\\" with the column mean for each column in which the \
string appears. \>\""}], ";"}]], "Input",ExpressionUUID->"00f94143-487f-438a-\
8032-cd32603ed4e2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"perimeter", "::", "usage"}], "=", 
   "\"\<perimeter[Triangle[{\!\(\*SubscriptBox[StyleBox[\"pt\", \"TI\"], \
\"1\"]\),\!\(\*SubscriptBox[StyleBox[\"pt\", \"TI\"], \
\"2\"]\),\!\(\*SubscriptBox[StyleBox[\"pt\", \"TI\"], \"3\"]\)}]] computes \
the perimeter of the triangle determined by the three points \
\!\(\*SubscriptBox[StyleBox[\"pt\", \"TI\"], \"1\"]\), \
\!\(\*SubscriptBox[StyleBox[\"pt\", \"TI\"], \"2\"]\), and \
\!\(\*SubscriptBox[StyleBox[\"pt\", \"TI\"], \"3\"]\).\>\""}], ";"}]], "Input",\
ExpressionUUID->"ddc0dbce-f53e-41b8-b078-4ed5c8ab0cf7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"$VersionNumber", "<", "11.1"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Perimeter", "::", "usage"}], "=", 
     "\"\<Perimeter[Triangle[{\!\(\*SubscriptBox[StyleBox[\"pt\", \"TI\"], \
\"1\"]\),\!\(\*SubscriptBox[StyleBox[\"pt\", \"TI\"], \
\"2\"]\),\!\(\*SubscriptBox[StyleBox[\"pt\", \"TI\"], \"3\"]\)}]] computes \
the perimeter of the triangle determined by the three points \
\!\(\*SubscriptBox[StyleBox[\"pt\", \"TI\"], \"1\"]\), \
\!\(\*SubscriptBox[StyleBox[\"pt\", \"TI\"], \"2\"]\), and \
\!\(\*SubscriptBox[StyleBox[\"pt\", \"TI\"], \"3\"]\).\>\""}]}], "]"}], 
  ";"}]], "Input",ExpressionUUID->"663ef4b3-e12d-48a4-920e-3e1fa0983070"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SignedArea", "::", "usage"}], "=", 
   "\"\<SignedArea[Triangle[{\!\(\*SubscriptBox[StyleBox[\"pt\", \"TI\"], \"1\
\"]\),\!\(\*SubscriptBox[StyleBox[\"pt\", \"TI\"], \
\"2\"]\),\!\(\*SubscriptBox[StyleBox[\"pt\", \"TI\"], \"3\"]\)}]] computes \
the area of the triangle determined by the three points \
\!\(\*SubscriptBox[StyleBox[\"pt\", \"TI\"], \"1\"]\), \
\!\(\*SubscriptBox[StyleBox[\"pt\", \"TI\"], \"2\"]\), and \
\!\(\*SubscriptBox[StyleBox[\"pt\", \"TI\"], \"3\"]\). This value may be \
negative depending upon the order of the three points. The area is zero if \
the points are collinear.\>\""}], ";"}]], "Input",ExpressionUUID->"0a3ecbb2-\
679c-478f-b06b-96209c14665b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"squareMatrixQ", "::", "usage"}], "=", 
   "\"\<squareMatrixQ[\!\(\*StyleBox[\"mat\", \"TI\"]\)] yields true if \
\!\(\*StyleBox[\"mat\", \"TI\"]\) is a square matrix.\>\""}], ";"}]], "Input",\
ExpressionUUID->"80a2e20b-9257-4224-bdf7-d3d2d775d853"],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"$VersionNumber", "<", "10.0"}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SquareMatrixQ", "::", "usage"}], "=", 
     "\"\<SquareMatrixQ[\!\(\*StyleBox[\"mat\", \"TI\"]\)] yields true if \
\!\(\*StyleBox[\"mat\", \"TI\"]\) is a square matrix.\>\""}], ";"}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",ExpressionUUID->"bbffc284-cba6-4cb3-\
87b0-be7907600364"]
}, Closed]],

Cell[CellGroupData[{

Cell["Options", "Subsection",ExpressionUUID->"74e556fe-6f2c-44d5-a51d-4ee5bd5183de"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "Dice", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Color", "\[Rule]", 
     RowBox[{"Darker", "@", "Blue"}]}], "}"}]}], ";"}]], "Input",ExpressionUUI\
D->"c15fd831-1c53-4478-b0f1-f14a0dc4dfcc"]
}, Closed]],

Cell[CellGroupData[{

Cell["Private context", "Subsection",ExpressionUUID->"670230cd-71ee-4f58-9f4e-250a35e9c1d3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}], ";"}]], "Input",Expression\
UUID->"00e625f6-3051-4b19-aed3-1fb7f3076de7"]
}, Closed]],

Cell[CellGroupData[{

Cell["Function definitions (public and private)", "Subsection",ExpressionUUID->"c949c8d1-b1ef-48c5-afaf-72f30068e38d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Dice", "[", 
   RowBox[{"n_", ",", 
    RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"rules", ",", 
      RowBox[{"off", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"OptionValue", "[", "Color", "]"}], ",", 
         RowBox[{"Disk", "[", "]"}]}], "}"}]}], ",", 
      RowBox[{"on", "=", 
       RowBox[{"{", 
        RowBox[{"White", ",", 
         RowBox[{"Disk", "[", "]"}]}], "}"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"rules", "=", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"1", "\[Rule]", "off"}], ",", 
          RowBox[{"2", "\[Rule]", "off"}], ",", 
          RowBox[{"3", "\[Rule]", "off"}], ",", 
          RowBox[{"4", "\[Rule]", "off"}], ",", 
          RowBox[{"5", "\[Rule]", "on"}], ",", 
          RowBox[{"6", "\[Rule]", "off"}], ",", 
          RowBox[{"7", "\[Rule]", "off"}], ",", 
          RowBox[{"8", "\[Rule]", "off"}], ",", 
          RowBox[{"9", "\[Rule]", "off"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"1", "\[Rule]", "off"}], ",", 
          RowBox[{"2", "\[Rule]", "off"}], ",", 
          RowBox[{"3", "\[Rule]", "on"}], ",", 
          RowBox[{"4", "\[Rule]", "off"}], ",", 
          RowBox[{"5", "\[Rule]", "off"}], ",", 
          RowBox[{"6", "\[Rule]", "off"}], ",", 
          RowBox[{"7", "\[Rule]", "on"}], ",", 
          RowBox[{"8", "\[Rule]", "off"}], ",", 
          RowBox[{"9", "\[Rule]", "off"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"1", "\[Rule]", "off"}], ",", 
          RowBox[{"2", "\[Rule]", "off"}], ",", 
          RowBox[{"3", "\[Rule]", "on"}], ",", 
          RowBox[{"4", "\[Rule]", "off"}], ",", 
          RowBox[{"5", "\[Rule]", "on"}], ",", 
          RowBox[{"6", "\[Rule]", "off"}], ",", 
          RowBox[{"7", "\[Rule]", "on"}], ",", 
          RowBox[{"8", "\[Rule]", "off"}], ",", 
          RowBox[{"9", "\[Rule]", "off"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"1", "\[Rule]", "on"}], ",", 
          RowBox[{"2", "\[Rule]", "off"}], ",", 
          RowBox[{"3", "\[Rule]", "on"}], ",", 
          RowBox[{"4", "\[Rule]", "off"}], ",", 
          RowBox[{"5", "\[Rule]", "off"}], ",", 
          RowBox[{"6", "\[Rule]", "off"}], ",", 
          RowBox[{"7", "\[Rule]", "on"}], ",", 
          RowBox[{"8", "\[Rule]", "off"}], ",", 
          RowBox[{"9", "\[Rule]", "on"}]}], "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"1", "\[Rule]", "on"}], ",", 
          RowBox[{"2", "\[Rule]", "off"}], ",", 
          RowBox[{"3", "\[Rule]", "on"}], ",", 
          RowBox[{"4", "\[Rule]", "off"}], ",", 
          RowBox[{"5", "\[Rule]", "on"}], ",", 
          RowBox[{"6", "\[Rule]", "off"}], ",", 
          RowBox[{"7", "\[Rule]", "on"}], ",", 
          RowBox[{"8", "\[Rule]", "off"}], ",", 
          RowBox[{"9", "\[Rule]", "on"}]}], "}"}], ",", "\[IndentingNewLine]",
         "\[VeryThinSpace]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"1", "\[Rule]", "on"}], ",", 
          RowBox[{"2", "\[Rule]", "off"}], ",", 
          RowBox[{"3", "\[Rule]", "on"}], ",", 
          RowBox[{"4", "\[Rule]", "on"}], ",", 
          RowBox[{"5", "\[Rule]", "off"}], ",", 
          RowBox[{"6", "\[Rule]", "on"}], ",", 
          RowBox[{"7", "\[Rule]", "on"}], ",", 
          RowBox[{"8", "\[Rule]", "off"}], ",", 
          RowBox[{"9", "\[Rule]", "on"}]}], "}"}]}], "\[IndentingNewLine]", 
       "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"GraphicsGrid", "[", 
      RowBox[{
       RowBox[{"Map", "[", 
        RowBox[{"Graphics", ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{
            RowBox[{"Range", "[", "9", "]"}], ",", "3"}], "]"}], "/.", 
          "\[VeryThinSpace]", 
          RowBox[{"rules", "[", 
           RowBox[{"[", "n", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", "2", "}"}]}], "]"}], ",", 
       RowBox[{"Background", "\[Rule]", 
        RowBox[{"First", "[", "off", "]"}]}], ",", 
       RowBox[{"Spacings", "\[Rule]", "10"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "40"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",ExpressionUUID->"06bf9f34-cdf4-\
4765-a268-6e0b4ce0a9a9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"findSubsequence", "[", 
   RowBox[{"lis_List", ",", "subseq_List"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"p", ",", 
      RowBox[{"len", "=", 
       RowBox[{"Length", "[", "subseq", "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"p", "=", 
      RowBox[{"Partition", "[", 
       RowBox[{"lis", ",", "len", ",", "1"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Position", "[", 
       RowBox[{"p", ",", "subseq"}], "]"}], "/.", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"num_", "?", "IntegerQ"}], "}"}], "\[RuleDelayed]", 
       RowBox[{"{", 
        RowBox[{"num", ",", 
         RowBox[{"num", "+", "len", "-", "1"}]}], "}"}]}]}]}]}], 
   "]"}]}]], "InputOnly",
 CellTags->
  "4.3 Solutions",ExpressionUUID->"bccb2a15-eb8f-473e-9caa-54c548285554"],

Cell[BoxData[
 RowBox[{
  RowBox[{"findSubsequence", "[", 
   RowBox[{"n_Integer", ",", "subseq_Integer"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"nlist", "=", 
       RowBox[{"IntegerDigits", "[", "n", "]"}]}], ",", 
      RowBox[{"sublist", "=", 
       RowBox[{"IntegerDigits", "[", "subseq", "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"findSubsequence", "[", 
     RowBox[{"nlist", ",", "sublist"}], "]"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "InputOnly",
 CellTags->
  "4.3 Solutions",ExpressionUUID->"8661e4df-9f26-4502-be11-1b67221604d2"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"From", " ", 
   RowBox[{"Strings", ".", "nb"}]}], " ", "*)"}]], "Input",ExpressionUUID->\
"c968c19c-a7c5-470c-a3c1-2ba8b40c8e2e"],

Cell[BoxData[
 RowBox[{"(*", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"FindSubsequence", "[", 
    RowBox[{
     RowBox[{"num_", "?", "NumberQ"}], ",", 
     RowBox[{"subseq_", "?", "NumberQ"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"n", "=", 
        RowBox[{"ToString", "[", "num", "]"}]}], ",", 
       RowBox[{"s", "=", 
        RowBox[{"ToString", "[", "subseq", "]"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Head", "[", "num", "]"}], "==", "Real"}], ",", 
        RowBox[{"n", "=", 
         RowBox[{"Part", "[", 
          RowBox[{
           RowBox[{"StringSplit", "[", 
            RowBox[{"n", ",", "\"\<.\>\""}], "]"}], ",", "2"}], "]"}]}]}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"StringPosition", "[", 
       RowBox[{"n", ",", "s"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  "\[IndentingNewLine]", "*)"}]], "Input",ExpressionUUID->"a6ad82e5-457c-4507-\
a8cc-a6170479b173"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FixArray", "[", "mat_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "fixcolumn", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"fixcolumn", "[", "col_", "]"}], ":=", 
      RowBox[{
       RowBox[{"mat", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "col"}], "]"}], "]"}], "/.", 
       RowBox[{"\"\<NAN\>\"", "\[RuleDelayed]", 
        RowBox[{"Mean", "[", 
         RowBox[{"Cases", "[", 
          RowBox[{
           RowBox[{"mat", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "col"}], "]"}], "]"}], ",", 
           RowBox[{"_", "?", "NumberQ"}]}], "]"}], "]"}]}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Transpose", "[", 
      RowBox[{"Map", "[", 
       RowBox[{"fixcolumn", ",", 
        RowBox[{"Range", "[", 
         RowBox[{"Length", "[", 
          RowBox[{"First", "[", "mat", "]"}], "]"}], "]"}]}], "]"}], 
      "]"}]}]}], "\[IndentingNewLine]", "]"}]}]], "Input",ExpressionUUID->\
"c0318c43-3b5e-4c07-bd05-f871d1b8d43d"],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"$VersionNumber", "<", "11.1"}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Perimeter", "[", 
     RowBox[{"Triangle", "[", 
      RowBox[{"pts", ":", 
       RowBox[{"{", 
        RowBox[{"p1_", ",", "p2_", ",", "p3_"}], "}"}]}], "]"}], "]"}], ":=", 
    
    RowBox[{"RegionMeasure", "[", 
     RowBox[{"Line", "[", 
      RowBox[{"pts", "/.", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"pt1_", ",", "pn__"}], "}"}], "\[RuleDelayed]", 
        RowBox[{"{", 
         RowBox[{"pt1", ",", "pn", ",", "pt1"}], "}"}]}]}], "]"}], "]"}]}], 
   ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"perimeter", "[", 
     RowBox[{"Triangle", "[", 
      RowBox[{"pts", ":", 
       RowBox[{"{", 
        RowBox[{"p1_", ",", "p2_", ",", "p3_"}], "}"}]}], "]"}], "]"}], ":=", 
    
    RowBox[{"RegionMeasure", "[", 
     RowBox[{"Line", "[", 
      RowBox[{"pts", "/.", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"pt1_", ",", "pn__"}], "}"}], "\[RuleDelayed]", 
        RowBox[{"{", 
         RowBox[{"pt1", ",", "pn", ",", "pt1"}], "}"}]}]}], "]"}], "]"}]}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",ExpressionUUID->"bbc4b6fd-5f36-4901-\
95e8-6e4426734331"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SignedArea", "[", 
   RowBox[{"Triangle", "[", 
    RowBox[{"{", 
     RowBox[{"v1_", ",", "v2_", ",", "v3_"}], "}"}], "]"}], "]"}], ":=", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   RowBox[{"Det", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"v1", ",", "v2", ",", "v3"}], "}"}], "/.", "\[InvisibleSpace]", 
     
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x_", ",", "y_"}], "}"}], "\[RuleDelayed]", 
      RowBox[{"{", 
       RowBox[{"x", ",", "y", ",", "1"}], "}"}]}]}], "]"}]}]}]], "Input",Expre\
ssionUUID->"67224627-1c0f-4212-8c7f-fc853a28382a"]
}, Closed]],

Cell[CellGroupData[{

Cell["End private context", "Subsection",ExpressionUUID->"b31c278a-bcaa-40bf-9db9-74b6dfbf4d3f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"End", "[", "]"}], ";"}]], "Input",ExpressionUUID->"577de4ae-581f-4089-88d4-6427829c342e"]
}, Closed]],

Cell[CellGroupData[{

Cell["EndPackage", "Subsection",ExpressionUUID->"000f4f38-57da-4d4c-8716-eae2dc3a9af1"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"EndPackage", "[", "]"}], "*)"}]], "Input",ExpressionUUID->\
"a124f039-b42a-42bc-894e-5c3eb2c02d3e"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Examples", "Section",ExpressionUUID->"422ccfc1-345f-4fc6-a66e-6ee6930bc06d"],

Cell[CellGroupData[{

Cell["Load package", "Subsection",ExpressionUUID->"687bccc7-0754-41a8-a8e2-b4e65b514f05"],

Cell["Quit current session:", "Text",ExpressionUUID->"afe19cb9-055a-497f-9a92-39a5810c4b9f"],

Cell[BoxData["Quit"], "Input",
 CellLabel->
  "In[107]:=",ExpressionUUID->"6a88bd03-ebd5-4458-99e4-dd09c629da97"],

Cell[TextData[{
 "Load package (do ",
 StyleBox["not",
  FontSlant->"Italic"],
 " say \[OpenCurlyDoubleQuote]Yes\[CloseCurlyDoubleQuote] to dialog asking to \
evaluate init cells in this notebook)."
}], "Text",ExpressionUUID->"7fb429c3-391b-4e10-90a2-a7d10159fd3a"],

Cell[BoxData[
 RowBox[{"<<", "EPM`"}]], "Input",
 CellLabel->"In[1]:=",ExpressionUUID->"6de6f805-40fd-4503-b940-ee5f6aaffa62"]
}, Closed]],

Cell[CellGroupData[{

Cell["Test usage messages", "Subsection",ExpressionUUID->"d5af6e5a-71fd-4d99-abe8-a03f34bedf51"],

Cell[BoxData[
 RowBox[{"?", "Dice"}]], "Input",
 CellLabel->"In[2]:=",ExpressionUUID->"5acf2fae-cc2a-4f5d-8bb1-5d22294507ae"],

Cell[BoxData[
 RowBox[{"?", "findSubsequence"}]], "Input",
 CellLabel->"In[3]:=",ExpressionUUID->"3a83f27f-d0ba-46ed-b4a8-f61332d1d0c8"],

Cell[BoxData[
 RowBox[{"?", "FixArray"}]], "Input",
 CellLabel->"In[4]:=",ExpressionUUID->"b5c296cd-51ed-42fc-b174-c159ea74ea5a"],

Cell[BoxData[
 RowBox[{"?", "perimeter"}]], "Input",
 CellLabel->"In[5]:=",ExpressionUUID->"02086517-8d03-46ec-b153-356d99ab00dd"],

Cell[BoxData[
 RowBox[{"?", "SignedArea"}]], "Input",
 CellLabel->"In[6]:=",ExpressionUUID->"6881910d-2907-4c83-940f-7964af2d53b3"]
}, Closed]],

Cell[CellGroupData[{

Cell["Exercise the functions and options", "Subsection",ExpressionUUID->"9d0dffd2-ef9a-4dd7-938d-7c16598c0922"],

Cell[CellGroupData[{

Cell["Dice", "Subsubsection",ExpressionUUID->"b1799db4-2cc7-45ff-84ff-a27bc291f4c5"],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"Dice", "[", "n", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "1", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[7]:=",ExpressionUUID->"cbf334d4-d2b7-4fec-9fdd-17798a52ee4c"],

Cell[BoxData[
 RowBox[{"Dice", "[", 
  RowBox[{"5", ",", 
   RowBox[{"Color", "\[Rule]", "Red"}]}], "]"}]], "Input",
 CellLabel->"In[8]:=",ExpressionUUID->"d73b3d37-aa82-41a5-b986-832653a711a4"]
}, Closed]],

Cell[CellGroupData[{

Cell["findSubsequence", "Subsubsection",ExpressionUUID->"f2fd9617-cd81-4c54-b0a4-83374c49e71c"],

Cell[BoxData[
 RowBox[{"pidigs", "=", 
  RowBox[{"First", "[", 
   RowBox[{"RealDigits", "[", 
    RowBox[{"\[Pi]", ",", "10", ",", 
     SuperscriptBox["10", "6"], ",", 
     RowBox[{"-", "1"}]}], "]"}], "]"}]}]], "Input",
 CellTags->"4.3",
 CellLabel->"In[9]:=",ExpressionUUID->"b95a110b-52ca-419f-8c75-d0cb6929c49f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"findSubsequence", "[", 
   RowBox[{"pidigs", ",", 
    RowBox[{"{", 
     RowBox[{"3", ",", "1", ",", "4", ",", "1", ",", "5", ",", "9"}], "}"}]}],
    "]"}], "//", "Timing"}]], "Input",
 CellTags->"4.3",
 CellLabel->"In[10]:=",ExpressionUUID->"f6e52bf1-020a-44f4-98d9-9eb2e2fab76a"],

Cell["Or use two integers as arguments.", "Text",ExpressionUUID->"fd385b7c-ac97-45d3-9d10-fbcd2de8298d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"pi", "=", 
   RowBox[{"FromDigits", "[", 
    RowBox[{"First", "@", 
     RowBox[{"RealDigits", "[", 
      RowBox[{
       RowBox[{"N", "[", 
        RowBox[{"Pi", ",", 
         SuperscriptBox["10", "5"]}], "]"}], "-", "3"}], "]"}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{"findSubsequence", "[", 
  RowBox[{"pi", ",", "1415"}], "]"}]}], "InputOnly",
 CellTags->"4.3 Solutions",
 CellLabel->"In[11]:=",ExpressionUUID->"fbc8b2cc-81ce-4f07-8b1e-f7da8a3265b3"]
}, Closed]],

Cell[CellGroupData[{

Cell["FixArray", "Subsubsection",ExpressionUUID->"c84402e7-0221-4498-8ace-5188228f6984"],

Cell[BoxData[
 StyleBox[
  RowBox[{
   RowBox[{"array", "=", 
    TagBox[
     RowBox[{"(", "\[NoBreak]", GridBox[{
        {"0.9034000000000001`", "\"\<NAN\>\"", "0.7163`", "0.8588`", 
         "0.1228`"},
        {"0.30310000000000004`", "0.5827`", "0.26990000000000003`", 
         "0.8063`", "\"\<NAN\>\""},
        {"0.041800000000000004`", "0.8426`", "\"\<NAN\>\"", 
         "0.8634000000000001`", "0.9682000000000001`"},
        {"0.9163`", "0.8913000000000001`", "0.06620000000000001`", 
         "0.8432000000000001`", "0.054700000000000006`"},
        {"0.7937000000000001`", "0.6905`", "0.9105000000000001`", 
         "0.5589000000000001`", "0.8993`"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
     Function[BoxForm`e$, 
      MatrixForm[BoxForm`e$]]]}], ";"}],
  NumberMarks->False]], "Input",
 CellLabel->"In[13]:=",ExpressionUUID->"f3ea975e-9098-4165-a8ed-4b3d0c9c0df0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FixArray", "[", "array", "]"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[14]:=",ExpressionUUID->"ba905a19-d5c1-4349-b10f-f14270681d4a"]
}, Closed]],

Cell[CellGroupData[{

Cell["Perimeter", "Subsubsection",ExpressionUUID->"bacea244-92c4-46a8-b069-008594b710f5"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"pts", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"$VersionNumber", "<", "11.1"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Perimeter", "[", 
    RowBox[{"Triangle", "[", "pts", "]"}], "]"}], ",", "\[IndentingNewLine]", 
   
   RowBox[{"perimeter", "[", 
    RowBox[{"Triangle", "[", "pts", "]"}], "]"}]}], "\[IndentingNewLine]", 
  "]"}]}], "Input",
 CellLabel->"In[15]:=",ExpressionUUID->"e1d20590-4717-4fa9-8012-9f60ffa16c90"]
}, Closed]],

Cell[CellGroupData[{

Cell["SignedArea", "Subsubsection",ExpressionUUID->"451fdd50-2129-4898-9141-7b9bbb5c86b2"],

Cell[BoxData[
 RowBox[{"SignedArea", "[", 
  RowBox[{"Triangle", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}]}], "}"}], "]"}], "]"}]], "Input",
 CellLabel->"In[17]:=",ExpressionUUID->"5d0fa6c7-6f9d-4ab5-be6b-a3c2151b85ab"],

Cell[BoxData[
 RowBox[{"SignedArea", "[", 
  RowBox[{"Triangle", "[", 
   RowBox[{"Reverse", "@", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "4"}], "}"}]}], "}"}]}], "]"}], "]"}]], "Input",
 CellLabel->"In[18]:=",ExpressionUUID->"8f8c8a55-eed4-493a-8829-b3f77e7d668f"]
}, Closed]]
}, Closed]]
}, Closed]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{993, 879},
WindowMargins->{{27, Automatic}, {Automatic, 11}},
ShowSelection->True,
Magnification:>1.25 Inherited,
FrontEndVersion->"13.3 for Mac OS X ARM (64-bit) (July 24, 2023)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"ef7e146f-e33d-4fb0-ac34-a3a5f16f5af2"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "4.3 Solutions"->{
  Cell[15006, 408, 906, 27, 147, "InputOnly",ExpressionUUID->"bccb2a15-eb8f-473e-9caa-54c548285554",
   CellTags->"4.3 Solutions"],
  Cell[15915, 437, 629, 17, 147, "InputOnly",ExpressionUUID->"8661e4df-9f26-4502-be11-1b67221604d2",
   CellTags->"4.3 Solutions"],
  Cell[24511, 705, 492, 14, 87, "InputOnly",ExpressionUUID->"fbc8b2cc-81ce-4f07-8b1e-f7da8a3265b3",
   CellTags->"4.3 Solutions"]},
 "4.3"->{
  Cell[23761, 683, 319, 8, 51, "Input",ExpressionUUID->"b95a110b-52ca-419f-8c75-d0cb6929c49f",
   CellTags->"4.3"],
  Cell[24083, 693, 318, 8, 47, "Input",ExpressionUUID->"f6e52bf1-020a-44f4-98d9-9eb2e2fab76a",
   CellTags->"4.3"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"4.3 Solutions", 28903, 839},
 {"4.3", 29309, 846}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 118, 2, 105, "Section",ExpressionUUID->"c94a21cb-3aba-448d-99e2-29813c50cc8b",
 InitializationGroup->True],
Cell[700, 26, 295, 9, 83, "Text",ExpressionUUID->"6feaa97d-d1c7-4346-a1c5-9f261df2ea55"],
Cell[CellGroupData[{
Cell[1020, 39, 85, 0, 84, "Subsection",ExpressionUUID->"086f15bd-ebdf-4cbe-a271-eb7e9b08f7ef"],
Cell[1108, 41, 166, 3, 47, "Input",ExpressionUUID->"aa435e2d-3933-4421-aee3-f0b1487f5271"],
Cell[1277, 46, 248, 6, 47, "Input",ExpressionUUID->"49335658-028b-4b97-a34c-3b4088dcb2f5"],
Cell[1528, 54, 203, 5, 47, "Input",ExpressionUUID->"91d3a3f4-a19f-4dc7-9e9a-114cba80b384"],
Cell[1734, 61, 367, 8, 80, "Input",ExpressionUUID->"09c8a8e1-e149-4620-a8a1-a2537c8c7caa"],
Cell[2104, 71, 169, 3, 47, "Input",ExpressionUUID->"6e7b36fd-79f8-484a-84cb-db33fdf32d28"],
Cell[2276, 76, 190, 4, 47, "Input",ExpressionUUID->"038495be-b44f-4da8-963a-8eb99211d5ae"],
Cell[2469, 82, 266, 6, 47, "Input",ExpressionUUID->"bc444255-131a-4ad7-9668-a116f2e6af4b"],
Cell[2738, 90, 505, 11, 144, "Input",ExpressionUUID->"23379a7f-967b-4f9d-9910-0e39a940652e"],
Cell[3246, 103, 379, 8, 112, "Input",ExpressionUUID->"01c7ebfa-ec8a-471a-b1a1-50ae495b9d7a"],
Cell[3628, 113, 188, 4, 47, "Input",ExpressionUUID->"f8fd5c7a-68cb-4553-a692-1943bfa26960"],
Cell[3819, 119, 195, 4, 47, "Input",ExpressionUUID->"a0bce5c4-b43f-4d9b-9354-9412df3cb502"],
Cell[4017, 125, 181, 3, 47, "Input",ExpressionUUID->"03b9e7c3-fc4d-48eb-a992-7aeab7e952ff"],
Cell[4201, 130, 238, 5, 47, "Input",ExpressionUUID->"525b72b2-2298-4b19-ae3f-16bcdf7f464d"],
Cell[4442, 137, 238, 5, 47, "Input",ExpressionUUID->"d1db429f-7c9a-47f4-af8d-2e7d96dde62e"]
}, Closed]],
Cell[CellGroupData[{
Cell[4717, 147, 89, 0, 57, "Subsection",ExpressionUUID->"14832385-07e7-4612-8ec4-a672fd61c504"],
Cell[4809, 149, 253, 5, 80, "Input",ExpressionUUID->"a2e607ba-4e6f-41ce-a51e-a1947c744c7e"],
Cell[5065, 156, 178, 3, 47, "Input",ExpressionUUID->"411063df-cce9-4e91-802d-7b0afd832737"]
}, Closed]],
Cell[CellGroupData[{
Cell[5280, 164, 112, 0, 57, "Subsection",ExpressionUUID->"6b34136a-06ca-41e3-9657-5284641f432f"],
Cell[5395, 166, 268, 6, 112, "Input",ExpressionUUID->"af0c6934-33d9-43f0-9c22-c54f532b2040"],
Cell[5666, 174, 283, 6, 80, "Input",ExpressionUUID->"e98eb8c3-002c-425b-8332-f144d50ae5ae"],
Cell[5952, 182, 485, 9, 112, "Input",ExpressionUUID->"5f6df003-da3a-4948-9e4f-757dd47b601e"],
Cell[6440, 193, 336, 7, 144, "Input",ExpressionUUID->"00f94143-487f-438a-8032-cd32603ed4e2"],
Cell[6779, 202, 607, 11, 146, "Input",ExpressionUUID->"ddc0dbce-f53e-41b8-b078-4ed5c8ab0cf7"],
Cell[7389, 215, 731, 14, 178, "Input",ExpressionUUID->"663ef4b3-e12d-48a4-920e-3e1fa0983070"],
Cell[8123, 231, 727, 13, 210, "Input",ExpressionUUID->"0a3ecbb2-679c-478f-b06b-96209c14665b"],
Cell[8853, 246, 295, 6, 80, "Input",ExpressionUUID->"80a2e20b-9257-4224-bdf7-d3d2d775d853"],
Cell[9151, 254, 443, 10, 144, "Input",ExpressionUUID->"bbffc284-cba6-4cb3-87b0-be7907600364"]
}, Closed]],
Cell[CellGroupData[{
Cell[9631, 269, 84, 0, 57, "Subsection",ExpressionUUID->"74e556fe-6f2c-44d5-a51d-4ee5bd5183de"],
Cell[9718, 271, 255, 7, 47, "Input",ExpressionUUID->"c15fd831-1c53-4478-b0f1-f14a0dc4dfcc"]
}, Closed]],
Cell[CellGroupData[{
Cell[10010, 283, 92, 0, 57, "Subsection",ExpressionUUID->"670230cd-71ee-4f58-9f4e-250a35e9c1d3"],
Cell[10105, 285, 149, 3, 40, "Input",ExpressionUUID->"00e625f6-3051-4b19-aed3-1fb7f3076de7"]
}, Closed]],
Cell[CellGroupData[{
Cell[10291, 293, 118, 0, 57, "Subsection",ExpressionUUID->"c949c8d1-b1ef-48c5-afaf-72f30068e38d"],
Cell[10412, 295, 4591, 111, 688, "Input",ExpressionUUID->"06bf9f34-cdf4-4765-a268-6e0b4ce0a9a9"],
Cell[15006, 408, 906, 27, 147, "InputOnly",ExpressionUUID->"bccb2a15-eb8f-473e-9caa-54c548285554",
 CellTags->"4.3 Solutions"],
Cell[15915, 437, 629, 17, 147, "InputOnly",ExpressionUUID->"8661e4df-9f26-4502-be11-1b67221604d2",
 CellTags->"4.3 Solutions"],
Cell[16547, 456, 175, 4, 47, "Input",ExpressionUUID->"c968c19c-a7c5-470c-a3c1-2ba8b40c8e2e"],
Cell[16725, 462, 1081, 30, 240, "Input",ExpressionUUID->"a6ad82e5-457c-4507-a8cc-a6170479b173"],
Cell[17809, 494, 1073, 29, 176, "Input",ExpressionUUID->"c0318c43-3b5e-4c07-bd05-f871d1b8d43d"],
Cell[18885, 525, 1249, 36, 208, "Input",ExpressionUUID->"bbc4b6fd-5f36-4901-95e8-6e4426734331"],
Cell[20137, 563, 603, 18, 105, "Input",ExpressionUUID->"67224627-1c0f-4212-8c7f-fc853a28382a"]
}, Closed]],
Cell[CellGroupData[{
Cell[20777, 586, 96, 0, 57, "Subsection",ExpressionUUID->"b31c278a-bcaa-40bf-9db9-74b6dfbf4d3f"],
Cell[20876, 588, 124, 2, 40, "Input",ExpressionUUID->"577de4ae-581f-4089-88d4-6427829c342e"]
}, Closed]],
Cell[CellGroupData[{
Cell[21037, 595, 87, 0, 57, "Subsection",ExpressionUUID->"000f4f38-57da-4d4c-8716-eae2dc3a9af1"],
Cell[21127, 597, 140, 3, 108, "Input",ExpressionUUID->"a124f039-b42a-42bc-894e-5c3eb2c02d3e"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[21316, 606, 82, 0, 105, "Section",ExpressionUUID->"422ccfc1-345f-4fc6-a66e-6ee6930bc06d"],
Cell[CellGroupData[{
Cell[21423, 610, 89, 0, 84, "Subsection",ExpressionUUID->"687bccc7-0754-41a8-a8e2-b4e65b514f05"],
Cell[21515, 612, 92, 0, 55, "Text",ExpressionUUID->"afe19cb9-055a-497f-9a92-39a5810c4b9f"],
Cell[21610, 614, 113, 2, 47, "Input",ExpressionUUID->"6a88bd03-ebd5-4458-99e4-dd09c629da97"],
Cell[21726, 618, 265, 6, 91, "Text",ExpressionUUID->"7fb429c3-391b-4e10-90a2-a7d10159fd3a"],
Cell[21994, 626, 126, 2, 47, "Input",ExpressionUUID->"6de6f805-40fd-4503-b940-ee5f6aaffa62"]
}, Closed]],
Cell[CellGroupData[{
Cell[22157, 633, 96, 0, 84, "Subsection",ExpressionUUID->"d5af6e5a-71fd-4d99-abe8-a03f34bedf51"],
Cell[22256, 635, 125, 2, 47, "Input",ExpressionUUID->"5acf2fae-cc2a-4f5d-8bb1-5d22294507ae"],
Cell[22384, 639, 136, 2, 47, "Input",ExpressionUUID->"3a83f27f-d0ba-46ed-b4a8-f61332d1d0c8"],
Cell[22523, 643, 129, 2, 47, "Input",ExpressionUUID->"b5c296cd-51ed-42fc-b174-c159ea74ea5a"],
Cell[22655, 647, 130, 2, 47, "Input",ExpressionUUID->"02086517-8d03-46ec-b153-356d99ab00dd"],
Cell[22788, 651, 131, 2, 47, "Input",ExpressionUUID->"6881910d-2907-4c83-940f-7964af2d53b3"]
}, Closed]],
Cell[CellGroupData[{
Cell[22956, 658, 111, 0, 84, "Subsection",ExpressionUUID->"9d0dffd2-ef9a-4dd7-938d-7c16598c0922"],
Cell[CellGroupData[{
Cell[23092, 662, 84, 0, 71, "Subsubsection",ExpressionUUID->"b1799db4-2cc7-45ff-84ff-a27bc291f4c5"],
Cell[23179, 664, 250, 6, 47, "Input",ExpressionUUID->"cbf334d4-d2b7-4fec-9fdd-17798a52ee4c"],
Cell[23432, 672, 194, 4, 47, "Input",ExpressionUUID->"d73b3d37-aa82-41a5-b986-832653a711a4"]
}, Closed]],
Cell[CellGroupData[{
Cell[23663, 681, 95, 0, 71, "Subsubsection",ExpressionUUID->"f2fd9617-cd81-4c54-b0a4-83374c49e71c"],
Cell[23761, 683, 319, 8, 51, "Input",ExpressionUUID->"b95a110b-52ca-419f-8c75-d0cb6929c49f",
 CellTags->"4.3"],
Cell[24083, 693, 318, 8, 47, "Input",ExpressionUUID->"f6e52bf1-020a-44f4-98d9-9eb2e2fab76a",
 CellTags->"4.3"],
Cell[24404, 703, 104, 0, 55, "Text",ExpressionUUID->"fd385b7c-ac97-45d3-9d10-fbcd2de8298d"],
Cell[24511, 705, 492, 14, 87, "InputOnly",ExpressionUUID->"fbc8b2cc-81ce-4f07-8b1e-f7da8a3265b3",
 CellTags->"4.3 Solutions"]
}, Closed]],
Cell[CellGroupData[{
Cell[25040, 724, 88, 0, 71, "Subsubsection",ExpressionUUID->"c84402e7-0221-4498-8ace-5188228f6984"],
Cell[25131, 726, 1304, 30, 150, "Input",ExpressionUUID->"f3ea975e-9098-4165-a8ed-4b3d0c9c0df0"],
Cell[26438, 758, 177, 3, 47, "Input",ExpressionUUID->"ba905a19-d5c1-4349-b10f-f14270681d4a"]
}, Closed]],
Cell[CellGroupData[{
Cell[26652, 766, 89, 0, 71, "Subsubsection",ExpressionUUID->"bacea244-92c4-46a8-b069-008594b710f5"],
Cell[26744, 768, 725, 20, 176, "Input",ExpressionUUID->"e1d20590-4717-4fa9-8012-9f60ffa16c90"]
}, Closed]],
Cell[CellGroupData[{
Cell[27506, 793, 90, 0, 71, "Subsubsection",ExpressionUUID->"451fdd50-2129-4898-9141-7b9bbb5c86b2"],
Cell[27599, 795, 395, 11, 47, "Input",ExpressionUUID->"5d0fa6c7-6f9d-4ab5-be6b-a3c2151b85ab"],
Cell[27997, 808, 433, 12, 47, "Input",ExpressionUUID->"8f8c8a55-eed4-493a-8829-b3f77e7d668f"]
}, Closed]]
}, Closed]]
}, Closed]]
}
]
*)

