(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     15267,        413]
NotebookOptionsPosition[     10048,        322]
NotebookOutlinePosition[     10506,        340]
CellTagsIndexPosition[     10463,        337]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["EPM`StemPlots`", "Section",
 InitializationGroup->
  True,ExpressionUUID->"da4e6a40-a01f-4335-9343-279b72db1620"],

Cell[TextData[{
 StyleBox["From",
  FontWeight->"Bold"],
 ": Essentials of Programming in ",
 StyleBox["Mathematica\n",
  FontSlant->"Italic"],
 "\[Copyright] Paul R. Wellin 2015"
}], "Text",
 CellMargins->{{28, 10}, {7, 7}},
 FontSize->14,ExpressionUUID->"725a0613-7de9-4614-82ff-5f9f32573b7b"],

Cell[CellGroupData[{

Cell["Metadata", "Subsection",ExpressionUUID->"2f0beffa-7a64-4757-98f7-d216c88ec231"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Name", ":", " ", "EPM`StemPlots`"}], " ", "*)"}]], "Input",Exp\
ressionUUID->"faa39528-100a-4f07-aa45-7c31f01025a4"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Book", ":", " ", 
   RowBox[{
   "Essentials", " ", "of", " ", "Programming", " ", "in", " ", 
    "Mathematica"}]}], " ", "*)"}]], "Input",ExpressionUUID->"18766c25-46b4-\
4d55-8f4f-2ffa3afad138"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Paul", " ", "Wellin"}]}]}], " ", "*)"}]], "Input",ExpressionUUID->\
"86326a8c-05e6-4a9c-9ca4-5653f9ad4d3c"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Summary", ":", " ", 
   RowBox[{
   "This", " ", "package", " ", "contains", " ", "the", " ", "functions", " ",
     "defined", " ", "in", " ", "Chapter", " ", "6", " ", "Programs"}]}], " ",
   "*)"}]], "Input",ExpressionUUID->"3e489d70-0ce7-4896-a652-697092e3989f"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Context", ":", " ", "EPM`StemPlots`"}], " ", "*)"}]], "Input",\
ExpressionUUID->"f3b5a4af-a77d-476c-9fac-7ee3d2efcfd7"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", 
    RowBox[{"Version", ":", " ", "1.0"}]}]}], " ", "*)"}]], "Input",Expression\
UUID->"e830ec3c-2e97-4c7b-8f21-41d5951a7ae3"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", "Copyright", ":", " ", 
    RowBox[{"Copyright", " ", "2015"}]}], ",", " ", 
   RowBox[{"Paul", " ", "R", " ", "Wellin"}]}], " ", "*)"}]], "Input",Expressi\
onUUID->"7c204971-22c5-4f69-97ba-fe32f130739a"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{
     "Version", " ", "1.0", " ", "by", " ", "Paul", " ", "Wellin"}]}]}], ",", 
   " ", 
   RowBox[{"Dec", " ", "2012"}]}], " ", "*)"}]], "Input",ExpressionUUID->\
"04384a00-f80a-4ec9-bacb-4744006ba958"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Keywords", ":", " ", 
   RowBox[{"stem", " ", "plots"}]}], " ", "*)"}]], "Input",ExpressionUUID->\
"a2ddf466-8b11-45d1-9b38-f2d3b52b289f"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Source", ":", " ", 
   RowBox[{"StemPlots", ".", "nb"}]}], " ", "*)"}]], "Input",ExpressionUUID->\
"d8602cf4-408c-4242-b2c3-36c7c2b7e507"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", "Version"}], ":", " ", "10.3"}], " ", 
  "*)"}]], "Input",ExpressionUUID->"3248ac6d-ace4-4134-aa8c-48698d99e156"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Tested", " ", "in", " ", "Mathematica", " ", "11.1"}], " ", 
  "*)"}]], "Input",ExpressionUUID->"f695ddda-4832-45f2-a1d7-28430d3f4ff9"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Tested", " ", "in", " ", "Mathematica", " ", "12.0"}], ",", " ", 
   RowBox[{"Feb", " ", "2019"}]}], " ", "*)"}]], "Input",ExpressionUUID->\
"252b132f-5a13-4b6e-a9ad-02c1062e7e19"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Tested", " ", "in", " ", "Mathematica", " ", "13.2"}], ",", " ", 
   RowBox[{"Aug", " ", "2023"}]}], " ", "*)"}]], "Input",ExpressionUUID->\
"772f411f-7bff-4889-a5d4-e218c5dbdff0"]
}, Closed]],

Cell[CellGroupData[{

Cell["BeginPackage", "Subsection",ExpressionUUID->"75b5e199-7508-4c51-9cc5-5780b5fd71d9"],

Cell[BoxData[
 RowBox[{"Remove", "[", "StemPlot", "]"}]], "Input",ExpressionUUID->"59303e04-35d7-4cdc-845c-ad3b8eed321a"],

Cell[BoxData[
 RowBox[{"BeginPackage", "[", "\"\<EPM`StemPlots`\>\"", "]"}]], "Input",Expres\
sionUUID->"e7bf43a9-cc6f-40ad-b107-a6948e4ffcb5"]
}, Closed]],

Cell[CellGroupData[{

Cell["Usage messages for public functions", "Subsection",ExpressionUUID->"6d401d9d-e379-4476-a3ba-be7949ba1727"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StemPlot", "::", "usage"}], "=", 
   "\"\<StemPlot[\!\(\*StyleBox[\"data\", \"TI\"]\)] returns a stem plot of \
the discrete data, \!\(\*StyleBox[\"data\", \"TI\"]\).\>\""}], ";"}]], "Input",\
ExpressionUUID->"1c3a2519-0744-4303-965a-b3163e6889f3"]
}, Closed]],

Cell[CellGroupData[{

Cell["Warning messages", "Subsection",ExpressionUUID->"b6dc0c01-5ed5-4134-a31c-3e1838dcfb5e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StemPlot", "::", "badarg"}], "=", 
   "\"\<The first argument to StemPlot must be a list of numbers.\>\""}], 
  ";"}]], "Input",ExpressionUUID->"440e982b-d2af-4b29-8bd2-1902dd06a82f"]
}, Closed]],

Cell[CellGroupData[{

Cell["Options", "Subsection",ExpressionUUID->"36c42b6d-3686-4502-9947-bc880061299c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "StemPlot", "]"}], "=", 
   RowBox[{"Options", "[", "ListPlot", "]"}]}], ";"}]], "Input",ExpressionUUID\
->"7a5ba265-276a-4595-b84a-c3f371644124"]
}, Closed]],

Cell[CellGroupData[{

Cell["Private context", "Subsection",ExpressionUUID->"adf51c61-e6fd-4dc2-913d-4a8a5d0dc5de"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}], ";"}]], "Input",Expression\
UUID->"1debec01-5ae4-459d-b364-52ece01c5d06"]
}, Closed]],

Cell[CellGroupData[{

Cell["Function definitions (public and private)", "Subsection",ExpressionUUID->"3be3a157-8a2b-4926-832a-1b0d77130f50"],

Cell[BoxData[
 RowBox[{
  RowBox[{"StemPlot", "[", 
   RowBox[{"lis_", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"MatchQ", "[", 
     RowBox[{"lis", ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"__", "?", "NumericQ"}], "}"}], "|", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"__", "?", "NumericQ"}], "}"}], ".."}], "}"}]}]}], "]"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{"ListPlot", "[", 
     RowBox[{"lis", ",", "opts", ",", 
      RowBox[{"Filling", "\[Rule]", "Axis"}]}], "]"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Message", "[", 
     RowBox[{"StemPlot", "::", "badarg"}], "]"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",ExpressionUUID->"9fc2c08a-6860-47a2-98bf-cdc2e460a33f"]
}, Closed]],

Cell[CellGroupData[{

Cell["End private context", "Subsection",ExpressionUUID->"8b986643-55f0-4a4d-a34a-ddd260800ba6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"End", "[", "]"}], ";"}]], "Input",ExpressionUUID->"d9529413-2b3a-481b-925f-ae242876cecd"]
}, Closed]],

Cell[CellGroupData[{

Cell["EndPackage", "Subsection",ExpressionUUID->"3d6fd33a-d4d7-43cf-a9f6-912bd472154c"],

Cell[BoxData[
 RowBox[{"EndPackage", "[", "]"}]], "Input",ExpressionUUID->"5892ae4d-442d-4bff-a4d5-7685d04834ea"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Examples", "Section",ExpressionUUID->"775b17d7-52a0-41be-9897-b4d377e1648d"],

Cell[CellGroupData[{

Cell["Load package", "Subsection",ExpressionUUID->"83f56422-6a78-4f8b-92b1-5c5d22a187d9"],

Cell["Quit current session:", "Text",ExpressionUUID->"3353c1f9-7ab3-480e-9227-769ad4b3e599"],

Cell[BoxData["Quit"], "Input",ExpressionUUID->"d6ab19bb-f4fa-4bee-b3b3-b722469230f8"],

Cell[TextData[{
 "Load package (do ",
 StyleBox["not",
  FontSlant->"Italic"],
 " say \[OpenCurlyDoubleQuote]Yes\[CloseCurlyDoubleQuote] to dialog asking to \
evaluate init cells in this notebook)."
}], "Text",ExpressionUUID->"79e7336b-9956-4b05-993a-15b5f30af40d"],

Cell[BoxData[
 RowBox[{"<<", "EPM`StemPlots`"}]], "Input",
 CellLabel->"In[79]:=",ExpressionUUID->"e1dbb1cc-7fa4-4a4e-9c9a-acc80a407469"]
}, Closed]],

Cell[CellGroupData[{

Cell["Test usage messages", "Subsection",ExpressionUUID->"e39f7444-5ecb-4801-8fdf-c574bfbb81b1"],

Cell[BoxData[
 RowBox[{"?", "StemPlot"}]], "Input",
 CellLabel->"In[80]:=",ExpressionUUID->"2dec5202-0a04-4472-abcd-6146f32e68f8"]
}, Closed]],

Cell[CellGroupData[{

Cell["Exercise the functions and options", "Subsection",ExpressionUUID->"9a1c2c81-0a65-43c5-9f47-5255d94ea0d1"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "5"}], ",", "10"}], "}"}], ",", "12"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"StemPlot", "[", "data", "]"}]}], "Input",
 CellLabel->"In[81]:=",ExpressionUUID->"5f9c6bff-56c4-49f6-8a73-72a5c4d5a260"],

Cell[BoxData[
 RowBox[{"StemPlot", "[", 
  RowBox[{"data", ",", 
   RowBox[{"PlotTheme", "\[Rule]", "\"\<Business\>\""}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", "28"}]}], "]"}]], "Input",
 CellLabel->"In[83]:=",ExpressionUUID->"66f318d5-790e-463f-b237-b7aa64a527d5"],

Cell["Multiple data sets:", "Text",ExpressionUUID->"0e3cd1a1-f6e6-4e4e-ac71-d4b69134eb56"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "5"}], ",", "10"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "12"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"StemPlot", "[", "data", "]"}]}], "Input",
 CellLabel->"In[84]:=",ExpressionUUID->"dd01ffe0-06fd-447f-85c0-0fa1237db7a3"]
}, Closed]]
}, Closed]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{907, 785},
WindowMargins->{{234, Automatic}, {Automatic, 10}},
Magnification:>1.25 Inherited,
FrontEndVersion->"13.3 for Mac OS X ARM (64-bit) (July 24, 2023)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"490076b1-1188-42c5-9af0-62bc7c25b0c7"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 119, 2, 105, "Section",ExpressionUUID->"da4e6a40-a01f-4335-9343-279b72db1620",
 InitializationGroup->True],
Cell[701, 26, 295, 9, 83, "Text",ExpressionUUID->"725a0613-7de9-4614-82ff-5f9f32573b7b"],
Cell[CellGroupData[{
Cell[1021, 39, 85, 0, 84, "Subsection",ExpressionUUID->"2f0beffa-7a64-4757-98f7-d216c88ec231"],
Cell[1109, 41, 167, 3, 47, "Input",ExpressionUUID->"faa39528-100a-4f07-aa45-7c31f01025a4"],
Cell[1279, 46, 248, 6, 47, "Input",ExpressionUUID->"18766c25-46b4-4d55-8f4f-2ffa3afad138"],
Cell[1530, 54, 203, 5, 47, "Input",ExpressionUUID->"86326a8c-05e6-4a9c-9ca4-5653f9ad4d3c"],
Cell[1736, 61, 317, 6, 80, "Input",ExpressionUUID->"3e489d70-0ce7-4896-a652-697092e3989f"],
Cell[2056, 69, 170, 3, 47, "Input",ExpressionUUID->"f3b5a4af-a77d-476c-9fac-7ee3d2efcfd7"],
Cell[2229, 74, 204, 5, 47, "Input",ExpressionUUID->"e830ec3c-2e97-4c7b-8f21-41d5951a7ae3"],
Cell[2436, 81, 266, 6, 47, "Input",ExpressionUUID->"7c204971-22c5-4f69-97ba-fe32f130739a"],
Cell[2705, 89, 313, 9, 47, "Input",ExpressionUUID->"04384a00-f80a-4ec9-bacb-4744006ba958"],
Cell[3021, 100, 189, 4, 47, "Input",ExpressionUUID->"a2ddf466-8b11-45d1-9b38-f2d3b52b289f"],
Cell[3213, 106, 189, 4, 47, "Input",ExpressionUUID->"d8602cf4-408c-4242-b2c3-36c7c2b7e507"],
Cell[3405, 112, 195, 4, 47, "Input",ExpressionUUID->"3248ac6d-ace4-4134-aa8c-48698d99e156"],
Cell[3603, 118, 181, 3, 47, "Input",ExpressionUUID->"f695ddda-4832-45f2-a1d7-28430d3f4ff9"],
Cell[3787, 123, 238, 5, 47, "Input",ExpressionUUID->"252b132f-5a13-4b6e-a9ad-02c1062e7e19"],
Cell[4028, 130, 238, 5, 47, "Input",ExpressionUUID->"772f411f-7bff-4889-a5d4-e218c5dbdff0"]
}, Closed]],
Cell[CellGroupData[{
Cell[4303, 140, 89, 0, 57, "Subsection",ExpressionUUID->"75b5e199-7508-4c51-9cc5-5780b5fd71d9"],
Cell[4395, 142, 121, 1, 40, "Input",ExpressionUUID->"59303e04-35d7-4cdc-845c-ad3b8eed321a"],
Cell[4519, 145, 143, 2, 40, "Input",ExpressionUUID->"e7bf43a9-cc6f-40ad-b107-a6948e4ffcb5"]
}, Closed]],
Cell[CellGroupData[{
Cell[4699, 152, 112, 0, 57, "Subsection",ExpressionUUID->"6d401d9d-e379-4476-a3ba-be7949ba1727"],
Cell[4814, 154, 295, 6, 40, "Input",ExpressionUUID->"1c3a2519-0744-4303-965a-b3163e6889f3"]
}, Closed]],
Cell[CellGroupData[{
Cell[5146, 165, 93, 0, 57, "Subsection",ExpressionUUID->"b6dc0c01-5ed5-4134-a31c-3e1838dcfb5e"],
Cell[5242, 167, 230, 5, 35, "Input",ExpressionUUID->"440e982b-d2af-4b29-8bd2-1902dd06a82f"]
}, Closed]],
Cell[CellGroupData[{
Cell[5509, 177, 84, 0, 57, "Subsection",ExpressionUUID->"36c42b6d-3686-4502-9947-bc880061299c"],
Cell[5596, 179, 208, 5, 35, "Input",ExpressionUUID->"7a5ba265-276a-4595-b84a-c3f371644124"]
}, Closed]],
Cell[CellGroupData[{
Cell[5841, 189, 92, 0, 57, "Subsection",ExpressionUUID->"adf51c61-e6fd-4dc2-913d-4a8a5d0dc5de"],
Cell[5936, 191, 149, 3, 35, "Input",ExpressionUUID->"1debec01-5ae4-459d-b364-52ece01c5d06"]
}, Closed]],
Cell[CellGroupData[{
Cell[6122, 199, 118, 0, 57, "Subsection",ExpressionUUID->"3be3a157-8a2b-4926-832a-1b0d77130f50"],
Cell[6243, 201, 878, 25, 122, "Input",ExpressionUUID->"9fc2c08a-6860-47a2-98bf-cdc2e460a33f"]
}, Closed]],
Cell[CellGroupData[{
Cell[7158, 231, 96, 0, 57, "Subsection",ExpressionUUID->"8b986643-55f0-4a4d-a34a-ddd260800ba6"],
Cell[7257, 233, 124, 2, 35, "Input",ExpressionUUID->"d9529413-2b3a-481b-925f-ae242876cecd"]
}, Closed]],
Cell[CellGroupData[{
Cell[7418, 240, 87, 0, 57, "Subsection",ExpressionUUID->"3d6fd33a-d4d7-43cf-a9f6-912bd472154c"],
Cell[7508, 242, 113, 1, 35, "Input",ExpressionUUID->"5892ae4d-442d-4bff-a4d5-7685d04834ea"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7670, 249, 82, 0, 105, "Section",ExpressionUUID->"775b17d7-52a0-41be-9897-b4d377e1648d"],
Cell[CellGroupData[{
Cell[7777, 253, 89, 0, 84, "Subsection",ExpressionUUID->"83f56422-6a78-4f8b-92b1-5c5d22a187d9"],
Cell[7869, 255, 92, 0, 55, "Text",ExpressionUUID->"3353c1f9-7ab3-480e-9227-769ad4b3e599"],
Cell[7964, 257, 85, 0, 47, "Input",ExpressionUUID->"d6ab19bb-f4fa-4bee-b3b3-b722469230f8"],
Cell[8052, 259, 265, 6, 91, "Text",ExpressionUUID->"79e7336b-9956-4b05-993a-15b5f30af40d"],
Cell[8320, 267, 137, 2, 47, "Input",ExpressionUUID->"e1dbb1cc-7fa4-4a4e-9c9a-acc80a407469"]
}, Closed]],
Cell[CellGroupData[{
Cell[8494, 274, 96, 0, 84, "Subsection",ExpressionUUID->"e39f7444-5ecb-4801-8fdf-c574bfbb81b1"],
Cell[8593, 276, 130, 2, 47, "Input",ExpressionUUID->"2dec5202-0a04-4472-abcd-6146f32e68f8"]
}, Closed]],
Cell[CellGroupData[{
Cell[8760, 283, 111, 0, 84, "Subsection",ExpressionUUID->"9a1c2c81-0a65-43c5-9f47-5255d94ea0d1"],
Cell[8874, 285, 363, 10, 80, "Input",ExpressionUUID->"5f9c6bff-56c4-49f6-8a73-72a5c4d5a260"],
Cell[9240, 297, 268, 5, 47, "Input",ExpressionUUID->"66f318d5-790e-463f-b237-b7aa64a527d5"],
Cell[9511, 304, 90, 0, 55, "Text",ExpressionUUID->"0e3cd1a1-f6e6-4e4e-ac71-d4b69134eb56"],
Cell[9604, 306, 416, 12, 80, "Input",ExpressionUUID->"dd01ffe0-06fd-447f-85c0-0fa1237db7a3"]
}, Closed]]
}, Closed]]
}
]
*)

